#!/bin/sh
# 
#  Copyright (C) 1998  Jesper Pedersen <jews@imada.ou.dk>
#  This code is released under GNU GPL version 2 or later
# 
#  Usage: configure.sh  

# Default variables
JDKHOME=/usr/local/java
SWINGHOME=/usr/local/swing
INSTALLDIR=/usr/local/BurnIT
SCRIPTDIR=/usr/local/bin

echo "BurnIT configuration script:"
echo "============================"

# Test to see if the user is root
USER=`whoami`

if test 'root' != $USER
then
echo "You need to be root to install this program"
exit 1
fi

echo -n "BurnIT installation directory ["
echo -n $INSTALLDIR
echo -n "] : "
read install_dir

if test -z $install_dir 
then install_dir=$INSTALLDIR
fi

echo -n "BurnIT startup script placement ["
echo -n $SCRIPTDIR
echo -n "] : "
read script_dir

if test -z $script_dir 
then script_dir=$SCRIPTDIR
fi

echo ""

echo -n "JAVA installation ["
echo -n $JDKHOME
echo -n "] : "
read jdk_dir

if test -z $jdk_dir 
then jdk_dir=$JDKHOME
fi

echo -n "Swing installation ["
echo -n $SWINGHOME
echo -n "] : "
read swing_dir

if test -z $swing_dir 
then swing_dir=$SWINGHOME
fi

echo -n "Use Swing-1.0 ? [Yes] : "
read swing10

if test -z $swing10 
then swing10="Yes"
fi

if test $swing10 = 'Yes'
then convert="NO"
else convert="YES"
fi

echo ""

# Test if info is correct
javac=$jdk_dir/bin/javac
if test -x $javac
then echo "JAVA installation found."
else 
echo "JAVA installation not found."
exit 1
fi

swingall=$swing_dir/swingall.jar
if test -e $swingall
then echo "Swing installation found."
else 
echo "Swing installation not found."
exit 1
fi

echo ""
echo "Now run: make ; make install"
echo "Please read the Readme file, if you havn't done it yet."
echo ""
echo "Happy burning :)"

# Test which make program to use
PRG=`which gmake`

if test -z $PRG
then
MAKEPRG='Gmake.linux'
else
MAKEPRG='Gmake'
fi

if test $convert = "YES"
then 
cd src
./convert.pl
cd ..
fi

echo -n "JDKHOME=" > Makefile
echo $jdk_dir >> Makefile
echo -n "SWINGHOME=" >> Makefile
echo $swing_dir >> Makefile
echo -n "INSTALLDIR=" >> Makefile
echo $install_dir >> Makefile
echo -n "SCRIPTDIR=" >> Makefile
echo $script_dir >> Makefile
echo -n "CDRMAKE=" >> Makefile
echo $MAKEPRG >> Makefile

cat Makefile.in >> Makefile
