/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

public class CDSize  {
  protected DataTrackFrame   dataFrame;
  protected AudioTracksFrame audioFrame;
  protected ImageFileFrame   imageFrame;

  protected float dataSize;
  protected float audioSize;
  protected float imageSize;

  protected float totalSize;

  public CDSize() {
    dataSize = 0;
    audioSize = 0;
    imageSize = 0;
    
    totalSize = 0;
  }

  private void addSizes() {
    totalSize = dataSize + audioSize + imageSize;
  }

  private void updateFrameValues() {
    dataFrame.updateValues();
    audioFrame.updateValues();
    imageFrame.updateValues();
  }

  public void setDataTrackFrame(DataTrackFrame d) {
    dataFrame = d;
  }

  public void setAudioTracksFrame(AudioTracksFrame a) {
    audioFrame = a;
  }

  public void setImageFileFrame(ImageFileFrame i) {
    imageFrame = i;
  }

  public float getTotalSize() {
    return totalSize;
  }

  public void setDataTrackSize(float f) {
    dataSize = f;
    addSizes();
    updateFrameValues();
  }

  public void setAudioTracksSize(float f) {
    audioSize = f;
    addSizes();
    updateFrameValues();
  }

  public void setImageFileSize(float f) {
    imageSize = f;
    addSizes();
    updateFrameValues();
  }

}

