/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class CdrecordFrame extends JPanel implements ItemListener {
    protected BurnITFrame  parent;

    protected JPanel       borderPane;
    protected JPanel       borderPane2;
    protected JPanel       dataPane;
    protected JPanel       panel1;
    protected JPanel       panel2;
    protected JPanel       panel3;
    protected JPanel       panel4;
    protected JLabel       label;
    protected JComboBox    Output;
    protected JComboBox    Speed;
    protected JLabel       SpeedLabel;
    protected JCheckBox    Multi;
    protected JComboBox    Data1;
    protected JComboBox    Data2;
    protected JComboBox    Preemp;
    protected JComboBox    Pad;
    protected JCheckBox    Eject;
    protected JCheckBox    Dummy;
    protected JCheckBox    Swap;
    protected JTextField   Device;
    protected JLabel       DeviceLabel;
    protected JTextField   Imagefile;
    protected JTextField   Soundfiles;
    protected JTextField   Special;
    protected JLabel       SpecialLabel;

    protected Settings settings;
  
    public CdrecordFrame(BurnITFrame p, Settings set) {
        parent = p;
	settings = set;

        this.setLayout(new BorderLayout());

	borderPane = new JPanel();
	borderPane.setBorder(new EmptyBorder(5,5,5,5));
	borderPane.setLayout(new BorderLayout());
	
	borderPane2 = new JPanel();
	borderPane2.setBorder(new MatteBorder(1,1,1,1,Color.gray));
	borderPane2.setLayout(new BorderLayout());

	label = new JLabel("cdrecord options");
	label.setForeground(Color.black);

	dataPane = new JPanel();
	dataPane.setBorder(new EmptyBorder(5,5,5,5));
	dataPane.setLayout(new GridLayout(4,1));

	panel1 = new JPanel();
	panel1.setLayout(new FlowLayout(FlowLayout.LEFT));

	panel2 = new JPanel();
	panel2.setLayout(new FlowLayout(FlowLayout.LEFT));

	panel3 = new JPanel();
	panel3.setLayout(new FlowLayout(FlowLayout.LEFT));

	panel4 = new JPanel();
	panel4.setLayout(new FlowLayout(FlowLayout.LEFT));

        Output = new JComboBox();
	Output.addItem(" ");
	Output.addItem("-v");
	Output.addItem("-V");
	Output.addItem("-debug");
	panel1.add(Output);
	Output.addItemListener(this);
	
	DeviceLabel = new JLabel("dev=");
        DeviceLabel.setForeground(Color.black);
	panel1.add(DeviceLabel);

	Device = new JTextField(5);
	Device.setEditable(true);
	Device.setForeground(Color.black);
	Device.setBackground(Color.white);
	Device.setText(settings.getWrDevNumber());
	panel1.add(Device);
	
	SpeedLabel = new JLabel("speed=");
	SpeedLabel.setForeground(Color.black);
	panel1.add(SpeedLabel);

	Speed = new JComboBox();
	Speed.addItem("1");
	Speed.addItem("2");
	Speed.addItem("4");
	Speed.addItem("0");
	panel1.add(Speed);
	Speed.addItemListener(this);
	
 	Multi = new JCheckBox("-multi",false);
 	panel1.add(Multi);
 	Multi.addItemListener(this);
	
 	Pad = new JComboBox();
 	Pad.addItem("-nopad");
 	Pad.addItem("-pad");
 	panel1.add(Pad);
 	Pad.addItemListener(this);
	
 	Eject = new JCheckBox("-eject",false);
 	panel1.add(Eject);
 	Eject.addItemListener(this);
	
 	Dummy = new JCheckBox("-dummy",false);
 	panel2.add(Dummy);
 	Dummy.addItemListener(this);
	
 	Preemp = new JComboBox();
 	Preemp.addItem("-nopreemp");
 	Preemp.addItem("-preemp");
 	panel2.add(Preemp);
 	Preemp.addItemListener(this);
	
 	Swap = new JCheckBox("-swap",false);
 	panel2.add(Swap);
 	Swap.addItemListener(this);
	
 	Data1 = new JComboBox();
 	Data1.addItem("-audio");
 	Data1.addItem("-data");
 	Data1.addItem("-mode2");
 	Data1.addItem("-xa1");
 	Data1.addItem("-xa2");
 	Data1.addItem("-cdi");
 	panel3.add(Data1);
 	Data1.addItemListener(this);
	
 	Imagefile = new JTextField(15);
 	Imagefile.setEditable(true);
 	Imagefile.setForeground(Color.black);
 	Imagefile.setBackground(Color.white);
 	panel3.add(Imagefile);
 	String s = new String("");
 	s = s.concat(settings.getTmp());
 	s = s.concat("/image.iso");
 	Imagefile.setText(s);
	
 	Data2 = new JComboBox();
 	Data2.addItem(" ");
 	Data2.addItem("-audio");
 	panel3.add(Data2);
 	Data2.addItemListener(this);
	
 	Soundfiles = new JTextField(15);
 	Soundfiles.setEditable(true);
 	Soundfiles.setForeground(Color.black);
 	Soundfiles.setBackground(Color.white);
 	panel3.add(Soundfiles);
	
	SpecialLabel = new JLabel("Special:");
        SpecialLabel.setForeground(Color.black);
	panel4.add(SpecialLabel);

 	Special = new JTextField(15);
 	Special.setEditable(true);
 	Special.setForeground(Color.black);
 	Special.setBackground(Color.white);
 	Special.setText(settings.getComment());
 	panel4.add(Special);
	
	dataPane.add(panel1);
	dataPane.add(panel2);
	dataPane.add(panel3);
	dataPane.add(panel4);

	// Set defaults
	Speed.setSelectedItem(settings.getWrWrite());
 	Data1.setSelectedItem("-data");

        borderPane2.add(dataPane, BorderLayout.CENTER);
        borderPane.add(label, BorderLayout.NORTH);
        borderPane.add(borderPane2, BorderLayout.CENTER);

        this.add(borderPane, BorderLayout.NORTH);

	setSettings();
    }
  
    public void setSettings() {
      boolean second = false;
      String s;

      s = settings.getAdvCdr();

      StringTokenizer st = new StringTokenizer(s);
      while (st.hasMoreTokens()) {
	s = st.nextToken();

	if (s.compareTo("-v") == 0) {
	  Output.setSelectedItem("-v");
	} else if (s.compareTo("-V") == 0) {
	  Output.setSelectedItem("-V");
	} else if (s.compareTo("-debug") == 0) {
	  Output.setSelectedItem("-debug");
	} else if (s.compareTo("1") == 0) {
	  Speed.setSelectedItem("1");
	} else if (s.compareTo("2") == 0) {
	  Speed.setSelectedItem("2");
	} else if (s.compareTo("4") == 0) {
	  Speed.setSelectedItem("4");
	} else if (s.compareTo("0") == 0) {
	  Speed.setSelectedItem("0");
	} else if (s.compareTo("-multi") == 0) {
	  Multi.setSelected(true);
	} else if (s.compareTo("-audio") == 0) {
	  if (second == false) {
	    Data1.setSelectedItem("-audio");
	    second = true;
	  } else {
	    Data2.setSelectedItem("-audio");
	  }
	} else if (s.compareTo("-data") == 0) {
	  Data1.setSelectedItem("-data");
	  second = true;
	} else if (s.compareTo("-mode2") == 0) {
	  Data1.setSelectedItem("-mode2");
	  second = true;
	} else if (s.compareTo("-xa1") == 0) {
	  Data1.setSelectedItem("-xa1");
	  second = true;
	} else if (s.compareTo("-xa2") == 0) {
	  Data1.setSelectedItem("-xa2");
	  second = true;
	} else if (s.compareTo("-cdi") == 0) {
	  Data1.setSelectedItem("-cdi");
	  second = true;
	} else if (s.compareTo("-nopreemp") == 0) {
	  Preemp.setSelectedItem("-nopreemp");
	} else if (s.compareTo("-preemp") == 0) {
	  Preemp.setSelectedItem("-preemp");
	} else if (s.compareTo("-nopad") == 0) {
	  Pad.setSelectedItem("-nopad");
	} else if (s.compareTo("-pad") == 0) {
	  Pad.setSelectedItem("-pad");
	} else if (s.compareTo("-eject") == 0) {
	  Eject.setSelected(true);
	} else if (s.compareTo("-dummy") == 0) {
	  Dummy.setSelected(true);
	} else if (s.compareTo("-swap") == 0) {
	  Swap.setSelected(true);
	}
      }
      showButtons();
    }

    public String getAdvCdr() {
      String tmp;
      String adv = new String("");

      tmp = (String)Output.getSelectedItem();
      if (tmp.compareTo(" ") != 0) {
	adv = adv.concat(tmp);
	adv = adv.concat(" ");
      }
      adv = adv.concat((String)Speed.getSelectedItem());
      adv = adv.concat(" ");
      if (Multi.isSelected()) {
	adv = adv.concat("-multi ");
      }
      adv = adv.concat((String)Data1.getSelectedItem());
      adv = adv.concat(" ");
      tmp = (String)Data2.getSelectedItem();
      if (tmp.compareTo(" ") != 0) {
	adv = adv.concat(tmp);
	adv = adv.concat(" ");
      }
      tmp = (String)Preemp.getSelectedItem();
      if (tmp.compareTo(" ") != 0) {
	adv = adv.concat(tmp);
	adv = adv.concat(" ");
      }
      tmp = (String)Pad.getSelectedItem();
      if (tmp.compareTo(" ") != 0) {
	adv = adv.concat(tmp);
	adv = adv.concat(" ");
      }
      if (Eject.isSelected()) {
	adv = adv.concat("-eject ");
      }
      if (Dummy.isSelected()) {
	adv = adv.concat("-dummy ");
      }
      if (Swap.isSelected()) {
	adv = adv.concat("-swap");
      }
      return adv;
    }

    public String getBurnString(boolean onTheFly) {
      String tmp;
      String tmp2;
      String burn = new String("");

      tmp = (String)Output.getSelectedItem();
      if (tmp.compareTo(" ") != 0) {
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      burn = burn.concat("dev=");
      burn = burn.concat(Device.getText());
      burn = burn.concat(" ");

      burn = burn.concat("speed=");
      burn = burn.concat((String)Speed.getSelectedItem());
      burn = burn.concat(" ");

      tmp = Special.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      if (Multi.isSelected()) {
	burn = burn.concat("-multi ");
      }
      tmp = (String)Pad.getSelectedItem();
      if (tmp.compareTo(" ") != 0) {
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      if (Eject.isSelected()) {
	burn = burn.concat("-eject ");
      }
      if (Dummy.isSelected()) {
	burn = burn.concat("-dummy ");
      }
      tmp  = (String)Data1.getSelectedItem();
      tmp2 = (String)Data2.getSelectedItem();
      if ((tmp.compareTo("-audio") == 0)||
	  (tmp2.compareTo("-audio") == 0)) {
	tmp = (String)Preemp.getSelectedItem();
	if (tmp.compareTo(" ") != 0) {
	  burn = burn.concat(tmp);
	  burn = burn.concat(" ");
	}
	if (Swap.isSelected()) {
	  burn = burn.concat("-swap");
	}
      }
      burn = burn.concat((String)Data1.getSelectedItem());
      burn = burn.concat(" ");
      if (onTheFly) {
	burn = burn.concat("-");
      } else {
	burn = burn.concat(Imagefile.getText());
	burn = burn.concat(" ");

	tmp = (String)Data2.getSelectedItem();
	if (tmp.compareTo(" ") != 0) {
	  burn = burn.concat(tmp);
	  burn = burn.concat(" ");
	  burn = burn.concat(Soundfiles.getText());
	  burn = burn.concat(" ");
	}
      }
      return burn;
    }

    public void setImageName(String s) {
      Imagefile.setText(s);
    }

    public void addPath(String s) {
      Imagefile.setText(s);
    }

    protected void showButtons() {
      String tmp;
      String tmp2;
      boolean tmp3;

      tmp = (String)Data1.getSelectedItem();
      tmp2 = (String)Data2.getSelectedItem();
      tmp3 = Multi.isSelected();

      if (tmp.compareTo("-audio") == 0) {
	Preemp.setVisible(true);
	Swap.setVisible(true);
	Data2.setVisible(false);
	Soundfiles.setVisible(false);
      } else {
	if (tmp2.compareTo("-audio") != 0) {
	  Preemp.setVisible(false);
	  Swap.setVisible(false);
	}
	if (tmp3 == false) {
	  Data2.setVisible(true);
	  Soundfiles.setVisible(true);
	}
      }
      if ((tmp2.compareTo("-audio") == 0)&&
	  (tmp3 == false)) {
	Preemp.setVisible(true);
	Swap.setVisible(true);
      }
      if (tmp3) {
	Preemp.setVisible(false);
	Swap.setVisible(false);
	Data2.setVisible(false);
	Soundfiles.setVisible(false);
	if ((tmp.compareTo("-data") != 0)&&
	    (tmp.compareTo("-xa2") != 0)) {
	  Data1.setSelectedItem("-xa2");
	}
      }
      parent.updateScreen();
    }

    // Refresh screen
    public void refresh() {
	showButtons();
	repaint();
    }

    public void itemStateChanged(ItemEvent event) {
      // If a JComboBox was clicked on, repaint !
      if ((event.getSource() == Multi)||(event.getSource() == Data1)||
	  (event.getSource() == Data2)) {
	showButtons();
	repaint();
      }
    }
}
