/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

class EraseDisc extends JFrame implements ActionListener {
  protected JPanel       dataPane;
  protected JPanel       panel1;
  protected JPanel       panel2;
  protected JPanel       panel3;
  protected JPanel       panel4;
  protected JPanel       buttonPane;
  protected JButton      erase;
  protected JButton      cancel;

  protected JRadioButton disc;
  protected JRadioButton fast;
  protected ButtonGroup  buttonGroup;
  protected JLabel       discLabel;
  protected JLabel       fastLabel;

  protected WrComboBox   EraseSpeed;
  protected JLabel       EraseSpeedLabel;

  protected JLabel       deviceLabel;
  protected JLabel       device;

  protected Utils        utils;
  protected Settings     settings;

  public EraseDisc(Settings set, Utils utl) {
    this.setTitle("Erase Disc");

    setSize(450,200);
    setResizable(false);

    this.getContentPane().setLayout(new BorderLayout()); 

    settings = set;
    utils = utl;

    dataPane = new JPanel();
    dataPane.setLayout(new GridLayout(4,1));
    dataPane.setBorder(new EmptyBorder(5,5,5,5));

    panel1 = new JPanel();
    panel1.setLayout(new GridLayout(1,2));

    panel2 = new JPanel();
    panel2.setLayout(new GridLayout(1,2));

    panel3 = new JPanel();
    panel3.setLayout(new GridLayout(1,2));

    panel4 = new JPanel();
    panel4.setLayout(new GridLayout(1,2));

    deviceLabel = new JLabel("Using device:");
    deviceLabel.setForeground(Color.black);

    device = new JLabel();
    device.setForeground(Color.black);
    String s = new String();
    s = s.concat(settings.getWrModel());
    s = s.concat(" (");
    s = s.concat(settings.getWrDevNumber());
    s = s.concat(")");
    device.setText(s);
    
    panel1.add(deviceLabel);
    panel1.add(device);

    EraseSpeedLabel = new JLabel("Erase speed");
    EraseSpeedLabel.setForeground(Color.black);
    panel2.add(EraseSpeedLabel);

    EraseSpeed = new WrComboBox();
    EraseSpeed.setSelectedItem(settings.getWrErase());
    panel2.add(EraseSpeed);

    discLabel = new JLabel("Blank the entire disc");
    discLabel.setForeground(Color.black);

    fastLabel = new JLabel("Minimally blank");
    fastLabel.setForeground(Color.black);

    buttonGroup = new ButtonGroup();
    disc = new JRadioButton("Disc",true);
    buttonGroup.add(disc);
    fast = new JRadioButton("Fast");
    buttonGroup.add(fast);
    panel3.add(disc);
    panel3.add(discLabel);
    panel4.add(fast);
    panel4.add(fastLabel);

    dataPane.add(panel1);
    dataPane.add(panel2);
    dataPane.add(panel3);
    dataPane.add(panel4);

    buttonPane = new JPanel();
    buttonPane.setLayout(new BorderLayout());
    buttonPane.setBorder(new EmptyBorder(5,5,5,5));

    erase = new JButton("Erase");
    erase.addActionListener(this);
    buttonPane.add(erase, BorderLayout.EAST);

    cancel = new JButton("Cancel");
    cancel.addActionListener(this);
    buttonPane.add(cancel, BorderLayout.WEST);

    this.getContentPane().add(dataPane, BorderLayout.NORTH);
    this.getContentPane().add(buttonPane, BorderLayout.SOUTH);

    this.setVisible(true);
  }

  public void actionPerformed(ActionEvent e) {
    // The Erase button was clicked on, handle it ...
    if (e.getSource() == erase) {
      String tmp;
      String cmd = new String(settings.getCdrecord());
      
      cmd = cmd.concat(" -v dev=");
      cmd = cmd.concat(settings.getWrDevNumber());
      cmd = cmd.concat(" speed=");

      tmp = (String)EraseSpeed.getSelectedItem();
      cmd = cmd.concat(tmp);

      if (disc.isSelected() == true) {
	cmd = cmd.concat (" -blank=disc");
      } else if (fast.isSelected() == true) {
	cmd = cmd.concat(" -blank=fast");
      }

      ExecuteThread th = new ExecuteThread(cmd);

      setVisible(false);
      dispose();
    // The CANCEL button was clicked on, handle it ...
    } else if (e.getSource() == cancel) {
      setVisible(false);
      dispose();
    }
  }
}
