/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import java.io.*;

class ExecuteThread extends Thread {
  protected String[] cmds;
  protected ExecuteCmdsThread callee = null;
  protected CDPlayer cdp = null;
  //Output out;
  protected boolean output;
  protected Process proc;

  public ExecuteThread(String cmd_in) {
    cmds = new String[1];
    cmds[0] = cmd_in;
    output = true;
    //out = new Output("Executing ...", 500,300);

    start();
  }

  public ExecuteThread(String[] cmds_in, ExecuteCmdsThread callee_in) {
    cmds = cmds_in;
    output = true;
    callee = callee_in;
    //out = new Output("Executing ...", 500,300);

    start();
  }

  public ExecuteThread(String[] cmds_in) {
    cmds = cmds_in;
    output = true;
    //out = new Output("Executing ...", 500,300);

    start();
  }

  public ExecuteThread(String cmd_in, boolean output_in) {
    cmds = new String[1];
    cmds[0] = cmd_in;
    output = output_in;
    //out = new Output("Executing ...", 500,300);

    start();
  }

  public ExecuteThread(String cmd_in, boolean output_in, CDPlayer cdp_in) {
    cmds = new String[1];
    cmds[0] = cmd_in;
    output = output_in;
    cdp = cdp_in;

    start();
  }

  public void run() {
    for (int procnr = 0; procnr < cmds.length; procnr++) {
      if (output) {
        System.out.print("Executing : ");
	System.out.println(cmds[procnr]);
      }
      try {
	proc = Runtime.getRuntime().exec(cmds[procnr],null);
	int c;
	if (output) {
	  if ((cmds[procnr].indexOf("mkisofs") == -1)&&
	      (cmds[procnr].indexOf("mkhybrid") == -1)&&
	      (cmds[procnr].indexOf("cdda2wav") == -1)&&
	      (cmds[procnr].indexOf("encode") == -1)&&
	      (cmds[procnr].indexOf("decode") == -1)&&
	      (cmds[procnr].indexOf("cdparanoia") == -1)) {
	    if ((cmds[procnr].indexOf("cdrecord") != -1)||
		(cmds[procnr].indexOf("./user.cmd") != -1)) {
	      MyInputStream charIn = new MyInputStream(proc.getInputStream());
	      while ((c = charIn.readChar()) != -1) {
		System.out.print((char) c);
	      }
	    } else {
	      MyInputStream lineIn = new MyInputStream(proc.getInputStream());
	      try {
		String line;
		while (true) {
		  line = lineIn.readLine();
		  System.out.println(line);
		}
	      } catch (EOFException e) {
	      }
	    }
	  } else {
	    if ((cmds[procnr].indexOf("encode") != -1)||
		(cmds[procnr].indexOf("decode") != -1)||
		(cmds[procnr].indexOf("cdparanoia") != -1)) {
	      MyInputStream charIn = new MyInputStream(proc.getErrorStream());
	      while ((c = charIn.readChar()) != -1) {
		System.out.print((char) c);
	      }
	    } else {
	      MyInputStream lineIn = new MyInputStream(proc.getErrorStream());
	      try {
		String line;
		while (true) {
		  line = lineIn.readLine();
		  System.out.println(line);
		}
	      } catch (EOFException e) {
	      }
	    }
	  }
	  System.out.println("Command complete.");
	} else {
	  c = proc.waitFor();
	}
	proc.destroy();
      } catch (Exception e) {
      }
    }
    try {
      this.sleep(1000);
    } catch (InterruptedException e) {
    }
    if (cdp != null) {
      cdp.threadFinished();
    }
    if (callee != null) {
      callee.threadFinished();
    }
  }

  public void killProcess() {
    int i;

    proc.destroy();
    try {
      i = proc.waitFor();
    } catch (InterruptedException e) {
    }
    try {
      this.sleep(1000);
    } catch (InterruptedException e) {
    }
    this.stop();
  }
}

