/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;
import com.sun.java.swing.tree.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

class FileManager extends JFrame implements ActionListener {
  protected BurnITFrame  parent;

  protected JPanel       dataPane;

  protected JPanel       panel1;
  protected JButton      add;
  protected JTextField   dirs;

  protected JTree        tree;
  protected DefaultMutableTreeNode top;

  protected JPanel       buttonPane;
  protected JButton      ok;
  protected JButton      cancel;

  protected Utils        utils;
  protected Settings     settings;

  public FileManager(BurnITFrame p, Settings set, Utils utl) {
    this.setTitle("BurnIT: File Manager");

    setSize(500,300);

    this.getContentPane().setLayout(new BorderLayout()); 

    parent = p;
    settings = set;
    utils = utl;

    dataPane = new JPanel();
    dataPane.setLayout(new BorderLayout());
    dataPane.setBorder(new EmptyBorder(5,5,5,5));

    panel1 = new JPanel();
    panel1.setLayout(new BorderLayout());

    add = new JButton("Add");
    add.addActionListener(this);
    panel1.add(add,BorderLayout.WEST);

    dirs = new JTextField();
    panel1.add(dirs,BorderLayout.CENTER);

    top = new DefaultMutableTreeNode("/");
    
    tree = new JTree(top);
    tree.setCellRenderer(new FileManager_TCR()); 
    dataPane.add(new JScrollPane(tree), BorderLayout.CENTER);
    dataPane.add(panel1, BorderLayout.SOUTH);

    MouseListener ml = new MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
	try {
	  Object[] path;
	  DefaultMutableTreeNode node;
	  Vector track = new Vector();
	  Vector tckno = new Vector();
	  Vector tckname = new Vector();
	  int i,j;
	  String s,r,tmps;

	  dirs.setText("");
	  TreePath[] selPath = tree.getSelectionPaths();
	  
	  for (j=0; j < selPath.length; j++) {
	    s = new String();
	    r = new String();
	    path = selPath[j].getPath();
	    for (i=0;i<path.length;i++) {
	      s = s.concat(path[i].toString());
	      if (i > 0) {
		s = s.concat("/");
	      }
	    }
	    
	    if (e.getClickCount() == 1) {
	      node = (DefaultMutableTreeNode)path[path.length-1];
	      
	      if (node.getChildCount() == 0) {
		DefaultMutableTreeNode[] children;
		DefaultMutableTreeNode tmp;
		
		children = utils.getDirectory(s);
		
		for (i=0;i<children.length;i++) {
		  tmp = children[i];
		  node.add(tmp);
		}
		tree.repaint();
	      }
	      if (s.length() != 1) {
		s = s.substring(0,s.length()-1);
	      }
	      r = dirs.getText();
	      if (j > 0)
		r = r.concat(";");
	      r = r.concat(s);
	      dirs.setText(r);
	    } else if (e.getClickCount() == 3) {
	      s = s.substring(0,s.length()-1);
	      if (utils.isAudioFile(s)) {
		tmps = new String("File ");
		tmps = tmps.concat(s);
		tckno.addElement(tmps);
		tckname.addElement(s);
	      }
	    }
	  }
	  if (tckno.size() > 0) {
	    track.addElement(tckno);
	    for (j=0;j<tckname.size();j++) {
	      tmps = (String)tckname.elementAt(j);
	      track.addElement(tmps);
	    }
	    CDPlayer cdp = new CDPlayer(settings,utils,track);
	  }
	} catch (Exception exp) {
	}
      }
    };
    tree.addMouseListener(ml);
    
    buttonPane = new JPanel();
    buttonPane.setLayout(new BorderLayout());
    buttonPane.setBorder(new EmptyBorder(5,5,5,5));

    ok = new JButton("Ok");
    ok.addActionListener(this);
    buttonPane.add(ok, BorderLayout.EAST);

    cancel = new JButton("Cancel");
    cancel.addActionListener(this);
    buttonPane.add(cancel, BorderLayout.WEST);

    this.getContentPane().add(dataPane, BorderLayout.CENTER);
    this.getContentPane().add(buttonPane, BorderLayout.SOUTH);

    this.setVisible(true);
  }

  public void actionPerformed(ActionEvent e) {
    // The Ok button was clicked on, handle it ...
    if (e.getSource() == ok) {
      String s;
      s = dirs.getText();

      StringTokenizer st = new StringTokenizer(s,";");
      while (st.hasMoreTokens()) {
	s = st.nextToken();
	parent.addPath(s);
      }

      this.setVisible(false); 
    // The Add button was clicked on, handle it ...
    } else if (e.getSource() == add) {
      String s;
      s = dirs.getText();

      StringTokenizer st = new StringTokenizer(s,";");
      while (st.hasMoreTokens()) {
	s = st.nextToken();
	parent.addPath(s);
      }
    // The Cancel button was clicked on, handle it ...
    } else if (e.getSource() == cancel) {
      this.setVisible(false);
    }
  }
}
