/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class GeneralFrame extends JPanel implements ItemListener {
    protected JPanel       borderPane;
    protected JPanel       borderPane2;
    protected JPanel       dataPane;
    protected JLabel       label;
    protected JPanel       pane1;
    protected JPanel       pane2;
    protected JPanel       pane3;
    protected JPanel       pane4;
    protected JPanel       pane5;
    protected JTextField   defaultTmp;
    protected JLabel       defaultTmp_Label;
    protected JCheckBox    writeISOImage;
    protected JTextField   writeDest;
    protected WrComboBox   speed;
    protected JLabel       speed_Label;
    protected JCheckBox    onTheFly;
    protected JCheckBox    testBefore;

    protected JPanel       panel;
    protected JPanel       panel2;
    protected JPanel       dataPane2;
    protected JPanel       sessionPane;
    protected JPanel       discPane;
    protected JLabel       label2;
    protected JComboBox    sessionType;
    protected JLabel       sessionType_Label;
    protected JCheckBox    closeDisc;
    protected JCheckBox    discAtOnce;

    protected int          state;
    
    protected Settings     settings;

    public GeneralFrame(int s,Settings set) {
        state = s;
        settings = set;

	this.setLayout(new BorderLayout());

	borderPane = new JPanel();
	borderPane.setBorder(new EmptyBorder(5,5,5,5));
	borderPane.setLayout(new BorderLayout());
	
	borderPane2 = new JPanel();
	borderPane2.setBorder(new MatteBorder(1,1,1,1,Color.gray));
	borderPane2.setLayout(new BorderLayout());

	label = new JLabel("Writing Parameters");
	label.setForeground(Color.black);

	dataPane = new JPanel();
	dataPane.setBorder(new EmptyBorder(5,5,5,5));
	dataPane.setLayout(new GridLayout(5,1));

	pane1 = new JPanel();
	pane1.setLayout(new FlowLayout(FlowLayout.LEFT));

	pane2 = new JPanel();
	pane2.setLayout(new FlowLayout(FlowLayout.LEFT));

	pane3 = new JPanel();
	pane3.setLayout(new FlowLayout(FlowLayout.LEFT));

	pane4 = new JPanel();
	pane4.setLayout(new FlowLayout(FlowLayout.LEFT));

	pane5 = new JPanel();
	pane5.setLayout(new FlowLayout(FlowLayout.LEFT));

	defaultTmp_Label = new JLabel("Temporary directory");
	defaultTmp_Label.setForeground(Color.black);
	defaultTmp_Label.setBackground(Color.gray);
 	pane1.add(defaultTmp_Label);

	defaultTmp = new JTextField(15);
	defaultTmp.setText(settings.getTmp());
	pane1.add(defaultTmp);
	
	if ((state == BurnITFrame.isAudio)||
	    (state == BurnITFrame.isCDROM_wImage)||
	    (state == BurnITFrame.isMixedModeCD_wImage)) {
	  defaultTmp_Label.setEnabled(false);
	  defaultTmp.setEnabled(false);
	} 

	writeISOImage = new JCheckBox("Write real ISO image to");
 	pane2.add(writeISOImage);

	String tmp;
	writeDest = new JTextField(15);
	tmp = settings.getTmp();
	tmp = tmp.concat("/image.iso");
	writeDest.setText(tmp);
	pane2.add(writeDest);
	
	if ((state == BurnITFrame.isCDROM_wImage)||
	    (state == BurnITFrame.isAudio)||
	    (state == BurnITFrame.isCDCopy)||
	    (state == BurnITFrame.isMixedModeCD)||
	    (state == BurnITFrame.isMixedModeCD_wImage)) {
	  writeISOImage.setEnabled(false);
	  writeDest.setEnabled(false);
	}

	speed_Label = new JLabel("Writing speed");
	speed_Label.setForeground(Color.black);
	speed_Label.setBackground(Color.gray);
 	pane3.add(speed_Label);

	speed = new WrComboBox();
	pane3.add(speed);
	speed.addItemListener(this);
	speed.setSelectedItem(settings.getWrWrite());
	
	onTheFly = new JCheckBox("Write on the Fly");
	if ((state == BurnITFrame.isCDROM_wImage)||
	    (state == BurnITFrame.isAudio)||
	    (state == BurnITFrame.isCDCopy)||
	    (state == BurnITFrame.isMixedModeCD)||
	    (state == BurnITFrame.isMixedModeCD_wImage)) {
	  onTheFly.setEnabled(false);
	}
 	pane4.add(onTheFly);

	testBefore = new JCheckBox("Test before writing");
 	pane5.add(testBefore);

	dataPane.add(pane1);
	dataPane.add(pane2);
	dataPane.add(pane3);
	dataPane.add(pane4);
	dataPane.add(pane5);

        borderPane2.add(dataPane, BorderLayout.NORTH);
        borderPane.add(label, BorderLayout.NORTH);
        borderPane.add(borderPane2, BorderLayout.CENTER);

	panel = new JPanel();
	panel.setBorder(new EmptyBorder(5,5,5,5));
	panel.setLayout(new BorderLayout());
	
	panel2 = new JPanel();
	panel2.setBorder(new MatteBorder(1,1,1,1,Color.gray));
	panel2.setLayout(new BorderLayout());

	label2 = new JLabel("CD Format");
	label2.setForeground(Color.black);

	GridLayout layout = new GridLayout(1,2);

	dataPane2 = new JPanel();
	dataPane2.setBorder(new EmptyBorder(5,5,5,5));
	dataPane2.setLayout(layout);

	sessionPane = new JPanel();
	sessionPane.setLayout(new FlowLayout(FlowLayout.LEFT));

	sessionType_Label = new JLabel("Session type");
	sessionType_Label.setForeground(Color.black);
	sessionType_Label.setBackground(Color.gray);
	if (state == BurnITFrame.isCDCopy) {
	  sessionType_Label.setEnabled(false);
	}
  	sessionPane.add(sessionType_Label);

	sessionType = new JComboBox();
	if ((state == BurnITFrame.isMultisessionCD)||
	    (state == BurnITFrame.isCDROM)||
	    (state == BurnITFrame.isCDROM_wImage)||
	    (state == BurnITFrame.isMixedModeCD)||
	    (state == BurnITFrame.isMixedModeCD_wImage)) {
	  sessionType.addItem("CD-ROM");
	  sessionType.addItem("XA2");
	} else if ((state == BurnITFrame.isAudio)) {
	  sessionType.addItem("AUDIO");
	} else if (state == BurnITFrame.isCDCopy) {
	  sessionType.setEnabled(false);
	}
	sessionPane.add(sessionType);
	sessionType.addItemListener(this);
	
	discPane = new JPanel();
	discPane.setLayout(new BorderLayout());

	closeDisc = new JCheckBox("Close Disc");
	closeDisc.setEnabled(false);
 	discPane.add(closeDisc,BorderLayout.WEST);

	discAtOnce = new JCheckBox("Disc at Once");
	discAtOnce.setEnabled(false);
 	discPane.add(discAtOnce,BorderLayout.CENTER);

	dataPane2.add(sessionPane);
	dataPane2.add(discPane);

        panel2.add(dataPane2, BorderLayout.CENTER);
        panel.add(label2, BorderLayout.NORTH);
        panel.add(panel2, BorderLayout.CENTER);

        this.add(panel, BorderLayout.SOUTH);
        this.add(borderPane, BorderLayout.CENTER);
    }

    public boolean getOnTheFly() {
      return onTheFly.isSelected();
    }

    public void setOnTheFly(boolean b) {
      onTheFly.setSelected(b);
    }

    public boolean getDiscAtOne() {
      return discAtOnce.isSelected();
    }

    public boolean getWriteISOImage() {
      return writeISOImage.isSelected();
    }

    public String getWriteDest() {
      return writeDest.getText();
    }

    public String getTmp() {
      return defaultTmp.getText();
    }

    public String getSpeed() {
      return (String)speed.getSelectedItem();
    }

    public void setSpeed(String s) {
      speed.setSelectedItem(s);
    }

    public String getTestBefore() {
      if (testBefore.isSelected()) {
	return new String("-dummy");
      }
      return new String("");
    }

    public void setTestBefore(boolean b) {
      testBefore.setSelected(b);
    }

    public String getSessionType() {
      String s = (String)sessionType.getSelectedItem();
      if (s.compareTo("CD-ROM") == 0) {
	return new String("-data");
      } else if (s.compareTo("XA2") == 0) {
	return new String("-xa2");
      } else if (s.compareTo("AUDIO") == 0) {
	return new String("-audio");
      }
      return new String("");
    }

    // Refresh screen
    public void refresh() {
      repaint();
    }

    public void itemStateChanged(ItemEvent event) {
      // If a JComboBox was clicked on, repaint !
      if (event.getSource() instanceof JComboBox) {
	repaint();
      }
    }

}

