/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class ImageFileFrame extends JPanel {
  protected JPanel      borderPane;
  protected JPanel      borderPane2;
  protected JPanel      dataPane;
  protected JLabel      label;
  protected JTextField  image;

  protected CDSize      cdsize;

  protected Settings    settings;
  protected Utils       utils;

  public ImageFileFrame(Settings set, Utils utl) {
    this.setLayout(new BorderLayout());
    
    settings = set;
    utils = utl;

    borderPane = new JPanel();
    borderPane.setBorder(new EmptyBorder(5,5,5,5));
    borderPane.setLayout(new BorderLayout());
    
    borderPane2 = new JPanel();
    borderPane2.setBorder(new MatteBorder(1,1,1,1,Color.gray));
    borderPane2.setLayout(new BorderLayout());
    
    label = new JLabel("Select image file");
    label.setForeground(Color.black);

    dataPane = new JPanel();
    dataPane.setBorder(new EmptyBorder(5,5,5,5));
    dataPane.setLayout(new FlowLayout(FlowLayout.LEFT));

    image = new JTextField(30);
    String s = new String("");
    s = s.concat(settings.getTmp());
    s = s.concat("/image.iso");
    image.setText(s);
    
    dataPane.add(image);

    borderPane2.add(dataPane, BorderLayout.CENTER);
    borderPane.add(label, BorderLayout.NORTH);
    borderPane.add(borderPane2, BorderLayout.CENTER);
    
    this.add(borderPane, BorderLayout.NORTH);
  }

  public void updateValues() {
  }

  // Refresh screen
  public void refresh() {
    
  }

  public void addPath(String s) {
    String res;
    int i;
    float value;

    image.setText(s);
    res = new String(utils.getFileSize(s));
    i = new Integer(res).intValue();

    value = i / (1024 * 1024);
    cdsize.setImageFileSize(value);
  }

  public void setCDSizeObject(CDSize cd) {
    cdsize = cd;
  }

  public String getBurnString() {
    return image.getText();
  }

}

