/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class LoadContentsFrame extends JPanel implements ActionListener {
  protected JPanel        borderPane;
  protected JPanel        borderPane2;
  protected JPanel        dataPane;

  protected JLabel        label;
  protected JTextField    session;
  protected JButton       Msinfo_button;

  protected Utils         util;

  public LoadContentsFrame(Utils utl) {
    this.setLayout(new BorderLayout());
    
    util = utl;

    borderPane = new JPanel();
    borderPane.setBorder(new EmptyBorder(5,5,5,5));
    borderPane.setLayout(new BorderLayout());
    
    borderPane2 = new JPanel();
    borderPane2.setBorder(new MatteBorder(1,1,1,1,Color.gray));
    borderPane2.setLayout(new BorderLayout());
    
    label = new JLabel("Session to include");
    label.setForeground(Color.black);

    dataPane = new JPanel();
    dataPane.setBorder(new EmptyBorder(5,5,5,5));
    dataPane.setLayout(new FlowLayout(FlowLayout.LEFT));

    
    session = new JTextField(30);

    Msinfo_button = new JButton("Get msinfo");
    Msinfo_button.addActionListener(this);

    dataPane.add(session);
    dataPane.add(Msinfo_button);

    borderPane2.add(dataPane, BorderLayout.CENTER);
    borderPane.add(label, BorderLayout.NORTH);
    borderPane.add(borderPane2, BorderLayout.CENTER);
    
    this.add(borderPane, BorderLayout.NORTH);
  }

  // Refresh screen
  public void refresh() {
    
  }

  public String getBurnString() {
    return session.getText();
  }

  public void setMultisession(String s) {
    session.setText(s);
  }

  public void actionPerformed(ActionEvent event) {
    if (event.getSource() == Msinfo_button) {
      String magic = new String("");
      
      magic = util.getMagicParameters();
      if (magic.compareTo("") != 0) {
	session.setText(magic);
      }
      repaint();
    }
  }
}

