/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class MkisofsFrame extends JPanel implements ActionListener, ItemListener{
    protected BurnITFrame  parent;
    protected JPanel       borderPane;
    protected JPanel       borderPane2;
    protected JPanel       buttonPane;
    protected JPanel       dataPane;
    protected JPanel       panel1;
    protected JPanel       panel2;
    protected JPanel       panel3;
    protected JPanel       panel4;
    protected JPanel       panel5;
    protected JPanel       panel6;
    protected JLabel       label;
    protected JCheckBox    Mkiso_a;
    protected JCheckBox    Mkiso_d;
    protected JCheckBox    Mkiso_D;
    protected JCheckBox    Mkiso_f;
    protected JCheckBox    Mkiso_J;
    protected JCheckBox    Mkiso_l;
    protected JCheckBox    Mkiso_L;
    protected JCheckBox    Mkiso_N;  
    protected JCheckBox    Mkiso_quiet;
    protected JComboBox    Mkiso_r;
    protected JCheckBox    Mkiso_T;
    protected JCheckBox    Mkiso_v;
    protected JComboBox    Mkiso_nosym;
    protected JLabel       Mkiso_b_Label;
    protected JTextField   Mkiso_b;
    protected JLabel       Mkiso_c_Label;
    protected JTextField   Mkiso_c;
    protected JLabel       Mkiso_C_Label;
    protected JTextField   Mkiso_C;
    protected JLabel       Mkiso_m_Label;
    protected JTextField   Mkiso_m;
    protected JLabel       Mkiso_M_Label;
    protected JTextField   Mkiso_M;
    protected JLabel       Mkiso_o_Label;
    protected JTextField   Mkiso_o;
    protected JLabel       Mkiso_x_Label;
    protected JTextField   Mkiso_x;
    protected JLabel       Mkiso_A_Label;
    protected JTextField   Mkiso_A;
    protected JLabel       Mkiso_p_Label;
    protected JTextField   Mkiso_p;
    protected JLabel       Mkiso_P_Label;
    protected JTextField   Mkiso_P;
    protected JLabel       Mkiso_V_Label;
    protected JTextField   Mkiso_V;
    protected JLabel       Mkiso_Biblio_Label;
    protected JTextField   Mkiso_Biblio;
    protected JLabel       Mkiso_Copy_Label;
    protected JTextField   Mkiso_Copy;
    protected JLabel       Mkiso_SysID_Label;
    protected JTextField   Mkiso_SysID;
    protected JLabel       Mkiso_VolSet_Label;
    protected JTextField   Mkiso_VolSet;
    protected JTextField   Mkiso_files;
    protected JButton      Generate_button;
    protected JButton      Mount_button;
    protected JButton      Msinfo_button;

    protected boolean      ButGenerate;
    protected boolean      ButMount;

    protected Settings      settings;
    protected Utils         util;
    protected CdrecordFrame cdrecord;

    public MkisofsFrame(BurnITFrame p, Settings set, Utils utl, CdrecordFrame cdr) {
        parent = p;
	settings = set;
	util = utl;
	cdrecord = cdr;

	ButGenerate = false;
	ButMount = false;

	this.setLayout(new BorderLayout());

	borderPane = new JPanel();
	borderPane.setBorder(new EmptyBorder(5,5,5,5));
	borderPane.setLayout(new BorderLayout());
	
	borderPane2 = new JPanel();
	borderPane2.setBorder(new MatteBorder(1,1,1,1,Color.gray));
	borderPane2.setLayout(new BorderLayout());

	label = new JLabel("mkisofs options");
	label.setForeground(Color.black);

	buttonPane = new JPanel();
	buttonPane.setBorder(new EmptyBorder(5,5,5,5));
	buttonPane.setLayout(new FlowLayout(FlowLayout.LEFT));
	
	dataPane = new JPanel();
	dataPane.setBorder(new EmptyBorder(5,5,5,5));
	dataPane.setLayout(new GridLayout(6,1));

	panel1 = new JPanel();
	panel1.setLayout(new FlowLayout(FlowLayout.LEFT));

	panel2 = new JPanel();
	panel2.setLayout(new FlowLayout(FlowLayout.LEFT));

	panel3 = new JPanel();
	panel3.setLayout(new FlowLayout(FlowLayout.LEFT));

	panel4 = new JPanel();
	panel4.setLayout(new FlowLayout(FlowLayout.LEFT));

	panel5 = new JPanel();
	panel5.setLayout(new FlowLayout(FlowLayout.LEFT));

	panel6 = new JPanel();
	panel6.setLayout(new FlowLayout(FlowLayout.LEFT));

	Mkiso_a = new JCheckBox("-a",false);
	panel1.add(Mkiso_a);
	Mkiso_a.addItemListener(this);
	
 	Mkiso_d = new JCheckBox("-d",false);
 	panel1.add(Mkiso_d);
 	Mkiso_d.addItemListener(this);
	
 	Mkiso_D = new JCheckBox("-D",false);
 	panel1.add(Mkiso_D);
 	Mkiso_D.addItemListener(this);
	
 	Mkiso_f = new JCheckBox("-f",false);
 	panel1.add(Mkiso_f);
 	Mkiso_f.addItemListener(this);
	
 	Mkiso_J = new JCheckBox("-J",false);
 	panel1.add(Mkiso_J);
 	Mkiso_J.addItemListener(this);
	
 	Mkiso_l = new JCheckBox("-l",false);
 	panel1.add(Mkiso_l);
 	Mkiso_l.addItemListener(this);
	
 	Mkiso_L = new JCheckBox("-L",false);
 	panel1.add(Mkiso_L);
 	Mkiso_L.addItemListener(this);
	
 	Mkiso_N = new JCheckBox("-N",false);
 	panel1.add(Mkiso_N);
 	Mkiso_N.addItemListener(this);
	
 	Mkiso_quiet = new JCheckBox("-quiet",false);
 	panel1.add(Mkiso_quiet);
 	Mkiso_quiet.addItemListener(this);
	
 	Mkiso_r = new JComboBox();
 	Mkiso_r.addItem(" ");
 	Mkiso_r.addItem("-r");
 	Mkiso_r.addItem("-R");
 	panel2.add(Mkiso_r);
 	Mkiso_r.addItemListener(this);
	
 	Mkiso_T = new JCheckBox("-T",false);
 	panel2.add(Mkiso_T);
 	Mkiso_T.addItemListener(this);
	
 	Mkiso_v = new JCheckBox("-v",false);
 	panel2.add(Mkiso_v);
 	Mkiso_v.addItemListener(this);
	
 	Mkiso_nosym = new JComboBox();
 	Mkiso_nosym.addItem(" ");
 	Mkiso_nosym.addItem("-no-split-symlink-components");
 	Mkiso_nosym.addItem("-no-split-symlink-fields");
 	panel2.add(Mkiso_nosym);
 	Mkiso_nosym.addItemListener(this);
	
	Mkiso_m_Label = new JLabel("-m");
	Mkiso_m_Label.setForeground(Color.black);
	Mkiso_m_Label.setBackground(Color.gray);
 	panel2.add(Mkiso_m_Label);

  	Mkiso_m = new JTextField(10);
  	Mkiso_m.setEditable(true);
  	Mkiso_m.setForeground(Color.black);
  	Mkiso_m.setBackground(Color.white);
  	panel2.add(Mkiso_m);
	
	Mkiso_b_Label = new JLabel("-b");
	Mkiso_b_Label.setForeground(Color.black);
	Mkiso_b_Label.setBackground(Color.gray);
 	panel3.add(Mkiso_b_Label);

 	Mkiso_b = new JTextField(10);
  	Mkiso_b.setEditable(true);
  	Mkiso_b.setForeground(Color.black);
  	Mkiso_b.setBackground(Color.white);
  	panel3.add(Mkiso_b);
	
	Mkiso_c_Label = new JLabel("-c");
	Mkiso_c_Label.setForeground(Color.black);
	Mkiso_c_Label.setBackground(Color.gray);
 	panel3.add(Mkiso_c_Label);

 	Mkiso_c = new JTextField(10);
 	Mkiso_c.setEditable(true);
 	Mkiso_c.setForeground(Color.black);
 	Mkiso_c.setBackground(Color.white);
 	panel3.add(Mkiso_c);
	
	Mkiso_C_Label = new JLabel("-C");
	Mkiso_C_Label.setForeground(Color.black);
	Mkiso_C_Label.setBackground(Color.gray);
 	panel3.add(Mkiso_C_Label);
 	Mkiso_C_Label.setVisible(false);

 	Mkiso_C = new JTextField(10);
 	Mkiso_C.setEditable(true);
 	Mkiso_C.setForeground(Color.black);
 	Mkiso_C.setBackground(Color.white);
 	panel3.add(Mkiso_C);
 	Mkiso_C.setVisible(false);
	
	Mkiso_M_Label = new JLabel("-M");
	Mkiso_M_Label.setForeground(Color.black);
	Mkiso_M_Label.setBackground(Color.gray);
 	panel3.add(Mkiso_M_Label);
 	Mkiso_M_Label.setVisible(false);

 	Mkiso_M = new JTextField(10);
 	Mkiso_M.setEditable(true);
 	Mkiso_M.setForeground(Color.black);
 	Mkiso_M.setBackground(Color.white);
 	panel3.add(Mkiso_M);
 	Mkiso_M.setText(settings.getWrGen());
 	Mkiso_M.setVisible(false);
	
	Mkiso_A_Label = new JLabel("-A");
	Mkiso_A_Label.setForeground(Color.black);
	Mkiso_A_Label.setBackground(Color.gray);
 	panel4.add(Mkiso_A_Label);

 	Mkiso_A = new JTextField(10);
 	Mkiso_A.setEditable(true);
 	Mkiso_A.setForeground(Color.black);
 	Mkiso_A.setBackground(Color.white);
 	panel4.add(Mkiso_A);
	
	Mkiso_p_Label = new JLabel("-p");
	Mkiso_p_Label.setForeground(Color.black);
	Mkiso_p_Label.setBackground(Color.gray);
 	panel4.add(Mkiso_p_Label);

 	Mkiso_p = new JTextField(10);
 	Mkiso_p.setEditable(true);
 	Mkiso_p.setForeground(Color.black);
 	Mkiso_p.setBackground(Color.white);
 	panel4.add(Mkiso_p);
	
	Mkiso_P_Label = new JLabel("-P");
	Mkiso_P_Label.setForeground(Color.black);
	Mkiso_P_Label.setBackground(Color.gray);
 	panel4.add(Mkiso_P_Label);

 	Mkiso_P = new JTextField(10);
 	Mkiso_P.setEditable(true);
 	Mkiso_P.setForeground(Color.black);
 	Mkiso_P.setBackground(Color.white);
 	panel4.add(Mkiso_P);
	
	Mkiso_V_Label = new JLabel("-V");
	Mkiso_V_Label.setForeground(Color.black);
	Mkiso_V_Label.setBackground(Color.gray);
 	panel4.add(Mkiso_V_Label);

 	Mkiso_V = new JTextField(10);
 	Mkiso_V.setEditable(true);
 	Mkiso_V.setForeground(Color.black);
 	Mkiso_V.setBackground(Color.white);
 	panel4.add(Mkiso_V);
	
	Mkiso_Biblio_Label = new JLabel("-biblio");
	Mkiso_Biblio_Label.setForeground(Color.black);
	Mkiso_Biblio_Label.setBackground(Color.gray);
 	panel5.add(Mkiso_Biblio_Label);

 	Mkiso_Biblio = new JTextField(8);
 	Mkiso_Biblio.setEditable(true);
 	Mkiso_Biblio.setForeground(Color.black);
 	Mkiso_Biblio.setBackground(Color.white);
 	panel5.add(Mkiso_Biblio);
	
	Mkiso_Copy_Label = new JLabel("-copyright");
	Mkiso_Copy_Label.setForeground(Color.black);
	Mkiso_Copy_Label.setBackground(Color.gray);
 	panel5.add(Mkiso_Copy_Label);

 	Mkiso_Copy = new JTextField(8);
 	Mkiso_Copy.setEditable(true);
 	Mkiso_Copy.setForeground(Color.black);
 	Mkiso_Copy.setBackground(Color.white);
 	panel5.add(Mkiso_Copy);
	
	Mkiso_SysID_Label = new JLabel("-sysid");
	Mkiso_SysID_Label.setForeground(Color.black);
	Mkiso_SysID_Label.setBackground(Color.gray);
 	panel5.add(Mkiso_SysID_Label);

 	Mkiso_SysID = new JTextField(8);
 	Mkiso_SysID.setEditable(true);
 	Mkiso_SysID.setForeground(Color.black);
 	Mkiso_SysID.setBackground(Color.white);
 	panel5.add(Mkiso_SysID);
	
	Mkiso_VolSet_Label = new JLabel("-volset");
	Mkiso_VolSet_Label.setForeground(Color.black);
	Mkiso_VolSet_Label.setBackground(Color.gray);
 	panel5.add(Mkiso_VolSet_Label);

 	Mkiso_VolSet = new JTextField(8);
 	Mkiso_VolSet.setEditable(true);
 	Mkiso_VolSet.setForeground(Color.black);
 	Mkiso_VolSet.setBackground(Color.white);
 	panel5.add(Mkiso_VolSet);
	
	Mkiso_o_Label = new JLabel("-o");
	Mkiso_o_Label.setForeground(Color.black);
	Mkiso_o_Label.setBackground(Color.gray);
 	panel6.add(Mkiso_o_Label);

 	Mkiso_o = new JTextField(15);
 	Mkiso_o.setEditable(true);
 	Mkiso_o.setForeground(Color.black);
 	Mkiso_o.setBackground(Color.white);
 	panel6.add(Mkiso_o);
 	String s = new String("");
 	s = s.concat(settings.getTmp());
 	s = s.concat("/image.iso");
 	Mkiso_o.setText(s);
	
	Mkiso_x_Label = new JLabel("-x");
	Mkiso_x_Label.setForeground(Color.black);
	Mkiso_x_Label.setBackground(Color.gray);
 	panel6.add(Mkiso_x_Label);

 	Mkiso_x = new JTextField(10);
 	Mkiso_x.setEditable(true);
 	Mkiso_x.setForeground(Color.black);
 	Mkiso_x.setBackground(Color.white);
 	panel6.add(Mkiso_x);
	
 	Mkiso_files = new JTextField(20);
 	Mkiso_files.setEditable(true);
 	Mkiso_files.setForeground(Color.black);
 	Mkiso_files.setBackground(Color.white);
 	panel6.add(Mkiso_files);
 	s = new String(settings.getDflSourcePath());
 	Mkiso_files.setText(s);


	dataPane.add(panel1);
	dataPane.add(panel2);
	dataPane.add(panel3);
	dataPane.add(panel4);
	dataPane.add(panel5);
	dataPane.add(panel6);

	Msinfo_button = new JButton("Get msinfo");
	buttonPane.add(Msinfo_button, BorderLayout.WEST);
	Msinfo_button.addActionListener(this);

	Generate_button = new JButton("Generate Image");
	buttonPane.add(Generate_button, BorderLayout.CENTER);
	Generate_button.addActionListener(this);

	Mount_button = new JButton(" Mount Image ");
	buttonPane.add(Mount_button, BorderLayout.EAST);
	Mount_button.addActionListener(this);

        borderPane2.add(dataPane, BorderLayout.CENTER);
        borderPane.add(label, BorderLayout.NORTH);
        borderPane.add(borderPane2, BorderLayout.CENTER);
        borderPane.add(buttonPane, BorderLayout.SOUTH);

        this.add(borderPane, BorderLayout.NORTH);

	setSettings();
    }

    public void setSettings() {
      String s;

      s = settings.getAdvMki();

      StringTokenizer st = new StringTokenizer(s);
      while (st.hasMoreTokens()) {
	s = st.nextToken();

	if (s.compareTo("-a") == 0) {
	  Mkiso_a.setSelected(true);
	} else if (s.compareTo("-d") == 0) {
	  Mkiso_d.setSelected(true);
	} else if (s.compareTo("-D") == 0) {
	  Mkiso_D.setSelected(true);
	} else if (s.compareTo("-f") == 0) {
	  Mkiso_f.setSelected(true);
	} else if (s.compareTo("-J") == 0) {
	  Mkiso_J.setSelected(true);
	} else if (s.compareTo("-l") == 0) {
	  Mkiso_l.setSelected(true);
	} else if (s.compareTo("-L") == 0) {
	  Mkiso_L.setSelected(true);
	} else if (s.compareTo("-N") == 0) {
	  Mkiso_N.setSelected(true);
	} else if (s.compareTo("-quiet") == 0) {
	  Mkiso_quiet.setSelected(true);
	} else if (s.compareTo("-r") == 0) {
	  Mkiso_r.setSelectedItem("-r");
	} else if (s.compareTo("-R") == 0) {
	  Mkiso_r.setSelectedItem("-R");
	} else if (s.compareTo("-T") == 0) {
	  Mkiso_T.setSelected(true);
	} else if (s.compareTo("-v") == 0) {
	  Mkiso_v.setSelected(true);
	} else if (s.compareTo("-no-split-symlink-components") == 0) {
	  Mkiso_nosym.setSelectedItem("-no-split-symlink-components");
	} else if (s.compareTo("-no-split-symlink-fields") == 0) {
	  Mkiso_nosym.setSelectedItem("-no-split-symlink-fields");
	}
      }
    }

    public String getAdvMki() {
      String tmp;
      String adv = new String("");
    
      if (Mkiso_a.isSelected()) {
	adv = adv.concat("-a ");
      }
      if (Mkiso_d.isSelected()) {
	adv = adv.concat("-d ");
      }
      if (Mkiso_D.isSelected()) {
	adv = adv.concat("-D ");
      }
      if (Mkiso_f.isSelected()) {
	adv = adv.concat("-f ");
      }
      if (Mkiso_J.isSelected()) {
	adv = adv.concat("-J ");
      }
      if (Mkiso_l.isSelected()) {
	adv = adv.concat("-l ");
      }
      if (Mkiso_L.isSelected()) {
	adv = adv.concat("-L ");
      }
      if (Mkiso_N.isSelected()) {
	adv = adv.concat("-N ");
      }
      if (Mkiso_quiet.isSelected()) {
	adv = adv.concat("-quiet ");
      }
      tmp = (String)Mkiso_r.getSelectedItem();
      if (tmp.compareTo(" ") != 0) {
	adv = adv.concat(tmp);
	adv = adv.concat(" ");
      }
      if (Mkiso_T.isSelected()) {
	adv = adv.concat("-T ");
      }
      if (Mkiso_v.isSelected()) {
	adv = adv.concat("-v ");
      }
      tmp = (String)Mkiso_nosym.getSelectedItem();
      if (tmp.compareTo(" ") != 0) {
	adv = adv.concat(tmp);
      }
      return adv;
    }

    public String getBurnString(boolean onTheFly) {
      String tmp;
      String burn = new String("");

      if (Mkiso_a.isSelected()) {
	burn = burn.concat("-a ");
      }
      if (Mkiso_d.isSelected()) {
	burn = burn.concat("-d ");
      }
      if (Mkiso_D.isSelected()) {
	burn = burn.concat("-D ");
      }
      if (Mkiso_f.isSelected()) {
	burn = burn.concat("-f ");
      }
      if (Mkiso_J.isSelected()) {
	burn = burn.concat("-J ");
      }
      if (Mkiso_l.isSelected()) {
	burn = burn.concat("-l ");
      }
      if (Mkiso_L.isSelected()) {
	burn = burn.concat("-L ");
      }
      if (Mkiso_N.isSelected()) {
	burn = burn.concat("-N ");
      }
      if (Mkiso_quiet.isSelected()) {
	burn = burn.concat("-quiet ");
      }
      tmp = (String)Mkiso_r.getSelectedItem();
      if (tmp.compareTo(" ") != 0) {
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      if (Mkiso_T.isSelected()) {
	burn = burn.concat("-T ");
      }
      if (Mkiso_v.isSelected()) {
	burn = burn.concat("-v ");
      }
      tmp = (String)Mkiso_nosym.getSelectedItem();
      if (tmp.compareTo(" ") != 0) {
	burn = burn.concat(tmp);
      }
      tmp = Mkiso_m.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-m ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      tmp = Mkiso_b.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-b ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      tmp = Mkiso_c.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-c ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      tmp = Mkiso_C.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-C ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
	tmp = Mkiso_M.getText();
	burn = burn.concat("-M ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      tmp = Mkiso_A.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-A ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      tmp = Mkiso_p.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-p ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      tmp = Mkiso_P.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-P ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      tmp = Mkiso_V.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-V ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      tmp = Mkiso_Biblio.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-biblio ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      tmp = Mkiso_Copy.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-copyright ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      tmp = Mkiso_SysID.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-sysid ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      tmp = Mkiso_VolSet.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-volset ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      if (onTheFly == false) {
	burn = burn.concat("-o ");
	burn = burn.concat(Mkiso_o.getText());
	burn = burn.concat(" ");
      }
      tmp = Mkiso_x.getText();
      if (tmp.compareTo("") != 0) {
	burn = burn.concat("-x ");
	burn = burn.concat(tmp);
	burn = burn.concat(" ");
      }
      burn = burn.concat(Mkiso_files.getText());

      return burn;
    }

    public String getImageName() {
      return Mkiso_o.getText();
    }

    public void addPath(String s) {
      String tmp;

      if (util.isDirectory(s) == true) {
	tmp = Mkiso_files.getText();
	tmp = tmp.concat(" ");
	tmp = tmp.concat(s);
	Mkiso_files.setText(tmp);
      } else if (util.isISOFile(s) == true) {
	Mkiso_o.setText(s);
      }
    }

    protected void updateScreen() {
      Mkiso_C_Label.setVisible(true);
      Mkiso_C.setVisible(true);
      Mkiso_M_Label.setVisible(true);
      Mkiso_M.setVisible(true);
      parent.updateScreen();
    }

    // Refresh screen
    public void refresh() {

    }

    public void itemStateChanged(ItemEvent event) {
      // If a JComboBox was clicked on, repaint !
      if (event.getSource() instanceof JComboBox) {
	repaint();
      }
    }

    public void actionPerformed(ActionEvent event) {
      if (event.getSource() == Generate_button) {
	String cmd = new String(settings.getMkisofs());
	cmd = cmd.concat(" ");
	cmd = cmd.concat(getBurnString(false));
	ExecuteThread th = new ExecuteThread(cmd);
	cdrecord.setImageName(Mkiso_o.getText());
	ButGenerate = true;
      } else
      if (event.getSource() == Msinfo_button) {
	String magic = new String("");
	
	magic = util.getMagicParameters();
	if (magic.compareTo("") != 0) {
	  Mkiso_C.setText(magic);
	  updateScreen();
	}
	repaint();
      } else
      if (event.getSource() == Mount_button) {
	if (ButGenerate == true) {
	  if (ButMount == false) {
	    // Mount iso-image
	    String command = new String("mount");
	    if (System.getProperty("os.name").compareTo("Linux") == 0) {
	      command = command.concat(" -r -t iso9660 -o loop ");
	    } else {
	      command = command.concat(" -r -F fbk -o type=hsfs /dev/fbk0:");
	    }
	    command = command.concat(Mkiso_o.getText());
	    command = command.concat(" ");
	    command = command.concat(settings.getMnt());
	    ExecuteThread th = new ExecuteThread(command);
	    ButMount = true;
	    Mount_button.setText("Unmount Image");
	  } else {
	    // Unmount iso-image
	    String command = new String("umount");
	    command = command.concat(" ");
	    command = command.concat(settings.getMnt());
	    ExecuteThread th = new ExecuteThread(command);
	    ButMount = false;
	    Mount_button.setText(" Mount Image ");
	  }
	}
      }
    }
}

