/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class NewCDLayout extends JPanel implements ActionListener {
  protected BurnITFrame   parent;

  protected JPanel        borderPane;
  protected JPanel        borderPane2;
  protected JPanel        buttonPane;
  protected JPanel        dataPane;
  protected JLabel        label;

  protected JList         list;
  protected Vector        data;

  protected JButton       ok;

  public NewCDLayout(BurnITFrame p) {
    this.setLayout(new BorderLayout());
    
    parent = p;

    borderPane = new JPanel();
    borderPane.setBorder(new EmptyBorder(5,5,5,5));
    borderPane.setLayout(new BorderLayout());
    
    borderPane2 = new JPanel();
    borderPane2.setBorder(new MatteBorder(1,1,1,1,Color.gray));
    borderPane2.setLayout(new BorderLayout());
    
    label = new JLabel("Choose new CD layout");
    label.setForeground(Color.black);

    buttonPane = new JPanel();
    buttonPane.setBorder(new EmptyBorder(5,5,5,5));
    buttonPane.setLayout(new FlowLayout(FlowLayout.LEFT));
    
    ok = new JButton("Ok");
    ok.addActionListener(this);

    buttonPane.add(ok);

    dataPane = new JPanel();
    dataPane.setBorder(new EmptyBorder(5,5,5,5));
    dataPane.setLayout(new FlowLayout(FlowLayout.LEFT));

    data = new Vector();
    data.addElement(new String("CD-ROM"));
    data.addElement(new String("CD-ROM (image)"));
    data.addElement(new String("Multisession"));
    data.addElement(new String("Audio CD"));
    data.addElement(new String("Disc-2-Disc"));
    data.addElement(new String("Mixed Mode CD"));
    data.addElement(new String("Mixed Mode CD (image)"));
    data.addElement(new String("Advanced"));

    list = new JList(data);

    dataPane.add(list);

    borderPane2.add(dataPane, BorderLayout.CENTER);
    borderPane.add(label, BorderLayout.NORTH);
    borderPane.add(borderPane2, BorderLayout.CENTER);
    borderPane.add(buttonPane, BorderLayout.SOUTH);
    
    this.add(borderPane, BorderLayout.NORTH);
  }

  // Refresh screen
  public void refresh() {
    repaint();
  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == ok) {
      int newLayout;
      String s;

      try {
	s = (String)list.getSelectedValue();
	
	if (s.compareTo("CD-ROM") == 0) {
	  newLayout = BurnITFrame.isCDROM;
	} else if (s.compareTo("CD-ROM (image)") == 0) {
	  newLayout = BurnITFrame.isCDROM_wImage;
	} else if (s.compareTo("Multisession") == 0) {
	  newLayout = BurnITFrame.isMultisessionCD;
	} else if (s.compareTo("Audio CD") == 0) {
	  newLayout = BurnITFrame.isAudio;
	} else if (s.compareTo("Disc-2-Disc") == 0) {
	  newLayout = BurnITFrame.isCDCopy;
	} else if (s.compareTo("Mixed Mode CD") == 0) {
	  newLayout = BurnITFrame.isMixedModeCD;
	} else if (s.compareTo("Mixed Mode CD (image)") == 0) {
	  newLayout = BurnITFrame.isMixedModeCD_wImage;
	} else {
	  newLayout = BurnITFrame.isAdvanced;
	}
	parent.setState(newLayout);
      } catch (Exception exp) {
      }
    }
  }
}

