/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

class SelectDevice extends JFrame implements ItemListener, ActionListener {
  protected BurnITFrame  parent; 
  protected JPanel       dataPane;
  protected JPanel       devicePane;
  protected JPanel       namePane;
  protected JPanel       typePane;
  protected JPanel       typePane2;
  protected JPanel       typePane3;
  protected JPanel       typePane4;
  protected JPanel       buttonPane;
  protected JButton      ok;
  protected JButton      cancel;
  protected JTextField   comments;
  protected JTabbedPane  tab;
  protected JTable       deviceTable;
  protected JScrollPane  scrollDevicePane;
  protected Vector       tableData;
  protected Vector       names;
  protected JList        nameList;
  protected JScrollPane  scrollNamePane;

  protected JRadioButton cdr;
  protected JRadioButton cdrw;
  protected JRadioButton dvdr;
  protected ButtonGroup  buttonGroup;

  protected RdComboBox   ReadSpeed;
  protected WrComboBox   WriteSpeed;
  protected WrComboBox   EraseSpeed;
  protected JLabel       EraseSpeedLabel;
  protected JLabel       ReadSpeedLabel;
  protected JLabel       WriteSpeedLabel;

  protected JPanel       adv;
  protected JPanel       adv_panel1;
  protected JPanel       adv_panel2;
  protected JButton      adv_button;
  protected JLabel       adv_device;
  protected JTextField   adv_field;
  protected JLabel       adv_number;
  protected JTextField   adv_num;
  protected boolean      adv_option;

  protected Utils        utils;
  protected Settings     settings;

  protected final String[] supported = {
    "Generic CD-ROM",
    "Generic mmc CD-ROM",
    "Generic mmc CD-R",
    "Generic mmc CD-RW",
    "Generic mmc2 DVD",
    "ACER CR-1420C",
    "ACER CDRW 6206A",
    "BTC BCE 621E",
    "COMPRO CW-7502",
    "Dysan CR-622",
    "Dysan CR-1622",
    "DynaTec CDM-240J",
    "DynaTec CDM-240",
    "DynaTec CDM-400",
    "Grundig CDR-100",
    "Hewlett Packard 4020i",
    "Hewlett Packard 6020i",
    "HP C4324/C4325",
    "HP 7100",
    "HP 7110",
    "HP 7200",
    "HP 8100",
    "Hi-Val CD-R",
    "JVC XR-W2001",
    "JVC XR-W2010",
    "JVC XR-W2020",
    "JVC XR-W2080",
    "Kodak PCD-200",
    "Kodak PCD-200 Plus",
    "Kodak PCD-225",
    "Kodak PCD-240",
    "Kodak PCD-600",
    "Matsushita CW-7502",
    "Matsushita CW-7582",
    "Memorex CR-622",
    "Memorex CR-1622",
    "Memorex CRW-1622",
    "Microboards PlayWrite 2000",
    "Microboards PlayWrite 4000",
    "Microboards PlayWrite 4001RW",
    "MicroNet MasterCD Plus 4x4",
    "MicroNet MasterCD Plus 4x6",
    "Mitsubishi MCA-CDRW 226", 
    "Mitsumi CR-2401-TS",
    "Mitsumi CR-2600-TE",
    "Mitsumi CR-2801",
    "Mitsumi CR-4801",
    "Nomai 680.rw",
    "Olympus CDS615E",
    "Olympus CDS620E",
    "Olympus CD-R2x6",
    "Optima Dis Kovery 650 CD-R",
    "OTI CDRW 965",
    "Panasonic CW-7502",
    "Panasonic CW-7582",
    "Philips CDD-521",
    "Philips CDD-522",
    "Philips CDD-2000",
    "Philips CDD-2600",
    "Philips CDD-3600",
    "Philips CDD-3610",
    "Philips Omniwriter 26",
    "Philips Omniwriter 26A",
    "Pinnacle Micro RCD-1000",
    "Pinnacle Micro RCD-5020",
    "Pinnacle Micro RCD-5040",
    "Pinnacle Micro RCD-4x4",
    "Pioneer DW-S114X",
    "Plasmon CDR 4220",
    "Plasmon RF-4100",
    "Plasmon RF-4102",
    "Plasmon CDR 4400",
    "Plasmon CDR 480",
    "Plextor PX-R24CS",
    "Plextor PX-R412C",
    "Plextor PX-R820C",
    "Procom PCDR 4",
    "Ricoh RO-1420C",
    "Ricoh MP-6200",
    "Ricoh MP-6200I",
    "Ricoh MP-6201",
    "Smart & Friendly CD-R1002",
    "Smart & Friendly CD-R1004",
    "Smart & Friendly CD-R2004",
    "Smart & Friendly CD-R2006 PLUS",
    "Smart & Friendly CD-R2006 PRO",
    "Smart & Friendly CD-R4000",
    "Smart & Friendly CD-R4006",
    "Smart & Friendly CD-R4012",
    "Smart & Friendly CD-R8020",
    "Smart & Friendly CD-RW226",
    "Sony CDU920S",
    "Sony CDU924S",
    "Sony CDU926S",
    "Sony CDU928",
    "Sony CDU940S",
    "Sony CDU948S",
    "Sony CRX-100",
    "Taiyo Yuden CD-WO EW-50",
    "TEAC CD-R50S",
    "TEAC CD-R55S",
    "TEAC CD-R56S",
    "That's Write CDR-N820S",
    "Traxdata CDRW2260+",
    "Traxdata CDR-4120",
    "Traxdata CDRW-4260",
    "Turtle Beach 2040R",
    "Wearnes CD-R622",
    "Wearnes CD-R632P",
    "Yamaha CDR-100",
    "Yamaha CDR-102",
    "Yamaha CDR-200",
    "Yamaha CDR-400",
    "Yamaha CDR-401",
    "Yamaha CRW-2260",
    "Yamaha CRW-4001",
    "Yamaha CRW-4260",
    "Yamaha CRW-4416"
  };

  public SelectDevice(BurnITFrame p, Settings set, Utils utl) {
    String s;

    parent = p;
    settings = set;

    utils = utl;

    this.setTitle("Select CD-writer");

    updateScreen();

    this.getContentPane().setLayout(new BorderLayout()); 

    dataPane = new JPanel();
    dataPane.setLayout(new BorderLayout());

    devicePane = new JPanel();
    devicePane.setLayout(new BorderLayout());

    tableData = utils.getSCSIDevices();

    names = new Vector();
    names.addElement(new String("SCSI ID"));
    names.addElement(new String("Vendor"));
    names.addElement(new String("Identifikation"));
    names.addElement(new String("Revision"));
    names.addElement(new String("Drive ID"));

    TableModel tableModel = new AbstractTableModel() {
      public int getColumnCount() { 
	return names.size();
      }
      public int getRowCount() {
	return tableData.size();
      }
      public Object getValueAt(int row, int col) {
	Vector tmp; 
	tmp = (Vector)tableData.elementAt(row);
	return tmp.elementAt(col);
      }
      public String getColumnName(int column) {
	return (String)names.elementAt(column);
      }
      public Class getColumnClass(int c) {
	return getValueAt(0, c).getClass();
      }
      public boolean isCellEditable(int row, int col) {
	return false;
      }
      public void setValueAt(Object aValue, int row, int column) { 
	Vector tmp;
	tmp = (Vector)tableData.elementAt(row);
	tmp.setElementAt(aValue,column);
	tableData.setElementAt(tmp,row);
      }
   };

    deviceTable = new JTable(tableData,names);
    deviceTable.setModel(tableModel);
    deviceTable.getTableHeader().setReorderingAllowed(false);
    deviceTable.setSelectionMode(0);

    scrollDevicePane = new JScrollPane(deviceTable);
 
    devicePane.add(scrollDevicePane, BorderLayout.CENTER);
    
    String result;
    for (int i=0; i < deviceTable.getRowCount(); i++) {
      result = (String)deviceTable.getValueAt(i,0);
      if (result.compareTo(settings.getWrDevNumber()) == 0) {
	deviceTable.setRowSelectionInterval(i,i);
      }
    }

    MouseListener mouseListenerDeviceTable = new MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
	if (e.getClickCount() == 1) {
	  updateNameList();
	  comments.setText(getComments());
	}
      }
    };
    deviceTable.addMouseListener(mouseListenerDeviceTable);

    adv_option = false;

    adv = new JPanel();
    adv.setLayout(new GridLayout(1,2));

    adv_panel1 = new JPanel();
    adv_panel1.setLayout(new FlowLayout(FlowLayout.LEFT));

    adv_device = new JLabel("Device number");
    adv_device.setForeground(Color.black);
    adv_device.setVisible(false);

    adv_field = new JTextField(5);
    adv_field.setText(settings.getWrDevNumber());
    adv_field.setVisible(false);

    adv_number = new JLabel("CD number");
    adv_number.setForeground(Color.black);
    adv_number.setVisible(false);

    s = new String(settings.getWrGen());
    s = s.substring(s.length()-1);
    adv_num = new JTextField(2);
    adv_num.setText(s);
    adv_num.setVisible(false);

    adv_panel1.add(adv_device);
    adv_panel1.add(adv_field);
    adv_panel1.add(adv_number);
    adv_panel1.add(adv_num);

    adv_panel2 = new JPanel();
    adv_panel2.setLayout(new FlowLayout(FlowLayout.RIGHT));

    adv_button = new JButton("Advanced");
    adv_button.addActionListener(this);

    adv_panel2.add(adv_button);

    adv.add(adv_panel1);
    adv.add(adv_panel2);

    devicePane.add(adv, BorderLayout.SOUTH);

    namePane = new JPanel();
    namePane.setLayout(new BorderLayout());
    
    nameList = new JList();
    nameList.setListData(supported);

    scrollNamePane = new JScrollPane(nameList);

    MouseListener mouseListenerNameList = new MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
	if (e.getClickCount() == 1) {
	  comments.setText(getComments());
	}
      }
    };
    nameList.addMouseListener(mouseListenerNameList);

    comments = new JTextField();
    comments.setText(settings.getComment());

    namePane.add(scrollNamePane, BorderLayout.CENTER);
    namePane.add(comments, BorderLayout.SOUTH);
    
    nameList.setSelectedValue(settings.getWrModel(),true);

    typePane = new JPanel();
    typePane.setLayout(new BorderLayout());
    typePane.setBorder(new EmptyBorder(5,5,5,5));

    typePane3 = new JPanel();
    typePane3.setLayout(new BorderLayout());

    typePane4 = new JPanel();
    typePane4.setLayout(new GridLayout(3,2));

    ReadSpeedLabel = new JLabel("Read speed ");
    ReadSpeedLabel.setForeground(Color.black);
    typePane4.add(ReadSpeedLabel);

    ReadSpeed = new RdComboBox();
    ReadSpeed.setSelectedItem(settings.getWrRead()); 
    typePane4.add(ReadSpeed);

    WriteSpeedLabel = new JLabel("Write speed");
    WriteSpeedLabel.setForeground(Color.black);
    typePane4.add(WriteSpeedLabel);

    WriteSpeed = new WrComboBox();
    WriteSpeed.setSelectedItem(settings.getWrWrite());
    typePane4.add(WriteSpeed);

    EraseSpeedLabel = new JLabel("Erase speed");
    EraseSpeedLabel.setForeground(Color.black);
    typePane4.add(EraseSpeedLabel);

    EraseSpeed = new WrComboBox();
    EraseSpeed.setSelectedItem(settings.getWrErase());
    typePane4.add(EraseSpeed);

    result = settings.getType();
    if (result.compareTo("CD-RW") != 0) {
      EraseSpeedLabel.setEnabled(false);
      EraseSpeed.setEnabled(false);
    }

    typePane3.add(typePane4,BorderLayout.NORTH);

    typePane2 = new JPanel();
    typePane2.setLayout(new GridLayout(3,1));

    buttonGroup = new ButtonGroup();
    cdr = new JRadioButton("CD-R",true);
    cdr.addItemListener(this);
    buttonGroup.add(cdr);
    cdrw = new JRadioButton("CD-RW");
    cdrw.addItemListener(this);
    buttonGroup.add(cdrw);
    dvdr = new JRadioButton("DVD-R");
    dvdr.addItemListener(this);
    buttonGroup.add(dvdr);

    typePane2.add(cdr);
    typePane2.add(cdrw);
    typePane2.add(dvdr);

    result = settings.getType();
    if (result.compareTo("CD-R") == 0) {
      cdr.setSelected(true);
    } else if (result.compareTo("CD-RW") == 0) {
      cdrw.setSelected(true);
    } else {
      dvdr.setSelected(true);
    }

    typePane.add(typePane2,BorderLayout.NORTH);
    typePane.add(typePane3,BorderLayout.CENTER);

    tab = new JTabbedPane();

    tab.addTab("Device",devicePane);
    tab.addTab("Name",namePane);
    tab.addTab("Type",typePane);

    dataPane.add(tab, BorderLayout.CENTER);

    buttonPane = new JPanel();
    buttonPane.setLayout(new BorderLayout());
    buttonPane.setBorder(new EmptyBorder(5,5,5,5));

    ok = new JButton("OK");
    ok.addActionListener(this);
    buttonPane.add(ok, BorderLayout.EAST);

    cancel = new JButton("Cancel");
    cancel.addActionListener(this);
    buttonPane.add(cancel, BorderLayout.WEST);

    this.getContentPane().add(dataPane, BorderLayout.CENTER);
    this.getContentPane().add(buttonPane, BorderLayout.SOUTH);

    this.setVisible(true);
  }

  private void updateScreen() {
    pack();
    setSize(new Dimension(550,300));
    repaint();
  }

  protected void updateNameList() {
    String result;
    if (deviceTable.getSelectedRow() != -1) {
      result = (String)deviceTable.getValueAt(deviceTable.getSelectedRow(),4);
      nameList.setSelectedValue(result,true);
    }
  }

  protected String getComments(){
    String comment = new String("");
    String result;

    if (nameList.getSelectedIndex() != -1) {
      result = (String)nameList.getSelectedValue();
      if (result.compareTo("DynaTec CDM-240J") == 0) {
	comment = comment.concat("use driver=teac_cdr50");
      } else if (result.compareTo("DynaTec CDM-240") == 0) {
	comment = comment.concat("use driver=yamaha_cdr100");
      } else if (result.compareTo("DynaTec CDM-400") == 0) {
	comment = comment.concat("use driver=yamaha_cdr100");
      } else if (result.compareTo("Hi-Val CD-R") == 0) {
	comment = comment.concat("use driver=teac_cdr50");
      } else if (result.compareTo("JVC XR-W2001") == 0) {
	comment = comment.concat("uses TEAC alpha code - audio not working");
      } else if (result.compareTo("JVC XR-W2010") == 0) {
	comment = comment.concat("uses TEAC alpha code - audio not working");
      } else if (result.compareTo("JVC XR-W2020") == 0) {
	comment = comment.concat("uses TEAC alpha code - audio not working");
      } else if (result.compareTo("Microboards PlayWrite 2000") == 0) {
	comment = comment.concat("use driver=sony_cdu924");
      } else if (result.compareTo("Microboards PlayWrite 4000") == 0) {
	comment = comment.concat("use driver=yamaha_cdr100");
      } else if (result.compareTo("MicroNet MasterCD Plus 4x4") == 0) {
	comment = comment.concat("use driver=yamaha_cdr100");
      } else if (result.compareTo("Olympus CDS620E") == 0) {
	comment = comment.concat("use driver=sony_cdu924");
      } else if (result.compareTo("Olympus CD-R2x6") == 0) {
	comment = comment.concat("use driver=sony_cdu924");
      } else if (result.compareTo("Optima Dis Kovery 650 CD-R") == 0) {
	comment = comment.concat("use driver=sony_cdu924");
      } else if (result.compareTo("Philips CDD-521") == 0) {
	comment = comment.concat("use revision: 2.07");
      } else if (result.compareTo("Pinnacle Micro RCD-1000") == 0) {
	comment = comment.concat("uses TEAC alpha code : Need to upgrade firmware to 2.35");
      } else if (result.compareTo("Pinnacle Micro RCD-5020") == 0) {
	comment = comment.concat("uses TEAC alpha code - audio not working");
      } else if (result.compareTo("Pinnacle Micro RCD-5040") == 0) {
	comment = comment.concat("uses TEAC alpha code - audio not working");
      } else if (result.compareTo("Plasmon CDR 4220") == 0) {
	comment = comment.concat("not tested");
      } else if (result.compareTo("Plasmon CDR 4400") == 0) {
	comment = comment.concat("use driver=yamaha_cdr100");
      } else if (result.compareTo("Plextor PX-R24CS") == 0) {
	comment = comment.concat("use driver=ricoh_ro1420c");
      } else if (result.compareTo("Procom PCDR 4") == 0) {
	comment = comment.concat("use driver=yamaha_cdr100");
      } else if (result.compareTo("Smart & Friendly CD-R1002") == 0) {
	comment = comment.concat("use driver=sony_cdu924");
      } else if (result.compareTo("Smart & Friendly CD-R1004") == 0) {
	comment = comment.concat("use driver=yamaha_cdr100");
      } else if (result.compareTo("Smart & Friendly CD-R2004") == 0) {
	comment = comment.concat("use driver=sony_cdu924");
      } else if (result.compareTo("Smart & Friendly CD-R4000") == 0) {
	comment = comment.concat("use driver=yamaha_cdr100");
      } else if (result.compareTo("Turtle Beach 2040R") == 0) {
	comment = comment.concat("use driver=ricoh_ro1420c");
      } else if (result.compareTo("Yamaha CDR-400") == 0) {
	comment = comment.concat("use firmware revision 1.0d and up");
      }
    }
    return comment;
  }

  public void itemStateChanged(ItemEvent event) {
    // If a JRadioButton was clicked on ...
    if ((event.getSource() == cdr)||(event.getSource() == cdrw)||
	(event.getSource() == dvdr)) {
      if (cdrw.isSelected()) {
	EraseSpeedLabel.setEnabled(true);
	EraseSpeed.setEnabled(true);
      } else {
	EraseSpeedLabel.setEnabled(false);
	EraseSpeed.setEnabled(false);
      }
      repaint();
    }
  }

  private boolean checkSetup() {
    String s = new String("");
    boolean result = true;

    if (adv_option == false) {
      if (deviceTable.getSelectedRow() == -1) {
	result = false;
	s = new String("Please choose device");
      }
    } else {
      if (adv_field.getText().compareTo("") == 0) {
	result = false;
	s = new String("Please choose device");
      } else
      if (adv_num.getText().compareTo("") == 0) {
	result = false;
	s = new String("Please choose CD number");
      }
    }

    if (result == false) {
      JOptionPane f = new JOptionPane();
      f.showMessageDialog(this,s,"BurnIT: Error", JOptionPane.ERROR_MESSAGE);
    }

    return result;
  }

  public void actionPerformed(ActionEvent e) {
    // The OK button was clicked on, handle it ...
    if (e.getSource() == ok) {
      if (checkSetup()) {
	String s = new String("");
	String comment = new String("");
	String number = new String("");
	String str;
	
	if (adv_option == false) {
	  settings.setWrDevNumber((String)deviceTable.getValueAt(deviceTable.getSelectedRow(),0));
	  number = new Integer(deviceTable.getSelectedRow()).toString();
	} else {
	  settings.setWrDevNumber(adv_field.getText());
	  number = new String(adv_num.getText());
	}
	settings.setWrModel((String)nameList.getSelectedValue()); 
	
	str = new String("/dev/scd");
	str = str.concat(number);
	settings.setWrDev(str);
	
	str = new String("/dev/sr");
	str = str.concat(number);
	settings.setWrGen(str);
	
	if (cdr.isSelected() == true) {
	  settings.setType("CD-R");
	} else if (cdrw.isSelected() == true) {
	  settings.setType("CD-RW");
	} else {
	  settings.setType("DVD-R");
	}
	
	s = comments.getText();
	StringTokenizer st = new StringTokenizer(s);
	while (st.hasMoreTokens()) {
	  s = st.nextToken();
	  if (s.startsWith("driver")) {
	    comment = comment.concat(s);
	  }
	}
	settings.setComment(comment);
	settings.setWrRead((String)ReadSpeed.getSelectedItem());
	settings.setWrWrite((String)WriteSpeed.getSelectedItem());
	settings.setWrErase((String)EraseSpeed.getSelectedItem());
	parent.setDeviceName();
	setVisible(false);
	dispose();
      }
    // The CANCEL button was clicked on, handle it ...
    } else if (e.getSource() == cancel) {
      setVisible(false);
      dispose();
    // The ADVANCED button was clicked on, handle it ...
    } else if (e.getSource() == adv_button) {
      if (adv_option == false) {
	adv_option = true;
	adv_device.setVisible(true);
	adv_field.setVisible(true);
	adv_number.setVisible(true);
	adv_num.setVisible(true);
      } else {
	adv_option = false;
	adv_device.setVisible(false);
	adv_field.setVisible(false);
	adv_number.setVisible(false);
	adv_num.setVisible(false);
      }
      updateScreen();
    }
  }
}
