/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import java.io.*;
import java.util.*;
import com.sun.java.swing.*;

class Settings {
  protected String   version;

  protected String   wrDevNumber;
  protected String   wrModel;
  protected String   wrDev;
  protected String   wrGen;
  protected String   type;
  protected String   com;
  protected String   wrRead;
  protected String   wrWrite;
  protected String   wrErase;

  protected String   rdDevNumber;
  protected String   rdModel;
  protected String   rdDev;
  protected String   rdGen;
  protected String   rdRead;

  protected String   mnt;
  protected String   tmp;
  protected String   spath;
  protected String   fs;

  protected String   advcdr;
  protected String   advmki;
  protected String   cdrecord;
  protected String   mkisofs;
  protected String   mkhybrid;
  protected String   audiorip;
  protected boolean  riptype;
  protected String   cdrplayer;
  protected String   wavplayer;
  protected String   mp3player;
  protected boolean  user;
  protected String   encoder;
  protected boolean  encodertype;
  protected String   decoder;

  protected ReadTextFile  rf;
  protected WriteTextFile wf;

  public Settings() {
    version = new String("");
    
    wrDevNumber = new String("");
    wrModel = new String("");
    wrDev = new String("");
    wrGen = new String("");
    type = new String("");
    com = new String("");
    wrRead = new String("");
    wrWrite = new String("");
    wrErase = new String("");
    
    rdDevNumber = new String("");
    rdModel = new String("");
    rdDev = new String("");
    rdGen = new String("");
    rdRead = new String("");
    
    mnt = new String("");
    tmp = new String("");
    spath = new String("");
    fs = new String("");
    
    advcdr = new String("");
    advmki = new String("");
    cdrecord = new String("");
    mkisofs = new String("");
    mkhybrid = new String("");
    audiorip = new String("");
    riptype = true;
    cdrplayer = new String("");
    wavplayer = new String("");
    mp3player = new String("");
    user = false;
    encoder = new String("");
    decoder = new String("");
    encodertype = true;

    //System.out.println("Settings");
    loadSettings();
  }

  /** Load settings */
  public void loadSettings() {
    String s = new String();

    try {
      rf = new ReadTextFile(getConfigFileName());
      
      s = rf.readLine();
      while (s.compareTo("") != 0) {
	if (s.startsWith("WRITER=") == true) {
	  StringTokenizer st = new StringTokenizer(s.substring(7),"|");
	  wrDevNumber = st.nextToken();
	  wrModel = st.nextToken();
	  wrDev = st.nextToken();
	  wrGen = st.nextToken();
	} else if (s.startsWith("COM=") == true) {
	  com = new String(s.substring(4));
	} else if (s.startsWith("TYPE=") == true) {
	  type = new String(s.substring(5));
	} else if (s.startsWith("WRREAD=") == true) {
	  wrRead = new String(s.substring(7));
	} else if (s.startsWith("WRWRITE=") == true) {
	  wrWrite = new String(s.substring(8));
	} else if (s.startsWith("WRERASE=") == true) {
	  wrErase = new String(s.substring(8));
	} else if (s.startsWith("READER=") == true) {
	  StringTokenizer st = new StringTokenizer(s.substring(7),"|");
	  rdDevNumber = st.nextToken();
	  rdModel = st.nextToken();
	  rdDev = st.nextToken();
	  rdGen = st.nextToken();
	} else if (s.startsWith("RDREAD=") == true) {
	  rdRead = new String(s.substring(7));
	} else if (s.startsWith("MNT=") == true) {
	  mnt = new String(s.substring(4));
	} else if (s.startsWith("TMP=") == true) {
	  tmp = new String(s.substring(4));
	} else if (s.startsWith("SPATH=") == true) {
	  spath = new String(s.substring(6));
	} else if (s.startsWith("VERSION=") == true) {
	  version = new String(s.substring(8));
	} else if (s.startsWith("ADVCDR=") == true) {
	  advcdr = new String(s.substring(7));
	} else if (s.startsWith("ADVMKI=") == true) {
	  advmki = new String(s.substring(7));
	} else if (s.startsWith("FS=") == true) {
	  fs = new String(s.substring(3));
	} else if (s.startsWith("CDRECORD=") == true) {
	  cdrecord = new String(s.substring(9));
	} else if (s.startsWith("MKISOFS=") == true) {
	  mkisofs = new String(s.substring(8));
	} else if (s.startsWith("MKHYBRID=") == true) {
	  mkhybrid = new String(s.substring(9));
	} else if (s.startsWith("AUDIORIP=") == true) {
	  audiorip = new String(s.substring(9));
	} else if (s.startsWith("RIPTYPE=") == true) {
	  s = s.substring(8);
	  if (s.compareTo("NO") == 0) {
	    riptype = false;
	  } else {
	    riptype = true;
	  }
	} else if (s.startsWith("CDRPLAYER=") == true) {
	  cdrplayer = new String(s.substring(10));
	} else if (s.startsWith("WAVPLAYER=") == true) {
	  wavplayer = new String(s.substring(10));
	} else if (s.startsWith("MP3PLAYER=") == true) {
	  mp3player = new String(s.substring(10));
	} else if (s.startsWith("USER=") == true) {
	  s = s.substring(5);
	  if (s.compareTo("YES") == 0) {
	    user = true;
	  } else {
	    user = false;
	  }
	} else if (s.startsWith("ENCODER=") == true) {
	  encoder = new String(s.substring(8));
	} else if (s.startsWith("ENCTYPE=") == true) {
	  s = s.substring(8);
	  if (s.compareTo("NO") == 0) {
	    encodertype = false;
	  } else {
	    encodertype = true;
	  }
	} else if (s.startsWith("DECODER=") == true) {
	  decoder = new String(s.substring(8));
	}
	s = rf.readLine();
      }
      rf.close();
    } catch (Exception e) {
      System.err.println("Settings: I/O error");
      System.err.println(s);
      System.exit(1);
    }
  }

  /** Save settings */
  public void saveSettings() {
    String s = new String("");

    try {
      wf = new WriteTextFile(getConfigFileName());

      s = new String("VERSION=");
      s = s.concat(getConfigVersion());
      wf.writeLine(s);

      s = new String("WRITER=");
      s = s.concat(getWrDevNumber());
      s = s.concat("|");
      s = s.concat(getWrModel());
      s = s.concat("|");
      s = s.concat(getWrDev());
      s = s.concat("|");
      s = s.concat(getWrGen());
      s = s.concat("|");
      wf.writeLine(s);

      s = new String("TYPE=");
      s = s.concat(getType());
      wf.writeLine(s);

      s = new String("COM=");
      s = s.concat(getComment());
      wf.writeLine(s);

      s = new String("WRREAD=");
      s = s.concat(getWrRead());
      wf.writeLine(s);

      s = new String("WRWRITE=");
      s = s.concat(getWrWrite());
      wf.writeLine(s);

      s = new String("WRERASE=");
      s = s.concat(getWrErase());
      wf.writeLine(s);

      s = new String("READER=");
      s = s.concat(getRdDevNumber());
      s = s.concat("|");
      s = s.concat(getRdModel());
      s = s.concat("|");
      s = s.concat(getRdDev());
      s = s.concat("|");
      s = s.concat(getRdGen());
      s = s.concat("|");
      wf.writeLine(s);

      s = new String("RDREAD=");
      s = s.concat(getRdRead());
      wf.writeLine(s);

      s = new String("MNT=");
      s = s.concat(getMnt());
      wf.writeLine(s);

      s = new String("TMP=");
      s = s.concat(getTmp());
      wf.writeLine(s);

      s = new String("SPATH=");
      s = s.concat(getDflSourcePath());
      wf.writeLine(s);

      s = new String("FS=");
      s = s.concat(getFileSystem());
      wf.writeLine(s);

      s = new String("USER=");
      if (getAdvancedUser()) {
	s = s.concat("YES");
      } else {
	s = s.concat("NO");
      }
      wf.writeLine(s);

      s = new String("ADVCDR=");
      s = s.concat(getAdvCdr());
      wf.writeLine(s);

      s = new String("ADVMKI=");
      s = s.concat(getAdvMki());
      wf.writeLine(s);

      s = new String("CDRECORD=");
      s = s.concat(getCdrecord());
      wf.writeLine(s);

      s = new String("MKISOFS=");
      s = s.concat(getMkisofs());
      wf.writeLine(s);

      s = new String("MKHYBRID=");
      s = s.concat(getMkhybrid());
      wf.writeLine(s);

      s = new String("AUDIORIP=");
      s = s.concat(getAudioRip());
      wf.writeLine(s);

      s = new String("RIPTYPE=");
      if (getRipType()) {
	s = s.concat("YES");
      } else {
	s = s.concat("NO");
      }
      wf.writeLine(s);

      s = new String("CDRPLAYER=");
      s = s.concat(getCDRPlayer());
      wf.writeLine(s);

      s = new String("WAVPLAYER=");
      s = s.concat(getWAVPlayer());
      wf.writeLine(s);

      s = new String("MP3PLAYER=");
      s = s.concat(getMP3Player());
      wf.writeLine(s);

      s = new String("ENCODER=");
      s = s.concat(getEncoder());
      wf.writeLine(s);

      s = new String("ENCTYPE=");
      if (getEncoderType()) {
	s = s.concat("YES");
      } else {
	s = s.concat("NO");
      }
      wf.writeLine(s);

      s = new String("DECODER=");
      s = s.concat(getDecoder());
      wf.writeLine(s);

      wf.close();
    } catch (IOException e) {
      JOptionPane f = new JOptionPane();

      f.showMessageDialog(null,"Access denied to BurnIT.ini", 
			  "BurnIT: Write error", JOptionPane.ERROR_MESSAGE);
    } catch (Exception e) {
      System.err.println("Settings: Exception (saveSettings)");
      System.err.println(s);
    }
  }

  /** Get the init file name */
  public String getConfigFileName() {
    String s = new String("BurnIT.ini");
    return s;
  }

  /** Set config version */
  public void setConfigVersion(String s) {
    version = new String(s);
  }

  /** Get config version */
  public String getConfigVersion() {
    return version;
  }

  /** Get writer device number */
  public String getWrDevNumber() {
    return wrDevNumber;
  }

  /** Set writer device number */
  public void setWrDevNumber(String s) {
    wrDevNumber = new String(s);
  }

  /** Get writer model */
  public String getWrModel() {
    return wrModel;
  }

  /** Set writer model */
  public void setWrModel(String s) {
    wrModel = new String(s);
  }

  /** Get writer device */
  public String getWrDev() {
    return wrDev;
  }

  /** Set writer device */
  public void setWrDev(String s) {
    wrDev = new String(s);
  }

  /** Get writer generic */
  public String getWrGen() {
    return wrGen;
  }

  /** Set writer generic */
  public void setWrGen(String s) {
    wrGen = new String(s);
  }

  /** Get comment for device */
  public String getComment() {
    return com;
  }

  /** Set comment for device */
  public void setComment(String s) {
    com = new String(s);
  }

  /** Get writer read speed */
  public String getWrRead() {
    if (wrRead.compareTo("") == 0) {
      return new String("1");
    }
    return wrRead;
  }

  /** Set writer read speed */
  public void setWrRead(String s) {
    wrRead = new String(s);
  }

  /** Get writer write speed */
  public String getWrWrite() {
    if (wrWrite.compareTo("") == 0) {
      return new String("1");
    }
    return wrWrite;
  }

  /** Set writer write speed */
  public void setWrWrite(String s) {
    wrWrite = new String(s);
  }

  /** Get writer erase speed */
  public String getWrErase() {
    if (wrErase.compareTo("") == 0) {
      return new String("1");
    }
    return wrErase;
  }

  /** Set writer erase speed */
  public void setWrErase(String s) {
    wrErase = new String(s);
  }

  /** Get writer type */
  public String getType() {
    if (type.compareTo("") == 0) {
      return new String("CD-R");
    }
    return type;
  }

  /** Set writer type */
  public void setType(String s) {
    type = new String(s);
  }

  /** Get reader device number */
  public String getRdDevNumber() {
    return rdDevNumber;
  }

  /** Set reader device number */
  public void setRdDevNumber(String s) {
    rdDevNumber = new String(s);
  }

  /** Get reader model */
  public String getRdModel() {
    return rdModel;
  }

  /** Set reader model */
  public void setRdModel(String s) {
    rdModel = new String(s);
  }

  /** Get reader device */
  public String getRdDev() {
    return rdDev;
  }

  /** Set reader device */
  public void setRdDev(String s) {
    rdDev = new String(s);
  }

  /** Get reader generic */
  public String getRdGen() {
    return rdGen;
  }

  /** Set reader generic */
  public void setRdGen(String s) {
    rdGen = new String(s);
  }

  /** Get reader read speed */
  public String getRdRead() {
    if (rdRead.compareTo("") == 0) {
      return new String("1");
    }
    return rdRead;
  }

  /** Set reader read speed */
  public void setRdRead(String s) {
    rdRead = new String(s);
  }

  /** Get mount-point */
  public String getMnt() {
    if (mnt.compareTo("") == 0) {
      return new String("/mnt");
    }
    return mnt;
  }

  /** Set mount-point */
  public void setMnt(String s) {
    mnt = new String(s);
  }

  /** Get tmp directory */
  public String getTmp() {
    if (tmp.compareTo("") == 0) {
      return new String("/tmp");
    }
    return tmp;
  }

  /** Set tmp directory */
  public void setTmp(String s) {
    tmp = new String(s);
  }

  /** Get default source path */
  public String getDflSourcePath() {
    return spath;
  }

  /** Set default source path */
  public void setDflSourcePath(String s) {
    spath = new String(s);
  }

  /** Get advanced cdrecord options */
  public String getAdvCdr() {
    return advcdr;
  }

  /** Set advanced cdrecord options */
  public void setAdvCdr(String s) {
    advcdr = new String(s);
  }

  /** Get advanced mkisofs options */
  public String getAdvMki() {
    return advmki;
  }

  /** Set advanced mkisofs options */
  public void setAdvMki(String s) {
    advmki = new String(s);
  }

  /** Get default file system */
  public String getFileSystem() {
    return fs;
  }

  /** Set default file system */
  public void setFileSystem(String s) {
    fs = new String(s);
  }

  /** Get CDRECORD base */
  public String getCdrecord() {
    if (cdrecord.compareTo("") == 0) {
      return new String("./cdrecord");
    }
    return cdrecord;
  }

  /** Set CDRECORD base */
  public void setCdrecord(String s) {
    cdrecord = new String(s);
  }

  /** Get MKISOFS base */
  public String getMkisofs() {
    if (mkisofs.compareTo("") == 0) {
      return new String("./mkisofs");
    }
    return mkisofs;
  }

  /** Set MKISOFS base */
  public void setMkisofs(String s) {
    mkisofs = new String(s);
  }

  /** Get MKHYBRID base */
  public String getMkhybrid() {
    return mkhybrid;
  }

  /** Set MKHYBRID base */
  public void setMkhybrid(String s) {
    mkhybrid = new String(s);
  }

  /** Get AUDIORIP base */
  public String getAudioRip() {
    if (audiorip.compareTo("") == 0) {
      return new String("./cdda2wav");
    }
    return audiorip;
  }

  /** Set AUDIORIP base */
  public void setAudioRip(String s) {
    audiorip = new String(s);
  }

  /** Get RIPTYPE */
  public boolean getRipType() {
    return riptype;
  }

  /** Set RIPTYPE */
  public void setRipType(boolean t) {
    riptype = t;
  }

  /** Get CDRPlayer */
  public String getCDRPlayer() {
    if (cdrplayer.compareTo("") == 0) {
      return new String("./play");
    }
    return cdrplayer;
  }

  /** Set CDRPlayer */
  public void setCDRPlayer(String s) {
    cdrplayer = new String(s);
  }

  /** Get WAVPlayer */
  public String getWAVPlayer() {
    if (wavplayer.compareTo("") == 0) {
      return new String("./play -x");
    }
    return wavplayer;
  }

  /** Set WAVPlayer */
  public void setWAVPlayer(String s) {
    wavplayer = new String(s);
  }

  /** Get MP3Player */
  public String getMP3Player() {
    return mp3player;
  }

  /** Set MP3Player */
  public void setMP3Player(String s) {
    mp3player = new String(s);
  }

  /** Get Advanced User */
  public boolean getAdvancedUser() {
    return user;
  }

  /** Set Advanced User */
  public void setAdvancedUser(boolean m) {
    user = m;
  }

  /** Get Encoder */
  public String getEncoder() {
    if (encoder.compareTo("") == 0) {
      return new String("./encode -l 2 -p 2 -b");
    }
    return encoder;
  }

  /** Set Encoder */
  public void setEncoder(String s) {
    encoder = new String(s);
  }

  /** Get Encoder Type */
  public boolean getEncoderType() {
    return encodertype;
  }

  /** Set Encoder Type */
  public void setEncoderType(boolean b) {
    encodertype = b;
  }

  /** Get Decoder */
  public String getDecoder() {
    if (decoder.compareTo("") == 0) {
      return new String("./decode");
    }
    return decoder;
  }

  /** Set Decoder */
  public void setDecoder(String s) {
    decoder = new String(s);
  }


  public String toString() {
    System.out.println(version);
    
    System.out.println(wrDevNumber);
    System.out.println(wrModel);
    System.out.println(wrDev);
    System.out.println(wrGen);
    System.out.println(type);
    System.out.println(com);
    System.out.println(wrRead);
    System.out.println(wrWrite);
    System.out.println(wrErase);
    
    System.out.println(rdDevNumber);
    System.out.println(rdModel);
    System.out.println(rdDev);
    System.out.println(rdGen);
    System.out.println(rdRead);
    
    System.out.println(mnt);
    System.out.println(tmp);
    System.out.println(spath);
    System.out.println(fs);
    
    System.out.println(advcdr);
    System.out.println(advmki);
    System.out.println(cdrecord);
    System.out.println(mkisofs);
    System.out.println(mkhybrid);
    System.out.println(audiorip);
    System.out.println(riptype);
    System.out.println(cdrplayer);
    System.out.println(wavplayer);
    System.out.println(mp3player);
    System.out.println(user);
    System.out.println(encoder);
    System.out.println(encodertype);
    System.out.println(decoder);

    return new String("");
  }

  protected void finalize() {
    // Just be sure :-)
    saveSettings();
  }
}
