/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.tree.*;
import java.util.*;
import java.io.*;

public class Utils {
  protected Settings settings;

  public Utils() {
    settings = null;
  }

  public Utils(Settings set) {
    settings = set;
  }

  public String getVersion() {
    String version = new String("1.5pre5");
    return version;
  }

  /** Get SCSI devices */
  public Vector getSCSIDevices() {
    Vector units = new Vector();
    Vector v;
    String unit = new String("");
    String unit_major = new String("");
    String unit_minor = new String("");

    try {
      String cmd = new String(settings.getCdrecord());
      cmd = cmd.concat(" -scanbus");
      Process procSETUP = Runtime.getRuntime().exec(cmd,null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      
      String line;
      line = lineIn.readLine();
      while ((line.compareTo("") != 0)||(lineIn.eos() == false)) {
	if (line.startsWith("scsibus")) {
	  unit_major = new String(line.substring(7,8));
	}
	if (line.endsWith("Removable CD-ROM")) {
	  v = new Vector();

	  unit_minor = new String(line.substring(4,5));
	  unit = new String(unit_major);
	  unit = unit.concat(",");
	  unit = unit.concat(unit_minor);
	  unit = unit.concat(",0");   // Get LUN information
	  v.addElement(unit);

	  try {
	    String command = new String(settings.getCdrecord());
	    command = command.concat(" dev=");
	    command = command.concat(unit);
	    command = command.concat(" -checkdrive");
	    Process procSETUP2 = Runtime.getRuntime().exec(command,null);
	    MyInputStream lineIn2 = new MyInputStream(procSETUP2.getInputStream());

	    String line2;
	    line2 = lineIn2.readLine();
	    while (line2.compareTo("") != 0) {
	      if (line2.startsWith("Vendor_info")) {
		v.addElement(new String(line2.substring(18,line2.length()-1)));
	      } else 
	      if (line2.startsWith("Identifikation")) {
		v.addElement(new String(line2.substring(18,line2.length()-1)));
	      } else 
	      if (line2.startsWith("Revision")) {
		v.addElement(new String(line2.substring(18,line2.length()-1)));
	      } else 
	      if (line2.startsWith("Device seems to be:")) {
		v.addElement(new String(line2.substring(20,line2.length()-1)));
	      } 
	      line2 = lineIn2.readLine();
	    }
	    procSETUP.destroy();
	  } catch (Exception e) {
	  }
	  units.addElement(v);
	}
	line = lineIn.readLine();
      }
      procSETUP.destroy();
    } catch (Exception e) {
    }
    return units;
  }

  /** Get Tracks */
  public Vector getTracks() {
    Vector result = new Vector();
    Vector v = new Vector();
    Vector track = new Vector();
    Vector mode = new Vector();
    Vector start = new Vector();
    String command = new String(settings.getCdrecord());

    command = command.concat(" dev=");
    command = command.concat(settings.getRdDevNumber());
    command = command.concat(" -toc");
    try {
      Process procTracks = Runtime.getRuntime().exec(command,null);
      MyInputStream lineIn = new MyInputStream(procTracks.getInputStream());

      String track_s;
      String mode_s;
      String start_s;

      String line = lineIn.readLine();
      while (line.compareTo("") != 0) {

	if (line.startsWith("track")) {
	  track_s = new String(line.substring(8,10));
	  mode_s = new String(line.substring(line.length()-2));
	  start_s = new String(line.substring(19,25));
	  start_s = new String(start_s.substring(getFirstIndex(start_s)));

	  track.addElement(track_s);
	  mode.addElement(mode_s);
	  start.addElement(start_s);
	}
	line = lineIn.readLine();
      }
      procTracks.destroy();
    } catch (Exception e) {
    }
    int i;

    int current,next,length;
    String m;

    for (i=0; i < track.size(); i++) {
      m = (String)mode.elementAt(i);
      if (m.compareTo("15") == 0) {
	// Identified as: Audio track
	v = new Vector();
	v.addElement((String)track.elementAt(i));
	v.addElement((String)start.elementAt(i));
	current = new Integer((String)start.elementAt(i)).intValue();
	next = new Integer((String)start.elementAt(i+1)).intValue();
	length = next - current;
	v.addElement(new Integer(length).toString());
	v.addElement(new String("Audio"));
	result.addElement(v);
      } else if (m.compareTo(" 0") == 0) {
	// Identified as: ??? track
	v = new Vector();
	v.addElement((String)track.elementAt(i));
	v.addElement((String)start.elementAt(i));
	current = new Integer((String)start.elementAt(i)).intValue();
	next = new Integer((String)start.elementAt(i+1)).intValue();
	length = next - current;
	v.addElement(new Integer(length).toString());
	v.addElement(new String("Unknown"));
	result.addElement(v);
      } else if (m.compareTo("-1") == 0) {
	// Identified as: Don't have a clue
	m = (String)track.elementAt(i);
	if (m.compareTo("ut") != 0) {
	  v = new Vector();
	  v.addElement((String)track.elementAt(i));
	  v.addElement((String)start.elementAt(i));
	  current = new Integer((String)start.elementAt(i)).intValue();
	  next = new Integer((String)start.elementAt(i+1)).intValue();
	  length = next - current;
	  v.addElement(new Integer(length).toString());
	  v.addElement(new String("Unknown"));
	  result.addElement(v);
	}
      }
    }
    return result;
  }

  private int getFirstIndex(String s) {
    int index = 255;
    int i;

    i = s.indexOf("0");
    if ((index > i)&&(i >= 0)) {
      index = i;
    }
    i = s.indexOf("1");
    if ((index > i)&&(i >= 0)) {
      index = i;
    }
    i = s.indexOf("2");
    if ((index > i)&&(i >= 0)) {
      index = i;
    }
    i = s.indexOf("3");
    if ((index > i)&&(i >= 0)) {
      index = i;
    }
    i = s.indexOf("4");
    if ((index > i)&&(i >= 0)) {
      index = i;
    }
    i = s.indexOf("5");
    if ((index > i)&&(i >= 0)) {
      index = i;
    }
    i = s.indexOf("6");
    if ((index > i)&&(i >= 0)) {
      index = i;
    }
    i = s.indexOf("7");
    if ((index > i)&&(i >= 0)) {
      index = i;
    }
    i = s.indexOf("8");
    if ((index > i)&&(i >= 0)) {
      index = i;
    }
    i = s.indexOf("9");
    if ((index > i)&&(i >= 0)) {
      index = i;
    }

    return index;
  }

  /** Get magic parameters */
  public String getMagicParameters() {
    String command = new String(settings.getCdrecord());

    command = command.concat(" dev=");
    command = command.concat(settings.getWrDevNumber());
    command = command.concat(" -msinfo");
    try {
      Process procMSINFO = Runtime.getRuntime().exec(command,null);
      MyInputStream lineIn = new MyInputStream(procMSINFO.getInputStream());
      
      String line = lineIn.readLine();
      if ((line.charAt(0) >= '0')&&(line.charAt(0) <= '9')) {
	return line;
      }
      procMSINFO.destroy();
    } catch (Exception e) {
    }
    return new String("");
  }

  /** Get number of CPUs */
  public int getNrOfCPUs() {
    int result = 0;
    String command = new String("cat /proc/cpuinfo");

    if (System.getProperty("os.name").compareTo("Linux") == 0) {
      try {
	Process procMSINFO = Runtime.getRuntime().exec(command,null);
	MyInputStream lineIn = new MyInputStream(procMSINFO.getInputStream());
	String line;
	
	while (true) {
	  line = lineIn.readLine();
	  if (line.startsWith("processor")) {  
	    result++;
	  }
	}
	//procMSINFO.destroy();
      } catch (Exception e) {
	// No /proc directory
	if (result == 0) result = 1;
      }
    } else {
      result = 1;  // Defaults to 1 :-(
    }
    return result;
  }

  /** Execute command (stdout) */
  public void execute(String cmd) {
    execute(cmd,true);
  }

  /** Execute command (stdout) */
  public void execute(String cmd, boolean output) {
    if (output) {
      System.out.print("Executing : ");
      System.out.println(cmd);
    }
    try {
      Process proc = Runtime.getRuntime().exec(cmd,null);
      int c;
      if (output) {
	MyInputStream charIn = new MyInputStream(proc.getInputStream());
	while ((c = charIn.readChar()) != -1) {
	  System.out.print((char) c);
	}
	System.out.println("Command complete.");
      } else {
	c = proc.waitFor();
      }
      proc.destroy();
    } catch (Exception e) {
    }
  }

  /** Execute command (stderr) */
  public void execute_err(String cmd) {
    execute_err(cmd,true);
  }

  /** Execute command (stderr) */
  public void execute_err(String cmd, boolean output) {
    //String title = new String("Running: ");

    //title = title.concat(cmd);
    //Output out = new Output(title,500,500);
    if (output) {
      System.out.print("Executing : ");
      System.out.println(cmd);
    }
    try {
      Process proc = Runtime.getRuntime().exec(cmd,null);
      int c;
      if (output) {
	MyInputStream charIn = new MyInputStream(proc.getErrorStream());
	while ((c = charIn.readChar()) != -1) {
	  System.out.print((char) c);
	}
	System.out.println("Command complete.");
      } else {
	c = proc.waitFor();
      }
      proc.destroy();
    } catch (Exception e) {
    }
  }

  /** Execute pipe command (stdout) */
  public void execute_pipe(String cmd1,String cmd2) {
    System.out.print("Executing : ");
    System.out.print(cmd1);
    System.out.print(" | ");
    System.out.println(cmd2);

    /*
     Should work -- but doesn't :  Pipe I/O bug for Process?
    try {
      Process proc1 = Runtime.getRuntime().exec(cmd1,null);
      Process proc2 = Runtime.getRuntime().exec(cmd2,null);
      
      new Thread(new ExecutePipe(proc1.getInputStream(),proc2.getOutputStream())).start(); 
      new Thread(new ExecutePipe(proc1.getErrorStream(), System.out)).start();
      new Thread(new ExecutePipe(proc2.getInputStream(), System.out)).start();

      System.out.println ("Command complete.");
    } catch (Exception e) {
      System.out.println (e);
    }
    */
    String s = new String("");

    s = s.concat(cmd1);
    s = s.concat(" | ");
    s = s.concat(cmd2);

    // Create a script with the commands
    try {
      WriteTextFile wf = new WriteTextFile("./user.cmd");
      wf.writeLine("#!/bin/sh");
      wf.writeLine(s);
      wf.close();
    } catch (IOException e) {
      System.err.println(e);
    }
    // Change execute permissions
    execute("chmod 755 ./user.cmd",false);

    String[] cmds = {new String("./user.cmd"), new String("rm -f ./user.cmd")}; 
    ExecuteCmdsThread th = new ExecuteCmdsThread(cmds, 2, 1);
  }

  public int getFreeSpace() {
    String ret = new String("");

    try {
      String command = new String(settings.getCdrecord());
      command = command.concat(" dev=");
      command = command.concat(settings.getWrDevNumber());
      command = command.concat(" -toc");
      Process procSETUP = Runtime.getRuntime().exec(command,null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      
      while (true) {
	String line = lineIn.readLine();
	if (line.startsWith("track:lout")) {
	  ret = ret.concat(line.substring(19,25));
	  break;
	}
      }
      procSETUP.destroy();
    } catch (Exception e) {
    }
    return Integer.valueOf(ret).intValue();
  }

  public DefaultMutableTreeNode[] getDirectory(String s) {
    DefaultMutableTreeNode[] result;
    Vector dirs = new Vector();
    String name = new String();
    String tmp;
    
    try {
      String command = new String("ls");
      command = command.concat(" -1F ");
      s = transformString(s);
      command = command.concat(s);
      Process procSETUP = Runtime.getRuntime().exec(command,null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      
      String line = lineIn.readLine();

      while (line.compareTo("") != 0) {

	if (line.endsWith("*")) {
	  line = line.substring(0,line.length()-1);
	}

	if (line.endsWith("/")) {             // Is Directory
	  line = line.substring(0,line.length()-1);
	  dirs.addElement(line);
	} else if (line.endsWith("@")) {      // Is Link
	  line = line.substring(0,line.length()-1);
	  name = new String(s);
	  name = name.concat(line);
	  if (isDirectory(name)) {
	    dirs.addElement(line);
	  }
	} else if (line.toUpperCase().endsWith(".MP3")) {    // MP3 File
	  dirs.addElement(line);
	} else if (line.toUpperCase().endsWith(".CDR")) {    // CDR File
	  dirs.addElement(line);
	} else if (line.toUpperCase().endsWith(".WAV")) {    // WAV File
	  dirs.addElement(line);
	} else if (line.toUpperCase().endsWith(".ISO")) {    // ISO File
	  dirs.addElement(line);
	} else if (line.toUpperCase().endsWith(".IMG")) {    // IMG File
	  dirs.addElement(line);
	}
	line = lineIn.readLine();
      }
      procSETUP.destroy();
    } catch (Exception e) {
    }

    result = new DefaultMutableTreeNode[dirs.size()];

    DefaultMutableTreeNode element;
    int i;
    for (i=0;i<dirs.size();i++) {
      tmp = (String)dirs.elementAt(i);
      if (tmp.toUpperCase().endsWith(".MP3")) {
	element = new MP3(tmp);
      } else if (tmp.toUpperCase().endsWith(".CDR")) {
	element = new CDR(tmp);
      } else if (tmp.toUpperCase().endsWith(".WAV")) {
	element = new WAV(tmp);
      } else if (tmp.toUpperCase().endsWith(".ISO")) {
	element = new ISO(tmp);
      } else if (tmp.toUpperCase().endsWith(".IMG")) {
	element = new IMG(tmp);
      } else {
	element = new DefaultMutableTreeNode(tmp);
      }
      result[i] = element;
    }
    return result;
  }

  /*
  // Return true if s is a directory (max 20 levels)
  public boolean isDirectory(String s, int l) {
    if (l == 20) {
      return false;
    } else {
      if (s.startsWith("/")) {
	try {
	  String command = new String("ls");
	  command = command.concat(" -1F ");
	  command = command.concat(s);

	  System.out.println(command);
	  Process procSETUP = Runtime.getRuntime().exec(command,null);
	  MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
	  
	  String line = lineIn.readLine();
	  System.out.println(line);
	  if (line.endsWith("/")) {             // Is Directory
	    return true;
	  } else if (line.endsWith("@")) {      // Is Link
	    return isDirectory(line.substring(0,line.length()-1),l+1);
	  } else {
	    return false;
	  }
	} catch (Exception e) {
	}
      } else {
	// Maybe a relative link - not implemented yet!
	return false;
      }
    }
    return false;
  }
  */

  public boolean isDirectory(String s) {

    try {
      String command = new String("ls");
      command = command.concat(" -ld ");
      command = command.concat(s);
      Process procSETUP = Runtime.getRuntime().exec(command,null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      
      String line = lineIn.readLine();
      if (line.startsWith("d")) {             // Is Directory
	return true;
      } else if (line.endsWith("/")) {  
	return true;
      }
      procSETUP.destroy();
    } catch (Exception e) {
    }
    return false;
  }

  /*
  public boolean isDirectory(String s) {

    try {
      String command = new String("cd ");
      command = command.concat(s);
      System.out.println("1");
      System.out.println(command);
      Process procSETUP = Runtime.getRuntime().exec(command,null);
      System.out.println("2");
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      System.out.println("3");
      
      String line = lineIn.readLine();
      System.out.println(s);
      System.out.println(line);
      if (line.compareTo("") == 0) {             // Is Directory
	  return true;
      }
      procSETUP.destroy();
    } catch (Exception e) {
    }
    return false;
  }
  */

  public boolean isAudioFile(String s) {
    if ((s.toUpperCase().endsWith(".MP3") == true)||
	(s.toUpperCase().endsWith(".CDR") == true)||
	(s.toUpperCase().endsWith(".WAV") == true)) {
      return true;
    } else {
      return false;
    }
  }

  public boolean isISOFile(String s) {
    if (s.toUpperCase().endsWith(".ISO") == true) {
      return true;
    } else {
      return false;
    }
  }

  public boolean isIMGFile(String s) {
    if (s.toUpperCase().endsWith(".IMG") == true) {
      return true;
    } else {
      return false;
    }
  }

  // Get size of directory in Mb
  public String getDirSize(String s) {
    String result,tmp;
    float val;

    result = new String("");

    try {
      String command = new String(settings.getMkisofs());
      command = command.concat(" -a -l -L -J -r -print-size ");
      command = command.concat(s);
      Process procSETUP = Runtime.getRuntime().exec(command,null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getErrorStream());
      
      String line = lineIn.readLine();
      while (line.compareTo("") != 0) {
	if (line.startsWith("Total")) {
	  tmp = new String(line.substring(line.indexOf('=')+2));
	  val = Float.valueOf(tmp).floatValue();
	  val = (val * 2) / 1024 ;
	  result = new String(new Float(val).toString());
	  result = result.substring(0,result.indexOf('.')+2);
	}
	line = lineIn.readLine();
      }
      procSETUP.destroy();
    } catch (Exception e) {
    }
    return result;
  }

  // Get size of file in bytes
  public String getFileSize(String s) {
    String result,tmp;

    result = new String("");

    try {
      String command = new String("du -b ");
      command = command.concat(s);
      Process procSETUP = Runtime.getRuntime().exec(command,null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      
      String line = lineIn.readLine();
      StringTokenizer st = new StringTokenizer(line);
      result = st.nextToken();

      procSETUP.destroy();
    } catch (Exception e) {
    }
    return result;
  }

  // Get number of file in directory
  public int getNumOfFiles(String s) {
    String tmp;
    int num;

    num = 0;
    try {
      String command = new String("ls -lR ");
      command = command.concat(s);
      Process procSETUP = Runtime.getRuntime().exec(command,null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      
      String line;

      while (lineIn.eos() == false) {
	line = lineIn.readLine();
	if (line.startsWith("-")) {
	  num++;
	}
      }
      procSETUP.destroy();
    } catch (Exception e) {
    }
    return num;
  }

  // Get number of directories in directory
  public int getNumOfDirs(String s) {
    String tmp;
    int num;

    num = 0;
    try {
      String command = new String("ls -lR ");
      command = command.concat(s);
      Process procSETUP = Runtime.getRuntime().exec(command,null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      
      String line;

      while (lineIn.eos() == false) {
	line = lineIn.readLine();
	if (line.startsWith("/")) {
	  num++;
	}
      }
      procSETUP.destroy();
    } catch (Exception e) {
    }
    return num;
  }

  // Get modified date of a directory
  public String getModifiedDate(String s) {
    String dir,name;

    dir = s.substring(0,s.lastIndexOf("/")+1);
    name = s.substring(s.lastIndexOf("/")+1);

    try {
      String command = new String("ls -l ");
      command = command.concat(dir);
      Process procSETUP = Runtime.getRuntime().exec(command,null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      
      String line;

      while (lineIn.eos() == false) {
	line = lineIn.readLine();
	if (line.endsWith(name)) {
	  return line.substring(42,54);
	}
      }
      procSETUP.destroy();
    } catch (Exception e) {
    }
    return new String("");
  }

  public boolean checkCdrecord() {
    String cmd;
    boolean ret = false;

    try {
      cmd = new String(settings.getCdrecord());
      cmd = cmd.concat(" -scanbus");
      Process procSETUP = Runtime.getRuntime().exec(cmd,null);
      MyInputStream lineIn = new MyInputStream(procSETUP.getInputStream());
      
      String line;
      while (lineIn.eos() == false) {
	line = lineIn.readLine();
	if (line.indexOf("scsi") != -1) {
	  ret = true;
	}
      }
    } catch (EOFException e) {
    } catch (Exception e) {
      ret = false;
    }
    return ret;
  }

  public String transformString(String s) {
    String result = new String("");

    if (s.indexOf(" ") == -1) {
      result = s;
    } else {
      char[] input = s.toCharArray();
      StringBuffer output = new StringBuffer();
      char ch;

      for (int i=0; i < input.length; i++) {
	ch = input[i];
	if (ch == ' ') {
	  output.append('\\');
	}
	output.append(ch);
      }
      result = output.toString();
    }
    return result;
  }

}
