/*
 *  Copyright (C) 1998,1999  Jesper Pedersen <jews@imada.ou.dk>
 *  This code is released under GNU GPL version 2 or later
 */

import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class VolumeInfoFrame extends JPanel {
    protected JPanel       borderPane;
    protected JPanel       borderPane2;
    protected JPanel       dataPane;
    protected JPanel       dataPane2;
    protected JPanel       dataPane3;

    protected JLabel       label;

    protected JPanel       idPane;
    protected JLabel       idlabel;
    protected JTextField   id;

    protected JPanel       preparerPane;
    protected JLabel       preparerlabel;
    protected JTextField   preparer;

    protected JPanel       publisherPane;
    protected JLabel       publisherlabel;
    protected JTextField   publisher;

    protected JPanel       applidPane;
    protected JLabel       applidlabel;
    protected JTextField   applid;

    protected JPanel       biblioPane;
    protected JLabel       bibliolabel;
    protected JTextField   biblio;

    protected JPanel       copyPane;
    protected JLabel       copylabel;
    protected JTextField   copy;

    protected JPanel       sysidPane;
    protected JLabel       sysidlabel;
    protected JTextField   sysid;

    protected JPanel       volsetPane;
    protected JLabel       volsetlabel;
    protected JTextField   volset;

    protected JPanel       abstrctPane;
    protected JLabel       abstrctlabel;
    protected JTextField   abstrct;

    protected JPanel       volsetsizePane;
    protected JLabel       volsetsizelabel;
    protected JTextField   volsetsize;

    protected JPanel       volsetseqPane;
    protected JLabel       volsetseqlabel;
    protected JTextField   volsetseq;


    public VolumeInfoFrame() {
        this.setLayout(new BorderLayout());

	borderPane = new JPanel();
	borderPane.setBorder(new EmptyBorder(5,5,5,5));
	borderPane.setLayout(new BorderLayout());
	
	borderPane2 = new JPanel();
	borderPane2.setBorder(new MatteBorder(1,1,1,1,Color.gray));
	borderPane2.setLayout(new BorderLayout());

	label = new JLabel("Volume Information");
	label.setForeground(Color.black);

	dataPane = new JPanel();
	dataPane.setBorder(new EmptyBorder(5,5,5,5));
	dataPane.setLayout(new BorderLayout());

	dataPane2 = new JPanel();
	dataPane2.setLayout(new GridLayout(7,1));

	dataPane3 = new JPanel();
	dataPane3.setLayout(new GridLayout(7,1));

	idPane = new JPanel();
	idPane.setBorder(new EmptyBorder(5,5,5,5));
	idPane.setLayout(new GridLayout(1,2));
	idlabel = new JLabel("Volume ID");
	idlabel.setForeground(Color.black);
	id = new JTextField();
	idPane.add(idlabel);
	idPane.add(id);

	preparerPane = new JPanel();
	preparerPane.setBorder(new EmptyBorder(5,5,5,5));
	preparerPane.setLayout(new GridLayout(1,2));
	preparerlabel = new JLabel("Volume Preparer");
	preparerlabel.setForeground(Color.black);
	preparer = new JTextField();
	preparerPane.add(preparerlabel);
	preparerPane.add(preparer);

	publisherPane = new JPanel();
	publisherPane.setBorder(new EmptyBorder(5,5,5,5));
	publisherPane.setLayout(new GridLayout(1,2));
	publisherlabel = new JLabel("Volume Publisher");
	publisherlabel.setForeground(Color.black);
	publisher = new JTextField();
	publisherPane.add(publisherlabel);
	publisherPane.add(publisher);

	applidPane = new JPanel();
	applidPane.setBorder(new EmptyBorder(5,5,5,5));
	applidPane.setLayout(new GridLayout(1,2));
	applidlabel = new JLabel("Application ID");
	applidlabel.setForeground(Color.black);
	applid = new JTextField();
	applidPane.add(applidlabel);
	applidPane.add(applid);

	biblioPane = new JPanel();
	biblioPane.setBorder(new EmptyBorder(5,5,5,5));
	biblioPane.setLayout(new GridLayout(1,2));
	bibliolabel = new JLabel("Bibliographic filename");
	bibliolabel.setForeground(Color.black);
	biblio = new JTextField();
	biblioPane.add(bibliolabel);
	biblioPane.add(biblio);

	copyPane = new JPanel();
	copyPane.setBorder(new EmptyBorder(5,5,5,5));
	copyPane.setLayout(new GridLayout(1,2));
	copylabel = new JLabel("Copyright filename");
	copylabel.setForeground(Color.black);
	copy = new JTextField();
	copyPane.add(copylabel);
	copyPane.add(copy);

	sysidPane = new JPanel();
	sysidPane.setBorder(new EmptyBorder(5,5,5,5));
	sysidPane.setLayout(new GridLayout(1,2));
	sysidlabel = new JLabel("System ID");
	sysidlabel.setForeground(Color.black);
	sysid = new JTextField();
	sysidPane.add(sysidlabel);
	sysidPane.add(sysid);

	volsetPane = new JPanel();
	volsetPane.setBorder(new EmptyBorder(5,5,5,5));
	volsetPane.setLayout(new GridLayout(1,2));
	volsetlabel = new JLabel("Volume set ID");
	volsetlabel.setForeground(Color.black);
	volset = new JTextField();
	volsetPane.add(volsetlabel);
	volsetPane.add(volset);

	abstrctPane = new JPanel();
	abstrctPane.setBorder(new EmptyBorder(5,5,5,5));
	abstrctPane.setLayout(new GridLayout(1,2));
	abstrctlabel = new JLabel("Abstract filename");
	abstrctlabel.setForeground(Color.black);
	abstrct = new JTextField();
	abstrctPane.add(abstrctlabel);
	abstrctPane.add(abstrct);

	volsetsizePane = new JPanel();
	volsetsizePane.setBorder(new EmptyBorder(5,5,5,5));
	volsetsizePane.setLayout(new GridLayout(1,2));
	volsetsizelabel = new JLabel("Volume Set Size");
	volsetsizelabel.setForeground(Color.black);
	volsetsize = new JTextField();
	volsetsizePane.add(volsetsizelabel);
	volsetsizePane.add(volsetsize);

	volsetseqPane = new JPanel();
	volsetseqPane.setBorder(new EmptyBorder(5,5,5,5));
	volsetseqPane.setLayout(new GridLayout(1,2));
	volsetseqlabel = new JLabel("Volume Seq. Number");
	volsetseqlabel.setForeground(Color.black);
	volsetseq = new JTextField();
	volsetseqPane.add(volsetseqlabel);
	volsetseqPane.add(volsetseq);

	dataPane2.add(idPane);	
	dataPane2.add(preparerPane);
	dataPane2.add(publisherPane);
	dataPane2.add(applidPane);
	dataPane2.add(new JPanel());
	dataPane2.add(new JPanel());
	dataPane2.add(new JPanel());

	dataPane3.add(abstrctPane);
	dataPane3.add(biblioPane);
	dataPane3.add(copyPane);
	dataPane3.add(sysidPane);
	dataPane3.add(volsetPane);
	dataPane3.add(volsetsizePane);
	dataPane3.add(volsetseqPane);

	dataPane.add(dataPane2, BorderLayout.WEST);
	dataPane.add(dataPane3, BorderLayout.EAST);

        borderPane2.add(dataPane, BorderLayout.CENTER);
        borderPane.add(label, BorderLayout.NORTH);
        borderPane.add(borderPane2, BorderLayout.CENTER);

        this.add(borderPane, BorderLayout.NORTH);
    }

    // Refresh screen
    public void refresh() {
      repaint();
    }

    public void setVolumeId(String s) {
      id.setText(s);
    }

    public void setVolumePreparer(String s) {
      preparer.setText(s);
    }

    public void setVolumePublisher(String s) {
      publisher.setText(s);
    }

    public void setApplicationId(String s) {
      applid.setText(s);
    }

    public String getBurnString() {
      String vol = new String("");

      if (id.getText().compareTo("") != 0) {
	vol = vol.concat(" -V ");
	vol = vol.concat(id.getText());
      }
      if (preparer.getText().compareTo("") != 0) {
	vol = vol.concat(" -p ");
	vol = vol.concat(preparer.getText());
      }
      if (publisher.getText().compareTo("") != 0) {
	vol = vol.concat(" -P ");
	vol = vol.concat(publisher.getText());
      }
      if (applid.getText().compareTo("") != 0) {
	vol = vol.concat(" -A ");
	vol = vol.concat(applid.getText());
      }
      if (abstrct.getText().compareTo("") != 0) {
	vol = vol.concat(" -abstract ");
	vol = vol.concat(volset.getText());
      }
      if (biblio.getText().compareTo("") != 0) {
	vol = vol.concat(" -biblio ");
	vol = vol.concat(biblio.getText());
      }
      if (copy.getText().compareTo("") != 0) {
	vol = vol.concat(" -copyright ");
	vol = vol.concat(copy.getText());
      }
      if (sysid.getText().compareTo("") != 0) {
	vol = vol.concat(" -sysid ");
	vol = vol.concat(sysid.getText());
      }
      if (volset.getText().compareTo("") != 0) {
	vol = vol.concat(" -volset ");
	vol = vol.concat(volset.getText());
      }
      if (volsetsize.getText().compareTo("") != 0) {
	vol = vol.concat(" -volset-size ");
	vol = vol.concat(volsetsize.getText());
	vol = vol.concat(" -volset-seqno ");
	vol = vol.concat(volsetseq.getText());
      }
      return vol;
    }
}

