#!/usr/bin/perl

# mp3munch
# Release .03

# mp3munch is designed to ease the process of creating
# audio cd's using basic system tools. It was created
# due to a lack of comprehensive console tools designed
# for this purpose. This script is inspired by  Ryan Richter's
# <bobort@bigfoot.com> mp3burn script which came the closest
# to what I desired.

# This script is a joint project of Kibble, rajak and Godot.

#### Settings ####

# make sure the proper dev setting is defined below. If you
# are unsure which, use 'cdrecord -scanbus' to determine
# the proper settings.

$cdrecord = "cdrecord -v -eject dev=6,0 speed=4 -pad -swab -audio";

#### Clean up the filenames ####
#### Another proud Rajak contribution

foreach $xold (`ls`){
  chomp $xold;
    
    $xnew = $xold;
    $xnew =~ s/\ /_/g;
    $xnew =~ s/(\(|\))//g;
    $xnew =~ s/\'/-/g;
        if($xnew ne $xold){
                print "renaming $xold to $xnew\n";
                rename $xold, $xnew or die "Failed renaming $xold\n";
        }
}
                    
#### Check to ensure total running time < 74 minutes ####

# rajak's function to ensure proper running time.
# rajak has a specific copyright on this stuff which I
# summarize as follows: if you do anything to this section
# he doesn't like, he'll sue.

use MP3::Info;
while($file = <*.[Mm][Pp]3>){

        $info = get_mp3info($file) or die "Error in reading of $file\n";
        $total += ($info->{MM} * 60) + $info->{SS};
}
if(!($total)){ die "No music was found in this directory.\n"; }
elsif($total > 4440){
    printf "Ack, far too much music in this directory for me to write on a CD (%d minutes %d seconds too much)\n", (($total-4440)/60), (($total-4440)%60);
    exit;
}

#### Proceed ####       

# See how sloppy? Clearly Godot's code
# Note the nifty sox string-- that's vintage Kibble
        
# new, 0.03
# try to ensure sox deals with
# the proper frequency.

while($converts = <*.mp3>){
	$info = get_mp3info($converts);
	$freq= ($info->{FREQUENCY});
	$freq=($freq*1000);
	print "$converts frequency is $freq -- informing sox\n";
        $convert_out = $converts;
        $convert_out =~ s/mp3$/wav/;
        system "mpg123 -q -s $converts | sox -t raw -c 2 -w -s -r $freq - -t wav $convert_out";
}

#### Ready to dump audio ####

system "$cdrecord *.wav"



