#   FILE: burn_baby_burn.spec.in --
# AUTHOR: W. Michael Petullo <burn_baby_burn@flyn.org>
#   DATE: 05 May 1999

%define ver	0.1.15
%define rel	1
%define prefix	/usr

Summary: Several scripts to aid in burning CD's.
Name: burn_baby_burn
Requires: cdrecord cdparanoia new mktemp mount fileutils e2fsprogs sh-utils textutils mkisofs bash mpg123 swap e2fsprogs lilo tar rsync bzip2
Version: %ver
Release: %rel
Copyright: GPL
Group: Utilities/System
Source: %name-%{PACKAGE_VERSION}.tar.gz
BuildRoot: /home/mike/development/live
Packager: W. Michael Petullo <burn_baby_burn@flyn.org>
URL: http://www.flyn.org

%description
The burn_baby_burn package contains a set of utilities for burning to
CD-R and CD-RW media.  The package allows one to easily perform tasks
such as burning a directory, burning an audio CD, burning a CD image,
and copying CD media from the command line.  It also includes programs
to build MPEG Layer III audio files from a CDDA CD.

Also included is a backup script, backup.sh, with the ability to burn
``El Torito'' bootable backup CD's.  This distribution includes very simple
inittab and rc files for booting; they should probably be customized
for your machine.

%changelog

%prep
%setup

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc

# NOTE: The following trick only works with a modified header-vars.am.
# Change the line ``DESTDIR ='' in this file to ``DESTDIR =
# ${ENV_DESTDIR}.''
export ENV_DESTDIR=$RPM_BUILD_ROOT
make install

cp -Rf burn_baby_burn $RPM_BUILD_ROOT/etc/burn_baby_burn
mkdir -p $RPM_BUILD_ROOT/usr/share/new
cp -R templates $RPM_BUILD_ROOT/usr/share/new
gzip -9 AUTHORS COPYING ChangeLog INSTALL NEWS README

%clean

%pre

%post

%preun

%postun

%files
%defattr(-, root, root)
%{prefix}/bin/backup.sh
%{prefix}/bin/burn_image.sh
%{prefix}/bin/burn_dir.sh
%{prefix}/bin/burn_pwd.sh
%{prefix}/bin/burn_wavs.sh
%{prefix}/bin/cdrip.sh
%{prefix}/bin/copy_iso9660.sh
%{prefix}/bin/copy_cdda.sh
%{prefix}/bin/demp_n_burn.sh
%{prefix}/bin/demp3ize.sh
%{prefix}/bin/erase_cdrw.sh
%{prefix}/bin/verify_burn.sh
%{prefix}/bin/mp3ize.sh
%{prefix}/bin/mkboot.sh
%{prefix}/share/new/templates/fstab/fstab.burn_baby_burn
%{prefix}/share/new/templates/conf/lilo.burn_baby_burn
%{prefix}/man/man?/*

%doc AUTHORS.gz COPYING.gz ChangeLog.gz INSTALL.gz NEWS.gz README.gz

%config 
/etc/burn_baby_burn/*
