#!/bin/bash

#   FILE: burn_wavs.sh -- Burns the fles in pwd.
# AUTHOR: W. Michael Petullo <burn_baby_burn@flyn.org>
#   DATE: 12 SEP 1998
#
# Copyright (c) 1999 W. Michael Petullo <burn_baby_burn@flyn.org>
# All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

. /etc/burn_baby_burn/bbb_functions

MEDIA_TYPE=$2
ERR_DEST=$3
USAGE="Usage: ${0##*/} volume_name cdr|cdrw log|stderr"

if test $# != 3; then
	usage "$USAGE"
elif [ $MEDIA_TYPE != cdr -a $MEDIA_TYPE != cdrw ]; then
	usage "$USAGE"
elif ! configured; then
	print_message $ERR_DEST "No config found in /etc or ~"
	exit 1
fi

if [ $MEDIA_TYPE = cdr ]; then
        SPEED=$CDR_SPEED
elif [ $MEDIA_TYPE = cdrw ]; then
	SPEED=$CDRW_SPEED
fi

if ! ls --color=none -R > ls-R; then
	print_message $ERR_DEST "WARNING: Error writing ls-R"
	rm -f ls-R
	exit 10
elif ! burn_dir.sh "$1" . $2 $3; then
	print_message $ERR_DEST "WARNING: Error recording disc"
	rm -f ls-R
	exit 8
fi

rm -f ls-R
exit 0
