#!/bin/bash

#   FILE: copy_cdda.sh -- Makes a 1-1 copy of an audio CD-ROM.
# AUTHOR: W. Michael Petullo <burn_baby_burn@flyn.org>
#   DATE: 17 FEB 1999
#
# Copyright (c) 1999 W. Michael Petullo <burn_baby_burn@flyn.org>
# All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

. /etc/burn_baby_burn/bbb_functions

USAGE="Usage: ${0##*/} cdr|cdrw \n
\n\
Copies the current audio disc in the CD-ROM drive. \n
\n
cdr causes the media to be burned at a faster speed. \n
cdrw causes the media to be erased and burned at a slower speed."

if [ $# != 1 ]; then
        usage "$USAGE"
fi

if ! configured; then
	print_message $ERR_DEST "No config found in /etc or ~"
	exit 1
fi

TMP_DIR=`mktemp -u /tmp/wavs.XXXXXX` \
        || ( logger -i ${0##*/}: Can\'t make tmp mount point; exit 5 )
mkdir $TMP_DIR
( cd $TMP_DIR; cdrip.sh )
echo Please insert the DESTINATION disc.
swap --wait=0 --no-mount
echo -n Are you SURE the DESTINATION disc is now in the drive? [yn]
read ANS
if [ $ANS = y ]; then
	( cd $TMP_DIR; burn_wavs.sh )
else
	rm -rf $TMP_DIR
	exit 10
fi

rm -rf $TMP_DIR
