#!/bin/bash

#   FILE: demp3ize.sh -- Converts all of the .mp3 files in the current 
#         directory to .wav files, placing the new .wav in 
#         /tmp/cd_wd.
# AUTHOR: W. Michael Petullo <burn_baby_burn@flyn.org>
#   DATE: 14 MAY 1998
#
# Copyright (c) 1999 W. Michael Petullo <burn_baby_burn@flyn.org>
# All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

. /etc/burn_baby_burn/bbb_functions

if ! configured; then
	print_message stderr "No config found in /etc or ~"
	exit 1
fi

if [ ! -d /tmp/cd_wd ]; then
	mkdir /tmp/cd_wd
else
	rm -rf /tmp/cd_wd/*
fi


TRACK=1
for mp3_name in `ls *_?.mp3`; do
	mpg123 -s $mp3_name | sox -t raw -r 44100 -w -s -c 2 - /tmp/cd_wd/trak_$TRACK.wav
	TRACK=`expr $TRACK + 1`
done

for mp3_name in `ls *_??.mp3`; do
	mpg123 -s $mp3_name | sox -t raw -r 44100 -w -s -c 2 - /tmp/cd_wd/trak_$TRACK.wav
	TRACK=`expr $TRACK + 1`
done
