#!/bin/bash

#   FILE: demp_n_burn.sh -- Converts .mp3s in current directory into 
#         CDDA audio and burns the traks.
# AUTHOR: W. Michael Petullo <burn_baby_burn@flyn.org>
#   DATE: 30 AUG 1998
#
# Copyright (c) 1999 W. Michael Petullo <burn_baby_burn@flyn.org>
# All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

. /etc/burn_baby_burn/bbb_functions

if ! configured; then
	print_message stderr "No config found in /etc or ~"
	exit 1
fi

# Convert .mp3 files in current directory to .wavs and place them in 
# /tmp/cd_wd
demp3ize.sh

# Make /tmp/cd_wd the pwd and burn the .wav files.
cd /tmp/cd_wd
burn_wavs.sh
