#!/bin/bash

#   FILE: mkboot.sh -- Makes a boot floppy image.
# AUTHOR: W. Michael Petullo <burn_baby_burn@flyn.org>
#   DATE: 21 Aug 1999
#
# Copyright (c) 1999 W. Michael Petullo <burn_baby_burn@flyn.org>
# All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

. /etc/burn_baby_burn/bbb_functions

if ! configured; then
	print_message stderr "No config found in /etc or ~"
	exit 1
fi

echo Mkboot.sh will attempt to create a bootable floppy image for use
echo in creating an El-Torito CD-ROM.
echo
echo Please insert a floppy disk and press Enter.

read
mke2fs $FLOPPY_DEV
mount $FLOPPY_DEV
MNT_PT=`grep $FLOPPY_DEV /etc/fstab | awk '{ print $2 }'`
if [ ! $MNT_PT ]; then
	echo $FLOPPY_DEV not found in fstab. > /dev/stderr
	exit 10
fi
rm -rf $MNT_PT/lost+found
mkdir {$MNT_PT/dev,$MNT_PT/boot,$MNT_PT/etc}
cp /dev/null $MNT_PT/dev
cp $FLOPPY_DEV $MNT_PT/dev
cp $CD_DEV $MNT_PT/dev
cp -f $KERNEL $BOOT_SECTOR $MNT_PT/boot
new $MNT_PT/etc/lilo.conf lilo.burn_baby_burn
lilo -v -C /etc/lilo.conf -r $MNT_PT -c
dd if=$FLOPPY_DEV of=/$BOOT_IMG bs=10k count=144
umount $FLOPPY_DEV
