#!/bin/bash

#   FILE: mp3ize.sh -- A script to rip each track from a CD, encode each 
#         track in the .mp3 format, and delete the original raw data file.
# AUTHOR: W. Michael Petullo, wp0002@drake.edu
#   DATE: 14 MAY 1998

USAGE="Usage: $0 artist album [disk_[123456789]].\n\
\n\
The directory artist/album[/disk_[123456789]] will be created if
it does not exist.  This is where the audio files will be placed."

if test $# != 2 -a $# != 3; then
        echo -e $USAGE | fmt
        exit 1
fi
if [ ! -d $1 ]; then
	mkdir $1
fi
if [ ! -d $1/$2 ]; then
	mkdir $1/$2
fi
if [ $3 ]; then
	# Probably has disk_[123456789] tacked on the end.
	if [ ! -d $1/$2/$3 ]; then
		mkdir $1/$2/$3
	fi	
	DIR=$1/$2/$3
	FILENAME=$1_$2_$3
else
	DIR=$1/$2
	FILENAME=$1_$2
fi
TRACK=1
(
# Okay, this can be done by specifying $DIR as part of the path arguments, 
# but encode seems to have a bit of a buffer overrun problem.  It malfunctions 
# for long paths, so this method shortens `em.
cd $DIR
while cdparanoia $TRACK $FILENAME.trak_$TRACK.wav; do
	encode -b 128 -l 3 -p 2 $FILENAME.trak_$TRACK.wav \
		$FILENAME.trak_$TRACK.mp3
	rm -f $FILENAME.trak_$TRACK.wav
	TRACK=`expr $TRACK + 1`
done
)
