#   NAME: verify_burn.sh -- Verifies a CD against the source filesystem.
# AUTHOR: W. Michael Petullo <burn_baby_burn@flyn.org>
#   DATE: 30 APR 1999 
#
# Copyright (c) 1999 W. Michael Petullo <burn_baby_burn@flyn.org>
# All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

. /etc/burn_baby_burn/bbb_functions

SRC_DIR=$1
ERR_DEST=$2
USAGE="Usage: ${0##*/} source_dir log|stderr\n
\n
Verifies a newly burned CD agains the original data using md5sum.\n
\n
log causes error messages to be logged using the logger command.\n
stderr causes error messages to be printed to stderr."

if [ $# -lt 1 ]; then
	usage "$USAGE"
elif ! configured; then
	print_message $ERR_DEST "No config found in /etc or ~"
	exit 1
elif ! disc_mounts; then
	print_message $ERR_DEST "WARNING: Bad filesystem -- after burn"
	exit 3
elif ! disc_filesystem_ok $SRC_DIR; then
	print_message $ERR_DEST "WARNING: Uh oh"
	exit 3
fi

print_message $ERR_DEST "All okay, jumpmaster"
exit 0
