//BackTool.java v0.1
//Copyrigth (C)1998 - 1999  Stefan Forstmoser 
//
//    This program is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as published by 
//    the Free Software Foundation; either version 2 of the License, or 
//    (at your option) any later version. 
//
//    This program is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public License 
//    along with this program; if not, write to the Free Software 
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 

import java.awt.*;
import java.awt.event.*;
import java.awt.FontMetrics.*;
import java.awt.Font.*;
import java.io.*;
import java.util.*;
import java.text.SimpleDateFormat;


public class BackTool extends Frame implements ActionListener {


	CheckboxMenuItem optionsCheckMenu =
	 new CheckboxMenuItem("Backup options", true);
	CheckboxMenuItem listCheckMenu =
	 new CheckboxMenuItem("Backup list", false);
	CheckboxMenuItem cdrCheckMenu =
	 new CheckboxMenuItem("CD-recorder options", false);
	CheckboxMenuItem netCheckMenu =
	 new CheckboxMenuItem("Network options for boot media", false);
	CheckboxMenuItem createCheckMenu =
	 new CheckboxMenuItem("Create initial boot media", false);
	CheckboxMenuItem manuallyCheckMenu =
	 new CheckboxMenuItem("Manually backup - boot stuff for CD", false);
	CheckboxMenuItem domanuCheckMenu =
	 new CheckboxMenuItem("Do manually backup", false);
	Button backwardButt = new Button("<<");
	Button forewardButt = new Button(">>");
	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints gridconst = new GridBagConstraints();
	Panel holderPanel = new Panel();
	CardLayout cards = new CardLayout();

	Panel typePanel;
	CheckboxGroup typeRadio = new CheckboxGroup();
	Checkbox[] typeBoxes = new Checkbox[2];
	Panel cdrPanel;
	Choice hostIdChoice = new Choice();
	Choice scsiIdChoice = new Choice();
	TextField maxcdsizeField = new TextField("650");
	TextField tmpdirField = new TextField();
	Checkbox dummyCheck = new Checkbox();
	TextField readmeField = new TextField();
	Choice zipdayChoice = new Choice();
	Choice speedChoice = new Choice();
	Choice ziplevelChoice = new Choice();
	CheckboxGroup burnzipdayRadio = new CheckboxGroup();
	Checkbox[] burnzipdayBoxes = new Checkbox[2];
	
	Panel allpartiPanel;
	List partiList = new List(7, false);
	Choice afstypChoice = new Choice();
	CheckboxGroup asizeRadio = new CheckboxGroup();
	TextField apartiField = new TextField();

	Panel networkPanel;
	Checkbox nonetworkCheck = new Checkbox("Disable network");
	TextField ipaddrField = new TextField();
	Choice netmaskChoice = new Choice();
	TextField gatewayField = new TextField();
	TextField nameserverField = new TextField();

	Panel bootCDPanel;
	TextField bootCDDevField = new TextField();
	TextField backDevField = new TextField();
	TextField subdirField = new TextField();
	TextField ownKernelField = new TextField("Kernel from distribution", 20);
	String actualOwnKernel = new String("/usr/src/linux/arch/i386/boot/zImage");
	Checkbox ownKernelCheck = new Checkbox("own kernel", false);
	TextField bootParamField = new TextField(25);

	Panel manuallyPanel;
	CheckboxGroup stuffRadio = new CheckboxGroup();
	Checkbox[] stuffBoxes = new Checkbox[4];
	TextField bootStuffFileField = new TextField();
	TextField bootStuffDirField = new TextField();

	Panel domanuPanel;
	CheckboxGroup domanuRadio = new CheckboxGroup();
	Checkbox[] domanuBoxes = new Checkbox[2];
	TextField domanuFileField = new TextField();

	MessageDialog myMessageDialog = new MessageDialog(this);
	FileDialog openFile = new FileDialog(this, "Open");
	FileDialog saveFile = new FileDialog(this, "Save", FileDialog.SAVE);
	String actualFile = new String("");
	String actualDir = new String("");
	int i;
	int c;
	MyFstypHash fstypHash = new MyFstypHash();
	String afstyptmp;
	String pwd = new String("");
	String dayOfWeek = new String();


	public void start(String argpwd) {

		Integer I;


		MenuBar mainmenu;
		Menu fileMenu;
		Menu windowMenu;
		Menu helpMenu;
		CheckMenuListener myListener;

		Panel navigPanel;

		Font mainLabelFont;
		Font mainSubLabelFont;
		Label typeMainLabel;
		Panel typeSubPanel;
		Label typeLabel;
		Label nullLabel3;
		Label tmpdirLabel;
		Label readmeLabel;
		Label cdrMainLabel;
		Panel cdrSubPanel;
		Label hostIdLabel;
		Label scsiIdLabel;
		Label maxcdsizeLabel;
		MaxSizeListener sizeListener;
		Label dummyLabel;
		Label zipdayLabel;
		Label speedLabel;
		Label ziplevelLabel;
		Panel burnzipdayCheckPanel;
		Label burnzipdayLabel;

		Label partiMainLabel;
		Panel partiPanel;
		Panel partiListPanel;
		Panel partiButtPanel;
		Panel newPanel;
		Label apartiLabel;
		Label asizeLabel;
		Checkbox[] asizeBoxes;
		Label nullLabel4;
		Label afstypLabel;
		
		Button addButt;
		Button deleteButt;
		Panel toButtPanel;
		Button totypeButt;

		Panel netMainLabelPanel;
		Label netMainLabel;
		Label netSubMainLabel;
		Panel networkSubPanel;
		Label fillerLabel;
		Label ipaddrLabel;
		Label netmaskLabel;
		Label gatewayLabel;
		Label nameserverLabel;

		Label bootMainLabel;
		Panel bootCDSubPanel;
		Panel bootCDDevPanel;
		Label bootCDDevLabel;
		Panel backDevPanel;
		Label backDevLabel;
		Panel subdirPanel;
		Label subdirLabel;
		Panel ownKernelPanel;
		Label ownKernelLabel;
		Panel bootParamPanel;
		Label bootParamLabel;
		Panel bootButtPanel;
		Button burnButt;
		Button floppyButt;

		Panel manuallyMainLabelPanel;
		Label manuallyMainLabel;
		Label manuallySubMainLabel;
		Panel manuallySubPanel;

		Label domanuMainLabel;
		Panel domanuSubPanel;
		Panel startBackupButtPanel;
		Button startBackupButt;


		mainmenu = new MenuBar();
		fileMenu = new Menu("File");
		fileMenu.addActionListener(this);
		windowMenu = new Menu("Window");
		windowMenu.addActionListener(this);
		myListener = new CheckMenuListener();
		optionsCheckMenu.addItemListener(myListener);
		listCheckMenu.addItemListener(myListener);
		cdrCheckMenu.addItemListener(myListener);
		netCheckMenu.addItemListener(myListener);
		createCheckMenu.addItemListener(myListener);
		manuallyCheckMenu.addItemListener(myListener);
		domanuCheckMenu.addItemListener(myListener);
		helpMenu = new Menu("Help");
		helpMenu.addActionListener(this);
		navigPanel = new Panel();
		backwardButt.addActionListener(this);
		forewardButt.addActionListener(this);

		mainLabelFont = new Font("Monospaced", getFont().BOLD, 24);
		mainSubLabelFont = new Font("Monospaced", getFont().BOLD, 18);

		typeMainLabel = new Label("Backup options");
		typeMainLabel.setFont(mainLabelFont);
		typeSubPanel = new Panel();
		typePanel = new Panel();
		typeLabel = new Label("Type:");
		nullLabel3 = new Label();
		typeBoxes[0] = new Checkbox("tgz", typeRadio, true);
		typeBoxes[1] = new Checkbox("dd", typeRadio, false);
		tmpdirLabel = new Label("Deeper subdirectory:");
		readmeLabel = new Label("README-file:");
		cdrMainLabel = new Label("CD-recorder options");
		cdrMainLabel.setFont(mainLabelFont);
		cdrPanel = new Panel();
		cdrSubPanel = new Panel();
		hostIdLabel = new Label("Host-Id:");
		scsiIdLabel = new Label("SCSI-Id:");
		maxcdsizeLabel = new Label("Max. CD-size (in MB):");
		sizeListener = new MaxSizeListener();
		maxcdsizeField.addTextListener(sizeListener);
		dummyLabel = new Label("Dummy-mode:");
		zipdayLabel = new Label("Zip-day:");
		speedLabel = new Label("Speed:");
		ziplevelLabel = new Label("Zip-level:");
		burnzipdayLabel = new Label("Burn also at zip-days?");
		burnzipdayCheckPanel = new Panel();
		burnzipdayBoxes[0] = new Checkbox("yes", burnzipdayRadio, true);
		burnzipdayBoxes[1] = new Checkbox("no", burnzipdayRadio, false);

		partiMainLabel = new Label("Backup list");
		partiMainLabel.setFont(mainLabelFont);
		allpartiPanel = new Panel();
		partiPanel = new Panel();
		partiListPanel = new Panel();
		partiButtPanel = new Panel();
		newPanel = new Panel();
		apartiLabel = new Label("Partition:");
		asizeLabel = new Label("Size:");
		asizeBoxes = new Checkbox[2];
		asizeBoxes[0] = new Checkbox("big", asizeRadio, true);
		asizeBoxes[1] = new Checkbox("small", asizeRadio, false);
		nullLabel4 = new Label();
		afstypLabel = new Label("fstype:");

		addButt = new Button("Add");
		addButt.addActionListener(this);
		deleteButt = new Button("Delete");
		deleteButt.addActionListener(this);
		toButtPanel = new Panel();

		netMainLabelPanel = new Panel();
		netMainLabel = new Label("Network options");
		netMainLabel.setFont(mainLabelFont);
		netSubMainLabel = new Label("for boot media");
		netSubMainLabel.setFont(mainSubLabelFont);
		networkPanel = new Panel();
		networkSubPanel = new Panel();
		nonetworkCheck.addItemListener(myListener);
		fillerLabel = new Label();
		ipaddrLabel = new Label("IP address:");
		netmaskLabel = new Label("Netmask:");
		gatewayLabel = new Label("Gateway:");
		nameserverLabel = new Label("Nameserver:");

		bootMainLabel = new Label("Create initial boot media");
		bootMainLabel.setFont(mainLabelFont);
		bootCDPanel = new Panel();
		bootCDSubPanel = new Panel();
		bootCDDevPanel = new Panel();
		bootCDDevLabel = new Label ("Boot CD device:");
		backDevPanel = new Panel();
		backDevLabel = new Label("Harddisk partition:");
		subdirPanel = new Panel();
		subdirLabel = new Label("Subdirectory:");
		ownKernelPanel = new Panel();
		ownKernelLabel = new Label("Kernel:");
		ownKernelCheck.addItemListener(myListener);
		bootParamPanel = new Panel();
		bootParamLabel = new Label("Boot parameters:");
		bootButtPanel = new Panel();
		burnButt = new Button("Burn initial boot CD");
		burnButt.addActionListener(this);
		floppyButt = new Button("Create bootable floppy disk");
		floppyButt.addActionListener(this);

		manuallyMainLabelPanel = new Panel();
		manuallyMainLabel = new Label("Manually backup");
		manuallyMainLabel.setFont(mainLabelFont);
		manuallySubMainLabel = new Label("- boot stuff for CD:");
		manuallySubMainLabel.setFont(mainSubLabelFont);
		manuallyPanel = new Panel();
		manuallySubPanel = new Panel();
		stuffBoxes[0] = new Checkbox("Not bootable backup CD", stuffRadio, true);
		stuffBoxes[0].addItemListener(myListener);
		stuffBoxes[1] = new Checkbox("Create with options from configuration tool", stuffRadio, false);
		stuffBoxes[1].addItemListener(myListener);
		stuffBoxes[2] = new Checkbox("Create with options from configuration file:", stuffRadio, false);
		stuffBoxes[2].addItemListener(myListener);
		stuffBoxes[3] = new Checkbox("Take already created boot directory (/boot on CD):", stuffRadio, false);
		stuffBoxes[3].addItemListener(myListener);

		domanuPanel = new Panel();
		domanuMainLabel = new Label("Do manually backup");
		domanuMainLabel.setFont(mainLabelFont);
		domanuSubPanel = new Panel();
		domanuBoxes[0] = new Checkbox("Take options from configuration tool", domanuRadio, true);
		domanuBoxes[0].addItemListener(myListener);
		domanuBoxes[1] = new Checkbox("Take options from configuration file:", domanuRadio, false);
		domanuBoxes[1].addItemListener(myListener);
		startBackupButtPanel = new Panel();
		startBackupButt = new Button("Start backup now");
		startBackupButt.addActionListener(this);


		fstypHash.loadFromFile(this);

//	End of initializing


		setTitle("CD Backup Linux configuration tool");

//	Main menu
		fileMenu.add("Open");
		fileMenu.add("Save");
		fileMenu.add("Save as");
		fileMenu.add("Exit");
		mainmenu.add(fileMenu);
		windowMenu.add(optionsCheckMenu);
		windowMenu.add(listCheckMenu);
		windowMenu.add(cdrCheckMenu);
		windowMenu.add(netCheckMenu);
		windowMenu.add(createCheckMenu);
		windowMenu.add(manuallyCheckMenu);
		windowMenu.add(domanuCheckMenu);
		mainmenu.add(windowMenu);
		helpMenu.add("Help");
		helpMenu.add("About");
		mainmenu.add(helpMenu);
		mainmenu.setHelpMenu(helpMenu);
		setMenuBar(mainmenu);
		holderPanel.setLayout( cards );

//	type tab
		typeSubPanel.setLayout( new GridLayout(7,2) );
		typeSubPanel.add(typeLabel);
		typeSubPanel.add(typeBoxes[0]);
		typeSubPanel.add(nullLabel3);
		typeSubPanel.add(typeBoxes[1]);
		typeSubPanel.add(zipdayLabel);
		zipdayChoice.addItem("any");
		zipdayChoice.addItem("no");
		zipdayChoice.addItem("Mon");
		zipdayChoice.addItem("Tue");
		zipdayChoice.addItem("Wed");
		zipdayChoice.addItem("Thu");
		zipdayChoice.addItem("Fri");
		zipdayChoice.addItem("Sat");
		zipdayChoice.addItem("Sun");
		typeSubPanel.add(zipdayChoice);
		typeSubPanel.add(burnzipdayLabel);
		burnzipdayCheckPanel.setLayout( new GridLayout(1,2) );
		burnzipdayCheckPanel.add(burnzipdayBoxes[0]);
		burnzipdayCheckPanel.add(burnzipdayBoxes[1]);
		typeSubPanel.add(burnzipdayCheckPanel);
		typeSubPanel.add(ziplevelLabel);
		for ( i=1; i<10; i++) {
			I = new Integer(i);
			ziplevelChoice.addItem(I.toString());
		}
		typeSubPanel.add(ziplevelChoice);
		typeSubPanel.add(readmeLabel);
		typeSubPanel.add(readmeField);
		typeSubPanel.add(tmpdirLabel);
		typeSubPanel.add(tmpdirField);
		typePanel.setLayout(gridbag);
		gridconst.anchor = GridBagConstraints.NORTH;
		gridconst.gridy = 0;
		gridbag.setConstraints(typeMainLabel, gridconst);
		typePanel.add(typeMainLabel);
		gridconst.anchor = GridBagConstraints.CENTER;
		gridconst.gridy = 1;
		gridbag.setConstraints(typeSubPanel, gridconst);
		typePanel.add(typeSubPanel);
		holderPanel.add("type", typePanel);

//	parti tab
		partiListPanel.setLayout(gridbag);
		gridconst.anchor = GridBagConstraints.CENTER;
		gridconst.gridy = 0;
		gridbag.setConstraints(partiList, gridconst);
		partiListPanel.add(partiList);
		gridconst.anchor = GridBagConstraints.SOUTH;
		gridconst.gridy = 1;
		gridbag.setConstraints(deleteButt, gridconst);
		partiListPanel.add(deleteButt);
		partiPanel.add(partiListPanel);
		partiButtPanel.setLayout(gridbag);
		newPanel.setLayout( new GridLayout(4,2) );
		newPanel.add(apartiLabel);
		newPanel.add(apartiField);
		newPanel.add(asizeLabel);
		newPanel.add(asizeBoxes[0]);
		newPanel.add(nullLabel4);
		newPanel.add(asizeBoxes[1]);
		newPanel.add(afstypLabel);
		afstypChoice.addItem("unknown");
		for (Enumeration enum = fstypHash.keys() ; enum.hasMoreElements() ;) {
			afstypChoice.addItem(enum.nextElement().toString());
		}
		newPanel.add(afstypChoice);
		gridconst.anchor = GridBagConstraints.NORTH;
		gridconst.gridy = 0;
		gridbag.setConstraints(newPanel, gridconst);
		partiButtPanel.add(newPanel);
		gridconst.anchor = GridBagConstraints.CENTER;
		gridconst.gridy = 1;
		gridbag.setConstraints(addButt, gridconst);
		partiButtPanel.add(addButt);
		partiPanel.add(partiButtPanel);
		allpartiPanel.setLayout(gridbag);
		gridconst.anchor = GridBagConstraints.NORTH;
		gridconst.gridy = 0;
		gridbag.setConstraints(partiMainLabel, gridconst);
		allpartiPanel.add(partiMainLabel);
		gridconst.anchor = GridBagConstraints.CENTER;
		gridconst.gridy = 1;
		gridbag.setConstraints(partiPanel, gridconst);
		allpartiPanel.add(partiPanel);
		holderPanel.add("parti", allpartiPanel);

//	cdr tab
		cdrSubPanel.setLayout( new GridLayout(5,2) );
		cdrSubPanel.add(hostIdLabel);
		for ( i=0; i<8; i++) {
			I = new Integer(i);
			hostIdChoice.addItem(I.toString());
		}
		cdrSubPanel.add(hostIdChoice);
		cdrSubPanel.add(scsiIdLabel);
		for ( i=0; i<16; i++) {
			I = new Integer(i);
			scsiIdChoice.addItem(I.toString());
		}
		cdrSubPanel.add(scsiIdChoice);
		cdrSubPanel.add(speedLabel);
		speedChoice.addItem("1");
		speedChoice.addItem("2");
		speedChoice.addItem("4");
		speedChoice.addItem("6");
		speedChoice.addItem("8");
		cdrSubPanel.add(speedChoice);
		cdrSubPanel.add(dummyLabel);
		cdrSubPanel.add(dummyCheck);
		cdrSubPanel.add(maxcdsizeLabel);
		cdrSubPanel.add(maxcdsizeField);
		cdrPanel.setLayout(gridbag);
		gridconst.anchor = GridBagConstraints.NORTH;
		gridconst.gridy = 0;
		gridbag.setConstraints(cdrMainLabel, gridconst);
		cdrPanel.add(cdrMainLabel);
		gridconst.anchor = GridBagConstraints.CENTER;
		gridconst.gridy = 1;
		gridbag.setConstraints(cdrSubPanel, gridconst);
		cdrPanel.add(cdrSubPanel);
		holderPanel.add("cdr", cdrPanel);

//	network tab
		netMainLabelPanel.setLayout( new GridLayout(2,1) );
		netMainLabelPanel.add(netMainLabel);
		netMainLabelPanel.add(netSubMainLabel);
		networkSubPanel.setLayout( new GridLayout(5,2) );
		networkSubPanel.add(nonetworkCheck);
		networkSubPanel.add(fillerLabel);
		networkSubPanel.add(ipaddrLabel);
		networkSubPanel.add(ipaddrField);
		networkSubPanel.add(netmaskLabel);
		netmaskChoice.addItem("255.255.255.0");
		netmaskChoice.addItem("255.255.0.0");
		netmaskChoice.addItem("255.0.0.0");
		networkSubPanel.add(netmaskChoice);
		networkSubPanel.add(gatewayLabel);
		networkSubPanel.add(gatewayField);
		networkSubPanel.add(nameserverLabel);
		networkSubPanel.add(nameserverField);
		networkPanel.setLayout(gridbag);
		gridconst.anchor = GridBagConstraints.NORTH;
		gridconst.gridy = 0;
		gridbag.setConstraints(netMainLabel, gridconst);
		networkPanel.add(netMainLabelPanel);
		gridconst.anchor = GridBagConstraints.CENTER;
		gridconst.gridy = 1;
		gridbag.setConstraints(networkSubPanel, gridconst);
		networkPanel.add(networkSubPanel);
		holderPanel.add("net", networkPanel);

//	boot tab
		bootCDSubPanel.setLayout(new GridLayout(6,1));
		bootCDDevPanel.setLayout(new GridLayout(1,2));
		bootCDDevPanel.add(bootCDDevLabel);
		bootCDDevPanel.add(bootCDDevField);
		bootCDSubPanel.add(bootCDDevPanel);
		backDevPanel.setLayout(new GridLayout(1,2));
		backDevPanel.add(backDevLabel);
		backDevPanel.add(backDevField);
		bootCDSubPanel.add(backDevPanel);
		subdirPanel.setLayout(new GridLayout(1,2));
		subdirPanel.add(subdirLabel);
		subdirPanel.add(subdirField);
		bootCDSubPanel.add(subdirPanel);
		ownKernelPanel.add(ownKernelLabel);
		ownKernelField.setEditable(false);
		ownKernelPanel.add(ownKernelField);
		ownKernelPanel.add(ownKernelCheck);
		bootCDSubPanel.add(ownKernelPanel);
		bootParamPanel.add(bootParamLabel);
		bootParamPanel.add(bootParamField);
		bootCDSubPanel.add(bootParamPanel);
		bootCDPanel.setLayout(gridbag);
		bootButtPanel.add(burnButt);
		bootButtPanel.add(floppyButt);
		bootCDSubPanel.add(bootButtPanel);
		gridconst.anchor = GridBagConstraints.NORTH;
		gridconst.gridy = 0;
		gridbag.setConstraints(bootMainLabel, gridconst);
		bootCDPanel.add(bootMainLabel);
		gridconst.anchor = GridBagConstraints.CENTER;
		gridconst.gridy = 1;
		gridbag.setConstraints(bootCDSubPanel, gridconst);
		bootCDPanel.add(bootCDSubPanel);
		holderPanel.add("boot", bootCDPanel);

//	manually tab
		manuallyMainLabelPanel.setLayout( new GridLayout(2,1) );
		manuallyMainLabelPanel.add(manuallyMainLabel);
		manuallyMainLabelPanel.add(manuallySubMainLabel);
		manuallySubPanel.setLayout( new GridLayout(6,1) );
		manuallySubPanel.add(stuffBoxes[0]);
		manuallySubPanel.add(stuffBoxes[1]);
		manuallySubPanel.add(stuffBoxes[2]);
		manuallySubPanel.add(bootStuffFileField);
		bootStuffFileField.setEditable(false);
		manuallySubPanel.add(stuffBoxes[3]);
		manuallySubPanel.add(bootStuffDirField);
		bootStuffDirField.setEditable(false);
		manuallyPanel.setLayout(gridbag);
		gridconst.anchor = GridBagConstraints.NORTH;
		gridconst.gridy = 0;
		gridbag.setConstraints(manuallyMainLabel, gridconst);
		manuallyPanel.add(manuallyMainLabelPanel);
		gridconst.anchor = GridBagConstraints.CENTER;
		gridconst.gridy = 1;
		gridbag.setConstraints(manuallySubPanel, gridconst);
		manuallyPanel.add(manuallySubPanel);
		holderPanel.add("manually", manuallyPanel);

//	domanually tab
		domanuSubPanel.setLayout( new GridLayout(5,1) );
		domanuSubPanel.add(domanuBoxes[0]);
		domanuSubPanel.add(domanuBoxes[1]);
		domanuSubPanel.add(domanuFileField);
		domanuFileField.setEditable(false);
		startBackupButtPanel.add(startBackupButt);
		domanuSubPanel.add(startBackupButtPanel);
		domanuPanel.setLayout(gridbag);
		gridconst.anchor = GridBagConstraints.NORTH;
		gridconst.gridy = 0;
		gridbag.setConstraints(domanuMainLabel, gridconst);
		domanuPanel.add(domanuMainLabel);
		gridconst.anchor = GridBagConstraints.CENTER;
		gridconst.gridy = 1;
		gridbag.setConstraints(domanuSubPanel, gridconst);
		domanuPanel.add(domanuSubPanel);
		holderPanel.add("domanu", domanuPanel);

//	Naviagtion panel
		navigPanel.setLayout( new BorderLayout() );
		navigPanel.add("West", backwardButt);
		navigPanel.add("East", forewardButt);

		setLayout(gridbag);
		gridconst.anchor = GridBagConstraints.CENTER;
		gridconst.gridy = 0;
		gridbag.setConstraints(holderPanel, gridconst);
		add(holderPanel);
		cards.show(holderPanel, "type");
		gridconst.anchor = GridBagConstraints.SOUTH;
		gridconst.gridy = 1;
		gridconst.fill = GridBagConstraints.HORIZONTAL;
		gridbag.setConstraints(navigPanel, gridconst);
		add(navigPanel);

		pwd = argpwd;

		Date today = new Date();
		SimpleDateFormat formatter = new SimpleDateFormat ("EEE");
		dayOfWeek = (formatter.format(today));

		setSize(400,350);
		setVisible(true);
		backwardButt.setVisible(false);
	}

	public void actionPerformed(ActionEvent e) {
		boolean unknownFstyp;
		String field1;
		String field2;
		String apartiString;
		String partiString = "";
		String bigString = "";
		String vfatString = "";
		int partiexistflag = 0;
		int validfileflag = 0;
		int checknr = 0;
		String syscall[] = new String[16];
		Process scriptProcess;
		boolean prebackupfailed = false;
		boolean distribkernel = false;
		boolean nonetwork = true;
		String[] checkThis = new String[4];
		if ("Open".equals(e.getActionCommand())) {
			openFile.setVisible(true);
			if ((openFile.getFile() != null) && (openFile.getFile().length() > 0)) {
				try {
					fstypHash.clearElements();
					FileInputStream inStr = new FileInputStream(openFile.getDirectory() + openFile.getFile());
					actualFile = openFile.getFile();
					actualDir = openFile.getDirectory();
					setTitle("CD Backup Linux configuration tool <" + actualFile + ">");
					c = inStr.read();
					while (c != -1) {
						field1 = "";
						while (c != -1 && ! ((char) c == ' ' || (char) c == '\t')) {
							field1 = (field1 + (char) c);
						c = inStr.read();
						}
						field2 = "";
						while (c != -1 && ((char) c == ' ' || (char) c == '\t')) {
							c = inStr.read();
						}
						while (c != -1 && (char) c != '\n') {
							field2 = (field2 + (char) c);
							c = inStr.read();
						}
						if ("PARTITIONS".equals(field1)) {
							partiString = field2.trim();
						} else if ("BIG".equals(field1)) {
							bigString = field2;
						} else if ("TYPE".equals(field1)) {
							if ("tgz".equals(field2)) {
								typeBoxes[0].setState(true);
							} else {
								typeBoxes[1].setState(true);
							}
						} else if ("CDDEV".equals(field1)) {
							if (field2.length() == 5) {
								hostIdChoice.select(field2.substring(0,1));
								field2 = field2.substring(2, 4);
							} else {
								hostIdChoice.select(0);
							}
							scsiIdChoice.select(field2.substring(0,1));
						} else if ("SPEED".equals(field1)) {
							speedChoice.select(field2);
						} else if ("MAXCDSIZE".equals(field1)) {
							maxcdsizeField.setText(field2);
						} else if ("TMPDIR".equals(field1)) {
							tmpdirField.setText(field2);
						} else if ("DUMMY".equals(field1)) {
							if ("0".equals(field2)) {
								dummyCheck.setState(false);
							} else {
								dummyCheck.setState(true);
							}
						} else if ("README".equals(field1)) {
							readmeField.setText(field2);
						} else if ("ZIPLEVEL".equals(field1)) {
							ziplevelChoice.select(field2);
						} else if ("ZIPDAY".equals(field1)) {
							zipdayChoice.select(field2);
						} else if ("BURNZIPDAY".equals(field1)) {
							if ("0".equals(field2)) {
								burnzipdayBoxes[1].setState(true);
							} else {
								burnzipdayBoxes[0].setState(true);
							}
						} else if ("NONETWORK".equals(field1)) {
							if ("0".equals(field2)) {
								nonetworkCheck.setState(false);
								ipaddrField.setEditable(true);
								netmaskChoice.setEnabled(true);
								gatewayField.setEditable(true);
								nameserverField.setEditable(true);
							} else {
								nonetworkCheck.setState(true);
								ipaddrField.setEditable(false);
								netmaskChoice.setEnabled(false);
								gatewayField.setEditable(false);
								nameserverField.setEditable(false);
							}
						} else if ("IPADDR".equals(field1)) {
							ipaddrField.setText(field2);
						} else if ("NETMASK".equals(field1)) {
							netmaskChoice.select(field2);
						} else if ("GATEWAY".equals(field1)) {
							gatewayField.setText(field2);
						} else if ("NAMESERVER".equals(field1)) {
							nameserverField.setText(field2);
						} else if ("BOOTCDDEV".equals(field1)) {
							bootCDDevField.setText(field2);
						} else if ("HDDEV".equals(field1)) {
							backDevField.setText(field2);
						} else if ("SUBDIR".equals(field1)) {
							subdirField.setText(field2);
						} else if ("DISTRIBKERNEL".equals(field1)) {
							if ("0".equals(field2)) {
								ownKernelCheck.setState(true);
							} else {
								ownKernelCheck.setState(false);
							}
						} else if ("OWNKERNEL".equals(field1)) {
							actualOwnKernel = field2;
							ownKernelField.setText(field2);
						} else if ("BOOTPARAM".equals(field1)) {
							bootParamField.setText(field2);
						} else if ("MANUBOOTSTUFF".equals(field1)) {
							try {
								stuffBoxes[Integer.parseInt(field2)].setState(true);
							} catch (NumberFormatException nume) {}
							if ("2".equals(field2)) {
								bootStuffFileField.setEditable(true);
							} else {
								bootStuffFileField.setEditable(false);
							}
							if ("3".equals(field2)) {
								bootStuffDirField.setEditable(true);
							} else {
								bootStuffDirField.setEditable(false);
							}
						} else if ("MANUCONFFILE".equals(field1)) {
							bootStuffFileField.setText(field2);
						} else if ("MANUBOOTDIR".equals(field1)) {
							bootStuffDirField.setText(field2);
						} else if ("MANUBACKUP".equals(field1)) {
							try {
								domanuBoxes[Integer.parseInt(field2)].setState(true);
							} catch (NumberFormatException nume) {}
							if ("1".equals(field2)) {
								domanuFileField.setEditable(true);
							} else {
								domanuFileField.setEditable(false);
							}
						} else if ("MANUBACKUPFILE".equals(field1)) {
							domanuFileField.setText(field2);
						} else if (fstypHash.containsKey(field1)) {
							fstypHash.put(field1, (fstypHash.get(field1) + field2 + " "));
						}
						if (c != -1) {c = inStr.read();}
					}
					if (ownKernelCheck.getState()) {
						ownKernelField.setText(actualOwnKernel);
						ownKernelField.setEditable(true);
					} else {
						ownKernelField.setText("Kernel from distribution");
						ownKernelField.setEditable(false);
					}
					partiList.removeAll();
					i=0;
					while (c < partiString.length()) {
						c = partiString.indexOf(" ", i);
						if (c < 0) {
							c = partiString.length();
						}
						apartiString = (partiString.substring(i, c) + " ");
						if (((bigString.indexOf(apartiString)) != -1) || bigString.endsWith(partiString.substring(i, c))) {
							apartiString = (apartiString + "big ");
						} else {
							apartiString = (apartiString + "small ");
						}
						unknownFstyp = true;
						for (Enumeration enum = fstypHash.keys() ; enum.hasMoreElements() ; ) {
							afstyptmp = enum.nextElement().toString();
							if ((fstypHash.get(afstyptmp).toString().indexOf(partiString.substring(i, c) + " ") != -1) || (fstypHash.get(afstyptmp).toString().endsWith(partiString.substring(i, c)))) {
								apartiString = (apartiString + afstyptmp);
								unknownFstyp = false;
							}
						}
						if (unknownFstyp) {
							apartiString = (apartiString + "unknown");
						}
						partiList.add(apartiString);
						i = (partiString.indexOf(" ", (i + 1)) + 1);
					}
				} catch (IOException ioe) {
					myMessageDialog.showMsg(this, "Cant't open " + openFile.getDirectory() + openFile.getFile() + "!");
				}
			}
		}
		if(e.getActionCommand().startsWith("Save")) {
			checkThis[0] = "backup";
			checkThis[1] = "record";
			checkThis[2] = "";
			checkThis[3] = "";
			if (! "".equals(checkFields(checkThis))) {
				myMessageDialog.showMsg(this, ("WARNING!\n\n" + checkFields(checkThis) + "Do you want to save anyway?"), "YesNo");
			}
			if ("".equals(checkFields(checkThis)) || "Yes".equals(myMessageDialog.getLastActionCommand())) {
				saveFile.setFile(actualFile);
				saveFile.setDirectory(actualDir);
				if("Save as".equals(e.getActionCommand()) || "".equals(actualFile.toString())) {
					saveFile.setVisible(true);
				} else {
				}
				if ((saveFile.getFile() != null) && (saveFile.getFile().length() > 0)) {
					saveConfigFile(saveFile.getDirectory() + saveFile.getFile());
				}
			}
		}
		if("Exit".equals(e.getActionCommand())) {
			dispose();
			System.exit(0);
		}
		if("Help".equals(e.getActionCommand())) {
					try {
						Runtime.getRuntime().exec("netscape file://" + pwd + "/doc/index.html");
					} catch (IOException ioe) {
						myMessageDialog.showMsg(this, "Please start your favourite browser to read " + pwd + "/doc/index.html.");
					}
		}
		if("About".equals(e.getActionCommand())) {
			myMessageDialog.showMsg(this, "CD Backup Linux configuration tool   Copyright (C) 1998 - 1999 Stefan Forstmoser");
		}
		if (">>".equals(e.getActionCommand())) {
			cards.next(holderPanel);
			updateWindowMenu();
		}
		if ("<<".equals(e.getActionCommand())) {
			cards.previous(holderPanel);
			updateWindowMenu();
		}
		if ("Add".equals(e.getActionCommand())) {
			for (i=0; i < partiList.getItemCount(); i++) {
				if (partiList.getItem(i).startsWith((apartiField.getText() + " "))) {
					partiexistflag = 1;
				}
			}
			if ("".equals(apartiField.getText())) {
				myMessageDialog.showMsg(this, "No partition entered.");
			} else if (partiexistflag > 0) {
				myMessageDialog.showMsg(this, "Partition already exists in list.");
			} else {
				partiList.add(apartiField.getText() + " " + asizeRadio.getSelectedCheckbox().getLabel() + " " + afstypChoice.getSelectedItem());
			}
		}
		if ("Delete".equals(e.getActionCommand())) {
			try {
				partiList.delItem(partiList.getSelectedIndex());
			} catch (Exception ex) {	
				myMessageDialog.showMsg(this, "No partition selected.");
			}
		}
		if ("Burn initial boot CD".equals(e.getActionCommand()) || "Create bootable floppy disk".equals(e.getActionCommand())) {
			checkThis[0] = "bootmedia";
			checkThis[1] = "";
			checkThis[2] = "";
			checkThis[3] = "";
			if (! "".equals(checkFields(checkThis))) {
				myMessageDialog.showMsg(this, checkFields(checkThis));
			} else {
				syscall[0] = "xterm";
				syscall[1] = "-e";
				syscall[2] = "createbootcd.sh";
				syscall[3] = bootCDDevField.getText();
				syscall[4] = backDevField.getText();
				syscall[5] = subdirField.getText();
				if (ownKernelCheck.getState()) {
					syscall[6] = ownKernelField.getText();
				} else {
					syscall[6] = "";
				}
				syscall[7] = bootParamField.getText();
				if (nonetworkCheck.getState()) {
					syscall[8] = "";
					syscall[9] = "";
					syscall[10] = "";
					syscall[11] = "";
				} else {
					syscall[8] = ipaddrField.getText();
					syscall[9] = netmaskChoice.getSelectedItem();
					syscall[10] = gatewayField.getText();
					syscall[11] = nameserverField.getText();
				}
				if ("Burn initial boot CD".equals(e.getActionCommand())) {
					syscall[12] = hostIdChoice.getSelectedItem();
					syscall[13] = scsiIdChoice.getSelectedItem();
					syscall[14] = speedChoice.getSelectedItem();
					if (dummyCheck.getState()) {
						syscall[15] = "1";
					} else {
						syscall[15] = "0";
					}
					myMessageDialog.showMsg(this, "Please insert an empty CD-R.", "Cancel");
				} else {
					syscall[12] = "floppy";
					syscall[13] = "";
					syscall[14] = "";
					syscall[15] = "";
					myMessageDialog.showMsg(this, "Please insert an empty floppy disk.", "Cancel");
				}
				if ("Ok".equals(myMessageDialog.getLastActionCommand())) {
					try {
						Runtime.getRuntime().exec(syscall);
					} catch (IOException ioe) {
						myMessageDialog.showMsg(this, "Can't exec 'xterm -e createbootcd.sh ...'!");
					}
				}
			}
		}
		if("Start backup now".equals(e.getActionCommand())) {
			if (stuffBoxes[1].getState()) {
				checkThis[0] = "bootmedia";
			} else {
				checkThis[0] = "";
			}
			checkThis[3] = "";
			if (domanuBoxes[0].getState()) {
				checkThis[1] = "manuallybackup";
				if (dayOfWeek.equals(zipdayChoice.getSelectedItem()) || ("any".equals(zipdayChoice.getSelectedItem()))) {
					checkThis[2] = "backup";
				} else {
					checkThis[2] = "record";
				}
			} else {
				checkThis[1] = "";
				checkThis[2] = "";
			}
			if (! "".equals(checkFields(checkThis))) {
				myMessageDialog.showMsg(this, ("FAULT!\n" + checkFields(checkThis)));
			} else {
				if (dayOfWeek.equals(zipdayChoice.getSelectedItem()) || ("any".equals(zipdayChoice.getSelectedItem()))) {
					myMessageDialog.showMsg(this, "Doing a backup session (zip-day)?", "YesNo");
				} else {
					myMessageDialog.showMsg(this, "Doing a burn session (non zip-day)?", "YesNo");
				}
				if ("Yes".equals(myMessageDialog.getLastActionCommand())) {
					syscall[0] = "xterm";
					syscall[1] = "-e";
					if (stuffBoxes[1].getState()) {
						syscall[2] = "createbootcd.sh";
						syscall[3] = bootCDDevField.getText();
						syscall[4] = backDevField.getText();
						syscall[5] = subdirField.getText();
						if (ownKernelCheck.getState()) {
							syscall[6] = ownKernelField.getText();
						} else {
							syscall[6] = "";
						}
						syscall[7] = bootParamField.getText();
						if (nonetworkCheck.getState()) {
							syscall[8] = "";
							syscall[9] = "";
							syscall[10] = "";
							syscall[11] = "";
						} else {
							syscall[8] = ipaddrField.getText();
							syscall[9] = netmaskChoice.getSelectedItem();
							syscall[10] = gatewayField.getText();
							syscall[11] = nameserverField.getText();
						}
					}
					if (stuffBoxes[2].getState()) {
						syscall[2] = "createbootcd.sh";
						try {
							FileInputStream confbootStr = new FileInputStream(bootStuffFileField.getText());
							c = confbootStr.read();
							while (c != -1) {
								field1 = "";
								while (c != -1 && ! ((char) c == ' ' || (char) c == '\t')) {
									field1 = (field1 + (char) c);
								c = confbootStr.read();
								}
								field2 = "";
								while (c != -1 && ((char) c == ' ' || (char) c == '\t')) {
									c = confbootStr.read();
								}
								while (c != -1 && (char) c != '\n') {
									field2 = (field2 + (char) c);
									c = confbootStr.read();
								}
								if ("BOOTCDDEV".equals(field1)) {
									syscall[3] = field2;
								} else if ("HDDEV".equals(field1)) {
									syscall[4] = field2;
								} else if ("SUBDIR".equals(field1)) {
									syscall[5] = field2;
								} else if ("OWNKERNEL".equals(field1)) {
									syscall[6] = field2;
								} else if ("BOOTPARAM".equals(field1)) {
									syscall[7] = field2;
								} else if ("IPADDR".equals(field1)) {
									syscall[8] = field2;
								} else if ("NETMASK".equals(field1)) {
									syscall[9] = field2;
								} else if ("GATEWAY".equals(field1)) {
									syscall[10] = field2;
								} else if ("NAMESERVER".equals(field1)) {
									syscall[11] = field2;
								} else if ("DISTRIBKERNEL".equals(field1)) {
									if ("1".equals(field2)) {
										distribkernel = true;
									} else {
										distribkernel = false;
									}
								} else if ("NONETWORK".equals(field1)) {
									if ("1".equals(field2)) {
										nonetwork = true;
									} else {
										nonetwork = false;
									}
								}
								if (c != -1) {c = confbootStr.read();}
							}
						if (distribkernel) {
							syscall[6] = "";
						}
						if (nonetwork) {
							for (i = 8; i < 12; i++) {syscall[i] = "";}
						}
		
						} catch (IOException ioe) {
							myMessageDialog.showMsg(this, "Can't open configuration file " + bootStuffFileField.getText() + " !");
							prebackupfailed = true;
						}
					}
					if ((stuffBoxes[1].getState() || stuffBoxes[2].getState()) && ! prebackupfailed) {
						for (i = 12; i < 16; i++) {syscall[i] = "";}
						try {
							scriptProcess = Runtime.getRuntime().exec(syscall);
							try {
								scriptProcess.waitFor();
							} catch (InterruptedException ie) {
								 prebackupfailed = true;
							}
						} catch (IOException ioe) {
							myMessageDialog.showMsg(this, "Can't exec 'xterm -e createbootcd.sh ...'!");
							prebackupfailed = true;
						}
					}
		
					syscall[2] = "backup.pl";
					if (domanuBoxes[0].getState()) {
						syscall[3] = backDevField.getText();
						syscall[4] = bootCDDevField.getText();
						syscall[5] = subdirField.getText();
						syscall[6] = "tmpcdbl.cfg";
						saveConfigFile("tmpcdbl.cfg", true);
					} else {
						try {
							FileInputStream confStr = new FileInputStream(domanuFileField.getText());
							c = confStr.read();
							while (c != -1) {
								field1 = "";
								while (c != -1 && ! ((char) c == ' ' || (char) c == '\t')) {
									field1 = (field1 + (char) c);
								c = confStr.read();
								}
								field2 = "";
								while (c != -1 && ((char) c == ' ' || (char) c == '\t')) {
									c = confStr.read();
								}
								while (c != -1 && (char) c != '\n') {
									field2 = (field2 + (char) c);
									c = confStr.read();
								}
								if ("BOOTCDDEV".equals(field1)) {
									syscall[3] = field2;
								} else if ("HDDEV".equals(field1)) {
									syscall[4] = field2;
								} else if ("SUBDIR".equals(field1)) {
									syscall[5] = field2;
								}
								if (c != -1) {c = confStr.read();}
							}
							syscall[6] = domanuFileField.getText();
							i = 0;
						} catch (IOException ioe) {
							myMessageDialog.showMsg(this, "Can't open configuration file " + domanuFileField.getText() + " !");
							prebackupfailed = true;
						}
					}
					if (! prebackupfailed) {
						if (stuffBoxes[1].getState()) {
							syscall[7] = "tmpboot/cd/boot";
						} else if (stuffBoxes[2].getState()) {
							syscall[7] = "tmpboot/cd/boot";
						} else if (stuffBoxes[3].getState()) {
							syscall[7] = bootStuffFileField.getText();
						} else {
							syscall[7] = "";
						}
						syscall[8] = "noauto";
						for (i = 9; i < 16; i++) {syscall[i] = "";}
						myMessageDialog.showMsg(this, "Please insert an empty CD-R.", "Cancel");
						if ("Ok".equals(myMessageDialog.getLastActionCommand())) {
							try {
								Runtime.getRuntime().exec(syscall);
							} catch (IOException ioe) {
								myMessageDialog.showMsg(this, "Can't exec 'xterm -e backup.pl ...'!");
							}
						}
					}
				}
			}
		}
	}

	public void saveConfigFile(String fileName) {
		saveConfigFile(fileName, false);
	}
	public void saveConfigFile(String fileName, boolean temporary) {
		String partiString = "";
		String bigString = "";
		int checknr = 0;
		try {
			FileOutputStream fStr = new FileOutputStream(fileName);
			if (! temporary) {
				actualFile = saveFile.getFile();
				actualDir = saveFile.getDirectory();
				setTitle("CD Backup Linux configuration tool <" + actualFile + ">");
			}
			fstypHash.clearElements();
			for (i=0; i < partiList.getItemCount(); i++) {
				partiString = (partiString + partiList.getItem(i).substring(0, partiList.getItem(i).indexOf(" ")) + " ");
				if ("big".equals(partiList.getItem(i).substring((partiList.getItem(i).indexOf(" ") + 1), partiList.getItem(i).lastIndexOf(" "))))  {
					bigString = (bigString + partiList.getItem(i).substring(0, partiList.getItem(i).indexOf(" ")) + " ");
				}
				for (Enumeration enum = fstypHash.keys() ; enum.hasMoreElements();) {
					afstyptmp = enum.nextElement().toString();
					if (afstyptmp.equals(partiList.getItem(i).substring((partiList.getItem(i).lastIndexOf(" ") + 1), partiList.getItem(i).length()))){
						fstypHash.put(afstyptmp, (fstypHash.get(afstyptmp) + partiList.getItem(i).substring(0, partiList.getItem(i).indexOf(" ")) + " "));
					}
				}
			}
			PrintStream outStr = new PrintStream(fStr);
			outStr.println("PARTITIONS\t" + partiString);
			outStr.println("BIG\t" + bigString);
			for (Enumeration enum = fstypHash.keys() ; enum.hasMoreElements(); ) {
				afstyptmp = enum.nextElement().toString();
				if (! "".equals(fstypHash.get(afstyptmp))) {
					outStr.println(afstyptmp + "\t" + fstypHash.get(afstyptmp));
				}
			}
			outStr.println("TYPE\t" + typeRadio.getSelectedCheckbox().getLabel());
			outStr.println("CDDEV\t" + hostIdChoice.getSelectedItem() + "," + scsiIdChoice.getSelectedItem() + ",0");
			outStr.println("SPEED\t" + speedChoice.getSelectedItem());
			outStr.println("MAXCDSIZE\t" + maxcdsizeField.getText());
			outStr.println("TMPDIR\t" + tmpdirField.getText());
			if (dummyCheck.getState()) {
				outStr.println("DUMMY\t1");
			} else {
				outStr.println("DUMMY\t0");
			}
			outStr.println("README\t" + readmeField.getText());
			outStr.println("ZIPDAY\t" + zipdayChoice.getSelectedItem());
			if (burnzipdayBoxes[0].getState()) {
				outStr.println("BURNZIPDAY\t1");
			} else {
				outStr.println("BURNZIPDAY\t0");
			}
			outStr.println("ZIPLEVEL\t" + ziplevelChoice.getSelectedItem());
			if (nonetworkCheck.getState()) {
				outStr.println("NONETWORK\t1");
			} else {
				outStr.println("NONETWORK\t0");
			}
			outStr.println("IPADDR\t" + ipaddrField.getText());
			outStr.println("NETMASK\t" + netmaskChoice.getSelectedItem());
			outStr.println("GATEWAY\t" + gatewayField.getText());
			outStr.println("NAMESERVER\t" + nameserverField.getText());
			outStr.println("BOOTCDDEV\t" + bootCDDevField.getText());
			outStr.println("HDDEV\t" + backDevField.getText());
			outStr.println("SUBDIR\t" + subdirField.getText());
			if (ownKernelCheck.getState()) {
				outStr.println("DISTRIBKERNEL\t0");
				outStr.println("OWNKERNEL\t" + ownKernelField.getText());
			} else {
				outStr.println("DISTRIBKERNEL\t1");
				outStr.println("OWNKERNEL\t" + actualOwnKernel);
			}
			outStr.println("BOOTPARAM\t" + bootParamField.getText());
			for (checknr = 0; ! stuffBoxes[checknr].getState(); checknr++);
			outStr.println("MANUBOOTSTUFF\t" + checknr);
			outStr.println("MANUCONFFILE\t" + bootStuffFileField.getText());
			outStr.println("MANUBOOTDIR\t" + bootStuffDirField.getText());
			for (checknr = 0; ! domanuBoxes[checknr].getState(); checknr++);
			outStr.println("MANUBACKUP\t" + checknr);
			outStr.println("MANUBACKUPFILE\t" + domanuFileField.getText());
		} catch (IOException ioe) {
			myMessageDialog.showMsg(this, "Can't save " + fileName + "!");
		}
	}

	private class CheckMenuListener implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
			if ("Backup options".equals(e.getItem())) {
				cards.show(holderPanel, "type");
				updateWindowMenu();
			}
			if("Backup list".equals(e.getItem())) {
				cards.show(holderPanel, "parti");
				updateWindowMenu();
			}
			if("CD-recorder options".equals(e.getItem())) {
				cards.show(holderPanel, "cdr");
				updateWindowMenu();
			}
			if("Network options for boot media".equals(e.getItem())) {
				cards.show(holderPanel, "net");
				updateWindowMenu();
			}
			if("Create initial boot media".equals(e.getItem())) {
				cards.show(holderPanel, "boot");
				updateWindowMenu();
			}
			if ("Manually backup - boot stuff for CD".equals(e.getItem())) {
				cards.show(holderPanel, "manually");
				updateWindowMenu();
			}
			if ("Do manually backup".equals(e.getItem())) {
				cards.show(holderPanel, "domanu");
				updateWindowMenu();
			}
			if("Disable network".equals(e.getItem())) {
				if (nonetworkCheck.getState()) {
					ipaddrField.setEditable(false);
					netmaskChoice.setEnabled(false);
					gatewayField.setEditable(false);
					nameserverField.setEditable(false);
				} else {
					ipaddrField.setEditable(true);
					netmaskChoice.setEnabled(true);
					gatewayField.setEditable(true);
					nameserverField.setEditable(true);
					ipaddrField.requestFocus();
				}
			}
			if("own kernel".equals(e.getItem())) {
				if (ownKernelCheck.getState()) {
					ownKernelField.setText(actualOwnKernel);
					ownKernelField.setEditable(true);
					ownKernelField.requestFocus();
				} else {
					actualOwnKernel=ownKernelField.getText();
					ownKernelField.setText("Kernel from distribution");
					ownKernelField.setEditable(false);
				}
			}
			if("Not bootable backup CD".equals(e.getItem())) {
				bootStuffFileField.setEditable(false);
				bootStuffDirField.setEditable(false);
			}
			if("Create with options from configuration tool".equals(e.getItem())) {
				bootStuffFileField.setEditable(false);
				bootStuffDirField.setEditable(false);
			}
			if("Create with options from configuration file:".equals(e.getItem())) {
				bootStuffFileField.setEditable(true);
				bootStuffFileField.requestFocus();
				bootStuffDirField.setEditable(false);
			}
			if("Take already created boot directory (/boot on CD):".equals(e.getItem())) {
				bootStuffFileField.setEditable(false);
				bootStuffDirField.setEditable(true);
				bootStuffDirField.requestFocus();
			}
			if("Take options from configuration tool".equals(e.getItem())) {
				domanuFileField.setEditable(false);
			}
			if("Take options from configuration file:".equals(e.getItem())) {
				domanuFileField.setEditable(true);
				domanuFileField.requestFocus();
			}
		}
	}

	private class MaxSizeListener implements TextListener {
		String actualMaxSize = new String("");
		public void textValueChanged(TextEvent txe) {
			boolean isNumber = true;
			String tryMaxSize = maxcdsizeField.getText();
			for (int i = 0; i < tryMaxSize.length(); i++){
				if ( (tryMaxSize.charAt(i) < '0' || tryMaxSize.charAt(i) > '9') ) {
					isNumber = false;
				}
			}
			if (isNumber) {
				actualMaxSize = tryMaxSize;
			} else {
				maxcdsizeField.setText(actualMaxSize);
			}
		}
	}

	private void updateWindowMenu() {
		optionsCheckMenu.setState(typePanel.isVisible());
		listCheckMenu.setState(allpartiPanel.isVisible());
		cdrCheckMenu.setState(cdrPanel.isVisible());
		netCheckMenu.setState(networkPanel.isVisible());
		createCheckMenu.setState(bootCDPanel.isVisible());
		manuallyCheckMenu.setState(manuallyPanel.isVisible());
		domanuCheckMenu.setState(domanuPanel.isVisible());
		if (typePanel.isVisible()) {
			backwardButt.setVisible(false);
		} else {
			backwardButt.setVisible(true);
		}
		if (domanuPanel.isVisible()) {
			forewardButt.setVisible(false);
		} else {
			forewardButt.setVisible(true);
		}
	}

	public boolean handleEvent(Event e) {
		if(e.id == e.WINDOW_DESTROY) {
			dispose();
			System.exit(0);
			return true;
		} else {
			return super.handleEvent(e);
		}
	}

	private String checkFields(String[] toCheck) {
		String warnMsg = new String("");
		String missingParams = new String("");
		File testFile;
		for (i = 0; i >= 0; i++) {
			try {
				missingParams = "";
				if ("backup".equals(toCheck[i])) {
					if ("".equals(maxcdsizeField.getText())) {
						missingParams = (missingParams + "Max. CD-size, ");
					}
					if (partiList.getItemCount() == 0) {
						missingParams = (missingParams + "Backup list, ");
					}
					if (! "".equals(missingParams)) {
						warnMsg = (warnMsg + "Backup will not work!\nMissing Parameter(s): " + missingParams.substring(0, (missingParams.length() - 2)) + ".\n\n");
					}
				} else if ("record".equals(toCheck[i])) {
					if ("".equals(maxcdsizeField.getText())) {
						missingParams = (missingParams + "Max. CD-size, ");
					}
					if (! "".equals(missingParams)) {
						warnMsg = (warnMsg + "CD-recroding will not work!\nMissing Parameter(s): " + missingParams.substring(0, (missingParams.length() - 2)) + ".\n\n");
					}
				} else if ("bootmedia".equals(toCheck[i])) {
					if ("".equals(bootCDDevField.getText())) {
						missingParams = (missingParams + "Boot CD device, ");
					}
					if ("".equals(backDevField.getText())) {
						missingParams = (missingParams + "Harddisk partition, ");
					}
					testFile = new File(ownKernelField.getText());
					if (ownKernelCheck.getState() && ! testFile.canRead()) {
						missingParams = (missingParams + "'Can not read own kernel.', ");
					}
					if (! nonetworkCheck.getState() && "".equals(ipaddrField.getText())) {
						missingParams = (missingParams + "IP address, ");
					}
					if (! "".equals(missingParams)) {
						warnMsg = (warnMsg + "Can't create boot media!\nMissing Parameter(s): " + missingParams.substring(0, (missingParams.length() - 2)) + ".\n\n");
					}
				} else if ("manuallybackup".equals(toCheck[i])) {
					if ("".equals(backDevField.getText())) {
						missingParams = (missingParams + "Harddisk partition, ");
					}
					if (! "".equals(missingParams)) {
						warnMsg = (warnMsg + "Can't do a manually backup!\nMissing Parameter(s): " + missingParams.substring(0, (missingParams.length() - 2)) + ".\n\n");
					}
				}
			} catch(Exception e) {i = -2;}
		}
		return warnMsg;
	}

	private class MyFstypHash extends Hashtable {
		public void clearElements() {
			for (Enumeration enum = this.keys() ; enum.hasMoreElements() ; ) {
				this.put(enum.nextElement().toString(), "");
			}
		}
		public void loadFromFile(Frame gui) {
			try {
				FileInputStream inStr = new FileInputStream("supfstyp");
				c = inStr.read();
				while (c != -1) {
					afstyptmp = "";
					while (c != -1 && (char) c != '\n') {
						afstyptmp = (afstyptmp + (char) c);
						c = inStr.read();
					}
					this.put(afstyptmp, "");
					if (c != -1) {
						c = inStr.read();
					}
				}
			} catch (IOException ioe) {
				myMessageDialog.showMsg(gui, "Can't open supfstyp!");
			}
		}

	}

	private class MessageDialog extends Dialog implements ActionListener {
		int thiswindowheight = 100;
		Panel messageDialogPanel;
		Label messageDialogLabel;
		TextArea messageDialogTextArea;
		int areaX;
		int areaY;
		Panel messageButtPanel;
		Button okDialogButt;
		Button cancelDialogButt;
		Button yesDialogButt;
		Button noDialogButt;
		FontMetrics labelFontMetrics;
		String lastButton;

		MessageDialog(Frame parent) {
			super(parent, "Message:", true);

			messageDialogPanel = new Panel();
			messageDialogLabel = new Label("");
			messageDialogTextArea = new TextArea("", 0, 0, TextArea.SCROLLBARS_NONE);
			messageButtPanel = new Panel();
			okDialogButt = new Button("Ok");
			okDialogButt.addActionListener(this);
			cancelDialogButt = new Button("Cancel");
			cancelDialogButt.addActionListener(this);
			yesDialogButt = new Button("Yes");
			yesDialogButt.addActionListener(this);
			noDialogButt = new Button("No");
			noDialogButt.addActionListener(this);
			lastButton = new String();

			messageButtPanel.add(okDialogButt);
			messageButtPanel.add(cancelDialogButt);
			messageButtPanel.add(yesDialogButt);
			messageButtPanel.add(noDialogButt);
			messageDialogTextArea.setEditable(false);
			messageDialogPanel.setLayout(gridbag);
			gridconst.anchor = GridBagConstraints.NORTH;
			gridconst.gridy = 0;
			gridbag.setConstraints(messageDialogLabel, gridconst);
			messageDialogPanel.add(messageDialogLabel);
			gridbag.setConstraints(messageDialogTextArea, gridconst);
			messageDialogPanel.add(messageDialogTextArea);
			gridconst.anchor = GridBagConstraints.SOUTH;
			gridconst.gridy = 1;
			gridbag.setConstraints(messageButtPanel, gridconst);
			messageDialogPanel.add(messageButtPanel);
			super.add(messageDialogPanel);
		}
		public void showMsg(Frame parent, String msg) {
			showMsg(parent, msg, "Ok");
		}
		public void showMsg(Frame parent, String msg, String type) {
			Point myLocation = parent.getLocationOnScreen();

			if (msg.indexOf('\n') >= 0) {
				messageDialogLabel.setVisible(false);
				messageDialogTextArea.setVisible(true);
				messageDialogTextArea.setText(msg);
				labelFontMetrics = messageDialogTextArea.getFontMetrics(messageDialogTextArea.getFont());
				areaY = areaX = 0;
				for (i=0; i < msg.length(); i++) {
					c = 0;
					for ( ; i < msg.length() &&
					 msg.charAt(i) != '\n'; i++) {
						c++;
					}
					if (areaX < labelFontMetrics.stringWidth(msg.substring((i - c), i))) {
						areaX = labelFontMetrics.stringWidth(msg.substring((i - c), i));
					}
					areaY++;
				}
				// hmm, setColumns behaves strange, lot of
				// workaround for that.
				messageDialogTextArea.setColumns(areaX / 7);
				messageDialogTextArea.setRows(areaY);
				super.setSize((areaX + 100), (areaY * labelFontMetrics.getHeight() + 70));
			} else {
				messageDialogLabel.setVisible(true);
				messageDialogTextArea.setVisible(false);
				messageDialogLabel.setText(msg);
				labelFontMetrics = messageDialogLabel.getFontMetrics(messageDialogLabel.getFont());
				super.setSize((labelFontMetrics.stringWidth(msg) + 30), thiswindowheight);
			}
			myLocation.translate((parent.getSize().width / 2 - (super.getSize().width / 2)), (parent.getSize().height / 2 - (super.getSize().height / 2)));
			super.setLocation(myLocation);
			if ("Cancel".equals(type)) {
				okDialogButt.setVisible(true);
				cancelDialogButt.setVisible(true);
				yesDialogButt.setVisible(false);
				noDialogButt.setVisible(false);
				
			} else {
				cancelDialogButt.setVisible(false);
				if("YesNo".equals(type)) {
					okDialogButt.setVisible(false);
					cancelDialogButt.setVisible(false);
					yesDialogButt.setVisible(true);
					noDialogButt.setVisible(true);
				} else {
						okDialogButt.setVisible(true);
						cancelDialogButt.setVisible(false);
						yesDialogButt.setVisible(false);
						noDialogButt.setVisible(false);
				}
			}
			super.setVisible(true);
		}
		public void actionPerformed(ActionEvent e) {
			lastButton = e.getActionCommand();
			setVisible(false);
		}
		public String getLastActionCommand() {
			return lastButton;
		}
	}



	public static void main(String args[]) {

		BackTool daTool = new BackTool();

		daTool.start(args[0]);

	}
}
