#!/usr/bin/perl

#backup.pl v0.1
#This program automatically creates backups on CD-R's
#Copyrigth (C)1998 - 1999  Stefan Forstmoser 
#
#    This program is free software; you can redistribute it and/or modify 
#    it under the terms of the GNU General Public License as published by 
#    the Free Software Foundation; either version 2 of the License, or 
#    (at your option) any later version. 
#
#    This program is distributed in the hope that it will be useful, 
#    but WITHOUT ANY WARRANTY; without even the implied warranty of 
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
#    GNU General Public License for more details. 
#
#    You should have received a copy of the GNU General Public License 
#    along with this program; if not, write to the Free Software 
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 

if (`id -u` != 0) {
	print "You must be 'root' to create backups or burn CD-Rs of them.\n";
	sleep 3;
	die;
}
$timeout = 15;
$mountcount = 0;
umask (0177);

$harddisk = $ARGV[0];
$bootcddev = $ARGV[1];
$subdir = $ARGV[2];
$otherbackup_conf = $ARGV[3];
$bootstuffdir = $ARGV[4];
$noautobackup = $ARGV[5];
#print "$harddisk - $bootcddev - $subdir - $otherbackup_conf - $bootstuffdir - $noautobackup \n";
unless ($harddisk) { mydie ("Parameter for harddisk missing!\nusage: $0 [HARDDISK] [BOOTCDDEV] [SUBDIR] [OTHERBACKUPCONF] [BOOTSTUFFDIR] [NOAUTO]") };

unless ($noautobackup) {
	print "\n********************************************************************************\n";
	print "                CDBL - automatically backup starting in $timeout seconds!\n";
	print "                    type 'kill $$' to abort (and maybe restore)\n\n\n\n\n\n\n\n";
	print "See /usr/cdbl:\n";
	print "backup.pl       : this script - automatically creates backups on CD-Rs\n";
	print "restore.pl      : for restoring those backups\n";
	print "helprestore.txt : help on restoring\n";
	print "\n       type halt to shutdown and afterwards ctrl-alt-del to reboot\n";
	print "********************************************************************************\n";
	sleep $timeout;
}

open (MTAB, "/etc/mtab");
$devfound = 0;
while (<MTAB>) {
	if (/$harddisk /) {
		$harddisk = (split)[1];
		$devfound = 1;
		last;
	}
}
close (MTAB);
unless ($devfound) {
	mkdir ("/cd-image.$$", 0755) || mydie ("Can't make directory /cd-image.\$\$ to mount $harddisk!");
	(`mount $harddisk /cd-image.$$ ; echo $?` && `grep /cd-image.$$ /etc/mtab` eq "") && mydie ("Can't mount $harddisk!");
	$harddisk = "/cd-image.$$"
}

# get parameters from cdbl.cfg
if ($otherbackup_conf) {
	open (CONF, $otherbackup_conf) ||
		mydie("Can't open backup configuration file '$otherbackup_conf'!");
} else {
	open (CONF, "$harddisk$subdir/cdbl.cfg") ||
		mydie ("No configuration file found ($harddisk$subdir/cdbl.cfg)!");
}
while (<CONF>) {
	unless ($_ =~ /^#/) {
		chomp;
		if ((split)[0] eq "PARTITIONS") {
			@partitionstmp=(split);
			shift @partitionstmp;
		} else {
			if ((split)[0] =~ /[0-9a-z]+/) {
				push(@supfstyp, (split)[0]);
			}
			if ((split) < 3) {
				$conf{(split)[0]} = ((split)[1]);
			} else {
				$conf{(split)[0]} = substr($_, index($_, (split)[1]));
			}
		}
	}
}

$conf{"BIG"} = ($conf{"BIG"} . " ");
foreach $asupfs (@supfstyp) {
	$conf{$asupfs} = ($conf{$asupfs} . " ");
}
unless ($conf{"MAXCDSIZE"} ) {
	mydie ("Parameter MAXCDSIZE missing in cdbl.cfg!");
}
$conf{"MAXCDSIZE"} = ($conf{"MAXCDSIZE"} * 1048576);
unless (@partitionstmp) {
	mydie ("Parameter PARTITIONS missing in cdbl.cfg!");
}
unless ($conf{"CDDEV"}) {
	mydie ("Parameter CDDEV missing in cdbl.cfg!");
}
unless ( $conf{"TYPE"} ) {
	mydie ("Parameter TYPE missing in cdbl.cfg!");
}
unless ($conf{"TYPE"} eq "dd" || $conf{"TYPE"} eq "tgz") {
	mydie ("TYPE '$conf{'TYPE'}' not supported. Use 'dd' or 'tgz'.");
}
if ($conf{"DUMMY"}) {
	$dummyflg="-dummy";
} else {
	$dummyflg="";
}
unless ($conf{"ZIPLEVEL"} =~ /[1-9]/) {
	$conf{"ZIPLEVEL"} = 6;
}

# So, what do we do today?
$day = `date +%a`;
chomp $day;
if ($day eq substr($conf{'ZIPDAY'}, 0, 3) || "any" eq substr($conf{'ZIPDAY'}, 0, 3)) {
	# A zip-day, lot of cpu-usage!

	# Checking, that the partitions are not mounted.
	open (MTAB, "/etc/mtab");
	while (<MTAB>) {
		for ($i = 0; $i <= $#partitionstmp; $i++) {
			if (/$partitionstmp[$i] /) {
				print "WARNING: /dev/$partitionstmp[$i] is mounted. NOT backing up!";
				$partitionstmp[$i] = "MOUNTED";
			}
		}
	}
	close (MTAB);
	foreach $partiti (@partitionstmp) {
		unless ($partiti eq "MOUNTED") { push (@partitions, $partiti); }
	}
	
	# Writing date-time, type and fdisk-output to backinfo
	if (@partitions) {
		$timestamp = `date +%Y%m%d%H%M`;
		chomp $timestamp;
		mkdir ("$harddisk$subdir$conf{'TMPDIR'}/$timestamp", 0755);

		open (BACKINFO, ">$harddisk$subdir$conf{'TMPDIR'}/backinfo.$timestamp");
		print BACKINFO "$timestamp $conf{'TYPE'}\n";
	}

	foreach $partiti (@partitions) {
		$olddisk=0;
		foreach $disk (@disks) {
			if ($disk eq substr($partiti, 0, 3)) { $olddisk = 1 }
		}
		unless ($olddisk == 1) {
			push @disks, substr($partiti, 0, 3);
			$disk = substr($partiti, 0, 3);
			open (FDISK, "fdisk /dev/$disk 2>/dev/null <<%
			p
			q
			%|");
			while (<FDISK>) {
				if ($_ =~ /^\/dev/) {
					print BACKINFO;
				}
			}
			close(FDISK);
		}
	}
	
	# Ok, let's go!
	
	
	print "Using type '$conf{'TYPE'}'.\n";
	foreach $partiti (@partitions) {
		$fstype = "";
		foreach $asupfs (@supfstyp) {
			if ($conf{$asupfs} =~ /$partiti /) {
				$fstype = ("-t " . $asupfs);
			}
		}
		print "Starting to create backup file of /dev/$partiti ...\n";
		print BACKINFO "$partiti\t";
		$filenr=1;
		unless ($conf{'BIG'} =~ /$partiti /) {
			if ($conf{'TYPE'} eq "dd") {
				system("dd if=/dev/$partiti | gzip -$conf{'ZIPLEVEL'} >$harddisk$subdir$conf{'TMPDIR'}/$timestamp/$partiti.dd.$filenr");
			} else {
				$mountcount++;
				mkdir("/mnt.$$.$mountcount", 0700);
				if (`mount $fstype -o ro /dev/$partiti /mnt.$$.$mountcount ; echo $?` && `ls /mnt.$$.$mountcount` eq "") {
					print "Can't mount $partiti!\n";
				} else {
					system("cd /mnt.$$.$mountcount ; tar -cO *|gzip -$conf{'ZIPLEVEL'} >$harddisk$subdir$conf{'TMPDIR'}/$timestamp/$partiti.tgz.$filenr");
					system("umount /mnt.$$.$mountcount");
				}
				rmdir("/mnt.$$.$mountcount");
			}
		} else {
			$i = 0;
			$mtd = 0;
			open (BACK, ">$harddisk$subdir$conf{'TMPDIR'}/$timestamp/$partiti.$conf{'TYPE'}.$filenr");
			if ($conf{'TYPE'} eq "dd") {
				open (ZIPSTR, "dd if=/dev/$partiti | gzip -$conf{'ZIPLEVEL'} |");
			} else {
				$mountcount++;
				mkdir("/mnt.$$.$mountcount", 0700);
				if (`mount $fstype -o ro /dev/$partiti /mnt.$$.$mountcount ; echo $?` && `ls /mnt.$$.$mountcount` eq "") {
					print "Can't mount $partiti:\n$!";
				} else {
					open (ZIPSTR, "cd /mnt.$$.$mountcount ; tar -cO *|gzip -$conf{'ZIPLEVEL'} |");
					$mtd = 1;
				}
			}
			# The knife:
			while (defined ($achar = getc ZIPSTR)) {
				print BACK $achar;
				$i++;
				if ($i >= $conf{"MAXCDSIZE"}) {
					close(BACK);
					$filenr++;
					$i = 0;
					open (BACK, ">$harddisk$subdir$conf{'TMPDIR'}/$timestamp/$partiti.$conf{'TYPE'}.$filenr");
				}
			}
			close(BACK);
			close (ZIPSTR);
			if ($mtd) {
				system("umount /mnt.$$.$mountcount");
				rmdir("/mnt.$$.$mountcount");
			}
		}

		print BACKINFO "$filenr\n";
		print "Backup file of /dev/$partiti finished.\n";
	}
	if (@partitions) {
		close (BACKINFO);
	}


	if ($conf{'BURNZIPDAY'}) {
		mkiso();
		burn()
	}

} else {
	# Burn-session...

#	$timestamp = `basename \`ls -td $harddisk$subdir$conf{'TMPDIR'}/[1-2][0-9][0-9][0-9][0-1][0-9][0-3][0-9][0-2][0-9][0-5][0-9]|head -1\``;
	open (LS, "ls -td $harddisk$subdir$conf{'TMPDIR'}/[1-2][0-9][0-9][0-9][0-1][0-9][0-3][0-9][0-2][0-9][0-5][0-9]|");
	$_ = <LS>;
	close (LS);
	$timestamp = (split("/"))[-1];
	chomp $timestamp;

	if ($timestamp) {
		mkiso();
		burn();
	} else {
		print "No backukp files found.\n";
	}
}

finished();

############################# End of main ###########################

sub mkiso {
	# moving in ..
	# .. bootstuff
	$bootcdflg="-b boot/bootdisk.img -c boot/boot.catalog";
	mkdir ("$harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp", 0755);
	mkdir ("$harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp/boot", 0755);
	if (-d $bootstuffdir) {
		system "cp -a $bootstuffdir/* $harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp/boot";
	} elsif (! $noautobackup) {
		if (-d "$harddisk$subdir$conf{'TMPDIR'}/boot") {
			system "cp -a $harddisk$subdir$conf{'TMPDIR'}/boot/* $harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp/boot";
		} else {
			$cdismounted = 0;
			open(MTAB, "/etc/mtab");
			while (<MTAB>) {
				if (/$bootcddev/) {
					$cdmnt = (split)[1];
					$cdismounted = 1;
				}
			}
			unless($cdismounted) {
				unless (system "mount $bootcddev /cdrom 2>/dev/null") {
					$cdmnt="/cdrom";
				}
			}
			if ( -d $cdmnt . "/boot") {
					system "cp -a $cdmnt/boot/* $harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp/boot";
					system "ls -l $harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp/boot";
			} else {
				rmdir ("$harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp/boot");
				print "No boot-stuff found!\n";
				$bootcdflg = "";
			}
			unless($cdismounted) {
					system "umount /cdrom 2>/dev/null";
			}
		}
	}
	# .. backup-files
	$filesleft = 0;
	open (LSS, "ls -lS $harddisk$subdir$conf{'TMPDIR'}/$timestamp|");
	$cdused = 0;
	while (<LSS>) {
		if (($cdused + ((split)[4])) > $conf{'MAXCDSIZE'}) {
			$filesleft++;
			next;
		}
		$cdused = $cdused + ((split)[4]);
		rename(("$harddisk$subdir$conf{'TMPDIR'}/$timestamp/" . ((split)[-1])),
		("$harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp/" . ((split)[-1])));
	}
	close(LSS);

	# .. infos
	if ($conf{"README"}) {
		system "cp $harddisk/$conf{'README'} $harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp";
	}
	
	system "cp $harddisk$subdir$conf{'TMPDIR'}/backinfo.$timestamp $harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp/backinfo";

	# creating isofs
	print "Creating iso-filesystem ...\n";
	system "mkisofs $bootcdflg -r -o $harddisk$subdir$conf{'TMPDIR'}/$timestamp.iso $harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp";

	# moving away what's done
	system "rm -r $harddisk$subdir$conf{'TMPDIR'}/$timestamp/isotmp";
	unless ($filesleft) {
		rmdir("$harddisk$subdir$conf{'TMPDIR'}/$timestamp");
		unlink("$harddisk$subdir$conf{'TMPDIR'}/backinfo.$timestamp");
	}
}
		

sub burn {
#	Multisession support, maybe in later release.
#	if (@_ eq "multi") {
#		$multiflg="-multi";
#	} else {
		$multiflg="";
#	}

#	$burnfile = `ls -td $harddisk$subdir$conf{'TMPDIR'}/[1-2][0-9][0-9][0-9][0-1][0-9][0-3][0-9][0-2][0-9][0-5][0-9].iso|head -1`;
	open (LS, "ls -td $harddisk$subdir$conf{'TMPDIR'}/[1-2][0-9][0-9][0-9][0-1][0-9][0-3][0-9][0-2][0-9][0-5][0-9].iso|");
	$burnfile = <LS>;
	chomp $burnfile;
	close (LS);

	unless ($burnfile) {
		print "No iso-image found to burn on CD.";
	} else {
		print "Starting to burn CD ...\n";
		system "cdrecord $dummyflg $multiflg fs=6m  speed=2 dev=$conf{'CDDEV'} $burnfile";

		print "... finished.\n";
		unlink($burnfile);
	}
}


sub mydie {
	print "Fatal error:\n";
	print ($_[0] . "\n");
	finished();
}

sub finished() {
	if (-d "/cd-image.$$") {
		system ("umount /cd-image.$$");
		rmdir ("/cd-image.$$");
	}
	for ($i = 0; $i <= $mountcount; $i++) {
		if (-d "/mnt.$$.$i") {
			system ("umount /mnt.$$.$i");
			rmdir ("/mnt.$$.$i");
		}
	}
	unless ($noautobackup) {
		print "\n********************************************************************************\n";
		print "                     CDBL - automatically backup finished.\n\n";
		print "                     Shuting down the system in $timeout seconds!\n\n\n\n";
		print "********************************************************************************\n";
		sleep $timeout;
		system("halt &");
	} else {
		system "rm -rf tmpboot";
		print "Press <Enter>.\n";
		<STDIN>;
	}
}
