#!/bin/sh

#createbootcd.sh v0.1
#This program is for creating bootable CD-ROMs or floppy disks with CDBL on it.
#Copyrigth (C)1998 - 1999  Stefan Forstmoser
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# usage:
# createbootcd.sh BOOTCDDEVICE HARDDISKPARTITION SUBDIRECTORY KERNEL BOOTPARAMETERS IPADDR NETMASK GATEWAY NAMESERVER HOSTID SCSIID SPEED DUMMYMODE
PATH=/usr/local/bin:$PATH

if [ `id -u` -ne 0 ]
then
	echo "You must be 'root' to create bootable CD-ROMs / floppy disks."
	sleep 3
	exit 1
fi
cd `dirname $0`
if [ ! -d "boot" ]
then
	echo "No boot-stuff around!"
	exit 1
fi
if [ ! -d "tmpboot" ]
then
	mkdir tmpboot
fi
if [ ! -d "tmpboot/cd" ]
then
	mkdir tmpboot/cd
fi
if [ ! -d "tmpboot/cd/boot" ]
then
	mkdir tmpboot/cd/boot
fi
if [ ! -d "tmpboot/mnt" ]
then
	mkdir tmpboot/mnt
fi
if [ ! -d "tmpboot/mnt1" ]
then
	mkdir tmpboot/mnt1
fi
echo "Modifying boot-script..."
BOOTCDDEV=`echo $1 | sed "s/\\//\\\\\\\\\\//g"`
HARDDISKPARTITION=`echo $2 | sed "s/\\//\\\\\\\\\\//g"`
SUBDIRECTORY=`echo $3 | sed "s/\\//\\\\\\\\\\//g"`
cp -a boot/* tmpboot/cd/boot
mount -o loop tmpboot/cd/boot/bootdisk.img tmpboot/mnt
cp tmpboot/mnt/initrd.gz tmpboot
gzip -d tmpboot/initrd.gz
mount -o loop tmpboot/initrd tmpboot/mnt1
sed s/BOOTCDDEV/$BOOTCDDEV/ tmpboot/mnt1/linuxrc >tmpboot/linuxrc
sed s/HARDDISKPARTITION/$HARDDISKPARTITION/ tmpboot/linuxrc >tmpboot/mnt1/linuxrc
sed s/SUBDIRECTORY/$SUBDIRECTORY/ tmpboot/mnt1/linuxrc >tmpboot/linuxrc
sed s/IPADDR/$6/ tmpboot/linuxrc >tmpboot/mnt1/linuxrc
sed s/DANETMASK/$7/ tmpboot/mnt1/linuxrc >tmpboot/linuxrc
case $7 in
"255.255.255.0")
	MYNET=`echo $6|awk  -F"." '{print $1"."$2"."$3".0"}'`
	;;
"255.255.0.0")
	MYNET=`echo $6|awk  -F"." '{print $1"."$2".0.0"}'`
	;;
"255.0.0.0")
	MYNET=`echo $6|awk  -F"." '{print $1.0.0.0"}'`
	;;
*)
	MYNET=""
	;;
esac
sed s/MYNET/$MYNET/ tmpboot/linuxrc >tmpboot/mnt1/linuxrc
sed s/GATEWAY/$8/ tmpboot/mnt1/linuxrc >tmpboot/linuxrc
sed s/NAMESERVER/$9/ tmpboot/linuxrc >tmpboot/mnt1/linuxrc
umount tmpboot/mnt1
gzip -9 tmpboot/initrd
mv tmpboot/initrd.gz tmpboot/mnt
if [ -n "$4" ]
then
	if [ -r $4 ]
	then
		echo "Adding own Kernel $4 ..."
		cp $4 tmpboot/mnt/linux
	fi
fi
if [ -n "$5" ]
then
	echo "Adding boot parameters ..."
	echo $5 >>tmpboot/mnt/syslinux.cfg
fi
umount tmpboot/mnt
if [ -n "${10}" ]
then
	if [ "${10}" == "floppy" ]
	then
		echo "Writing bootable floppy disk ..."
		dd if=tmpboot/cd/boot/bootdisk.img of=/dev/fd0
	else
		echo "Creating iso9660 filesystetm ..."
		mkisofs -b boot/bootdisk.img -c boot/boot.catalog -r -o tmpboot/bootcd.iso tmpboot/cd
		if [ ${13} -eq 0 ]
		then
			DUMMYFLG=""
		else
			DUMMYFLG="-dummy"
		fi
		# cdrecord $DUMMYFLG -multi fs=6m speed=${12} dev=${10},${11},0 tmpboot/bootcd.iso
		echo "Burning boot-CD ..."
		cdrecord $DUMMYFLG fs=6m speed=${12} dev=${10},${11},0 tmpboot/bootcd.iso
	fi
	rm -r tmpboot
else
		echo "Boot stuff is prepared to be burned on CD, together with backup files."
fi

echo
echo "... finished."
echo "Press <Enter>"
read ASDF
exit 0
