#!/usr/bin/perl

#restore.pl
#This program is for restoring the backups made with backup.pl
#Copyrigth (C)1998 - 1999  Stefan Forstmoser 
#
#    This program is free software; you can redistribute it and/or modify 
#    it under the terms of the GNU General Public License as published by 
#    the Free Software Foundation; either version 2 of the License, or 
#    (at your option) any later version. 
#
#    This program is distributed in the hope that it will be useful, 
#    but WITHOUT ANY WARRANTY; without even the implied warranty of 
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
#    GNU General Public License for more details. 
#
#    You should have received a copy of the GNU General Public License 
#    along with this program; if not, write to the Free Software 
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 

$filenr=1;
$prompt=">>> ";

print "*** CDBL restoring script ***\n";
print "NO WARRANTY ! If you use this program, you could lose data.\n";
print "See helprestore.txt (if you booted from CD)\n";
print "or doc/restorescript.html (otherwise) for more informations.\n";
print "Press Ctrl-C to abort at any time.\n\n";
print "Please insert your backup-CD and\nenter the device-path of your CD-ROM [/dev/scd0] :\n$prompt";
$backdev=<>;
chomp $backdev;
if ($backdev eq "") { $backdev = "/dev/scd0"; }
system "umount $backdev 2>/dev/null";
sleep 2;
if (! -d "/cdrom" ) {
	print "Creating directory /cdrom to mount $backdev.\n";
	mkdir("/cdrom", 0755);
	$delslashcdrom = 1;
}
system "mount $backdev /cdrom";

open (BACKINFO, "/cdrom/backinfo") || die "Can't open backinfo!";
while (<BACKINFO>) {
	if (/^[1-2][0-9][0-9][0-9]/) { ($timestamp, $type) = (split) }
	if (/^\/dev/) { push @devs, $_ }
	if (/^sd/ || /^hd/) { push @imgs, $_ }
}
close(BACKINFO);
print ("Backup made " . substr($timestamp, 6, 2) . "." . substr($timestamp, 4, 2,) . "." . substr($timestamp, 0, 4) . " " . substr($timestamp, 8, 2) . ":" . substr($timestamp, 10, 2) . "\n");

$devfound=0;
while ($devfound == 0) {
	print "Which partition do you want to restore?\n";
	foreach (@imgs) { print ((split)[0] . " ") }
	print "\n$prompt";
	$getback=<>;
	chomp $getback;
	foreach $dev (@devs) {
		if ($dev =~ /^\/dev\/$getback\b/) {
			print "fdisk-line of backup:\n";
			print $dev;
			$devfound=1;
		}
	}
	if ($devfound == 0) {
		print "Not found.\n";
	}
}

$nowayback="N";
until ($nowayback =~ /^[Yy]/) {
	print "Enter the partition-name, where you want to restore the backup to (e.g. 'sda1')\nor enter one or several harddisk-names (e.g. 'hda sda') to see a list\nof it's partitions:\n$prompt";
	
	$_=<>;
	if (/^[a-z]+[0-9]+$/) {
		print "Your partition:\n";
		chomp;
		$toback=$_;
		s/[0-9]//g;
		$mydisks[0]=$_;
	} else {
		print "Your harddisk(s):\n";
		$toback="";
		@mydisks=split();
	}
	foreach $disk (@mydisks) {
		open (FDISK, "fdisk /dev/$disk 2>/dev/null <<%
		p
		q
		%|");
		while (<FDISK>) {
			if (/^\/dev/) {
				unless ($toback) {
					print;
				} else {
					if (/$toback/) {
						print;
					}
				}
	       		}
		}
		close (FDISK);
	}
	unless ($toback) {
		print "Please enter the name of the partition to restore to (e.g. 'sda1'):\n$prompt";
		$toback=<>;
	}
	print "Sure [N]?\n$prompt";
	$nowayback=<>;
}

foreach (@imgs) {
	if (/^$getback/) {
		$lastfilenr = (split)[1];
	}
}
($lastfilenr) || die "backinfo damaged? lastfilenr missing for $getback.";



if ($type eq "tgz") {
	print "Should the partition be (re-)formated first (all data will be deleted) [N] ?\n$prompt";
	$doformat = <>;
	if ($doformat =~ /^[Yy]/) {
		print "Which filesystem type (ext2, FAT or FAT32 ) [ext2] ?\n$prompt";
		$formatfs = <>;
		chomp $formatfs;
		if (! $formatfs || $formatfs eq "ext2") {
			system "mke2fs /dev/$toback";
		} elsif ($formatfs eq "FAT") {
			system "mkfs.msdos /dev/$toback";
		} elsif ($formatfs eq "FAT32") {
			system "mkfs.msdos -F 32 /dev/$toback";
		}
	}
	mkdir ("/mnt.$$", 0755);
	system "mount /dev/$toback /mnt.$$";

	open (UNZSTR, "|gzip -dc|tar -x -C /mnt.$$");
} else {
	open (UNZSTR, "|gzip -dc|dd of=/dev/$toback");
}
$wrongcd = 0;
while ($filenr <= $lastfilenr) {
	while ( ! -r "/cdrom/$getback.$type.$filenr" || $wrongcd) {
		system "umount /cdrom 2>/dev/null";
		sleep 2;
		print "Please insert the CD containing the file $getback.$type.$filenr and press <Enter>";
		<>;
		system "umount $backdev 2>/dev/null";
		sleep 2;
		system "mount $backdev /cdrom";
		sleep 2;
		$wrongcd = 0;
		if (open (BACKINFO, "/cdrom/backinfo")) {
			unless (<BACKINFO> =~ /^$timestamp/) {
				print ("This CD doesn't belongs to the backup of the " . substr($timestamp, 6, 2) . "." . substr($timestamp, 4, 2,) . "." . substr($timestamp, 0, 4) . " " . substr($timestamp, 8, 2) . ":" . substr($timestamp, 10, 2));
				$wrongcd = 1;
			}
		} else {
			print "Doesn't seems to be a backup-CD (backinfo missing).";
				$wrongcd = 1;
		}
		close (BACKINFO);
	}
	open (BACK, "/cdrom/$getback.$type.$filenr");
	while (defined ($achar = getc BACK)) {
		print UNZSTR $achar;
	}
	close (BACK);
	$filenr++;
}
if (-d "/mnt.$$") {
	system "umount /mnt.$$";
	sleep 2;
	rmdir("/mnt.$$")
}
close (UNZSTR);
if ($delslashcdrom) { rmdir ("/cdrom") }
print "$getback restored to /dev/$toback.\n";
