/*
 * 
 * 	fryit - file master.h
 * 	Copyright Thomas Maier-Komor, 1999
 * 	
 */

#ifndef MASTER_H
#define MASTER_H

#include <qcheckbox.h>
#include <qcombobox.h>
#include <qtabdialog.h>
#include <qgrid.h>
#include <qhbox.h>
#include <qlineedit.h>
#include <qprogressdialog.h>
#include <qstring.h>
#include <qvbox.h>

class Process;
class Track;

class MakeIsofsDialog : public QTabDialog {
	Q_OBJECT
	public:
	MakeIsofsDialog();
	~MakeIsofsDialog() {};
	void show();
	
	private:
	QGrid *volumeArea;
	QVBox *optionArea,*sessionArea;
	QCheckBox *skipbackups, *rockridge, *translationtable, *joilet,
		*longnames, *followlinks, *allowperiod, *appendsession;
	QLineEdit *name, *preparer, *publisher, *volumeid, *application,
		*exclude;
	QLabel *nameLbl, *preparerLbl, *publisherLbl, *volumeidLbl, *applicationLbl,
		*excludeLbl, *directoryLbl;
	QComboBox *device;
	QPushButton *dirselect;
	Process *pr;
	
	private slots:
	void selectDir();
	void start();
};

class MakeIsofsProgress : public QProgressDialog {
	Q_OBJECT
	public:
	MakeIsofsProgress(Process *,Track *);
	~MakeIsofsProgress() {};
	
	private:
	Process *pr;
	Track *track;
	bool writeinfo;
	
	private slots:
	void update(const char *);
	void cancel();
	void finish();
};

#endif
