/*
 * 
 * 	fryit - file recorder.h
 * 	Copyright Thomas Maier-Komor, 1999
 * 	
 */

#ifndef RECORDER_H
#define RECORDER_H

#include <qlist.h>

class Track;
class Process;

class Recorder : public CDROM {
	Q_OBJECT
	public:
	Recorder(const char *,const char *,const char *,const char *,
		const char *,int,int,int,int,int,const char *,const char *);
	~Recorder() {};

	Process *writeTracks(QList <Track> &);
	Process *writeThroughStdin(int);
	Process *fixCD();
	void setWriteSpeed(int);
	inline int getWriteSpeed() const;
	inline int getDriver() const;
	void setDriver(int);
	void setFifo(int);
	inline int getFifo() const;
	void setSimulate(bool = true);
	inline bool getSimulate() const;
	void setEject(bool = true);
	inline bool getEject() const;
	void setMultisession(bool = true);
	inline bool getMultisession() const;
	
	public slots:
	virtual void cancelWriting();
	void writingFinished();
	
	private:
	int drv,wSpeed,fifo;
	bool multi,eject,simul;
	Process *pr;
};

//
// inline functions
//

inline int Recorder::getWriteSpeed() const {
	return wSpeed;
}

inline int Recorder::getDriver() const {
	return drv;
}

inline int Recorder::getFifo() const {
	return fifo;
}

inline bool Recorder::getSimulate() const {
	return simul;
}

inline bool Recorder::getEject() const {
	return eject;
}

inline bool Recorder::getMultisession() const {
	return multi;
}

#endif
