/*
 * 
 * 	fryit - file utils.h
 * 	Copyright Thomas Maier-Komor, 1999
 * 	
 */

#ifndef UTILS_H
#define UTILS_H

#include <qlabel.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qlist.h>
#include <qspinbox.h>
#include <qstring.h>
#include <qtimer.h>

class Error;

class Process : public QObject {
	Q_OBJECT
	public:
	Process(const char *[]);
	~Process();
	int getExitCode(int &r, bool wait = true);
	void input(const void *,int) throw(Error);
	
	public slots:
	void kill();
	void terminate();
	void stop();
	void cont();
	void interrupt();
	void cleanup();
	void endinput();
	
	signals:
	void out(const char *);
	void err(const char *);
	void quit(int);
	
	private:
	int errp[2],outp[2],inp[2],childpid,retValue;
	bool running;
	QTimer scanner;
	QString name;
	
	private slots:
	void manageChild();
};

class File {
	public:
	File(const char *,int,bool = false) throw(Error);
	File(const char *,int,int) throw(Error);
	~File();
	void close();
	inline operator int() const;
	
	private:
	int fd;
	bool closed;
	bool super;
};

int readProc(QString &, QString &, const char *[]);


//
// inline functions
//

File::operator int() const {
	return fd;
}

#endif
