%define	name	gcombust
%define	version	0.1.33
%define	release	1
%define	serial	1

Summary:	gcombust is a GTK+ frontend for mksisofs and cdrecord.
Name:		%{name}
Version:	%{version}
Release:	%{release}
Serial:		%{serial}
Copyright:	GPL
Group:		Applications/Archiving
URL:		http://www.iki.fi/jmunsin/gcombust
Vendor:		Jonas Munsin <jmunsin@iki.fi>
Source:		%{name}-%{version}.tar.gz
Requires:	gtk+ >= 1.2.0, cdrecord >= 1.8, mkisofs, cdlabelgen >= 1.5.0
BuildRoot:	/var/tmp/%{name}-%{version}

%description
gcombust is a gui for mkisofs and cdrecord Linux. It's written
in C and it uses the GTK+ widget set (currently it's been tested
and used only on Linux and X-Windows). gcombust is work in progress,
the current (development) release is to be considered beta software.
That means it hasn't been tested very well and that some parts of
the code isn't written.

%prep
%setup -q

%build
%configure --prefix=/usr
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
mkdir -p $RPM_BUILD_ROOT/usr/bin \
	 $RPM_BUILD_ROOT/usr/share/pixmaps
make prefix=$RPM_BUILD_ROOT/usr install-strip
install -m644 %{name}.xpm $RPM_BUILD_ROOT/usr/share/pixmaps

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README* THANKS
/usr/bin/gcombust
/usr/share/locale/*/LC_MESSAGES/gcombust.mo
/usr/share/pixmaps/gcombust.xpm

%changelog
* Fri Jun  2 2000 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.33-1]
- fixed bug in sv.po causing segfault when the Swedish translation
  was used (Mikael Hermansson <mikeh@bahnhof.se>)
- small code cleanup (Mikael Hermansson <mikeh@bahnhof.se>)
- hu.po update (narancs1@externet.hu)
- russian translation by Vladimir Bormotov <bor@vb.dn.ua>
- added 10 speed option
- added prefs option for the cdda (audio cdrom) device and for
  the "Existing ISO" device

* Mon May 15 2000 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.32-1]
- ja.po update (Yuusuke Tahara <tahara@gehenna.u-aizu.ac.jp>)
- fr.po update (Thibaut Cousin <cousin@in2p3.fr>)
- ko.po update (Man-Yong Lee <manyong@gnu.org>)
- audio total size wasn't reset when loading a selection
  (reported by nvignot <nvignot@online.fr>)
- duh, forget to raise the max file limit. really raised it this
  time (thanks to Goetz Waschk <waschk@informatik.uni-rostock.de>)
- compability fix for obsolete "Include all" option, reported by
  many people

* Wed Apr  5 2000 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.31-1]
- Allow untranslated filenames/Bootable CD mixup fixed
  (reported by sguarin@fi.uba.ar)
- ja.po update (Yuusuke Tahara <tahara@gehenna.u-aizu.ac.jp>)
- hu.po update (narancs1@mail.externet.hu)
- fixed an untranslated string
- a little more info on multisession status from
  "Inguva V.R.Sivakumar" <siva@jncasr.ac.in> included, see README.ms
- "100 dirs should be enough for everyone" didn't cut it, trying with
  1000 instead (number of files/dirs that can be mastered)
  (reported by Henrik Schmidt <hbs@ks.informatik.uni-kiel.de>)
- added noinst_HEADERS in src/Makefile.am
- audio DnD fix (maybe)
- the file selector is opened at the path it was last used
- a config option for the dir where file selections are stored
- added debian/ dir to EXTRA_DIST
- added 12 speed option

* Tue Feb 22 2000 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.30-1]
- a few files where missing from POTFILES.in, causing some strings
  not to get translated
- updated hu.po (narancs1@mail.externet.hu)

  [gcombust-0.1.29-1]
- de.po update (Juergen Lock <nox@jelal.kn-bremen.de>) (Juergen also
  provided a detailed bugreport which was very useful, thanks)
- the size of the old session in multisession mode is now taken
  into account for
- exit status of external programs reported a little bit better
  (though it could be made more finegrained), it used to always
  say "Operation finished successfully".
- hunted down a fixed a very old off-by-one bug that happened
  when exectuing commands sometimes
- noticed the output of cdrecord has changed in one place
- Hungarian translation by narancs1@mail.externet.hu
- Korean translation by Woohyun JANG <louis@mizi.co.kr>
- added -no-rr and -U options for mkisofs
- added saveable setting for fifo size

* Thu Jan 13 2000 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.28-1]
- sv.po update (Tommy Strand <gts@abc.se>)
- ja.po update (Yuusuke Tahara <m5021212@u-aizu.ac.jp>)
- small compability fix for change in cdrecord error message
- added note about multisession in the README file
- -hide-rr-moved option for mkisofs

* Mon Jan  3 2000 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.27-1]
- fixed the driver= option so that it actually works
- sv.po update (Tommy Strand <gts@abc.se>)
- a few minor compilation fixes
- alternative way to specify dev= for people who need the /dev/sga style
- added saveable settings for: eject, ISO file, WAV files

* Tue Dec 21 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.26-1]
- the gtk-1.2.5 fix caused earlier gtk versions to spit out an error
  messages
- missing tooltips & translations in the audio rip interface
- ja.po update (Yuusuke Tahara <m5021212@u-aizu.ac.jp>)
- fr.po update (Julien Brouchier <julien@ldsol.com>)
- de.po update (Juergen Lock <nox@jelal.kn-bremen.de>)
- fixed a few compiler warnings on some platforms
- widgets weren't unshaded in case of error in some places
- I think I fixed a bug where gcombust would start spitting out
  "** WARNING **: readers.c 380:" if several burns where made with the
  same gcombust session
- respects CDDA_DEVICE
- support for driver=

* Tue Sep 28 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.25-1]
- works with the latest "stable" release of gtk, 1.2.5 (well, as well
  as can be expected anyway, there is a tooltip bug in gtk 1.2.5 so
  it spits out warnings :\)
- de.po update (Juergen Lock <nox@jelal.kn-bremen.de>)

* Mon Sep 27 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.24-1]
- verify with include-dirname=off didn't work (reported by
  "Dipl.-Ing. Uwe Koloska" <koloska@Rcs1.urz.tu-dresden.de>)
  (discovered a few other bugs with verify at the same time)
- verify didn't lock out other operations
- snprintf->g_snprintf by Krisztian Tamas <krtom@tv2.hu>
- a bug introduced in 0.1.23 sometimes causing segfault when starting burn
- updated the README a little
- found and fixed a bug in read_into() that could cause output from
  programs to be lost sometimes
- fixed a small bug with exclude pattern
- updated ja.p (Yuusuke Tahara <m5021212@u-aizu.ac.jp>)
- audio CD -> wav files (using cdda2wav)
- audio CD -> audio CD
  (none of the audio CD features currently use the new .inf format for
  bitwise exact audio copys in cdrtools, maybe in a later version)

* Tue Sep 21 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.23-1]
- fr.po update by Julien Brouchier <julien@ldsol.com>
- no.po update by Atle Strand <atle82@online.no>
- cd2image bug with progressbar (reported by Jan Zgrebnak
  <socpdk@bb.telecom.sk>)
- updated README.irix ("Claudio Fanin" <claudio.fanin@pd.infn.it>)
- corrected the tooltip for the pad option (Miika Komu <mkomu@cc.hut.fi>)
- finds path to support programs by itself the first time it's started
  (patch by Julien Brouchier <julien@ldsol.com>)

* Thu Sep  9 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.22-1]
- updated Japanese, French and German translation.

* Tue Sep  7 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.21-1]
- BUGFIXES:
- it leaked a file descriptors or two for every operation (size check,
  etc), fixed it - reported by Steve Govenar <govenar@uiuc.edu>
- "Operation finished" window would get stuck sometimes (reported by
  Wolfgang Rohdewald <WRohdewald@online-club.de>)
- progress counters were not reset between burns (reported by
  Wolfgang Rohdewald <WRohdewald@online-club.de>)
- de.po update (Juergen Lock <nox@jelal.kn-bremen.de>)
- no.po update (Atle S <atle82@online.no>)
- ja.po update (Yuusuke Tahara <m5021212@u-aizu.ac.jp>)
- i18n the last few strings in the progressbar window - I think I
  understood how to use gettext with static initializers, but I'm
  not 100% sure
- typo fixes in various error messages, a few tooltips clarifications

- NEWS:
- changed selection mode to extended (ie you can now "paint" the files
  you want to add), useful when adding lots of files. this of course
  makes it harder to select a smaller set of non-continues files.
  choices, choices.
- cd-to-image copy (isosize.c and iso9660.h borrowed from the cdrecord
  package by J. Schilling)
  . some (all?) scsi burners used with the scsi emulation layer
    doesn't work with this
  . for every error encountered it retries 20 times before giving up
- french translation by Julien Brouchier <mystic@pipo.com> (also by
  Thibaut <thibaut.cousin@libertysurf.fr>, but Julien asked first)

* Fri Aug 17 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.20-1]
- Fixed a small bug in sanity checking, causing a crash if
  you tried to add a non-existing root directory (ie /asdfsdf)
  to the data source filelist
- updated de.po + a few FreeBSD pathches (for text in tooltips)
  Juergen Lock <nox@jelal.kn-bremen.de>

- Norwegian translation by "Atle Strand" <atlestrand@hotmail.com>
- save setting fore dummy run
- added verify operation:
  . uses GNU diff (most diff variants should be ok; it needs to
    support -r (recursive) and --brief option and report missing
    files as "Only in <path> to avoid false alarms)
  . it's a simple sollution and could be implemented better without
    using diff - but it gets the job done although it's very
    slow; you are free to submit patches :>
  . the only thing the progressbar shows is that something is
    happening

* Wed Aug  4 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.19-1]
- Version 0.1.19 Aug 03 1999
- a few more strings gettextizied, updated German .po file
- should compile on IRIX, too, since 0.1.18
- mkhybrid can't do < 800 kb HFS volumes, added a check
  (Allan Hsu <animate2@underworld.net>)
- small cdlabelgen changes, ok defaults and type fixes
  (Daniel Serodio <dserodio@email.com>)
- made the image source interface more obvious (suggested by
  Paul Barton-Davis <pbd@op.net>)
- Swedish .po file (Tommy Strand <gts@abc.se>)
- Japanese .po file (Daisuke Yabuki <dxy@optix.org>)
- netatalk option for mkhybrid (just mail me if you need more
  mkhybrid options, I don't know which ones are useful)
- added a cleat button for the output textboxes
- cleaned up save settings, added device, speed & swab
- support for the new options in cdlabelgen 1.5 (wordwrap and
  supression on plaque)
- "disable dirnames" option by Koaunghi Un
  <koaunghi.un@student.uni-tuebingen.de>

* Thu Jul  1 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.18-1]
- Version 0.1.18 Jun 30 1999
- various smaller bugfixes (a couple of wrong widget text/tootips,
  segfault with prefs window and attempting to make empty audio cds)
- added -q option to mkisofs when getting size of something - speeds up
  all those operations a bit
- "Done in:" wasn't keeping track of how much had been written totaly when
  making audio CDs
- bootable cd creation didn't work (Juergen Lock <nox@jelal.kn-bremen.de>)
- fixed mixup of bus & channel in autodetection
- tweaked autoconf scripts a bit
- more checks against user errors
- added -print-size/-tsize for burning on the fly in DAO mode
  or for drives requiering it (like some TEAC drives)
- "Detect scsi drive" now also detects if -swab option is needed
- now it's possible to choose multiple files/dirs at once in the
  file selectors
- German .po translation by Juergen Lock <nox@jelal.kn-bremen.de>
- added icon by chris scheidecker <scheides@theinferno.hextrack.com>

* Tue Jun 22 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.17-1]
- Version 0.1.17 Jun 22 1999
- removed the gtk_main_iteration() calls added in 0.1.14, they
  slowed things down too much
- improved DnD support
- added a few error warning dialogs
- cd-to-cd copy didn't work since the 0.1.15 changes, fixed
  (reported by Andy Zeneski <jaz@zsolv.com>)
- forgot to wait for pids since 0.1.15 changes -> zombies
  (ULISES ALONSO CAMARO <ualonso@slabii.eleinf.uv.es>)

* Mon Jun 21 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.16-1]
- Version 0.1.16 Jun 20 1999
- BUGFIXES:
- now refuses to add a path twice to the iso file-list
- gettext compile fix for systems building intl/libintl.a (BSD)
  (by Hubert Feyrer <feyrer@rfhs8012.fh-regensburg.de>)
- mkisofs command generated -T instead of -L
- NEWS:
- multisession support (not very well tested):
  - if you leave the "Path to old session" field empty, gcombust
    will asume this is the first session
  - if you press the recalc button in multisession mode, it will
    take into account the old session - this operation takes quite
    some time! (and I don't know if you can trust the result)
  - multisession doesn't seem to mix with Joliet (I get "Joliet
    tree sort failed." from mkisofs), so disable it if you get
    problems.
  - the current mkisofs version has a bug you might run into when
    making sessions (for all but the first session), so if mkisofs
    segfaults on you for no apparant reason, wait for the next
    release of cdrecord (or mail me for a patch)
  - you cannot make multisession CD's on the fly (except for the
    first session)

* Wed Jun 16 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.15-1]
- Version 0.1.15 Jun 16 1999
- BUGFIXES:
- fixed a bug with the cdlabelgen interface and Date
- fixed a bug making delete-audio-track not updating the
  size shown on screen (patch by <wasp@linuxfreak.com>)
- started on improving error handling and prevention (a few
  dialogs, some buttons unsensitive when they can't be used, etc)
- slight re-refix (gah!) of freeze/thaw and autoscroll (it was causing
  a crash under some circumstances, maybe an GTK+ bug)
- lazy use of execl() made gcombust not able to handle files with
  ' and other special charachters, replaced with execv() - resulted
  in a lot of internal changes, tons of bugs were probably
  introduced - treat it with respect!!! the cdlabel interface still
  does it the "lazy" way, should probably be fixed someday
- NEWS:
- disable widgets while executing a make image/burn operation
  (patch by MikeH <mikeh@bahnhof.se>)
- progress win hasn't necessarily a window of its own anymore
  (loosely based on patch by MikeH)
- started on preferences (paths, tooltips, progresswin)
- added a reset drive button
- DnD support for data & audio (still a bit messy - some
  gtk issues are unclear to me, but it seems to work ok)

* Tue Jun  1 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.14-1]
- Version 0.1.14 May 31 1999
- BUGFIXES:
- added a couple of gtk_main_iteration() calls to redraw the window
  when doing costly operations, suggested by Miroslav Vasko
  <mvasko@isternet.sk>
- slight refix of freeze/thaw and autoscroll
- NEWS:
- gettext/NLS support, I might have generated some autoconf<->gettext
  errors though, you tell me (I started on a Swedish translation just
  to test it, feel free to take over it :), es.po by "Toms V.V.Cox"
  <Cox@idecnet.com> included).
- autodetection of scsi devices, based on patch by blackburnm
  <blackburnm@mindspring.com>
- "Done in:" in progressbar

* Wed May 19 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.13-1]
- Version 0.1.13 May 17 1999
- BUGFIXES:
- clists don't have scrollbars automagically in gtk 1.2, fixed
- the attempted autoresize of scrollbars was wicked, replaced it
  with gtk's own autoresize (which is just slightly less wicked)
- the output textfields got freeze/thawed even when no text was
  added, causing ugly flickering, fixed
- NEWS:
- support for -atip (requires cdrecord 1.8a22) and user specified
  size in binpacking algoritm
- support for cd-to-cd data copy
- autoscroll output textfields

* Wed May 12 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.12-1]
- Version 0.1.12 May 12 1999
- now adds '' around audio files too (broke on filenames with spaces etc. before)
  note that the command generating is still buggy by design, it will brake on
  filenames containing ' and other special characters
- suport for fs= option (and CDR_FIFOSIZE)

* Mon Mar 29 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.11-1]
- Version 0.1.11 Mar 29 1999
- BUGFIXES:
- cd-rw info progressbar should print some more info now :)
  (untested, please send me some output from a cdrecord blank=...
  session if I didn't get it right this time either)
- NEWS:
- support for making bootable cds - it's maybe a bit clumsy though
- now requires gtk 1.2.x
- now requires cdlabelgen 1.1.3 (WYSIWYG attempt dumped in favor for
  more intelligent cdlabelgen :)
- small code reorganization and it doesn't build with gcc -g as default
  anymore (still a good idea to strip it though)
- load/save image/audio selections (audio selections only works with
  pure audio cd selections)

* Mon Mar 22 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.10-1]
- Version 0.1.10 Mar 19 1999
- BUGFIXES:
- now compiles with gtk 1.2.0 again, if you have gtk 1.2.0
  change the GCOM_GTK_VER in src/globals.h to 12 (default is
  gtk 1.0.x, with GCOM_GTK_VER set to 10) - gtk 1.0.x support
  will be dropped soon, I'm getting sick of testing against two
  different versions for every release

- Version 0.1.9 Mar 19 1999
- BUGFIXES:
- CDR_DEVICE=1,0 works
- added lot's of error checks in contractions.c
- small g_list bug fixed (hopefully)
- quotes volume IDs
- contractions.c: iso<->cdr close-mixup in p_open_r_err_in
- NEWS:
- prints out all unprocessed output from mkisofs/cdrecord
  to textboxes, added MB burned + fifo label
- blank=... for cd-rw (untested as I don't have a cd-rw drive)
- started on the menus
- printing labels using cdlabelgen 0.70
  (http://www.red-bean.com/~bwf/software/cdlabelgen/)
  the printwindow tries to match (WYSIWYG) what cdlabelgen can handle

* Mon Mar  8 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.8-1]
- Version 0.1.8 Mar 08 1999
- BUGFIXES:
- some systems had compilation problems (basename missing, and
  swab nameclash)
- fixed execl() problem that made gcombust quite useless on
  some systems (rh 5.1?)

* Thu Mar  4 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.7-1]
- Version 0.1.7 Mar 04 1999
- BUGFIXES:
- dao could only be used with audio cds
- try harder option would produce negative values sometimes
- NEWS:
- remade audio cd creation interface

* Fri Feb 26 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.6-1]
- Version 0.1.6 Feb 26 1999
- forgot to make cdrecord parsing and info window routines aware of audio cds
  in yesterdays release, fixed that
- added -swab and -dao option
- added (un)select all

* Thu Feb 25 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.5-1]
- Version 0.1.5 Feb 25 1999
- added option to make audio (CD-DA) or mixed mode cds
- fixed small bug leaving progresswindow open when trying to run cdrecord
  without root access and not using any image
- fixed gtk1.1.x problems

- Version 0.1.4 Feb 24 1999
- small layout changes to start burning button and stop button, added 6x button
- added a "try harder" option to the bin packing algoritm
- removed some unused code
- fixed a small bug that could crash gcombust if you had several
  "abort?" windows open

* Tue Feb 23 1999 Ryan Weaver <ryanw@infohwy.com>
  [gcombust-0.1.3-1]
- Initial RPM build.
