#ifndef CDEditData_included
#define CDEditData_included

/*** KisoCD ***/
#include "cdtree.h"
#include "switches.h"

/*** Qt ***/
#include <qdialog.h>
#include <qgroupbox.h>
#include <qlistbox.h>
#include <qpushbutton.h>

/*** KDE ***/
#ifndef KDE2
#include <drag.h>
#endif


/*** C++ ***/

class CDEditData : public QDialog
{
    Q_OBJECT

public:
    bool     fEditiert;

    CDEditData(QWidget*      parent,
               const char*   name,
	       CDTree*     EineCD);

    virtual ~CDEditData();

public slots:
  void highlightLeftLB(int welche);
  void highlightRightLB(int welche);
  void removeFromLeftLB();
  void removeFromRightLB();
#ifndef KDE2
  void DDDirectCB(KDNDDropZone* _dropZone);
#endif  
  void addExcl();

private:
 QGroupBox*    tmpQFrame1;
 QPushButton*  tmpQPushButton1;
 QGroupBox*    tmpQFrame2;
 QListBox*     tmpQListBox1;
 QListBox*     tmpQListBox2;
 QPushButton*  tmpQPushButton2;
 QPushButton*  tmpQPushButton3;
 QPushButton*  tmpQPushButton4;

 CDTree      *MeineCD;
#ifndef KDE2 
 KDNDDropZone *DNDDirektaufnahme;
#endif 
};

#endif // CDEditData_included

















