#include <cdtools.h>
#include <iostream.h>
#include <stdlib.h>
#include "tools.h"
#include "switches.h"

CDTools::CDTools(string aDevice, string aMountpoint)
{
    setDevice(aDevice);
    setMountpoint(aMountpoint);
    // check for existing tools
    // to be done!!!!
    use_cdctl = (whereisExec("cdctl") != "");
    use_eject = (whereisExec("eject") != "");
}

void CDTools::setDevice(string aDevice)
{
    device = aDevice;
}

void CDTools::setMountpoint(string aMountpoint)
{
    mountpoint = aMountpoint;
}

int CDTools::isOpen()
{
    return(0);
}

int CDTools::toggleOpen()
// shouldBeOpen is toggled regardless of returnCodes!
{
    int  retCode = 0;
    
    if (shouldBeOpen) 
      {
	retCode = close();
	shouldBeOpen = false;
      }
    else 
      {
	retCode = open();
	shouldBeOpen = true;
      }    

    return(retCode);
}

int CDTools::close()
// eject -t <device>
// cdctl -c 
{
    int retCode = 0;

#ifdef VERBOSEMESSAGES
    cout << "Trying to close the tray...\n";
#endif

    if (use_eject) retCode = doSystemCall("eject -t " + device);
    else
	if (use_cdctl) retCode = doSystemCall("cdctl -c " + device);
    if (!retCode) shouldBeOpen = false;
    return(retCode);
}

int CDTools::open()
// eject <device>
// cdctl -e 
{
    int retCode = 0;

#ifdef VERBOSEMESSAGES
    cout << "Trying to open the tray...\n";
#endif
    
    if (use_eject) retCode = doSystemCall("eject " + device);
    else
	if (use_cdctl) retCode = doSystemCall("cdctl -e " + device);
    if (!retCode) shouldBeOpen = true;
    return(retCode);
}

int CDTools::getInfo()
// cdctl -g    type of cd
// cdctl -l    lists tracks
{
    return(0);
}

int CDTools::doSystemCall(string cmdline)
{
#ifdef VERBOSEMESSAGES
  cout << "int CDTools::doSystemCall(" << cmdline << ")\n";
#endif
    return(system(cmdline.c_str()));
}












