#ifndef Copy_H 
#define Copy_H 

/*** KDE ***/
#include <kprocess.h>

/*** Qt ***/
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qtimer.h>

/*** C/C++ ***/

/*** KisoCD ***/
#include "switches.h"
#include "kcdmodule.h"
#include "cdtools.h"

class CopyWidget : public QWidget
{
  Q_OBJECT
public:
  QGroupBox*         gb_insertSource;
  QGroupBox*         gb_readImage;
  QGroupBox*         gb_burnCD;
  QPushButton*       pb_openClose;
  QPushButton*       pb_readImage;
  QPushButton*       pb_burnCD;
 
 CopyWidget(QWidget*, const char*);
 void update(T_Options &currOpts);
 void setButtonsEnabled(bool, bool, bool);
};

class Copy : public KCDModule
{
  Q_OBJECT
public:
  Copy(QWidget *parent = 0, const char *name = 0, int aModuleID = 0);
  ~Copy();
public slots:
 void commandCallback(int id_);
 void clickOn_openClose(); 
 void clickOn_readImage(); 
 void clickOn_burnCD(); 
 void setupMenu();
 void burnFinished(KProcess*);
 void imageFinished(KProcess*);
 void updateCreateImageStatus();
 void updateBurnStatus(QString);
private:
 CopyWidget*       mainView;
 QPopupMenu*       menuSingleStep; 
 QPopupMenu*       menuView; 
 CDTools           myCDTools;
 
 Subprocess*       imageProc;  
 QTimer*           myTimer;
 RemainingTimeTeller progress;

 bool              fMounted;
 

 int createImageScript();
 int createFinalScript(bool);
 virtual bool preExit();
};


#endif // Copy_H 











