// -*- c++ -*-

#ifndef dndlist_H
#define dndlist_H

/*** Qt ***/
#include <qlistview.h>
#include <qwidget.h>
#include <qstrlist.h>
#include <qdragobject.h>
#include <qpoint.h>
#include <qpopupmenu.h>

/*** KDE ***/

/*** C++ ***/
#include <iostream>

/*** KisoCD ***/
#include "tools.h"
#include "switches.h"

class dndList : public QListView
{
  Q_OBJECT

public: 
  dndList(QWidget * parent, const char * name, bool fMS, bool fTDM);
  
  void dropEvent(QDropEvent*);
  void dragEnterEvent(QDragEnterEvent*);
  void dragLeaveEvent(QDragLeaveEvent*);  
  void dragMoveEvent(QDragMoveEvent*);
private:
  bool     fMultiSelect;
  bool     fTrackDragMove;  
signals:
  void drop(string);  
  void newDir();
public slots:
  void contextMenu(QListViewItem *item, const QPoint &point, int col);
};

#endif // dndlist_H





















