#include "edit2.h"

/*** Qt ***/
#include <qstring.h>

/*** KDE ***/
#include <kprocess.h>
#ifdef KDE2
#include <klocale.h>
#else
#include <kapp.h>
#endif

/*** C++ ***/
#include <string>
#include <vector>
#include <fstream.h> 

/*** KisoCD ***/
#include "version.h"

void createPathItems(QListView*     ktl, 
		     string         pfad)
{
  QListViewItem* tmp = NULL;
  string         Pfadabschnitt;
  QListViewItem* lastParent = NULL;
  bool           Abbruch = false;
  bool           firstRun = true;

  while (pfad.length() > 1) {
    Abbruch = false;

    while ((!Abbruch) && (pfad.length() > 1)) {
      if (firstRun) {
	tmp = ktl->firstChild();
	firstRun = false;
	lastParent = NULL;
      }
      else {
	lastParent = tmp;
	tmp = tmp->firstChild();
      }
      
      pfad.replace(0, 1, "");  
      Pfadabschnitt = pfad.substr(0, pfad.find("/"));
      pfad.replace(0, pfad.find("/"), "");      
      
      while ((tmp != NULL) && (Pfadabschnitt.compare(tmp->text(0)) != 0)) {
	tmp = tmp->nextSibling();
      }
      if (tmp == NULL) Abbruch = true;
    }
    if ((Abbruch) || (pfad.length() > 1)) {
      if (lastParent == NULL) tmp = new QListViewItem(ktl, Pfadabschnitt.c_str());
      else                    tmp = new QListViewItem(lastParent, Pfadabschnitt.c_str());
    }
  }
}

string holPfadInhalt(QListViewItem* itemPtr)
{
  // gibt den Pfad von "itemPtr" zurck, inklusive der Wurzel, Anfang
  // und Ende mit "/".

  string           tmpStr = "/";
  vector<string>   drehpuffer;
  QListViewItem*   tmpPtr;
  QString          tmpStr2;
  
  tmpPtr = itemPtr;

  do {
    tmpStr2 = tmpPtr->text(0);
#ifdef KDE2    
    drehpuffer.push_back(tmpStr2.latin1());
#else
    drehpuffer.push_back((const char*)tmpStr2);
#endif    
    tmpPtr = tmpPtr->parent();
  } while (drehpuffer[drehpuffer.size()-1] != "CD");
  
  while (drehpuffer.size() > 0) {
    tmpStr += drehpuffer.back();
    drehpuffer.pop_back();
    tmpStr += "/";
  }  
#ifdef VERBOSEMESSAGES
  cout << tmpStr << "\n";
#endif
  return(tmpStr.c_str());
}


bool ausschlussTrifft(string Pfad, vector<string> Muster)
{
  int   flag;

  /*
  for (unsigned int Cnt= 0; Cnt < Muster.size(); Cnt++) {
    string such = Muster[Cnt];
    // nur nach Mustern, nicht nach Pfaden schauen:
    if (such[0] != '/') {

      flag = 0;

      if (such[such.size()-1] == '*') {
	flag |= 1;
	such.replace(such.size()-1, 1, "");
      }
      if (such[0] == '*') {
	flag |= 2;
	such.replace(0, 1, "");
      }
      switch (flag) {
      case 0:
	if (Pfad == such) return(true);
	break;  
      case 2:
	if (Pfad.find(such) == Pfad.size()-such.size()) return(true);
	break;
      case 1:
	if (Pfad.find(such) == 0) return(true);
	break;
      case 3:
	if (Pfad.find(such) != string::npos) return(true);
	break;
      }    
    }
  }
  return(false);
  */


  bool tmp = false;


  for (unsigned int Cnt= 0; Cnt < Muster.size(); Cnt++) {
    string such = Muster[Cnt];
    // nur nach Mustern, nicht nach Pfaden schauen:
    if (such[0] != '/') {

      flag = 0;

      if (such[such.size()-1] == '*') {
	flag |= 1;
	such.replace(such.size()-1, 1, "");
      }
      if (such[0] == '*') {
	flag |= 2;
	such.replace(0, 1, "");
      }
      if (such.size() <= Pfad.size()) {
	switch (flag) {
	case 0:
	  if (Pfad == such) tmp = true;
	  break;  
	case 2:
	  if (Pfad.find(such) == Pfad.size()-such.size()) tmp = true;
	  break;
	case 1:
	  if (Pfad.find(such) == 0) tmp = true;
	  break;
	case 3:
	  if (Pfad.find(such) != string::npos) tmp = true;
	  break;
	}    
      }
    }
    if (tmp) {
#ifdef VERBOSEMESSAGES
      cout << "****Treffer: " << such << "  " << Pfad << "\n";
#endif
      break;
    }
  }
  return(tmp);
}

int createMirrDir(ofstream          &outDat, 
		  string            sessPfad, 
		  T_SysOptions      sysOpts, 
		  string            &linkFile,
		  string            HeimatPfad)
{
  string mirrorDirBase;
  
  mirrorDirBase = sysOpts.tmpDir;
  
  outDat << "\n# Anlegen des Mirror-Verzeichnisses:\n";
  
  outDat << "baseDir=" << mirrorDirBase << "\n";
  outDat << "zaehler=0\n";
  outDat << "dirName=kisocd$zaehler\n";
  outDat << "fullPath=$baseDir$dirName\n";
  outDat << "\n";
  outDat << "while [ -d $fullPath ]\n";
  outDat << "do\n";
  outDat << "  dirName=kisocd$zaehler\n";
  outDat << "  fullPath=$baseDir$dirName\n";
  outDat << "  if [ $zaehler -ge 10 ]\n";
  outDat << "  then\n";
  outDat << "    echo There seem to be some mirror-dirs left in \n";
  outDat << "    echo $baseDir\n";
  outDat << "    echo maybe you want to delete them?\n";
  outDat << "    echo Because of earlier errors they have not been deleted.\n";
  outDat << "  fi\n";
  outDat << "  zaehler=`expr $zaehler + 1`\n";
  outDat << "done\n";
  outDat << "\n";
  outDat << "echo KisoCD: $fullPath as mirror-dir\n";
  outDat << "V=$fullPath\n";

  outDat << "if mkdir -p $V\n";
  outDat << "    then \n";
  outDat << "      true\n";
  outDat << "    else\n";
  outDat << "      echo KisoCD: aborted, because the mirror-dir\n";
  outDat << "      echo $V\n";  
  outDat << "      echo did already exist! You have to give a nonexistent directory!\n";
  outDat << "      exit\n";
  outDat << "fi\n";

  if (sessPfad != "")    
    {
      linkFile = sessPfad;
      linkFile.replace(0, 1, "");
      linkFile.replace(0, linkFile.find("/")+1, "");
	
      outDat << "V=${fullPath}/" << linkFile << "\n";
      outDat << "mkdir -p $V\n";
    }
  
  linkFile = HeimatPfad;
  linkFile += "/links.lst";
  
  linkFile = HeimatPfad;
  linkFile += "/dirs.lst";
  outDat << "echo \"KisoCD: Creating mirror-directory. This may take a while...\"\n";
  outDat << "source " << linkFile << "\n";
  
  linkFile = HeimatPfad;
  linkFile += "/links.lst";
  outDat << "source " << linkFile << "\n";
  
  outDat << "# Anlegen des Mirror-Verzeichnisses beendet.\n\n";
  return(0);
}

int deleteMirrDir(ofstream &outDat)
{
  outDat << "# Lschen des Mirror-Verzeichnisses:\n";
  outDat << "echo \"KisoCD: Deleting mirror-directory.\"\n";
  outDat << "rm -r $fullPath/\n";
  outDat << "# Lschen des Mirror-Verzeichnisses beendet.\n\n";
  return(0);
}


void downloadFile(string dropped)
{
  KShellProcess*  process = NULL;
  string          kurzTitel;
  
  kurzTitel = dropped;
  while (kurzTitel.length() > 10) kurzTitel.replace(0, 1, "");
  kurzTitel = "wget:" + kurzTitel;
  
  dropped = "\"" + dropped + "\"";	
  
  process = new KShellProcess;
  (*process) << "xterm" 
	     << "-T" << kurzTitel.c_str() 
	     << "-fn" << "5x8" 
	     << "-e" << "wget" 
	     << "-P" << "/win2/" 
	     << dropped.c_str();
  process->start(KShellProcess::DontCare);
  
  delete process;	
}




