#ifndef kcdmodule_H 
#define kcdmodule_H 

/*** KisoCD ***/
#include "subprocess.h"
#include "tools.h"
#include "types.h"
#include "switches.h"

/*** KDE ***/
#include <ktmainwindow.h>
#include <kmenubar.h>

/*** Qt ***/

/*** C/C++ ***/
#include <string>


class KCDModule : public KTMainWindow
{
  Q_OBJECT
public:
  KCDModule(QWidget *parent = 0, const char *name = 0, int aModuleID = 0);
  ~KCDModule();

  void getStdCDRWMenu(QPopupMenu* &menu);
  void getStdCDDocMenu(QPopupMenu* &menu);
  void getStdOptionsMenu(QPopupMenu* &menu);
  void getStdHelpMenu(QPopupMenu* &menu);

  bool stdCDRWCallback(int         id = 0, 
		       QPopupMenu* aMenu = 0,
		       int         aMenuID = 0);
  bool stdCDDocCallback(int id);
  bool stdOptionsCallback(int  id, 
			  bool &optsChanged);
  bool stdHelpCallback(int id);

  void showAboutBox();
  void showQuickstart();
  void showHelp();

  int  blankRW(int         id = 0, 
	       bool        force = true, 		       
	       QPopupMenu* aMenu = 0,
	       int         aMenuID = 0);
  void startLatexCompile(KShellProcess* &process, 
			 bool           &processStarted, 
			 bool           wait = false);


protected:
  KMenuBar*          menuBar;
  QPopupMenu*        menuFile;
  QPopupMenu*        menuCdDoc;
  QPopupMenu*        menuOptions;
  QPopupMenu*        menuCDRW;
  QPopupMenu*        menuHelp;
  
  Subprocess*        burnProc;  

  int                moduleID;

  FileWatch          texFileWatch;
 
  virtual void closeEvent( QCloseEvent* e );
  virtual bool preExit();
private slots:
    void blankFinished(KProcess*);
};

#endif // kcdmodule_H 










