/*** KisoCD ***/
#include "switches.h"
#include "edit.h"
#include "copy.h"
#include "tools.h"
#include "options.h"
#include "opt_cd.h"
#include "opt_sys.h"
#include "quickstartdialog.h"
#include "module.id"

/*** C/C++ ***/
#include <stdio.h>
#include <stdlib.h>   // fr getenv
#include <sys/stat.h> // fr die S_IRWXU-Angabe bei mkdir
#include <time.h>
#include <string>

/*** KDE ***/
#ifdef KDE2
#include <klocale.h>
#endif
#include <kapp.h>

#ifdef USEWAITCURS
time_t         aktZeit;     // dient zur "ich-lebe-noch-Anzeige" bei langdauernden Operationen
unsigned char  cursArt;     // dient zur "ich-lebe-noch-Anzeige" bei langdauernden Operationen   
#endif

int                debuglevel;
DebugFile          debugFile; 
int                moduleExitCode;
KSimpleConfig*     globalConf;
string             HeimatPfad;
T_Options          aktOpts;
T_Options          defOpts;
T_SysOptions       sysOpts;
QuickstartDialog*  myQuickHelp;



void getGlobalConfDat(KSimpleConfig* &globalConf);


int main(int argc, char **argv)
{
  KApplication   *app;
  Edit           *toplevelEdit;
  Copy           *toplevelCopy;
  bool           boolDummy;
  
  app= new KApplication(argc, argv, ProggieNameLC);
  

  // den KDE-string missbrauche ich jetzt, um sicherzustellen, dass mein Verz im 
  // Heimatverzeichnis des Users existiert; dazu muss ich es nur anlegen
  if (mkdir(getPersConfigDir().c_str(), S_IRWXU))
    {
      string befehl;
      
      befehl = "mkdir -p ";
      befehl += getPersConfigDir();
      if (system(befehl.c_str()))
	infoMessage(i18n("error creating KisoCD-directory!"));
    }

  debugFile.setDirName(getPersConfigDir() + "/", "kisocdDebug");    
  HeimatPfad = getPersConfigDir(); 
  cout << "my dir: " << HeimatPfad << "\n";
  getGlobalConfDat(globalConf);

  if (argc > 1 && argv[1][0] == '-')
    {
      argv[1][0] = ' ';
      debuglevel = atoi(argv[1]);
      cout << "Debuglevel: " << debuglevel << "\n";
    } 
  else debuglevel = 0;
  if (debuglevel & 2 != 0) 
    {
#ifdef VERBOSEMESSAGES
      cout << "calling getSysInfo()\n";
#endif
      getSysInfo(getNrFile(getPersConfigDir(), "/kisocdDebug"));
    }

  cerr << "Version " << ProggieVersion << "\n";

  /* ***************************************** */    
  myQuickHelp = new QuickstartDialog(0, "name", true);  
  if (ladeVorgaben(globalConf, HeimatPfad, aktOpts, sysOpts)) 
    {
      defOpts = aktOpts;

      myQuickHelp->show();

      if ((globalConf->readEntry("mOptions_system", "enabled") == "enabled") ||
	  globalConf->readEntry("mOptions", "enabled") == "enabled")
	{
	  Opt_sys tmpDiag(0, "name", globalConf, &sysOpts, true);
	  tmpDiag.exec();      
	}

      Opt_cd tmpDiag(0, "name", globalConf, &defOpts, &aktOpts, &boolDummy, &moduleExitCode);
      tmpDiag.exec();
    }
  else 
    {
      defOpts = aktOpts;
      
      if (sysOpts.fOptOnStartup)
	{
	  Opt_cd tmpDiag(0, "name", globalConf, &defOpts, &aktOpts, &boolDummy, &moduleExitCode);
	  tmpDiag.exec();    
	}
      else
	{
	  if (aktOpts.fCopyDataCD) 
	    moduleExitCode = ID_MODULE_COPY_DATA;
	  else 
	    moduleExitCode = ID_MODULE_CREATE_DATA;
	}
    }  
  delete myQuickHelp;
  myQuickHelp = new QuickstartDialog(0, "name", false);  


  cout << "Pfad: " << HeimatPfad << "\n";
  do
    {
      makeNewLatexFile(HeimatPfad); 
      switch (moduleExitCode)
	{
	case ID_MODULE_CREATE_DATA: 
	  cout << "Starting module: createDataCD\n";
	  toplevelEdit= new Edit(0, 0, ID_MODULE_CREATE_DATA); 
	  app->setMainWidget(toplevelEdit);
	  toplevelEdit->resize(600, 400);
	  toplevelEdit->setMinimumSize(600, 400);
	  toplevelEdit->show();
	  app->exec();
	  break;
	case ID_MODULE_COPY_DATA: 
	  cout << "Starting module: copyDataCD\n";
	  toplevelCopy= new Copy(0, 0, ID_MODULE_COPY_DATA); 
	  app->setMainWidget(toplevelCopy);
	  toplevelCopy->resize(550, 300);
	  toplevelCopy->setMinimumSize(400, 300);
	  toplevelCopy->show();
	  app->exec();
	  break;
	}
    }
  while (moduleExitCode != ID_MODULE_EXIT);
  
  // die Optionen speichern
  saveOptions(defOpts, sysOpts, HeimatPfad);
 
  //  delete toplevel; // hat sich schon selbst beendet!
  delete globalConf;
  delete myQuickHelp;
  delete app;
}


void getGlobalConfDat(KSimpleConfig* &globalConf)
{
  uid_t  meinUID;
  gid_t  meinGID;
  string tmp;
  QString qtmp;
  
  meinGID = getgid();
  meinUID = getuid();
  /*
  cerr << "my real UID: " << meinUID << "\n";
  cerr << "my effective UID: " << geteuid() << "\n";
  */
  
  // Den Pfad zur Konfig-Datei bestimmen 
  string confDatPfad = "";

#ifdef KDE2
  confDatPfad = "/home/jens/.kde/share/apps";
#else  
  confDatPfad = KApplication::kde_configdir();
#endif  
  confDatPfad += "/kisocdrc";
  
  if (!existDat(confDatPfad))
    if (existDat("/etc/defaults/kisocdrc")) confDatPfad = "/etc/defaults/kisocdrc";
    else confDatPfad = "/usr/local/etc/defaults/kisocdrc";
  
  if (existDat(confDatPfad)) 
    cout << "global config file is:" << confDatPfad << " (if it exists)\n";
  else 
    cout << "no global config file\n";
  
  globalConf = new KSimpleConfig(confDatPfad.c_str(), true);
  
  globalConf->setGroup("kisocd");

  if (existDat(confDatPfad)
      && globalConf->readEntry("version") != "0.5.0"
      && globalConf->readEntry("version") != "0.5.4"
      && globalConf->readEntry("version") != "0.5.2")	
    {
      // es eine Version vor 0.5.0
      qtmp = confDatPfad.c_str();
      qtmp += i18n("\nYour configuration file does not contain the current version number,\n"
		  "so it obviously won't work as you expect it. Some of the options have\n"
		  "changed with the release of version 0.5, please take a look at the\n"
		  "new ones in the current file.");
      infoMessage(qtmp);
    }
  
  if (existDat(confDatPfad)
      && globalConf->readEntry("version") == "0.5.0")
    {
      // es ist Version 0.5.0
      qtmp = confDatPfad.c_str();       
      qtmp += i18n("\nYour configuration file contains the version number 0.5.0.\n"
		  "Now the current is 0.5.4, change it to suppress this message.\n"
		  "What exactly has changed:\n"
		  "There's a new option \"oBasics_padTrack = [true | false]\"\n"
		  "corresponding to the new switch \"options|cd|basics|pad data track\"\n"
		  "more things...");
      infoMessage(qtmp);
    }

  if (existDat(confDatPfad)
      && globalConf->readEntry("version") == "0.5.2")
    {
      // es ist Version 0.5.2
      qtmp = confDatPfad.c_str();       
      qtmp += i18n("\nYour configuration file contains the version number 0.5.2.\n"
		  "Now the current is 0.5.4, change it to suppress this message.\n"
		  "What exactly has changed:\n"
		  "It is possible to give a list of available speeds for burning/blanking\n"
		  "and to set a speed for blanking.");
      infoMessage(qtmp);
    }
  
  tmp = "u" + itoStr(meinUID, ' ', 1);
  cout << "Searching for UID: [" << tmp << "]..";
  globalConf->setGroup(tmp.c_str());
  tmp = "g" + itoStr(meinGID, ' ', 1);    
  if (globalConf->readEntry("settings", "none") == "none")
    {
      cout << "...not there, take GID: [" << tmp << "]\n";
      globalConf->setGroup(tmp.c_str());
    }
  tmp = globalConf->readEntry("settings", "none");
  if (tmp != "none" && tmp != "custom")
    {
      cout << "...link to [" << tmp << "]\n";
      globalConf->setGroup(tmp.c_str());	
      tmp = globalConf->readEntry("settings", "none");
    }
  cout << "Settings: " << tmp << "\n";
}












