#ifndef OPT_SYS_H
#define OPT_SYS_H

/*** Qt ***/
#include <qwidget.h>
#include <qgroupbox.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlineedit.h>
#include <qdialog.h>

/*** KDE ***/
#include <ksimpleconfig.h>
#include <krestrictedline.h>
#include <kfiledialog.h>
#include <ktabctl.h>

/*** KisoCD ***/
#include "types.h"
#include "switches.h"

class Opt_sys : public QDialog  {
   Q_OBJECT
private:
    KSimpleConfig*    globalConf;
    T_SysOptions*     sysOpts;
    bool              validDevices;

public: 
	Opt_sys(QWidget        *parent, 
		const char     *name,
		KSimpleConfig  *globConf,
		T_SysOptions   *sysOptions,
		bool           cdrecordAllowed);
	~Opt_sys();

protected: 
	QPushButton *QB_readDevice_browse;
	QGroupBox *QGB_readDevice;
	QLabel *QL_readDevice;
	QGroupBox *QGroupBox_1;
	QComboBox *QComboBox_1;
	QLabel *QL_writeDeviceSFile;
	QLineEdit *il_device;
	QPushButton *QPushButton_1;
	QGroupBox *QGroupBox_2b;
	QLineEdit *il_deviceb;
	QPushButton *QPushButton_1b;
	QGroupBox *QGroupBox_3;
	QComboBox *QComboBox_2;
	QLabel *QLabel_2;
	QSpinBox *QSpinBox_1;
	QLabel *QLabel_3;
	QGroupBox *QGroupBox_4;
	QComboBox *QComboBox_3;
	QLabel *QLabel_4;
	QLabel* QL_imgfile;
	QLabel*       QL_tmpdir;
	QPushButton*  pb_tmpdir;
	QLineEdit*    il_tmpdir;
	QPushButton *QPushButton_2;
	QGroupBox *QGroupBox_5;
	QLineEdit *QLineEdit_1;
	QLineEdit *il_imagepath;
	QPushButton *buttonApply;
	QPushButton *buttonCancel;
	QPushButton *buttonOK;
	/*** ???? ***/
	QCheckBox *cb_eject;
	QCheckBox *cb_shutdown;
	QComboBox *combo_blankSpeed;
	QLabel    *label_blankSpeed;
	/*** allgemein ***/
	KTabCtl*       tabCtl;
	QWidget*       tabP1;
	QWidget*       tabP2;

protected slots:
   void applySettings();
   void ok_clicked(); 
   void imagefileBrowseClicked();
   void tmpDirBrowseClicked();
   void writeDeviceSFileBrowseClicked();
   void readDeviceBrowseClicked();
private: 
   void scanScsiBus(bool); 
   int getNrSpeeds();
   string getSpeed(int);
   int getNr(int speed);
};

#endif










