#include "opt_ui.h"

/*** KDE ***/
#ifdef KDE2
#include <klocale.h>
#else
#include <kapp.h>
#endif

/*** KisoCD ***/
#include "tools.h"

/*** C++ ***/
#include <string>
#include <iostream.h>


Opt_ui::Opt_ui(QWidget*       parent,
	       const char*    name,
	       KSimpleConfig* globConf,
	       T_SysOptions*  sysOptions)
  :QDialog( parent, name, TRUE, 110592 ) {

  globalConf = globConf;
  sysOpts    = sysOptions;

  /****************************** ui *********************************************/
  cb_OptOnStartup = new QCheckBox( this, "Label_1" );
  cb_OptOnStartup->setGeometry(20, 20, 300, 30);
  cb_OptOnStartup->setText(i18n("Show options|CD on startup"));
  cb_OptOnStartup->setChecked(sysOpts->fOptOnStartup);

  cb_ProcFinMsg = new QCheckBox( this, "Label_2" );
  cb_ProcFinMsg->setGeometry(20, 60, 300, 30);
  cb_ProcFinMsg->setText(i18n("Message when subprocess has finished"));
  cb_ProcFinMsg->setChecked(sysOpts->fProcFinMsg);

  cb_ProcWinOnStart = new QCheckBox( this, "Label_3" );
  cb_ProcWinOnStart->setGeometry(20, 100, 300, 30);
  cb_ProcWinOnStart->setText(i18n("Show subprocess window on start"));
  cb_ProcWinOnStart->setChecked(sysOpts->fProcWinOnStart);

  cb_SimpleDND = new QCheckBox( this, "Label_4" );
  cb_SimpleDND->setGeometry(20, 140, 300, 30);
  cb_SimpleDND->setText(i18n("Don't show options on Drag'n'Drop"));
  cb_SimpleDND->setChecked(sysOpts->fSimpleDND);

  /******************************** allgemein **************************************/
  buttonOK = new QPushButton( this, "PushButton_2" );
  buttonOK->setGeometry( 10, 190, 110, 30 );
  buttonOK->setText( i18n("OK") );
  buttonOK->setDefault(true);
  connect(buttonOK, SIGNAL(clicked()), SLOT(ok_clicked()));

  buttonApply = new QPushButton( this, "PushButton_2" );
  buttonApply->setGeometry( 130, 190, 110, 30 );
  buttonApply->setText( i18n("Apply") );
  connect(buttonApply, SIGNAL(clicked()), SLOT(applySettings()));

  buttonCancel = new QPushButton( this, "PushButton_1" );
  buttonCancel->setGeometry( 250, 190, 110, 30 );
  buttonCancel->setText( i18n("Cancel") );
  connect(buttonCancel, SIGNAL(clicked()), SLOT(accept()));
     
  resize( 370, 240 );
  setMinimumSize( 370, 240 );
  setMaximumSize( 370, 240 );

  /* Die Einstellungen aufgrund der globalen Konfig-datei vornehmen */
  if (globalConf->readEntry("oUI_OptOnStartup", "noValue") != "noValue")
    cb_OptOnStartup->setEnabled(false);
  if (globalConf->readEntry("oUI_ProcFinMsg", "noValue") != "noValue")
    cb_ProcFinMsg->setEnabled(false);
  if (globalConf->readEntry("oUI_ProcWinOnStart", "noValue") != "noValue")
    cb_ProcWinOnStart->setEnabled(false);
  if (globalConf->readEntry("oUI_simpleDND", "noValue") != "noValue")
    cb_SimpleDND->setEnabled(false);
}

void Opt_ui::ok_clicked()
{
  applySettings();
  emit(accept());
}

void Opt_ui::applySettings()
{
  sysOpts->fOptOnStartup   = cb_OptOnStartup->isChecked();
  sysOpts->fProcWinOnStart = cb_ProcWinOnStart->isChecked();
  sysOpts->fProcFinMsg     = cb_ProcFinMsg->isChecked();
  sysOpts->fSimpleDND      = cb_SimpleDND->isChecked();
}

Opt_ui::~Opt_ui()
{
  delete buttonCancel;
  delete buttonApply;
  delete buttonOK;
}


#include "opt_ui.moc"
















