/***************************************************************************
                          QuickstartDialog.cpp  -  description                              
                             -------------------                                         
    begin                : Sun Aug 22 1999                                           
    copyright            : (C) 1999 by Jens Wilhelm Wulf                         
    email                : jens_w2@gmx.net                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "quickstartdialog.h"

#include "version.h"
#include "tools.h"
#ifdef KDE2
#include <klocale.h>
#include <kstddirs.h>
#else 
#include <kapp.h>
#endif


extern int                debuglevel;
extern DebugFile          debugFile; 


QuickstartDialog::QuickstartDialog(QWidget *parent, 
				   const char *name, 
				   bool fModal) : QDialog(parent,name,fModal)
{
  this->resize(470,390);
  this->setMaximumSize(470,390);
  this->setMinimumSize(470,390);

  QListBox_1= new QListBox(this,"NoName");
  QListBox_1->setGeometry(10,10,450,330);

  b_close= new QPushButton(this,"NoName");
  b_close->setGeometry(30,350,100,30);
  b_close->setText(i18n("Close"));

  QPushButton_2= new QPushButton(this,"NoName");
  QPushButton_2->setGeometry(220,350,100,30);
  QPushButton_2->setText(i18n("<< previous"));

  QPushButton_1= new QPushButton(this,"NoName");
  QPushButton_1->setGeometry(340,350,100,30);
  QPushButton_1->setText(i18n("next >>"));

  QPushButton_1->setEnabled(false);
  QPushButton_2->setEnabled(false);
#ifdef KDE2
   helpDatPfad = getenv("KDEDIR");
   helpDatPfad += "/";
   helpDatPfad += KStandardDirs::kde_default("html");
#else
  helpDatPfad = KApplication::kde_htmldir() + "/";
#endif  
  {
    string lang1, lang2, lang3, progName;
    
    getPrefLang(lang1, lang2, lang3);
    progName = ProggieNameLC;
    

    if (existDat(helpDatPfad + lang1 + "/" + progName + "/quickstart.txt")) 
      helpDatPfad += lang1 + "/" + progName + "/quickstart.txt";
    else 
      if (existDat(helpDatPfad + lang2 + "/" + progName + "/quickstart.txt")) 
	helpDatPfad += lang2 + "/" + progName + "/quickstart.txt";
      else 
        if (existDat(helpDatPfad + lang3 + "/" + progName + "/quickstart.txt")) 
	  helpDatPfad += lang3 + "/" + progName + "/quickstart.txt";
        else
          helpDatPfad += "en/"+ progName +"/quickstart.txt";
  }
  
  chapter = 1;
  helpDat.open(helpDatPfad.c_str());
#ifdef VERBOSEMESSAGES
  cout << helpDatPfad << "\n";
#endif
  if (debuglevel) debugFile.output("helpDatPfad: " + helpDatPfad);
  if (!helpDat) errorMessage(i18n("Unable to open quickhelp-file!"));
  else 
    { 
      char     Zeile[103];
      
      helpDat.getline(Zeile, 100);
      readChapter();
      connect(QPushButton_2, SIGNAL(clicked()), SLOT(prevChapter()));
      connect(QPushButton_1, SIGNAL(clicked()), SLOT(nextChapter()));
      connect(b_close, SIGNAL(clicked()), SLOT(hide()));
      QPushButton_1->setEnabled(true);
    }
}

void QuickstartDialog::readChapter()
{
  char  Zeile[102];

  QListBox_1->clear();
  while ((!helpDat.eof()) && (Zeile[0] != '[')) 
    {
      helpDat.getline(Zeile, 100);
      if (Zeile[0] != '[') QListBox_1->insertItem(Zeile);
    }
  if (Zeile[0] != '[') QPushButton_1->setEnabled(false);
}

void QuickstartDialog::gotoFirstChapter()
{
  char     Zeile[103];

  chapter = 1;
  helpDat.close();      
  helpDat.open(helpDatPfad.c_str());
  helpDat.getline(Zeile, 100);
  readChapter();
  QPushButton_1->setEnabled(true);
  QPushButton_2->setEnabled(false);
}

void QuickstartDialog::prevChapter()
{
  if (chapter > 1)
    {
      char  C1, C2;     
      char  Zeile[102];

      chapter--;   
      if (chapter == 1) QPushButton_2->setEnabled(false);
      if (chapter / 10 > 0) C1 = (chapter/10)+48;
      else C1 = ' ';
      C2 = (chapter%10)+48;
      QPushButton_1->setEnabled(true);
      helpDat.close();
      helpDat.open(helpDatPfad.c_str());
      while ((!helpDat.eof()) && 
	     !(Zeile[0] == '[' && Zeile[1] == C1 && Zeile[2] == C2)) 
	helpDat.getline(Zeile, 100);
      readChapter();      
    }
}

void QuickstartDialog::nextChapter()
{
  readChapter();
  chapter++;
  QPushButton_2->setEnabled(true);  
}

QuickstartDialog::~QuickstartDialog()
{
}

#include "quickstartdialog.moc"




