#ifndef __toolsXY__HEADERDAT
#define __toolsXY__HEADERDAT

/*** Qt ***/
#include <qstring.h>

/*** KDE ***/
#include <kprocess.h>

/*** C++ ***/
#include <string>
#include <fstream.h> 
#include <sys/stat.h>
#include <time.h>

/*** KisoCD ***/
#include "types.h"
#include "switches.h"

class FileWatch {
public:
  bool        flag;
  
  bool hasChanged()
    {
      struct stat tmp;

      stat(aFileName.c_str(), &tmp);
      return(!(tmp.st_size == fileData.st_size &&
	       tmp.st_mtime == fileData.st_mtime));
    };
  
  void lookNow(string fileName)
    {
      aFileName = fileName;
      stat(fileName.c_str(), &fileData);
    };
private:
  struct stat fileData;
  string      aFileName;
};

class DebugFile {
 public:
  DebugFile(string dir = "", string name = "");
  ~DebugFile();
  void setDirName(string dir, string name);
  int newFile();
  int newSection(string title = "");
  int output(string aString);
  int output(const char* aString);
  int output(QString aString);
  int appendFile(string filename);
 private:
  ofstream myFile;
  string   myDir;
  string   myBaseName;
  bool     fileOpen;
  
  int createFile();
};

class RemainingTimeTeller {   /* its stupid-name-time again ;-) */
 public:
  RemainingTimeTeller();
  void cdrecordStarted(int forcedsize=0);
  int tellRemaining(QString line);  
 private:
  float   speed;
  time_t  starttime;
  int     forcedSize;
};

bool cmpStats(struct stat stat1, struct stat stat2);

string str2Latex(string tmpStr);
QString getSizeText(const char* Beschr, unsigned long Groesse);
void errorMessage(const char* inhalt);
void infoMessage(const char* inhalt); 
void errorMessage(QString Inhalt);
void infoMessage(QString Inhalt);
string backslashifyWhitespace(string inputStr);
string backslashifySpecial(string inputStr);
string dateiInhalt(string pfad);

string itoStr(long int nr, char fill, unsigned char digits);
string getNrPath(string root, string name);
string getNrFile(string root, string name);
bool existDat(string);
string whereisExec(string name);
int close_ofs(ofstream &outDat);
void dumpOptions(T_Options);
string holStartVerz(string);

int execKFM(string startDir);

int getPrefLang(string &lang1, string &lang2, string &lang3);

void writeKoverFileHeader(ofstream &);
void writeLatexFileHeader(ofstream &);
void writeKoverFileFooter(ofstream &);
void writeLatexFileFooter(ofstream &);

int writeCdrecordCmd(ofstream &outDat, T_Options aktOpts, T_SysOptions sysOpts);

string getDevID(string);

string rmSlashes(string);
void mountViewImage(bool &fMounted, T_SysOptions sysOpts);
void unmountImage(bool &fMounted, string mountPoint);
string getPersConfigDir();
void getSysInfo(string pfad);
void makeNewLatexFile(string HeimatPfad);
#ifdef KDE2
int getUriType(QString path);
#endif
int preBurningBox(bool fShutdown);

#endif  // __toolsXY__HEADERDAT


















