#ifndef Verzeichnis__HEADERDAT
#define Verzeichnis__HEADERDAT

/*** Qt ***/
#include <qlistview.h>
#include <qlistbox.h>
#include <qlabel.h>

/*** C++ ***/
#include <string>
#include <vector>
#include <fstream.h>

/*** KisoCD ***/
#include "switches.h"

struct VerzEintraege { // speichert alle Daten ber NICHT-VERZEICHNISSE!
  string      DateiName;      // der Name, wenn er bei Quelle und Ziel gleich ist
  string      quellName;      // leer, es sei denn, der Quellname war verschieden
  long int    Groesse;     
};

/**********************************************************************************
 *                                                                                *
 * class Verzeichnis                                                            *
 *                                                                                *
 **********************************************************************************
 **********************************************************************************/
class Verzeichnis {
private:
  string                    Name;
  unsigned long             Groesse;        // Enthlt die Groesse der enthaltenen 
                                            // Dateien, allerdings nicht derer in 
                                            // den Unterverzeichnissen!!!
  unsigned long             GesamtGroesse;  // Mit Unterverzeichnissen unter Bercksichtigung
                                            // der Ausschlsse
  unsigned long             GroesseII;      // Enthaltene Dateien unter Bercksichtigung
                                            // der Ausschlsse
  vector <Verzeichnis*>   UnterVerz;
  vector <VerzEintraege>  Dateien;
 
  string                    meinPlatz;      // Damit man weiss, unter welchem Item
                                            // der TreeList man sich zu zeigen hat.
  /*
  vector<QString>           PfadAbschnitte; // Muss zusammen mit "meinPlatz" 
                                            // benutzt werden.
  */
public:
  Verzeichnis();
  int Setzen(string iPfad, bool FollowSymLink);
  int SetzenD(string iFile, string oFile, bool FollowSymLink);
  unsigned long GetSizeR();  // Liefert die Grsse einschliesslich der Unterverzeichnisse
  unsigned long GetSize();   // Liefert die Gesamtgrsse der enthaltenen Dateien
  void calcSize(vector<string> Excl);   // Berechnet die Gesamtgrsse der enthaltenen Dateien
                                        // unter Bercksichtigung der Ausschlsse
  int fillTreeList(QListView* ktl, 
		   string SrcPath, 
		   string DstPath,
		   vector<string> Excl,
		   ofstream &dat);
  void zeigInhalt(unsigned long*    size,
		  unsigned long*    sizeR,
		  string            ZielPfad, 
		  QListView*        DatList, 
		  vector<string>    Excl);
  int erstellListe(ofstream &dat, vector<string> Excl, unsigned long int &cnt);

  ~Verzeichnis();
};

#endif  // Verzeichnis__HEADERDAT





















