/***************************************************************************
                          mastercd.h  -  description
                             -------------------
    begin                : Thu Jan 27 2000
    copyright            : (C) 2000 by Kai Heitkamp
    email                : koncd@kai-heitkamp.de
 ***************************************************************************/


#ifndef MASTERCD_H
#define MASTERCD_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <kseparator.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qcombobox.h>
//Generated area. DO NOT EDIT!!!(end)

#include <qdialog.h>

#include "processoutput.h"
#include "imgprocout.h"

/**
  *@author Kai Heitkamp
  */

class MasterCD : public QDialog  {
   Q_OBJECT

public:
	MasterCD(QWidget *parent=0, const char *name=0);
	~MasterCD();

protected:
	void initDialog();

	ProcessOutput procoutdlg;
	ImgProcOut imgprocoutdlg;

	//Generated area. DO NOT EDIT!!!(begin)
	QGroupBox *QGroupBox_data;
	QLabel *QLabel_1;
	QLabel *QLabel_2;
	QLabel *QLabel_3;
	QLabel *QLabel_4;
	QGroupBox *QGroupBox_identification;
	QLabel *QLabel_5;
	QLabel *QLabel_6;
	QLabel *QLabel_7;
	QLabel *QLabel_8;
	QGroupBox *QGroupBox_Options;
	QGroupBox *QGroupBox_CDRWOptions;
	QLabel *QLabel_9;
	QGroupBox *QGroupBox_DataSpeed;
	QLabel *QLabel_DataSize;
	QLabel *QLabel_ImageType;
	QLabel *QLabel_speed;
	KSeparator *KSeparator_1;
	QLineEdit *QLineEdit_SourceDir;
	QPushButton *QPushButton_SourceDir;
	QPushButton *QPushButton_FileManager;
	QLineEdit *QLineEdit_ImageFile;
	QPushButton *QPushButton_ImageFile;
	QLineEdit *QLineEdit_BootImage;
	QPushButton *QPushButton_BootImage;
	QPushButton *QPushButton_ImageType;
	QLineEdit *QLineEdit_VolumeID;
	QLineEdit *QLineEdit_Publisher;
	QLineEdit *QLineEdit_Preparer;
	QLineEdit *QLineEdit_AppID;
	QCheckBox *QCheckBox_CreateImage;
	QCheckBox *QCheckBox_WriteCD;
	QCheckBox *QCheckBox_BootableCD;
	QCheckBox *QCheckBox_LeaveImage;
	QCheckBox *QCheckBox_Multisession;
	QCheckBox *QCheckBox_ignoresize;
	QCheckBox *QCheckBox_Force;
	QCheckBox *QCheckBox_Simulate;
	QCheckBox *QCheckBox_nofix;
	QCheckBox *QCheckBox_EjectCD;
	QComboBox *QComboBox_WriterSpeed;
	QComboBox *QComboBox_CDRWBlanking;
	QPushButton *QPushButton_Calculate;
	QPushButton *QPushButton_Start;
	QPushButton *QPushButton_Quit;
	//Generated area. DO NOT EDIT!!!(end)

protected slots:
	void setupConnections();
	void slotImageType();
	void slotExit();
	void slotStart();
	void slotCalculateSize();
	void slotCalculateProcessExited(KProcess *);
	void slotCalculateRecStderr(KProcess *proc, char *buffer, int buflen);
	void slotSetSourceDir();
	void slotFileManager();
	void slotSetImageFile();
	void slotSetBootImage();
	void slotToggleCreateImage();
	void slotToggleWriteCD();
	void slotToggleBootableCD();
	void slotMultisession();
	void slotBurnRecStderr(KProcess *proc, char *buffer, int buflen);
	void slotBurnProcessExited(KProcess *);
	void slotMakeImageStdout(KProcess *proc, char *buffer, int buflen);
	void slotMakeImageProcessExited(KProcess *);
	void slotMakeImage();
	void slotWriteCD();
	void slotMSInfo();
	void slotMSOutput( KProcess *p, char *s, int n );
	void slotMSInfoExited(KProcess *rcproc);
	void abortHandler();

private:
	int MS_Start, MS_End;
	bool existsSession;
};

#endif
