#include "PrefGeneric.h"
#include <kapp.h>
#include <klocale.h>
#include <krabwidget.h>

PrefGeneric::PrefGeneric( QWidget* parent, const char* name )
{
	box = new QGroupBox(this,"box");
	box->setGeometry(10,10,520,420);

	ButtonGroup_tag_version = new QButtonGroup( this, "ButtonGroup_tag_version" );
	ButtonGroup_tag_version->setGeometry( 20, 150, 140, 120 );
	ButtonGroup_tag_version->setMinimumSize( 0, 0 );
	ButtonGroup_tag_version->setMaximumSize( 32767, 32767 );
	ButtonGroup_tag_version->setFocusPolicy( QWidget::NoFocus );
	ButtonGroup_tag_version->setBackgroundMode( QWidget::PaletteBackground );
	ButtonGroup_tag_version->setFontPropagation( QWidget::NoChildren );
	ButtonGroup_tag_version->setPalettePropagation( QWidget::NoChildren );
	ButtonGroup_tag_version->setFrameStyle( 49 );
	ButtonGroup_tag_version->setTitle( i18n("MP3 TAG Version") );
	ButtonGroup_tag_version->setAlignment( 1 );

	CheckBox_readAll = new QCheckBox( this, "CheckBox_readAll" );
	CheckBox_readAll->setGeometry( 20, 20, 460, 30 );
	CheckBox_readAll->setMinimumSize( 0, 0 );
	CheckBox_readAll->setMaximumSize( 32767, 32767 );
	CheckBox_readAll->setFocusPolicy( QWidget::TabFocus );
	CheckBox_readAll->setBackgroundMode( QWidget::PaletteBackground );
	CheckBox_readAll->setFontPropagation( QWidget::NoChildren );
	CheckBox_readAll->setPalettePropagation( QWidget::NoChildren );
	CheckBox_readAll->setText( i18n("Try to read all data.") );
	CheckBox_readAll->setAutoRepeat( FALSE );
	CheckBox_readAll->setAutoResize( FALSE );

	CheckBox_Capital_filename = new QCheckBox( this, "CheckBox_Capital_filename" );
	CheckBox_Capital_filename->setGeometry( 20, 50, 460, 30 );
	CheckBox_Capital_filename->setMinimumSize( 0, 0 );
	CheckBox_Capital_filename->setMaximumSize( 32767, 32767 );
	CheckBox_Capital_filename->setFocusPolicy( QWidget::TabFocus );
	CheckBox_Capital_filename->setBackgroundMode( QWidget::PaletteBackground );
	CheckBox_Capital_filename->setFontPropagation( QWidget::NoChildren );
	CheckBox_Capital_filename->setPalettePropagation( QWidget::NoChildren );
	CheckBox_Capital_filename->setText( i18n("Every word in the output filename begin with a capital letter.") );
	CheckBox_Capital_filename->setAutoRepeat( FALSE );
	CheckBox_Capital_filename->setAutoResize( FALSE );

	CheckBox_replace = new QCheckBox( this, "CheckBox_replace" );
	CheckBox_replace->setGeometry( 20, 80, 100, 30 );
	CheckBox_replace->setMinimumSize( 0, 0 );
	CheckBox_replace->setMaximumSize( 32767, 32767 );
	CheckBox_replace->setFocusPolicy( QWidget::TabFocus );
	CheckBox_replace->setBackgroundMode( QWidget::PaletteBackground );
	CheckBox_replace->setFontPropagation( QWidget::NoChildren );
	CheckBox_replace->setPalettePropagation( QWidget::NoChildren );
	CheckBox_replace->setText( i18n("Replace every") );
	CheckBox_replace->setAutoRepeat( FALSE );
	CheckBox_replace->setAutoResize( FALSE );

	Label_replace = new QLabel( this, "Label_replace" );
	Label_replace->setGeometry( 143, 80, 200, 30 );
	Label_replace->setText( i18n("letter in ouput filename with") );
	
	LineEdit_replace1 = new QLineEdit( this, "LineEdit_replace1" );
	LineEdit_replace1->setGeometry( 125, 80, 17, 30 );
	LineEdit_replace1->setMaxLength( 1 );

	LineEdit_replace2 = new QLineEdit( this, "LineEdit_replace2" );
	LineEdit_replace2->setGeometry( 350, 80, 17, 30 );
	LineEdit_replace2->setMaxLength( 1 );

	RadioButton_tag_v1 = new QRadioButton( ButtonGroup_tag_version, "RadioButton_tag_v1" );
	RadioButton_tag_v1->setGeometry( 20, 20, 100, 30 );
	RadioButton_tag_v1->setMinimumSize( 0, 0 );
	RadioButton_tag_v1->setMaximumSize( 32767, 32767 );
	RadioButton_tag_v1->setFocusPolicy( QWidget::TabFocus );
	RadioButton_tag_v1->setBackgroundMode( QWidget::PaletteBackground );
	RadioButton_tag_v1->setFontPropagation( QWidget::NoChildren );
	RadioButton_tag_v1->setPalettePropagation( QWidget::NoChildren );
	RadioButton_tag_v1->setText( i18n("Version 1.0") );
	RadioButton_tag_v1->setAutoRepeat( FALSE );
	RadioButton_tag_v1->setAutoResize( FALSE );
	RadioButton_tag_v1->setChecked( TRUE );

	RadioButton_tag_v2 = new QRadioButton( ButtonGroup_tag_version, "RadioButton_tag_v2" );
	RadioButton_tag_v2->setGeometry( 20, 80, 100, 30 );
	RadioButton_tag_v2->setMinimumSize( 0, 0 );
	RadioButton_tag_v2->setMaximumSize( 32767, 32767 );
	RadioButton_tag_v2->setFocusPolicy( QWidget::TabFocus );
	RadioButton_tag_v2->setBackgroundMode( QWidget::PaletteBackground );
	RadioButton_tag_v2->setFontPropagation( QWidget::NoChildren );
	RadioButton_tag_v2->setPalettePropagation( QWidget::NoChildren );
	RadioButton_tag_v2->setText( i18n("Version 2.0") );
	RadioButton_tag_v2->setAutoRepeat( FALSE );
	RadioButton_tag_v2->setAutoResize( FALSE );
	RadioButton_tag_v2->setEnabled( FALSE ); // NO SUPPORT YET

	RadioButton_tag_v11 = new QRadioButton( ButtonGroup_tag_version, "RadioButton_tag_v11" );
	RadioButton_tag_v11->setGeometry( 20, 50, 100, 30 );
	RadioButton_tag_v11->setMinimumSize( 0, 0 );
	RadioButton_tag_v11->setMaximumSize( 32767, 32767 );
	RadioButton_tag_v11->setFocusPolicy( QWidget::TabFocus );
	RadioButton_tag_v11->setBackgroundMode( QWidget::PaletteBackground );
	RadioButton_tag_v11->setFontPropagation( QWidget::NoChildren );
	RadioButton_tag_v11->setPalettePropagation( QWidget::NoChildren );
	RadioButton_tag_v11->setText( i18n("Version 1.1") );
	RadioButton_tag_v11->setAutoRepeat( FALSE );
	RadioButton_tag_v11->setAutoResize( FALSE );

	ButtonGroup_tag_version->insert( RadioButton_tag_v1 );
	ButtonGroup_tag_version->insert( RadioButton_tag_v2 );
	ButtonGroup_tag_version->insert( RadioButton_tag_v11 );

	resize( 500,340 );
	setMinimumSize( 0, 0 );
	setMaximumSize( 32767, 32767 );
}


PrefGeneric::~PrefGeneric()
{
}
