#include <fcntl.h>
#include <krabwidget.h>

void KrabWidget::doit( )
{
	QString temp, temp2;
	unsigned int i;
	working = 1;

	if ( play_prog_run )
		emit ( play_emited() ); // turn off !!!

	if ( todolist->outputPath == "" )
	{
#ifdef KDE2
		QMessageBox::information( this, i18n( "Error" ) , i18n( "Select an output path first ! \n") );
#else
		KMsgBox::message( this, i18n( "Error" ) , i18n( "Select an output path first ! \n") );
#endif
		return;
	};	
	if ( todolist->tracks == 0 )
	{
#ifdef KDE2
		QMessageBox::information( this, i18n( "Error" ), i18n( "Select some tracks or files first ! \n" ));
#else
		KMsgBox::message( this, i18n( "Error" ), i18n( "Select some tracks or files first ! \n" ));
#endif
		return;
	};
	if ( todolist->grab_mode == 15 )
	{
		if ( !sox ){
#ifdef KDE2
			QMessageBox::information( this, i18n( "Error" ) , i18n( "You need the sox... read the help \n") );
#else
			KMsgBox::message( this, i18n( "Error" ) , i18n( "You need the sox... read the help \n") );
#endif
			return;
		};
		void check_cdr();
		if ( cdr_pre_loaded < 0 ){
#ifdef KDE2
			QMessageBox::information( this, i18n( "Error" ) , i18n( "Please insert a writeable CD-R ! \n") );
#else
			KMsgBox::message( this, i18n( "Error" ) , i18n( "Please insert a writeable CD-R ! \n") );
#endif
			return;
		};
		if ( ((total_final_size+cdr_pre_loaded)/1024) > ( MAX_MB_ON_CD *1024) ){
#ifdef KDE2
			if ( 1 == QMessageBox::warning( (QWidget*)0, i18n( "Question" ), i18n("Not enough free space on CD-R !\n\nburn anyway ?"), 0, 0, 1 ) )
#else
			if ( 2 == KMsgBox::yesNo( (QWidget*)0, i18n( "Question" ), i18n("Not enough free space on CD-R !\n\nburn anyway ?"), KMsgBox::QUESTION ) )
#endif
				return;
		};
	};	

	if ( todolist->grab_mode > 0 && todolist->grab_mode < 16 )
		Status = new status_window( 0, "", encoder_max );
	else
		Status = new status_window( 0, "", 0 );
	connect( Status, SIGNAL(destroy_status()), SLOT(kill_doit()) );
	connect( Status, SIGNAL(send_signal(unsigned int)), SLOT(send_signal_process(unsigned int)) );
	Status->KSlider_nice->setValue( 19 - nice_level );
	Status->show();
	connect( Status, SIGNAL(renice(int)), SLOT(renice_process(int)) );

	temp2.setNum( todolist->tracks );
	temp = i18n ( "total job" );
	temp +=  ":  0/";
	temp += temp2;
	Status->QLabel_Status_total->setText( temp );

	convert_prog	    = 0;
	doit_control_run    = 0;
	progress_update_run = 0;
	read_prog_run       = 0;
	jobnumber           = 0;
	write_jobnumber     = 0;
	jobs_finished	    = 0;
	needed_encd_space   = 0;
	wait_4_cd_change    = 0;
	cdrecord_progress   = 0;
	for ( i = 0; i <= 5; i++ )
		write_prog_run[i] = 0;
	tempfilename.resize( todolist->tracks+2 );
	temp_file.resize( todolist->tracks+2 );
	int *Z;
	for ( i = 0; i <= todolist->tracks+1; i++ ){
		Z = (int*) malloc(sizeof(int));
		*Z = 0;
		temp_file.insert( i, Z );
	};
	total_finished = 0;

	calc_total_size();

	connect ( this, SIGNAL(ask_4_new_cd()), SLOT(pop_up_4_new_cd()) );

	QTimer_progress = new QTimer ( 0 );
	connect ( QTimer_progress, SIGNAL(timeout()), SLOT(progress_update()) );
	QTimer_progress->start( 200, 0 );
	QTimer_process = new QTimer ( 0 );
	connect ( QTimer_process, SIGNAL(timeout()), SLOT(doit_control()) );
	QTimer_process->start( 400, 0 );

	krabwidget_setEnabled( 0 );
};
void KrabWidget::doit_control()
{
	doit_control_run = 1;

	unsigned int i, nr_of_tempfile, max_write_ok;
	bool device_no_space;

	if ( !Status ) return;

	device_no_space = 0;

	if ( read_prog_run )
		max_write_ok = jobnumber - 1;
	else
		max_write_ok = jobnumber;
	nr_of_tempfile = 0;
	for ( i=1; i <= jobnumber; i++)
		if ( *temp_file[i] )
			nr_of_tempfile++;
	if ( !read_prog_run  && jobnumber<todolist->tracks && !wait_4_cd_change )
	   if  (( nr_of_tempfile<encoder_max && !krabber_config.readall) || krabber_config.readall)
	   {
		bool check_cd_flag = 0;
		if ( jobnumber == 0 && todolist->data[jobnumber+1]->type == 1 ){
			check_cd_flag = 1;
		}else{
			if (jobnumber+1 < todolist->tracks && jobnumber ){
				if ( todolist->data[jobnumber]->type == 1 && todolist->data[jobnumber+1]->type == 1){
			           if ( (todolist->data[jobnumber]->cddb_discid != todolist->data[jobnumber + 1]->cddb_discid) )
					check_cd_flag = 1;
				}else if (todolist->data[jobnumber]->type != 1 && todolist->data[jobnumber+1]->type == 1 )
					check_cd_flag = 1;
			};
		};
	
		if ( check_cd_flag )
			if ( current_discid( jobnumber+1 ) != todolist->data[jobnumber+1]->cddb_discid )
			{
				wait_4_cd_change = 1;
				emit ( ask_4_new_cd() );
			};

		if ( !wait_4_cd_change )
		{
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "df" );
			*help_prog << "-k" << "-P" << todolist->outputPath;
			connect(help_prog, SIGNAL(receivedStdout(KProcess *, char *, int )), this, SLOT(help_prog_df_stdout(KProcess *, char *, int  )));
			help_prog->start(KProcess::Block, KProcess::AllOutput);
			delete help_prog;
			help_prog = 0;
			double l;
			l = todolist->length_bytes(jobnumber + 1, dest_bitrate, dest_channels, dest_bits);
			if ( ((space_avaible - (needed_encd_space/1024) )- MINIMUM_FREE) > ( l /1024) )
			{
					jobnumber++;
					read_prog_run = 1;
					doit_read_prog();
					QString temp, temp2;
					temp2.setNum( jobnumber );
					temp = i18n ( "read job" );
					temp +=  ": ";
					temp += temp2;
					temp += "/";
					temp2.setNum( todolist->tracks );
					temp += temp2;
					Status->QLabel_Status_read->setText( temp );
					Status->read_led( 1 );
			}
			else
			{
				if ( nr_of_tempfile == 0 )
					device_no_space = 1;
			};
		};
	};
	for ( i=0 ; i < encoder_max ; i++)
	{
		if ( !write_prog_run[i]&&((QCheckBox_tempfiles->isChecked()&&read_prog_run)
			||(*temp_file[write_jobnumber + 1]&&write_jobnumber<jobnumber)) ) //write_jobnumber +1 -1
		{
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "df" );
			*help_prog << "-k" << todolist->outputPath;
			connect(help_prog, SIGNAL(receivedStdout(KProcess *, char *, int )), this, SLOT(help_prog_df_stdout(KProcess *, char *, int  )));
			help_prog->start(KProcess::Block, KProcess::AllOutput);
			delete help_prog;
			help_prog = 0;
			if ( todolist->grab_mode > 0 && todolist->grab_mode < 16 )
				Status->write_led( 1, i );

			write_jobnumber++;
			write_prog_run[i] = 1;
			write_job_track[i] = write_jobnumber - 1;
			doit_write_prog(i);
			if ( (space_avaible-MINIMUM_FREE) < (write_prog_final_size[i]/1024) )
			{
				device_no_space = 1;
//				disconnect(write_prog[i], SIGNAL(processExited(KProcess *)));
				write_prog[i]->kill(9);
				delete write_prog[i];
				write_prog[i] = 0;
				if ( todolist->grab_mode > 0 && todolist->grab_mode < 16 )
					Status->write_led( 0, i );
				help_prog = new KProcess;
				help_prog->clearArguments();
				help_prog->setExecutable( "rm" );
				*help_prog << "-f" << *tempfilename[i];
				help_prog->start(KProcess::Block, KProcess::AllOutput);
				delete help_prog;
				help_prog = 0;
				write_prog_run[i] = 0;
				*temp_file[write_jobnumber + 1] = 0;
				write_jobnumber--;
			};
		};
	};
	if ( Status && ( jobnumber==todolist->tracks || device_no_space ) && !read_prog_run && nr_of_tempfile == 0)
 	{
		for ( i=0 ; i < encoder_max ; i++)
		{
			if ( ( write_job_track[i] < max_write_ok ) && !write_prog_run[i])
				max_write_ok = write_job_track[i];
		}

		delete QTimer_progress;
		delete QTimer_process;
		QTimer_progress = 0;
		QTimer_process = 0;
		if ( device_no_space )
		{
			Status->QPushButton_Status_Cancel->setText( i18n( "Aborted !" ) );
#ifdef KDE2
		 	QMessageBox::information( this, i18n ("Error"), i18n ( "No space left on device !" ) );	
#else
		 	KMsgBox::message( this, i18n ("Error"), i18n ( "No space left on device !" ) );	
#endif
			if ( QCheckBox_clear_list->isChecked() ) {
				for ( i = 1; i <= todolist->tracks; i++){
					todolist->data.remove( i );
					todolist->data.insert( i, todolist->data[i+max_write_ok] );
				};
				todolist->tracks -= max_write_ok;
			};
			working = 0;
		}
		else
		{
			emit ( Status->KProgress_total->setValue( 100 ) );
			if ( todolist->grab_mode == 15 ){
			  if (QCheckBox_cdr_fix->isChecked()||QCheckBox_cdr_eject->isChecked())
				cdr_fix();
			  else{
				working = 0;
				Status->QPushButton_Status_Cancel->setText( i18n( "Finished !" ) );
				Status->total_led( 1 );
			  };
			}else{
				working = 0;
				Status->QPushButton_Status_Cancel->setText( i18n( "Finished !" ) );
				Status->total_led( 1 );
			};
			if ( QCheckBox_clear_list->isChecked() ){
			 	todolist->tracks = 0;	
				for ( i = 1; i <= todolist->tracks; i++)
					todolist->data.remove( i );
			};
                };
	};
	doit_control_run = 0;
};

void KrabWidget::kill_doit()
{
	unsigned int process_nr, max_write_ok, i;
	unsigned long total_counter;
	QString temp;

	disconnect( Status, SIGNAL(destroy_status()) );
	delete QTimer_progress;
	delete QTimer_process;
	QTimer_progress = 0;
	QTimer_process = 0;

	total_counter = kconfig->readUnsignedLongNumEntry( "total_counter", 0 );
	total_counter += (total_finished/1024)/1024;
	kconfig->writeEntry( "total_counter", total_counter );
	kconfig->sync();

	if ( read_prog )
	{
		read_prog->kill( SIGTERM );
		delete read_prog;
		read_prog = 0;
		if ( use_fifo ){
			use_fifo = 0;
			convert_prog->kill( SIGTERM );
			delete convert_prog;
			convert_prog = 0;
		};			
	}
	else
		max_write_ok = jobnumber ;

	if ( read_prog_run ){
		read_prog_run = 0;
		max_write_ok = jobnumber - 1;

		help_prog = new KProcess;
		help_prog->clearArguments();
		help_prog->setExecutable( "rm" );
		*help_prog << "-f" << *tempfilename[jobnumber-1];
		help_prog->start(KProcess::Block, KProcess::AllOutput);
		delete help_prog;
		help_prog = 0;
	}else
		max_write_ok = jobnumber ;

	for ( process_nr = 0; process_nr < encoder_max; process_nr++ )
	{
		if ( (write_job_track[process_nr] < max_write_ok) && write_prog[process_nr] != 0 )
		  if ( write_prog[process_nr]->isRunning() )
			max_write_ok = write_job_track[process_nr];
		if ( write_prog[process_nr] )
		  if ( write_prog[process_nr]->isRunning() ){
			write_prog[process_nr]->kill( SIGTERM );
			delete  write_prog[process_nr];
			write_prog[process_nr] = 0;
		  };
		if ( write_prog_run[process_nr] )
		{
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "rm" );
			*help_prog << "-f" ;
			if ( todolist->grab_mode == 5 )//QString + QString cause a seg fault at this point sometimes !!
			{
				temp = *tempfilename[write_job_track[process_nr]] + ".wav";
				*help_prog << temp;
				temp = *tempfilename[write_job_track[process_nr]] + ".mp3";
			};
			if ( todolist->grab_mode == 3 )//QString + QString cause a seg fault at this point sometimes !!
			{
				temp = *tempfilename[write_job_track[process_nr]];
				if ( !QCheckBox_tempfiles->isChecked() )
					*help_prog << temp;
				temp = *tempfilename[write_job_track[process_nr]] +".mp3";
			};
			if ( todolist->grab_mode != 5 && todolist->grab_mode != 0 )
				temp = outputfilename[ write_job_track[process_nr] ];
			*help_prog << temp;
			help_prog->start(KProcess::Block);//, KProcess::AllOutput);
			delete help_prog;
			help_prog = 0;
		};
		write_prog_run[process_nr] = 0;	
	};

	delete Status;
	Status = 0;
	if ( todolist->tracks && max_write_ok > 0 && QCheckBox_clear_list->isChecked() )
	{
		todolist->tracks -= max_write_ok;
		for ( i = 1; i <= todolist->tracks; i++){
			todolist->data.remove( i );
			todolist->data.insert( i, todolist->data[i+max_write_ok] );
		};
		for ( i = todolist->tracks+1; i <= todolist->tracks+max_write_ok; i++)
			todolist->data.remove( i );

		todolist->data.resize( todolist->tracks+1 );
	};

	for ( i=1; i<=todolist->tracks; i++)
		if (*temp_file[i])
		{
			help_prog = new KProcess;
			help_prog->clearArguments();
			help_prog->setExecutable( "rm" );
			*help_prog << "-f" << *tempfilename[i-1];
			help_prog->start(KProcess::Block, KProcess::AllOutput);
			delete help_prog;
			help_prog = 0;
			*temp_file[i] = 0;
		};

	temp_file.clear();
	tempfilename.clear();

	if ( todolist->grab_mode==15 && todolist->tracks==max_write_ok
		&& (QCheckBox_cdr_fix->isChecked()||QCheckBox_cdr_eject->isChecked()) )
		cdr_fix();
	else
		krabwidget_setEnabled( 1 );
};

void KrabWidget::renice_process( int nice_level_input )
{
	nice_level = 19 - nice_level_input;
	unsigned int i;
	QString temp;
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "renice" );
	temp.setNum( nice_level );
	*help_prog << temp << "-p";
	if ( read_prog_run )
	{
		temp.setNum( read_prog->getPid() );
		*help_prog << temp;
	}
	for ( i=0; i < MAX_ENCODERS; i++)
	{
		if ( write_prog_run[i] )
		{
			temp.setNum( write_prog[i]->getPid() );
			*help_prog << temp;
		}
	};
	help_prog->start(KProcess::Block, KProcess::AllOutput);		
	delete help_prog;
	help_prog = 0;
};

void KrabWidget::send_signal_process( unsigned int signal )
{
	unsigned int i;
	QString temp;
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "kill" );
	*help_prog << "-s" ;
	temp.setNum( signal );
	*help_prog << temp;
	if ( read_prog_run )
	{
		temp.setNum( read_prog->getPid() );
		*help_prog << temp;
 	};
	for ( i=0; i < MAX_ENCODERS; i++)
	{
		if ( write_prog_run[i] )
		{
			temp.setNum( write_prog[i]->getPid() );
			*help_prog << temp;
		}
	};
	help_prog->start(KProcess::Block, KProcess::AllOutput);		
	delete help_prog;
	help_prog = 0;
};

void KrabWidget::progress_update()
{
	if ( progress_update_run )
	{
//		return;
	}
	progress_update_run = 1;
	unsigned long int total_finished_part;
	double progress;
	unsigned long file_size;
	unsigned int i;

	total_finished_part = 0;

	if ( read_prog_run && !QCheckBox_tempfiles->isChecked() )
	{
		if ( read_prog_file->exists() )
			file_size = read_prog_file->size() ;
		else
			file_size = 0;
		if ( (file_size > 0) && (read_prog_final_size > 100) )
			progress = file_size/(read_prog_final_size/100);
		else
			progress = 0;
		Status->KProgress_read->setValue( (int) progress );
		if ( todolist->grab_mode == 0 || todolist->grab_mode > 15 )
			total_finished_part = (unsigned long) file_size;
	};
	if ( todolist->grab_mode == 15 ){  // cdrecord has no output file
		Status->KProgress_write[0]->setValue( (int)cdrecord_progress );
		total_finished_part = (unsigned long)  todolist->length_bytes_output(write_job_track[0]+1, dest_bitrate, dest_channels, dest_bits, bitrate);
		total_finished_part /= 100;
		total_finished_part *= cdrecord_progress;
	};
	if ( todolist->grab_mode != 0 && todolist->grab_mode < 15 ){
	   for ( i=0; i<encoder_max; i++)  {
	   	if ( write_prog_run[i] && todolist->grab_mode != 0 ){
			if ( write_prog_file[i]->exists() )
				file_size = write_prog_file[i]->size() ;
			else
				file_size = 0;
			if ( file_size > 0 && write_prog_final_size[i] > 0 )
				progress = (file_size*100)/write_prog_final_size[i];
			else
				progress = 0;

			Status->KProgress_write[i]->setValue( (int)progress );
			if ( QCheckBox_tempfiles->isChecked() )
				Status->KProgress_read->setValue( (int) progress );

			total_finished_part += (unsigned long) file_size;
		};
	   };
	};

	progress = (((double)total_finished + (double)total_finished_part)/(double)total_final_size)*100  ;

	Status->KProgress_total->setValue( (int) progress );
	progress_update_run = 0;
};
QString KrabWidget::character_replace( QString string, QString from, QString to )
{
	const char *to_p = to;

	for ( unsigned int i = 0; i<string.length(); i++ )
	{
		if ( string.mid( i, 1 ) == from.mid(0,1) )
		{
			string.remove( i, 1 );
			string.insert( i, to_p );
		};
	};

	return string;
};
void KrabWidget::help_prog_df_stdout(KProcess *kp, char *temp_p, int z )
{
	unsigned int j; kp=kp; z=z; // I hate compiler warnings...
	temp_p += 104;
	j=0;
	// this should work with df version 4; NOT TESTED !!!
	while ( *temp_p >=48 && *temp_p <=57 )
		temp_p++;
	while ( *temp_p == 32 )
		temp_p++;
	while ( *temp_p >=48 && *temp_p <=57 )
			j += *temp_p++ + j + (j<<3) - 48;

	space_avaible = j;
};

void KrabWidget::write_mp3_header( QString file_name, unsigned int number )
{
	QString output_string, temp, temp_fill;

	char input[4] = "AAA";
	char *input_p = input;

	QFile file;
	file.setName( file_name );
	if ( !file.open(IO_ReadWrite) )
		return;
	file.at(file.size()-128);
        file.readBlock( input_p, 3 );

	if ( input[0] == 'T' && input[1] == 'A' && input[2] == 'G' )
		file.at(file.size()-128);
	else
		file.at(file.size());

	output_string  = "TAG";
	temp = todolist->data[number]->title;
	temp = temp.left(30);
	temp_fill.fill(' ', (30 - temp.length()) );
	output_string += temp + temp_fill;
	temp = todolist->data[number]->group;
	temp = temp.left(30);
	temp_fill.fill(' ', (30 - temp.length()) );
	output_string += temp + temp_fill;
	temp = todolist->data[number]->album;
	temp = temp.left(30);
	temp_fill.fill(' ', (30 - temp.length()) );
	output_string += temp + temp_fill;
	temp = todolist->data[number]->year ;
	temp = temp.left(4);
	temp_fill.fill(' ', (4 - temp.length()) );
	output_string += temp.left(4) + temp_fill;
	temp = todolist->data[number]->comment;
	if ( krabber_config.mp3tag_version == 0 )
	{
		temp = temp.left(30);
		temp_fill.fill(' ', (30 - temp.length()) );
	};
	if ( krabber_config.mp3tag_version == 1 )
	{
		temp = temp.left(29);
		temp_fill.fill(' ', (29 - temp.length()) );
	};
	output_string += temp + temp_fill;
	const char *output = output_string;

	if ( krabber_config.mp3tag_version == 0 )
		file.writeBlock( output, 127 );
	if ( krabber_config.mp3tag_version == 1 )
	{
		file.writeBlock( output, 125 );
		file.putch( '\0' );
		file.putch( todolist->data[number]->tracknumber );
	};
	file.putch( todolist->data[number]->music_type );
	file.close();
};
unsigned long KrabWidget::current_discid( unsigned int job )
{
	if ( todolist->data[job]->type != 1 )
		{ cout << "Internal Krabber Error: current_discid"<<job<<endl; return 0; }

	QString temp = todolist->device_choiced;

	todolist->device_choiced = todolist->data[job]->device;

	cddalist *CddaList = new cddalist( 0, "", todolist, 0);
        CddaList->show();
	unsigned long disc_id = CddaList->disc_id;
	delete CddaList;

	todolist->device_choiced = temp;
	return disc_id;
};
bool CD_CHANGE_BUG = 0;
void KrabWidget::pop_up_4_new_cd()
{
	if (CD_CHANGE_BUG)
		return;
        CD_CHANGE_BUG = 1;
	cd_change();
	connect( cd_change_PushButton, SIGNAL(clicked()), SLOT(cd_changed()) );
	cd_change_Label_1->setText( i18n("Please change your CD in ") + todolist->data[jobnumber+1]->device );
	cd_change_Label_3->setText( todolist->data[jobnumber+1]->group +" / "+ todolist->data[jobnumber+1]->album );
	cd_change_Widget->show();
};
void KrabWidget::cd_changed()
{
	cd_change_Widget->close();
	delete cd_change_PushButton;
	delete cd_change_Label_1;
	delete cd_change_Label_2;
	delete cd_change_Label_3;
	delete cd_change_Widget;
	wait_4_cd_change = 0;
        CD_CHANGE_BUG = 0;
};

