#include <krabwidget.h>

void KrabWidget::cdr_fix_(){
	int ret;
#ifdef KDE2
	ret = QMessageBox::warning( 0, i18n("fix the CD-R ?"), i18n("fix the CD-R ?"), 0, 0, 1 );
#else
	ret = KMsgBox::yesNo( 0, i18n("fix the CD-R ?"), i18n("fix the CD-R ?") );
#endif
	if ( ret == 1 )
		cdr_fix( 1 );
};
void KrabWidget::cdr_fix( bool force_fix=0 ){
	QPushButton_cdr_fix->blockSignals( 1 );

	krabwidget_setEnabled( 0 );
	emit( new_status_info( i18n( "fix the CD-R..." ) ) );

	write_prog[0] = new KProcess;
	write_prog[0]->clearArguments();
	write_prog[0]->setExecutable( "cdrecord" );
	connect(write_prog[0], SIGNAL(processExited(KProcess *)), SLOT(cdr_job_end()));

	*write_prog[0] << "dev=" + cdrecord_device_id[QComboBox_cdr_device->currentItem()+1];
	switch ( QComboBox_cdr_speed->currentItem() ){
		case 0:
			*write_prog[0] << "speed=1";
			break;
		case 1:
			*write_prog[0] << "speed=2";
			break;
		case 2:
			*write_prog[0] << "speed=4";
			break;
		case 3:
			*write_prog[0] << "speed=6";
			break;
		case 4:
			*write_prog[0] << "speed=8";
			break;
	};
	if ( QCheckBox_cdr_dummy->isChecked() )
		*write_prog[0] << "-dummy";
	if ( QCheckBox_cdr_fix->isChecked()||force_fix )
		*write_prog[0] << "-fix";
	if ( QCheckBox_cdr_eject->isChecked() )
		*write_prog[0] << "-eject";
	write_prog[0]->start(KProcess::NotifyOnExit, KProcess::AllOutput);
};
void KrabWidget::cdr_check(){
	QColor color;

	if ( check_cdr_run )
		return;

	check_cdr_run = 1;
	help_prog_stdout_temp = "";

	write_prog[0] = new KProcess;
	write_prog[0]->clearArguments();
	write_prog[0]->setExecutable( "cdrecord" );
	connect(write_prog[0], SIGNAL(processExited(KProcess *)), SLOT(cdr_check_end()));

	*write_prog[0] << "dev=" + cdrecord_device_id[QComboBox_cdr_device->currentItem()+1];
	*write_prog[0] << "-toc";
	connect(write_prog[0], SIGNAL(receivedStdout(KProcess *, char *, int )),
	                             this, SLOT(test_env_stdout(KProcess *, char *, int  )));
	write_prog[0]->start(KProcess::NotifyOnExit, KProcess::AllOutput);

	QPushButton_cdr_size->setText( "" );
	color.setRgb( 20, 200, 20); // yellow
//	QPushButton_cdr_size->setColor( color ); // no sense yet ;-(
	emit( new_status_info( i18n( "check the CD-R(W)..." ) ) );
};
void KrabWidget::cdr_check_end(){
        cdr_pre_loaded = -99;
	if ( help_prog_stdout_temp.contains( "cdrecord: No disk / Wrong disk!" )
	     || help_prog_stdout_temp.contains( "medium not present" )){
		cdr_pre_loaded = -1;
//	} else 	if ( help_prog_stdout_temp.contains( "track:lout" ) ){
//		cdr_pre_loaded = -2;
	} else 	if ( help_prog_stdout_temp.contains( "first: 0 last 0" ) ){
		cdr_pre_loaded = 0;
	} else // unknown problem....
		cdr_pre_loaded = -100;

	if ( todolist->grab_mode != 15 )
		return;

	todolist_update_cdr();
	emit( new_status_info( i18n( "check the CD-R(W)... finished" ) ) );
	check_cdr_run = 0;
};
void KrabWidget::cdr_blank_start(){
	int ret;

//	QPushButton_cdr_blank->blockSignals( 1 );

#ifdef KDE2
	ret = QMessageBox::information( this, i18n("blank the CD-RW ?"), i18n("blank the CD-RW ?"),
				    i18n("fast"), i18n("all"), i18n("cancel"), 0, 2 );
#else
	ret = KMsgBox::yesNoCancel( 0, i18n("blank the CD-RW ?"), i18n("blank the CD-RW ?"),
				    KMsgBox::QUESTION, i18n("fast"), i18n("all"), i18n("cancel") );
#endif
	if ( ret == 3 )
		return;

	krabwidget_setEnabled( 0 );
	emit( new_status_info( i18n( "blank the CD-RW..." ) ) );

	write_prog[0] = new KProcess;
	write_prog[0]->clearArguments();
	write_prog[0]->setExecutable( "cdrecord" );
	connect(write_prog[0], SIGNAL(processExited(KProcess *)), SLOT(cdr_job_end()));

	*write_prog[0] << "dev=" + cdrecord_device_id[QComboBox_cdr_device->currentItem()+1];
	switch ( QComboBox_cdr_speed->currentItem() ){
		case 0:
			*write_prog[0] << "speed=1";
			break;
		case 1:
			*write_prog[0] << "speed=2";
			break;
		case 2:
			*write_prog[0] << "speed=4";
			break;
		case 3:
			*write_prog[0] << "speed=6";
			break;
		case 4:
			*write_prog[0] << "speed=8";
			break;
	};

	if ( ret == 1 )
		*write_prog[0] << "blank=fast";
	else
		*write_prog[0] << "blank=all";

	write_prog[0]->start(KProcess::NotifyOnExit, KProcess::AllOutput);
};
void KrabWidget::cdr_job_end(){
	disconnect(write_prog[0], SIGNAL(processExited(KProcess *)), this, SLOT(cdr_job_end()));
//	QPushButton_cdr_blank->blockSignals( 0 );
	QPushButton_cdr_fix->blockSignals( 0 );

	emit( new_status_info( i18n( "finished !" ) ) );

	if ( working ){
		working = 0;
		Status->QPushButton_Status_Cancel->setText( i18n( "Finished !" ) );
		Status->total_led( 1 );
	};

	delete write_prog[0];
	write_prog[0] = 0;

	krabwidget_setEnabled( 1 );

};
void KrabWidget::cdrecord_out(KProcess *, char *buffer, int buffer_size){
        int h,
            j=0, k=0;

	QString temp = buffer;
	int pos = 0;

	while ( (pos = temp.find( "Track ", pos+1 )) >0 ){
		if ( temp.mid( pos+14, 2 ) == "of" )
			break;
		if ( (unsigned int) pos > temp.length() ){
			pos = -1;
			break;
		};
	};

	if ( pos > 0 ){
		if (temp.mid( pos+14, 2 ) == "of" ) {
			buffer = buffer + pos + 10;

	        	for ( h=0; h<=4 ; h++)
	        	{
        	        	if ( *buffer >= 48 &&  *buffer <=57 )
	        	        {
        	        	        j += *buffer++ + j + (j<<3) - 48;
	                	}
		                else
        		                buffer++;
		        };
			buffer++;
	        	for ( h=0; h<=4 ; h++)
	        	{
        	        	if ( *buffer >= 48 &&  *buffer <=57 )
	        	        {
        	        	        k += *buffer++ + k + (k<<3) - 48;
	                	}
		                else
        		                buffer++;
		        };		
		};
	};
	if (k){
		cdrecord_progress = (j*100)/k;
	};
	*buffer = '\0';
};
