#include "cddalist.h"
#include <malloc.h>
#include <md5.h>
#include <kapp.h>
#include <klocale.h>

#include "detect_kde_version.h"

#include <config.h>

#ifdef KDE2
  #include <qmessagebox.h>
#else
  #include <kmsgbox.h>
#endif


unsigned int tracks_cdda;

cddalist::cddalist(QWidget *parent, const char *name, TodoList *tdlist, bool show_select_=1 ) : QWidget(parent, name)
{
 	initMetaObject();
	initLayout();
	todolist_p  = tdlist;
	show_select = show_select_;

	if (show_select)
		void initLayout(void);

	cdda2cdr_list.clearArguments();
	cdda2cdr_list.setExecutable ( "cdparanoia" );
// this is recommended on the KDE developer site, BUT did not work fine everytime in the past....:
//	cdda2cdr_list << "cdparanoia" ;
#ifdef OLD_CDPARANOIA
	cdda2cdr_list << "-Q" << "-d";
#else
	cdda2cdr_list << "-Q" << "-e" << "-d";
#endif
	cdda2cdr_list << (QString) todolist_p->device_choiced;
	connect(&cdda2cdr_list, SIGNAL(processExited(KProcess *)), SLOT(cdda2cdr_list_dead(KProcess *)));
	connect(&cdda2cdr_list, SIGNAL(receivedStderr(KProcess *, char *, int )), this, SLOT(cdda2cdr_list_stdout_read(KProcess *, char *, int  )));
	if (show_select)
	{
		connect( QPushButton_ok, SIGNAL(clicked()), SLOT(QPushButton_ok_clicked( )) );
		connect( QPushButton_takeall, SIGNAL(clicked()), SLOT(QPushButton_takeall_clicked()) );
		connect( QPushButton_cancel, SIGNAL(clicked()), SLOT(QPushButton_cancel_clicked()) );

	        resize( 349, 440 );
        	setFixedSize( 349, 440 );
	};
	cdda2cdr_list.start(KProcess::Block, KProcess::AllOutput);
};

cddalist::~cddalist()
{

};

void cddalist::closeEvent( QCloseEvent *e )
{
	e->accept();
	emit destroy_cddalist();
};

void cddalist::cdda2cdr_list_dead(KProcess *)
{
 	QString row;
	QString length;
	int j, z;
	todolist_p->tracks_cdda = 0;

	if ( !cddalist_temp.contains( "  1.  " ) )
	{
		if ( show_select )
#ifdef KDE2
               		QMessageBox::information( this, i18n( "CD Error" ), i18n( "No audiotracks found." ) );
#else
               		KMsgBox::message( this, i18n( "CD Error" ), i18n( "No audiotracks found." ) );
#endif
		return;
	}

	cddalist_temp = cddalist_temp.mid( cddalist_temp.find ("  1. " ) ,(cddalist_temp.length() - cddalist_temp.find ("  1. " ) - 2) );
	todolist_p->tracks_cdda = (cddalist_temp.length() / 59) + 1;
	for (z = 1; z <= (int) todolist_p->tracks_cdda; z++)
	{
		if (show_select)
		{
			row.setNum( z );
			time[z]  = cddalist_temp.mid(59*z - 44, 8);
			if ( z< 10 )
				row = "0" + row + ". Track: " + time[z];
 			else
				row = row + ". Track: " + time[z];
			QListBox_CDDA->insertItem(row);
		};
		j = 0;
		frame.frame[z - 1] =  char2int( cddalist_temp.mid(59*z - 24, 2))*60 * 75
			           +  char2int( cddalist_temp.mid(59*z - 21, 2))    * 75
			           +  char2int( cddalist_temp.mid(59*z - 18, 2)) + 150;
// cdparanoia (version 9.4) shows a wrong offset !!! so i must add this --------------^
	};
	z--;
	frame.frame[z] = ( (char2int( cddalist_temp.mid(59*z - 24, 2) ) * 60 * 75)
       			 + (char2int( cddalist_temp.mid(59*z - 21, 2) ) * 75)
		         + (char2int( cddalist_temp.mid(59*z - 18, 2) ) )
			 + (char2int( cddalist_temp.mid(59*z - 44, 2) ) * 60 * 75)
			 + (char2int( cddalist_temp.mid(59*z - 41, 2) ) * 75)
			 + (char2int( cddalist_temp.mid(59*z - 38, 2) ) )
               		 + 1) + 150;// <---------------------------;-)-----------------
// cdparanoia (version 9.4) shows a wrong offset !!! so i must add this --------------^
	absolute_frames = frame.frame[z];
	disc_id = cddb_discid();
	disc_id_cdindex = cdindex_calc();
}

void cddalist::QPushButton_cancel_clicked()
{
	emit destroy_cddalist();
}

void cddalist::QPushButton_takeall_clicked()
{
	unsigned int i;
	QString temp, temp2;
	temp = "123456";
	Data *data;

	for (i = 1; i <= todolist_p->tracks_cdda; i++)
	{
		todolist_p->tracks++;
		todolist_p->data.resize( (todolist_p->tracks+2) );
		data = new Data;

		data->tracknumber		= i;
		data->device			= todolist_p->device_choiced;
		data->frames_on_cd		= absolute_frames;
		data->o_frame			= frame;
		data->type			= 1;
		data->title 			= "";
		data->year			= "";
		data->comment			= "";
		data->group			= "";
		data->album			= "";
		data->cddb_discid		= disc_id;
		data->cd_index			= disc_id_cdindex;
		data->tracks_on_cd		= todolist_p->tracks_cdda;
		data->music_type		= 256;
		data->cddb_disable		= 0;
		data->input_rate		= 44100;
		data->input_channels		= 2;
		data->input_bit_per_rate	= 16;

		temp2.setNum( i );
		if ( i< 10 )
		{
			temp  = "KrabberFile0";
			temp += temp2;
		}
		else
		{
			temp  = "KrabberFile";
			temp += temp2;
		}
		data->output_filename = temp;
		todolist_p->data.insert( todolist_p->tracks, data );
	};

	emit destroy_cddalist();
}

void cddalist::QPushButton_ok_clicked()
{
	unsigned int i;
	QString temp, temp2;
	temp = "123456";
        Data *data;

	for (i = 1; i <= todolist_p->tracks_cdda; i++)
	{
		if ( QListBox_CDDA->isSelected( i - 1 )  )
		{
			todolist_p->tracks++;
			todolist_p->data.resize( (todolist_p->tracks+2) );
			data = new Data;

			data->tracknumber		= i;
			data->device			= todolist_p->device_choiced;
			data->frames_on_cd		= absolute_frames;
			data->o_frame			= frame;
			data->type			= 1;
			data->title 			= "";
			data->year			= "";
			data->comment			= "";
			data->group			= "";
			data->album			= "";
			data->cddb_discid		= disc_id;
			data->cd_index			= disc_id_cdindex;
			data->tracks_on_cd		= todolist_p->tracks_cdda;
			data->music_type		= 256;
			data->cddb_disable		= 0;
			data->input_rate		= 44100;
			data->input_channels		= 2;
			data->input_bit_per_rate	= 16;

			temp2.setNum( i );
			if ( i< 10 )
			{
				temp  = "KrabberFile0";
				temp += temp2;
			}
			else
			{
				temp  = "KrabberFile";
				temp += temp2;
			}
			data->output_filename = temp;
			todolist_p->data.insert( todolist_p->tracks, data );
 		};
	};

	emit destroy_cddalist();
}

void cddalist::cdda2cdr_list_stdout_read(KProcess *, char *buffer, int buffer_size)
{
	QString temp;
	temp = buffer;
	
	if (buffer_size > 1023)
	{
		cddalist_temp = cddalist_temp + temp.mid(0, 1024);
	}
	else
	{
		cddalist_temp = cddalist_temp + temp.mid(0, buffer_size);
	};
};

unsigned long cddalist::cddb_discid()
{
	int	i,
		t = 0,
		n = 0;

	/* For backward compatibility this algorithm must not change */
	/* Okay I have changed something, but it will work (ADRIAN) */
	for (i = 0; i < (int) todolist_p->tracks_cdda; i++)
		n += cddb_sum( frame.frame[i]/75 );

	t = ( frame.frame[todolist_p->tracks_cdda]/75 ) - ( frame.frame[0]/75 );

	return ((n % 0xff) << 24 | t << 8 | (todolist_p->tracks_cdda) );
};

int cddalist::cddb_sum(int n)
{
	char	buf[12],
		*p;
	int	ret = 0;
	long unsigned int ntemp = 0;
	ntemp = (long unsigned int) n;

	/* For backward compatibility this algorithm must not change */
	sprintf(buf, "%lu", ntemp);
	for (p = buf; *p != '\0'; p++)
		ret += (*p - '0');

	return (ret);
}
unsigned int cddalist::char2int( const char *pointer )
{
	int h,
	    j=0;

	for ( h=0; h<=2 ; h++)
	{
		if ( *pointer >= 48 &&  *pointer <=57 )
		{
			j += *pointer++ + j + (j<<3) - 48;
		}
		else
			pointer++;
	};
	return (j);
};
unsigned int cddalist::char2int( QString string )
{
	int h,
	    j=0;
	const char *pointer = string;

	for ( h=0; h<=2 ; h++)
	{
		if ( *pointer >= 48 &&  *pointer <=57 )
		{
			j += *pointer++ + j + (j<<3) - 48;
		}
		else
			pointer++;
	};
	return (j);
};

extern "C"
{
   #include "sha.h"
   #include "base64.h"
}

QString cddalist::cdindex_calc(){  // cdindex version 1.1.0 code (cvs) (with changes for krabber)
	char 		DiscId[33];
	QString		QDiscId;

	struct CDInfo { char  FirstTrack;
			char  LastTrack;
                        unsigned long FrameOffset[100]; };

	


	SHA_INFO       sha;
	unsigned char  digest[20], *base64;
	unsigned long  size;
	char           temp[9];
	int            i;

	sha_init(&sha);


	CDInfo *pCDInfo = (CDInfo*) malloc( sizeof( CDInfo ) );


	// Before we ran the hash on the binary data, but now to make
	// sure people on both types of endian systems create the same
	// keys, we convert the data to hex-ASCII first. :-)
	sprintf(temp, "%02X", pCDInfo->FirstTrack);
	sha_update(&sha, (unsigned char *)temp, strlen(temp));

	sprintf(temp, "%02X", pCDInfo->LastTrack);
	sha_update(&sha, (unsigned char *)temp, strlen(temp));

	for(i = 0; i < 100; i++)
	{
		sprintf(temp, "%08X", (unsigned int) pCDInfo->FrameOffset[i]);
		sha_update(&sha, (unsigned char *)temp, strlen(temp));
	}
	sha_final(digest, &sha);

	base64 = rfc822_binary(digest, 20, &size);
	memcpy(DiscId, base64, size);
	DiscId[size] = 0;
	free(base64);

	
        free( pCDInfo );

cout << sizeof(CDInfo)<<"X"<<sizeof(char)<<endl;
//for ( int p=0; p<100;p++) cout <<p<<": "<<pCDInfo->FrameOffset[p]<<endl;
cout << QDiscId <<endl;
	return QDiscId;
};
