#include "namewidget.h"
#include <iostream.h>
#include <qlist.h>
#include <klocale.h>

#ifdef KDE2
  #include <kglobal.h>
  #include <kstddirs.h>
  #include <qmessagebox.h>
#endif

namewidget::namewidget(QWidget *parent, const char *name, TodoList *tdlist, bool gui_ = 1 )
{
	gui = gui_;
	parent=parent;name=name; // i hate compiler warnings...
	todolist_n  = tdlist;
	todolist_nr = 1;
	if (gui)
	{
#ifdef KDE2
		QPixmap_locked = new QPixmap( locate( "data", "/krabber/pics/pindown.xpm" ) );
		QPixmap_unlocked = new QPixmap( locate( "data", "/krabber/pics/pinup.xpm") );
#else
		QPixmap_locked = new QPixmap( KApplication::kde_datadir() + "/krabber/pics/pindown.xpm" );
		QPixmap_unlocked = new QPixmap( KApplication::kde_datadir() + "/krabber/pics/pinup.xpm"  );
#endif
		init_db();
 		initMetaObject();
		initLayout();
		setCaption( i18n ("Krabber - hack in the track information") );

	        group_locked   = 0;
	        album_locked   = 0;
	        year_locked    = 0;
	        type_locked    = 0;
		comment_locked = 0;

		connect( QPushButton_lock_group, SIGNAL(clicked()), SLOT( lock_group()) );
		connect( QPushButton_lock_album, SIGNAL(clicked()), SLOT( lock_album()) );
		connect( QPushButton_lock_year, SIGNAL(clicked()), SLOT( lock_year()) );
		connect( QPushButton_lock_type, SIGNAL(clicked()), SLOT( lock_type()) );
		connect( QPushButton_lock_comment, SIGNAL(clicked()), SLOT( lock_comment()) );
		connect( QPushButton_Help, SIGNAL(clicked()), SLOT( invokeHelp()) );
		connect( QPushButton_Finish, SIGNAL(clicked()), SLOT(finish()) );
		connect( QPushButton_p_file, SIGNAL(clicked()), SLOT(previous_file()) );
		connect( QPushButton_n_file, SIGNAL(clicked()), SLOT(next_file()) );
		connect( QLineEdit_title, SIGNAL(returnPressed()), SLOT(next_file()) );
		connect( QLineEdit_nr_offset, SIGNAL(textChanged(const char *)), SLOT(update_nr_offset(const char *)) );
		connect( QLineEdit_title, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
		connect( QLineEdit_album, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
		connect( QLineEdit_group, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
		connect( QLineEdit_file_1, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
		connect( QLineEdit_file_2, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
		connect( QLineEdit_file_3, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
		connect( QLineEdit_file_4, SIGNAL(textChanged(const char *)), SLOT(update_view_filename(const char *)) );
		connect( QComboBox_file_1, SIGNAL(activated(int)), SLOT(update_view_filename(int)) );
		connect( QComboBox_file_2, SIGNAL(activated(int)), SLOT(update_view_filename(int)) );
		connect( QComboBox_file_3, SIGNAL(activated(int)), SLOT(update_view_filename(int)) );
		connect( QComboBox_file_4, SIGNAL(activated(int)), SLOT(update_view_filename(int)) );

		for ( unsigned int i=0; i<NR_CATEGORIES; i++)
		{
			if ( ((TypeIndex*) tlist.at(i))->typeNr>79 )
				QComboBoxType->insertItem( (((TypeIndex*) tlist.at(i))->TypeName) + "*" );
			else
				QComboBoxType->insertItem( ((TypeIndex*) tlist.at(i))->TypeName );
		};
	
		update_view();
		update_view_filename("");
		QLineEdit_group->setFocus();
		resize( 710, 290 );
		setFixedSize( 710, 290 );

		QString temp;
		temp.setNum( todolist_n->nr_offset );
		QLineEdit_nr_offset->setText( temp );

		if ( todolist_n->data[ todolist_nr ]->group == "" )
			lock_group();
		if ( todolist_n->data[ todolist_nr ]->year == "" )
			lock_year();
		if ( todolist_n->data[ todolist_nr ]->comment == ""  )
			lock_comment();
		if ( todolist_n->data[ todolist_nr ]->album == "" )
			lock_album();
		if ( todolist_n->data[ todolist_nr ]->music_type > NR_CATEGORIES  )
			lock_type();

	};
};

namewidget::~namewidget()
{
	;
}
void namewidget::lock_group(){
	group_locked = !group_locked;
	if ( group_locked )
		QPushButton_lock_group->setPixmap( *QPixmap_locked );
	else
		QPushButton_lock_group->setPixmap( *QPixmap_unlocked );
};
void namewidget::lock_album(){
	album_locked = !album_locked;
	if ( album_locked )
		QPushButton_lock_album->setPixmap( *QPixmap_locked );
	else
		QPushButton_lock_album->setPixmap( *QPixmap_unlocked );
};
void namewidget::lock_year(){
	year_locked = !year_locked;
	if ( year_locked )
		QPushButton_lock_year->setPixmap( *QPixmap_locked );
	else
		QPushButton_lock_year->setPixmap( *QPixmap_unlocked );
};
void namewidget::lock_type(){
	type_locked = !type_locked;
	if ( type_locked )
		QPushButton_lock_type->setPixmap( *QPixmap_locked );
	else
		QPushButton_lock_type->setPixmap( *QPixmap_unlocked );
};
void namewidget::lock_comment(){
	comment_locked = !comment_locked;
	if ( comment_locked )
		QPushButton_lock_comment->setPixmap( *QPixmap_locked );
	else
		QPushButton_lock_comment->setPixmap( *QPixmap_unlocked );
};
void namewidget::update_view_filename(const char *temp)
{
	QString temp2;
	if ( !init )
	{
		todolist_n->data[ todolist_nr ]->group = QLineEdit_group->text();
		todolist_n->data[ todolist_nr ]->album = QLineEdit_album->text();
		todolist_n->data[ todolist_nr ]->title = QLineEdit_title->text();
		temp2 = i18n ( "File name: " );
		QLabel_filename->setText( temp2 + update_filename( todolist_nr ) );
	};
};
void namewidget::update_view_filename( int z )
{
	z = z ; // I hate compiler warnings
	QString _temp_;
	if ( !init )
	{
		todolist_n->data[ todolist_nr ]->group = QLineEdit_group->text();
		todolist_n->data[ todolist_nr ]->album = QLineEdit_album->text();
		todolist_n->data[ todolist_nr ]->title = QLineEdit_title->text();
		_temp_ = i18n ( "File name: " );
		QLabel_filename->setText( _temp_ + update_filename( todolist_nr ) );
	};
};
void namewidget::update_nr_offset( const char *c ){
	int h,
            j=0;

        for ( h=0; h<=4 ; h++)
        {
		if ( *c >= 48 &&  *c <=57 )
                        j += *c++ + j + (j<<3) - 48;
                else
                        c++;
        };
	todolist_n->nr_offset = j;
	update_view_filename( c );
};
QString namewidget::update_filename ( unsigned int nr )
{
	QString temp;

	temp  = update_filename_sub( QComboBox_file_1->currentItem(), nr );
	temp += QLineEdit_file_1->text();
	temp += update_filename_sub( QComboBox_file_2->currentItem(), nr );
	temp += QLineEdit_file_2->text();
	temp += update_filename_sub( QComboBox_file_3->currentItem(), nr );
	temp += QLineEdit_file_3->text();
	temp += update_filename_sub( QComboBox_file_4->currentItem(), nr );
	temp += QLineEdit_file_4->text();

	return temp;
}
QString namewidget::update_filename_sub( unsigned int id, unsigned int nr)
{
	QString temp, temp2;
	temp = "";
	if ( id == 1 )	
	{
		temp2.setNum(nr+todolist_n->nr_offset);
		temp = temp2;
		if (  (nr + todolist_n->nr_offset)  < 10 )
			temp = "0" + temp;
	};
	if ( id == 2 )	
	{
		temp2.setNum ( todolist_n->nr_offset + todolist_n->data[ nr ]->tracknumber);
		temp = temp2;
		if ( (todolist_n->nr_offset + todolist_n->data[ nr ]->tracknumber) < 10 )
			temp = "0" + temp;
	};
	if ( id == 3 )
		temp = todolist_n->data[ nr ]->group;
	if ( id == 4 )
		temp = todolist_n->data[ nr ]->album;
	if ( id == 5 )
		temp = todolist_n->data[ nr ]->year;
	if ( id == 6 )
		temp = todolist_n->data[ nr ]->title;
	return temp;
}
void namewidget::next_file()
{
	save_input();
	if ( todolist_nr == todolist_n->tracks )
		todolist_nr = 1;
	else
		todolist_nr++;
	update_view();
	update_view_filename("");
};
void namewidget::previous_file()
{
	save_input();
	if ( todolist_nr == 1 )
		todolist_nr = todolist_n->tracks;
	else
		todolist_nr--;
	update_view();
	update_view_filename("");
};
void namewidget::update_view()
{
	QString temp, temp2;

	init = 1;
	if ( todolist_n->data[ todolist_nr ]->type == 1 )
	{
		temp2.setNum ( todolist_n->data[ todolist_nr ]->tracknumber );
		temp = temp2;
		if ( todolist_n->data[ todolist_nr ]->tracknumber < 10 )
			temp = "0" + temp;
	
		temp += i18n( ". Track on " ) + todolist_n->data[ todolist_nr ]->device + " : " ;
	};
	if ( todolist_n->data[ todolist_nr ]->type > 1 &&  todolist_n->data[ todolist_nr ]->type < 6 )
		temp = todolist_n->data[ todolist_nr ]->device + " : " ;

	temp2.setNum( (unsigned int)(todolist_n->length_bytes( todolist_nr, 44100, 2, 16)/1024)/1024 );
	temp += temp2 ;
	temp += "MB";


	QLabel_FileInfo->setText( temp );
	QLineEdit_title->setText( todolist_n->data[ todolist_nr ]->title );
	if ( !group_locked )
		QLineEdit_group->setText( todolist_n->data[ todolist_nr ]->group );
	if ( todolist_n->data[ todolist_nr ]->year != "" && !year_locked)
		QLineEdit_year->setText( todolist_n->data[ todolist_nr ]->year );
	if ( todolist_n->data[ todolist_nr ]->comment != "" && !comment_locked )
		QLineEdit_comment->setText( todolist_n->data[ todolist_nr ]->comment );
	if ( todolist_n->data[ todolist_nr ]->album != "" && !album_locked)
		QLineEdit_album->setText( todolist_n->data[ todolist_nr ]->album );
	if ( todolist_n->data[ todolist_nr ]->music_type < NR_CATEGORIES && !type_locked )
		QComboBoxType->setCurrentItem( find(todolist_n->data[ todolist_nr ]->music_type) );
	QCheckButton_create_groupdir->setChecked( todolist_n->create_dir_group );
	QCheckButton_create_albumdir->setChecked( todolist_n->create_dir_album );
	init = 0;
};
void namewidget::save_input()
{
	if ( !init )
	{
		todolist_n->create_dir_group = QCheckButton_create_groupdir->isChecked();
		todolist_n->create_dir_album = QCheckButton_create_albumdir->isChecked();

		todolist_n->data[ todolist_nr ]->group         = QLineEdit_group->text();
		todolist_n->data[ todolist_nr ]->album         = QLineEdit_album->text();
		todolist_n->data[ todolist_nr ]->title         = QLineEdit_title->text();
		todolist_n->data[ todolist_nr ]->year          = QLineEdit_year->text();
		todolist_n->data[ todolist_nr ]->comment       = QLineEdit_comment->text();
		todolist_n->data[ todolist_nr ]->music_type      = (tlist.at(QComboBoxType->currentItem()))->typeNr;
	}
	else
		cout <<"NAMEWIDGET INIT WORKAROUND"<<endl;
};
void namewidget::invokeHelp()
{
	kapp->invokeHTMLHelp("krabber/krabber-3.html#ss3.5", "");
}
void namewidget::finish()
{
	unsigned int i;

	save_input ();
	for ( i = 1; i <= todolist_n->tracks; i++ )
		todolist_n->data[ i ]->output_filename = update_filename( i );

	emit destroy_namewidget();
};
void namewidget::closeEvent( QCloseEvent *e )
{
	e->accept();
	finish();
};

void namewidget::init_db()
{
	unsigned int i;
	for ( i=0; i<NR_CATEGORIES; i++)
		init_db_sub( todolist_n->categories[i] , i);
	tlist.clear();
	for ( i = 0; i<NR_CATEGORIES; i++)
		tlist.inSort( &(TypeList[i]) );
};

void namewidget::init_db_sub( const char *c, unsigned int i)
{
	TypeList[i].TypeName = i18n( c );
	TypeList[i].typeNr   = i;
};
unsigned int namewidget::find( unsigned int typeNR )
{
	unsigned int i;
	bool flag;

	flag = 0;

	for ( i=0; i < NR_CATEGORIES; i++)
		if ( typeNR == tlist.at(i)->typeNr )
		{
			flag = 1;
			break;
		};

	if ( !flag )
	{
		cout << "KRABBER ERROR / FIND ERROR"<< i <<endl;
		return 0;
	};

	return i;
};
#ifdef KDE2
int TList::compareItems( QCollection::Item t1, QCollection::Item  t2)
#else
int TList::compareItems( GCI t1, GCI t2)
#endif
{
	const char *t1_ = ((TypeIndex*) t1)->TypeName;
	const char *t2_ = ((TypeIndex*) t2)->TypeName;
	int ret = qstrcmp( t1_, t2_ );

	return( ret );

//	return(stricmp( ((TypeIndex*)(t1))->TypeName, ((TypeIndex*)(t2))->TypeName ));
};
TList::TList( bool temp)
{
	dc=temp;
}
TList::~TList()
{
	clear();
};
#ifdef KDE2
QCollection::Item TList::newItem( QCollection::Item d )
#else
GCI TList::newItem( GCI d )
#endif
{
	TypeIndex* temp = new TypeIndex;
	temp->TypeName = ((TypeIndex*)d)->TypeName;
	temp->typeNr = ((TypeIndex*)d)->typeNr;
	return ( temp );
}
#ifdef KDE2
void TList::deleteItem( QCollection::Item d )
#else
void TList::deleteItem( GCI d )
#endif
{
	if ( dc )
		delete (TypeIndex*) d;
}
