#include "status_window.h"
#include <krabwidget.h>

#define SEP             KTabListBox_todo->separator()


status_window::status_window(QWidget *parent, const char *name, unsigned int get_write_nr) : QWidget(parent, name)
{
	unsigned int i;
	write_nr = get_write_nr;

#ifdef KDE2
	led_out   = locate( "data", "/krabber/pics/led_out.xpm" );
	led_ready = locate( "data", "/krabber/pics/led_ready.xpm" );
	led_run   = locate( "data", "/krabber/pics/led_run.xpm" );
#else
	QString temp;
	temp = KApplication::kde_datadir();
	led_out   = temp + "/krabber/pics/led_out.xpm" ;
	led_ready = temp + "/krabber/pics/led_ready.xpm" ;
	led_run   = temp + "/krabber/pics/led_run.xpm" ;
#endif

	led_out_p   = led_out;
	led_ready_p = led_ready;
	led_run_p   = led_run;
	stop = FALSE;
	led_read_on    = FALSE;
	led_read_blink = FALSE;
	for ( i=0; i<MAX_ENCODERS; i++)
	{
		led_write_on[i]    = FALSE;
		led_write_blink[i] = FALSE;
	};

 	initMetaObject();
	initLayout();
	connect (QPushButton_Status_Cancel, SIGNAL(clicked( )), SLOT(cancel( )) );
	connect (QPushButton_Status_Stop, SIGNAL(clicked( )), SLOT(stop_func( )) );
        connect( KSlider_nice, SIGNAL(valueChanged(int)), SLOT(KSlider_nice_moved(int)) ); 

	resize( 240, 270 + write_nr*30);
	setFixedSize( 240, 270 + write_nr*30);
};

status_window::~status_window() {
	;
}

void status_window::cancel( )
{
	emit destroy_status();
};

void status_window::KSlider_nice_moved( int nice_level )
{
	emit renice( nice_level );
};

void status_window::stop_func()
{
	unsigned int i;
	if ( stop )
	{
		delete QTimer_blinker;
		QTimer_blinker = NULL;
		stop = FALSE;
		emit send_signal( 18 );
		QPushButton_Status_Stop->setText( i18n ( "Stop" ) );
		if ( led_read_blink )
		{
			led_read_blink = FALSE;
			read_led( TRUE );
		};
		for ( i=0; i<write_nr; i++)
			if (led_write_blink[i])
			{
				write_led( TRUE, i );
				led_write_blink[i] = FALSE;
			};
	}
	else
	{
		stop = TRUE;
		emit send_signal( 19 );
		QPushButton_Status_Stop->setText( i18n ( "Continue" ) );
		QTimer_blinker = new QTimer(0);
		connect ( QTimer_blinker, SIGNAL(timeout()), SLOT(blinker()) );
		QTimer_blinker->start( 400, FALSE );
		if ( led_read_on )
			led_read_blink = TRUE;
		for ( i=0; i<write_nr; i++)
			if (led_write_on[i])
				led_write_blink[i] = TRUE;
	};
};

void status_window::blinker()
{
	unsigned int i;

	if ( led_read_blink )
		read_led( !led_read_on );
	for ( i=0; i<write_nr; i++)
		if ( led_write_blink[i] )
			write_led( !led_write_on[i], i );
};
void status_window::closeEvent( QCloseEvent *e )
{
	e->accept();
	emit destroy_status();
};
#ifdef KDE2
void status_window::read_led( bool on )
{
	if ( on != led_read_on )
	{
		led_read_on = on;
		if ( on ){
			QPixmap pix( led_run_p );
			QLabel_led_read->setPixmap( pix );
		}else{
			QPixmap pix( led_out_p );
			QLabel_led_read->setPixmap( pix );
		};
	};
};
void status_window::total_led( bool on )
{
	if ( on != led_total_on )
	{
		led_total_on = on;
		if ( on ){
			QPixmap pix( led_ready_p );
			QLabel_led_total->setPixmap( pix );
		}else{
			QPixmap pix( led_out_p );
			QLabel_led_total->setPixmap( pix );
		};
	};
};
void status_window::write_led( bool on, unsigned int i )
{
	if ( on != led_write_on[i] )
	{
		led_write_on[i] = on;
		if ( on ){
			QPixmap pix( led_run_p );
			QLabel_led_write[i]->setPixmap( pix );
		}else{
			QPixmap pix( led_out_p );
			QLabel_led_write[i]->setPixmap( pix );
                };
	};
};
#else
void status_window::read_led( bool on )
{
	if ( on != led_read_on )
	{
		led_read_on = on;
		if ( on )
			QLabel_led_read->setPixmap( led_run_p );
		else
			QLabel_led_read->setPixmap( led_out_p );
	};
};
void status_window::total_led( bool on )
{
	if ( on != led_total_on )
	{
		led_total_on = on;
		if ( on )
			QLabel_led_total->setPixmap( led_ready_p );
		else
			QLabel_led_total->setPixmap( led_out_p );
	};
};
void status_window::write_led( bool on, unsigned int i )
{
	if ( on != led_write_on[i] )
	{
		led_write_on[i] = on;
		if ( on )
			QLabel_led_write[i]->setPixmap( led_run_p );
		else
			QLabel_led_write[i]->setPixmap( led_out_p );
	};
};
#endif
