#include <qdir.h>
#include <krabwidget.h>
#include <PrefGeneric.h>
#include <PrefStartup.h>
#include <kapp.h>
#include <kurl.h>
#include <sys/stat.h>
#include <drag.h>

#ifdef KDE2
	#include <kstddirs.h>
	#include <qstringlist.h>
#endif

#define SEP		KTabListBox_todo->separator()

KrabWidget::KrabWidget(QWidget *parent, const char *name, TodoList *todolist_p) : QWidget(parent, name)
{
	unsigned int i;
	QString temp;
	QStrList temp_list;
	QTimer_process = 0;
	Init = 1;
	connected = 0;

	if (pipe(pipe_)){ cout <<"UNABLE TO CREATE PIPE"<<endl;exit(1);};
	if (pipe(dummy)){ cout <<"UNABLE TO CREATE PIPE"<<endl;exit(1);};

	cdr_pre_loaded = -1;
	check_cdr_run = 0;
	total_final_size=0;
	play_prog_run=0;
	convert_prog = 0;
 	todolist = todolist_p;
	for ( i=0; i<6; i++)
	{
	  write_job_track[i] = 0;
	  write_prog[i] = NULL;
	  write_prog_final_size[i] = 0;
	};
	read_prog = NULL;
	help_prog = NULL;
	tabdialog = NULL;
	empty = "";

	smtpMailer = new SMTP;
	connect(smtpMailer, SIGNAL(messageSent()), this, SLOT(smtpMessageSent()));
	connect(smtpMailer, SIGNAL(error(int)), this, SLOT(smtpError(int)));

#ifdef KDE2
	kconfig = KGlobal::config();
#else
	kconfig = kapp->getConfig();
	iloader  = kapp->getIconLoader();
#endif
	pix_cdda = new QPixmap( ICON ( "cdda.xpm" ) );
	pix_wav  = new QPixmap( ICON ("wav.xpm") );
	pix_mp2  = new QPixmap( ICON ("mp2.xpm") );
	pix_mp3  = new QPixmap( ICON ("mp3.xpm") );
	pix_dat  = new QPixmap( ICON ("dat.xpm") );
	pix_cdr  = new QPixmap( ICON ("cdr.xpm") );
	pix_raw  = new QPixmap( ICON ("raw.xpm") );
	pix_svx  = new QPixmap( ICON ("8svx.xpm") );
	pix_aiff = new QPixmap( ICON ("aiff.xpm") );
	pix_au   = new QPixmap( ICON ("au.xpm") );
	pix_maud = new QPixmap( ICON ("maud.xpm") );
	pix_sf   = new QPixmap( ICON ("sf.xpm") );
	pix_smp  = new QPixmap( ICON ("smp.xpm") );
	pix_voc  = new QPixmap( ICON ("voc.xpm") );
	pix_cvs  = new QPixmap( ICON ("cvs.xpm") );
	pix_vms  = new QPixmap( ICON ("vms.xpm") );
	pix_sndr = new QPixmap( ICON ("sndr.xpm") );
	pix_sndt = new QPixmap( ICON ("sndt.xpm") );
	pix_txw  = new QPixmap( ICON ("txw.xpm") );
	pix_wve  = new QPixmap( ICON ("wve.xpm") );
	pix_hcom = new QPixmap( ICON ("hcom.xpm") );
	pix_push_1 = new QPixmap( ICON ("button_1.xpm") );
	pix_push_2 = new QPixmap( ICON ("button_2.xpm") );
	pix_push_3 = new QPixmap( ICON ("button_3.xpm") );
	pix_push_4 = new QPixmap( ICON ("button_4.xpm") );
	pix_push_5 = new QPixmap( ICON ("button_5.xpm") );
	pix_push_6 = new QPixmap( ICON ("button_6.xpm") );
	pix_push_1_off = new QPixmap( ICON ("button_1_o.xpm") );
	pix_push_2_off = new QPixmap( ICON ("button_2_o.xpm") );
	pix_push_3_off = new QPixmap( ICON ("button_3_o.xpm") );
	pix_push_4_off = new QPixmap( ICON ("button_4_o.xpm") );
	pix_push_5_off = new QPixmap( ICON ("button_5_o.xpm") );
	pix_push_6_off = new QPixmap( ICON ("button_6_o.xpm") );

	initMetaObject();
	initLayout();

	connect( KSlider_nice, SIGNAL(valueChanged(int)), SLOT(KSlider_nice_moved(int)) );
	connect( KSlider_smp, SIGNAL(valueChanged(int)), SLOT(KSlider_smp_moved(int)) );
	connect( KTabListBox_todo, SIGNAL(headerClicked(int)), SLOT( todolist_update(int) ) );
	connect( KTabListBox_todo, SIGNAL(selected(int,int)), SLOT( KTabListBox_selected(int,int) ) );
	connect( KTabListBox_todo, SIGNAL(highlighted(int,int)), SLOT( KTabListBox_highlighted(int,int) ) );
	connect( KTabListBox_todo, SIGNAL(midClick(int,int)), SLOT( KTabListBox_midClick(int,int) ) );
	connect( KTabListBox_todo, SIGNAL(popupMenu(int,int)), SLOT( KTabListBox_popupMenu(int,int) ) );
	connect( QComboBox_encoder, SIGNAL(activated(int)), SLOT(QComboBox_encoder_clicked(int)) );
	connect( QCheckBox_tempfiles, SIGNAL(toggled(bool)), SLOT(direct_convert_toggled(bool)) );
	connect( QPushButton_cddb_get, SIGNAL(toggled(bool)), SLOT(get_cddb_from_server(bool)) );
	connect( QPushButton_cddb_send, SIGNAL(toggled(bool)), SLOT(send_cddb_to_server(bool)) );
	connect( QPushButton_cd, SIGNAL(clicked()), SLOT(cddalister()) );
	connect( QPushButton_doit, SIGNAL(clicked()), SLOT(doit(  )) );
 	connect( QPushButton_outputpath, SIGNAL(clicked()), SLOT(define_outputpath(  )) );
 	connect( QPushButton_names, SIGNAL(clicked()), SLOT(define_names(  )) );
	connect( QComboBox_bitrate, SIGNAL(activated(int)), SLOT(QComboBox_bitrate_clicked(int)) );
	connect( QLineEdit_bitrate_other, SIGNAL(textChanged(const char*)), SLOT(QLineEdit_bitrate_other_changed(const char*)) );
#ifdef KDE2
	setAcceptDrops( 1 );
#else
	connect( new KDNDDropZone(this, 0), SIGNAL( dropAction( KDNDDropZone *) ), SLOT( DropEvent(  KDNDDropZone *) ) );
#endif

	kconfig->setGroup("krabber");
	krabber_config.mp3tag_version       	= kconfig->readNumEntry( "mp3tag_version", 1 );
	krabber_config.testOnStartup        	= kconfig->readBoolEntry( "testOnStartup", 1 );
	krabber_config.readall             	= kconfig->readBoolEntry( "readAll", 0 );
	krabber_config.outputfilename_capital	= kconfig->readBoolEntry( "outfilename_capital", 0 );
	krabber_config.outputfilename_replace	= kconfig->readBoolEntry( "outfilename_replace", 0 );
	krabber_config.outputfilename_replace_from	= character_replace( kconfig->readEntry( "outfilename_replace_from", "@" ), "@",  " ");
	krabber_config.outputfilename_replace_to	= character_replace( kconfig->readEntry( "outfilename_replace_to", "_" ), "@",  " ");
	krabber_config.scan_device		= character_replace( kconfig->readEntry( "scan_device", "/dev/sbpcd_" ), "@",  " ");
	cdparanoia                          	= kconfig->readBoolEntry( "cdparanoia", 0 );
	cdrecord                          	= kconfig->readBoolEntry( "cdrecord", 0 );
	sox                                 	= kconfig->readBoolEntry( "sox", 0 );
	mpg123                              	= kconfig->readBoolEntry( "mpg123", 0 );
	hz8_mp3                             	= kconfig->readBoolEntry( "8hz_mp3", 0 );
	bladeenc                            	= kconfig->readBoolEntry( "bladeenc", 0 );
	l3enc                               	= kconfig->readBoolEntry( "l3enc", 0 );
	mp3enc                              	= kconfig->readBoolEntry( "mp3enc", 0 );
	xing                              	= kconfig->readBoolEntry( "xing", 0 );
	lame                              	= kconfig->readBoolEntry( "lameenc", 0 );
	encode                              	= kconfig->readBoolEntry( "encodeenc", 0 );
	devices_count 		            	= kconfig->readNumEntry( "NumOfDevices", 0 );
	cdrecord_devices_count 		       	= kconfig->readNumEntry( "NumOfCDRDevices", 0 );
	for ( i = 1; i<=cdrecord_devices_count; i++ )
	{
		temp = "CDR_" + i;
		cdrecord_device[i]     = kconfig->readEntry( temp, "ERROR" );
		temp = "CDRID_" + i;
		cdrecord_device_id[i]  = kconfig->readEntry( temp, "ERROR" );
	};
	for ( i = 1; i<=devices_count; i++ )
	{
		temp = "Device_" + i;
		devices[i]            = kconfig->readEntry( temp, "ERROR" );
		QComboBox_device->insertItem( devices[i] );
	};
	test_enviroment( 0, krabber_config.testOnStartup );

	QComboBox_encoder->setCurrentItem( kconfig->readNumEntry( "encoder", 0 ) );
	QCheckBox_jitter->setChecked( kconfig->readBoolEntry( "cdda_jitter", 0 ) );
	QCheckBox_q_resample->setChecked( kconfig->readBoolEntry( "quality_resample", 0 ) );
	QCheckBox_mp3_header->setChecked( kconfig->readBoolEntry( "mp3_header", 1 ) );
	QCheckBox_tempfiles->setChecked( kconfig->readBoolEntry( "direct_encoding", 0 ) );
	QCheckBox_clear_list->setChecked( kconfig->readBoolEntry( "clear_list", 1 ) );
	KSlider_nice->setValue( 19 - kconfig->readNumEntry( "nice_level", 19 ) );
#ifdef KDE2
	temp = locate( "data", "/kscd/cddb/" );
#else
	temp = KApplication::kde_datadir() + "/kscd/cddb/";
#endif
	cddb_config.cddbbasedir = kconfig->readEntry( "cddb_base_dir", temp );
	cddb_config.current_server = kconfig->readEntry( "cddb_current_server", "localhost cddbp 8880 -" );
	if ( kconfig->readListEntry( "cddb_server_list", cddb_config.cddbserverlist ) == 0 )
	{
		cddb_config.cddbserverlist.clear();
		cddb_config.cddbserverlist.append( "freedb.freedb.org cddbp 8880 -" );
		cddb_config.cddbserverlist.append( "www.cddb.com cddbp 8880 -" );
		cddb_config.cddbserverlist.append( "cddb.moonsoft.com http 80 /~cddb/cddb.cgi" );
	};
	if ( kconfig->readListEntry( "cddb_submit_list", cddb_config.cddbsubmitlist ) == 0 )
	{
		cddb_config.cddbsubmitlist.clear();
		cddb_config.cddbsubmitlist.append( "submit-cddb@freedb.org" );
		cddb_config.cddbsubmitlist.append( "xmcd-cddb@amb.org" );
		cddb_config.cddbsubmitlist.append( "cddb-test@xmcd.com" );
	};
	cddb_config.submitaddress                = kconfig->readEntry( "cddb_submit_address", "submit-cddb@freedb.org" );
	cddb_config.submitaddress                = kconfig->readEntry( "cddb_submit_address", "xmcd-cddb@amb.org" );
	cddb_config.cddb_remote_enabled          = kconfig->readBoolEntry( "cddb_remote_enabled", 0 );
	cddb_config.mailcmd                      = kconfig->readEntry("UnixMailCommand","/bin/mail -s \"%s\"");
	cddb_config.smtpConfigData.serverHost    = kconfig->readEntry("SMTPserverHOST","localhost");
	cddb_config.smtpConfigData.serverPort    = kconfig->readEntry("SMTPserverPORT","25");
	cddb_config.smtpConfigData.senderAddress = kconfig->readEntry("SMTPsenderADDRESS","someone@somewhere.org");
	cddb_config.smtpConfigData.enabled       = kconfig->readBoolEntry("SMTPenabled", 0 );
        cddb.setHTTPProxy( kconfig->readEntry( "cddb_proxy_host", ""), kconfig->readNumEntry("cddb_proxy_port", 0));
	cddb.useHTTPProxy( kconfig->readBoolEntry("cddb_proxy_enabled", 0));
	KSlider_nice_moved( 19 - kconfig->readNumEntry( "nice_level", 19 ) );
	KSlider_smp->setValue( kconfig->readNumEntry( "smp_process", 2 ) );
	KSlider_smp_moved( kconfig->readNumEntry( "smp_process", 1 ) );
	QComboBox_device->setCurrentItem( kconfig->readUnsignedNumEntry( "device", 0 ) );	
	todolist->outputPath = kconfig->readEntry( "outputpath", "/tmp" );	
	todolist->create_dir_group = kconfig->readBoolEntry( "name_create_gdir", 0 );
	todolist->create_dir_album = kconfig->readBoolEntry( "name_create_adir", 0 );

	FIFO = "/tmp/Krabber_FIFO_" + todolist->krabber_process_id;
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "mkfifo" );
	*help_prog << FIFO;
	help_prog->start(KProcess::Block, KProcess::AllOutput);
	help_prog->clearArguments();
	help_prog->setExecutable( "mkfifo" );
	*help_prog << FIFO + "_1";
	help_prog->start(KProcess::Block, KProcess::AllOutput);
	delete help_prog;
	help_prog = 0;
//	if ( mkfifo( (const char*) &FIFO, 0600 ) != 0 )
//		cout << "krabber was not able to create fifo:" << FIFO <<"!"<<endl;
	Init = 0;
	QComboBox_encoder_clicked( kconfig->readNumEntry( "encoder", 0 ) );
	load_config();
};

KrabWidget::~KrabWidget()
{
	QString temp;
	
	kconfig->setGroup("krabber");
	kconfig->writeEntry( "mp3tag_version", krabber_config.mp3tag_version );
	kconfig->writeEntry( "testOnStartup", krabber_config.testOnStartup );
	kconfig->writeEntry( "readAll", krabber_config.readall );
	kconfig->writeEntry( "outfilename_capital", krabber_config.outputfilename_capital );
	kconfig->writeEntry( "outfilename_replace", krabber_config.outputfilename_replace );
	kconfig->writeEntry( "outfilename_replace_from", character_replace(krabber_config.outputfilename_replace_from, " ", "@") );
	kconfig->writeEntry( "outfilename_replace_to", character_replace(krabber_config.outputfilename_replace_to, " ", "@") );
	kconfig->writeEntry( "scan_device", character_replace(krabber_config.scan_device, " ", "@") );

	kconfig->writeEntry( "cdparanoia", cdparanoia );
	kconfig->writeEntry( "cdrecord", cdrecord );
	kconfig->writeEntry( "sox", sox );
	kconfig->writeEntry( "mpg123", mpg123 );
	kconfig->writeEntry( "lameenc", lame );
	kconfig->writeEntry( "encodeenc", encode );
	kconfig->writeEntry( "8hz_mp3", hz8_mp3 );
	kconfig->writeEntry( "bladeenc", bladeenc );
	kconfig->writeEntry( "l3enc", l3enc );
	kconfig->writeEntry( "mp3enc", mp3enc );
	kconfig->writeEntry( "xing", xing );
	kconfig->writeEntry( "cdda_jitter", QCheckBox_jitter->isChecked() );
	kconfig->writeEntry( "quality_resample", QCheckBox_q_resample->isChecked() );
	kconfig->writeEntry( "mp3_header", QCheckBox_mp3_header->isChecked() );
	kconfig->writeEntry( "direct_encoding", QCheckBox_tempfiles->isChecked() );
	kconfig->writeEntry( "clear_list", QCheckBox_clear_list->isChecked() );
	kconfig->writeEntry( "nice_level", nice_level );
	kconfig->writeEntry( "smp_process", encoder_max );
	kconfig->writeEntry( "encoder", QComboBox_encoder->currentItem() );
	kconfig->writeEntry( "device", QComboBox_device->currentItem() );
	kconfig->writeEntry( "outputpath", todolist->outputPath );
	kconfig->writeEntry( "name_create_gdir", todolist->create_dir_group );
	kconfig->writeEntry( "name_create_adir", todolist->create_dir_album );
	kconfig->writeEntry( "cddb_base_dir", cddb_config.cddbbasedir );
	kconfig->writeEntry( "cddb_remote_enabled", cddb_config.cddb_remote_enabled );
	kconfig->writeEntry( "cddb_current_server", cddb_config.current_server );
	kconfig->writeEntry( "cddb_server_list", cddb_config.cddbserverlist );
	kconfig->writeEntry( "cddb_submit_address", cddb_config.submitaddress );
	kconfig->writeEntry( "cddb_submit_list", cddb_config.cddbsubmitlist );
	kconfig->writeEntry( "UnixMailCommand", cddb_config.mailcmd );
	kconfig->writeEntry( "SMTPserverHOST", cddb_config.smtpConfigData.serverHost );
	kconfig->writeEntry( "SMTPserverPORT", cddb_config.smtpConfigData.serverPort );
	kconfig->writeEntry( "SMTPsenderADDRESS", cddb_config.smtpConfigData.senderAddress );
	kconfig->writeEntry( "SMTPenabled", cddb_config.smtpConfigData.enabled );
	kconfig->writeEntry( "cddb_proxy_host", cddb.getHTTPProxyHost());
	kconfig->writeEntry( "cddb_proxy_port", cddb.getHTTPProxyPort());
	kconfig->writeEntry( "cddb_proxy_enabled", cddb.useHTTPProxy());

	save_config();

	kconfig->writeEntry( "NumOfDevices", devices_count );
	for ( unsigned int i = 1; i<=devices_count; i++ )
	{
		temp = "Device_" + i;
		kconfig->writeEntry( temp, devices[i] );
	};
	kconfig->writeEntry( "NumOfCDRDevices", cdrecord_devices_count );
	for ( unsigned int i = 1; i<=cdrecord_devices_count; i++ )
	{
		temp = "CDR_" + i;
		kconfig->writeEntry( temp, cdrecord_device[i] );
		temp = "CDRID_" + i;
		kconfig->writeEntry( temp, cdrecord_device_id[i] );
	};
	kconfig->sync();

	for ( int z=0; z<6; z++ )
		if ( write_prog[z] ){
			write_prog[z]->kill( SIGTERM );
			delete write_prog[z];
			write_prog[z]  = 0;
		};

	if ( QTimer_process )
		kill_doit();	

	if ( read_prog ){
		read_prog->kill( SIGTERM );
		delete read_prog;
		read_prog = 0;
	};
	if ( help_prog ){
		help_prog->kill( SIGTERM );
		delete help_prog;
		help_prog = 0;
	};
	if ( use_fifo && convert_prog ){
		use_fifo = 0;
		convert_prog->kill( SIGTERM );
		delete convert_prog;
		convert_prog = 0;
	};			
	help_prog = new KProcess;
	help_prog->clearArguments();
	help_prog->setExecutable( "rm" );
	*help_prog << "-f" << FIFO << FIFO + "_1";
	help_prog->start(KProcess::Block, KProcess::AllOutput);
	delete help_prog;
	help_prog=0;
};
void KrabWidget::KTabListBox_popupMenu( int index, int column )
{
	if ( play_prog_run )
		emit ( play_emited() ); // turn off !!!

	delete_job( index+1 );
	todolist_update();
};
void KrabWidget::KTabListBox_selected( int index, int column ){

	if ( play_prog_run )
		emit ( play_emited() ); // turn off !!!

	emit ( play_emited() );  // and on !!!
};
void KrabWidget::KTabListBox_highlighted( int index, int column ){

	if ( !play_prog_run )
		return;

	emit ( play_emited() ); // turn off !!!
	emit ( play_emited() );  // and on !!!
};
void KrabWidget::KTabListBox_midClick( int index, int column ){
	KTabListBox_todo->setCurrentItem( index );
	show_info();
};
void KrabWidget::play_job( unsigned int job){

	unsigned int grab_mode = todolist->grab_mode;

	play_finished();

	convert_prog	    = 0;
	doit_control_run    = 0;
	progress_update_run = 0;
	read_prog_run       = 0;
	jobs_finished	    = 0;
	needed_encd_space   = 0;
	wait_4_cd_change    = 0;
	use_sox		    = 0;
	use_fifo	    = 0;
	dest_bitrate = 44100;
	dest_channels = 2;
	dest_bits = 16;
	
	tempfilename.resize( todolist->tracks+2 );

	play_prog_run = 1;
	todolist->grab_mode = 18;
	jobnumber = job;
	doit_read_prog( 1 );

	write_prog[1] = new KProcess;
	write_prog[1]->clearArguments();
	write_prog[1]->setExecutable( "sox" );
	// input of sox set to raw. sox is not able to read wave from fifo with wrong header....
	*write_prog[1] << "-t" << "raw" << "-w" << "-s" << "-r" << "44100" << "-c" << "2" << FIFO + "_1";
	// set output to soundcard (working on linux... on other systems ????)
	*write_prog[1] << "-t" << "ossdsp" << "-w" << "-s" << AUDIO_DEVICE;
	write_prog[1]->start(KProcess::NotifyOnExit, KProcess::AllOutput);
	connect(write_prog[1], SIGNAL(processExited(KProcess *)), SLOT(play_finished()));

	todolist->grab_mode = grab_mode;
};
void KrabWidget::play_finished(){

	if ( !play_prog_run )
		return;

	play_prog_run = 0;

	write_prog[1]->kill( SIGTERM );
	delete write_prog[1];
	write_prog[1]  = 0;
	read_prog->kill( SIGTERM );
	delete read_prog;
	read_prog = 0;
	if ( use_fifo && convert_prog ){
		use_fifo = 0;
		convert_prog->kill( SIGTERM );
		delete convert_prog;
		convert_prog = 0;
	};			
	tempfilename.clear();
	emit ( play_finished_emited() );

};
void KrabWidget::xing_vbr_toggled(bool dummy){

	if ( QCheckBox_xing_vbr->isChecked() ){
		QComboBox_xing_br->setEnabled( 0 );
		QComboBox_xing_ql->setEnabled( 1 );
		QComboBox_xing_br->hide();
		QComboBox_xing_ql->show();
	}else{
		QComboBox_xing_br->setEnabled( 1 );
		QComboBox_xing_ql->setEnabled( 0 );
		QComboBox_xing_ql->hide();
		QComboBox_xing_br->show();
	};
};
void KrabWidget::direct_convert_toggled(bool state){

	if ( state ) {
		KSlider_smp->setValue( 0 );
		KSlider_smp->setEnabled( 0 );
	}else{
		KSlider_smp->setEnabled( 1 );
	};
};
void KrabWidget::get_cddb_from_server(bool isDown)
{
	if (todolist->tracks<=1 )
	{
		krabwidget_setEnabled( 1 );
		return;
	};
	if ( isDown )
	{
		get_cddb( 1 );
		QPushButton_cddb_get->blockSignals( 0 );
	}
	else
	{
		cddb.close_connection();
		new_status_info( i18n( "CDDB query canceled by YOU ! :-(" ) );
		krabwidget_setEnabled( 1 );
		todolist_update();
	};
};
void KrabWidget::send_cddb_to_server(bool isDown)
{
	if (todolist->tracks<=1 )
	{
		krabwidget_setEnabled( 1 );
		return;
	};
	if ( isDown )
	{
		krabwidget_setEnabled( 0 );
		QPushButton_cddb_send->blockSignals( 0 );
		put_cddb_remote( 1 );
	}
	else
	{
		cddb.close_connection();
		new_status_info( i18n( "CDDB post canceled by YOU ! :-(" ) );
		krabwidget_setEnabled( 1 );
		todolist_update();
	};
};
void KrabWidget::resizeEvent( QResizeEvent * )
{
	QFrame_controll->setGeometry( (width() - 299) ,4 ,297, 421);
	KTabListBox_todo->setGeometry( 4 ,4 , ( width() - 310) , (height()-10) );
};

void KrabWidget::KSlider_nice_moved(int temp)
{
	nice_level = 19 - temp;
}

void KrabWidget::KSlider_smp_moved(int temp)
{
	encoder_max = temp;
}
void KrabWidget::select_files()
{
	krabwidget_setEnabled( 0 );
	QString temp = KFileDialog::getOpenFileName(todolist->outputPath, "*.mp2 *.mp3 *.wav *.MP2 *.MP3 *.WAV", this, "Open");
	if ( temp != "" )
		select_file( temp );
	todolist_update();
	krabwidget_setEnabled( 1 );
};
void KrabWidget::define_names()
{
	QString temp = ".";
	if ( todolist->tracks == 0 )
	{
#ifdef KDE2
		QMessageBox::information( this, i18n( "Error" ), i18n( "Select some tracks or files first ! \n") );
#else
		KMsgBox::message( this, i18n( "Error" ), i18n( "Select some tracks or files first ! \n") );
#endif
		return;
	};
	krabwidget_setEnabled( 0 );
	NameWidget = new namewidget( 0, "", todolist );

	NameWidget->QComboBox_file_1->setCurrentItem( kconfig->readNumEntry( "name_combo_file_1", 2 ) );
	NameWidget->QComboBox_file_2->setCurrentItem( kconfig->readNumEntry( "name_combo_file_2", 6 ) );
	NameWidget->QComboBox_file_3->setCurrentItem( kconfig->readNumEntry( "name_combo_file_3", 0 ) );
	NameWidget->QComboBox_file_4->setCurrentItem( kconfig->readNumEntry( "name_combo_file_4", 0 ) );
	NameWidget->QLineEdit_file_1->setText( character_replace( kconfig->readEntry( "name_line_file_1", ".@" ), "@",  " ") );
	NameWidget->QLineEdit_file_2->setText( character_replace( kconfig->readEntry( "name_line_file_2", "" ), "@",  " ") );
	NameWidget->QLineEdit_file_3->setText( character_replace( kconfig->readEntry( "name_line_file_3", "" ), "@",  " ") );
	temp += format_out[todolist->grab_mode];
	NameWidget->QLineEdit_file_4->setText( temp );

       	connect( NameWidget, SIGNAL(destroy_namewidget()), SLOT(NameWidgetDestroyed()) );
	NameWidget->show();
};

void KrabWidget::NameWidgetDestroyed()
{
	kconfig->writeEntry( "name_combo_file_1", NameWidget->QComboBox_file_1->currentItem() );
	kconfig->writeEntry( "name_combo_file_2", NameWidget->QComboBox_file_2->currentItem() );
	kconfig->writeEntry( "name_combo_file_3", NameWidget->QComboBox_file_3->currentItem() );
	kconfig->writeEntry( "name_combo_file_4", NameWidget->QComboBox_file_4->currentItem() );
	kconfig->writeEntry( "name_combotype", NameWidget->QComboBoxType->currentItem() );
	kconfig->writeEntry( "name_line_file_1", character_replace( NameWidget->QLineEdit_file_1->text(), " ", "@") );
	kconfig->writeEntry( "name_line_file_2", character_replace( NameWidget->QLineEdit_file_2->text(), " ", "@") );
	kconfig->writeEntry( "name_line_file_3", character_replace( NameWidget->QLineEdit_file_3->text(), " ", "@") );
	kconfig->writeEntry( "name_line_file_4", character_replace( NameWidget->QLineEdit_file_4->text(), " ", "@") );
	kconfig->sync();
	delete NameWidget;

	put_cddb_local();
	krabwidget_setEnabled( 1 );
	todolist_update();
};

void KrabWidget::define_outputpath()
{
	QString temp;
	krabwidget_setEnabled( 0 );
	temp = KFileDialog::getOpenFileName(todolist->outputPath, ".", this, i18n ("Select a file") );
//	todolist->outputPath = QFileDialog::getExistingDirectory( todolist->outputPath, this, "test");
	if ( temp.length() )
		todolist->outputPath = temp;
	krabwidget_setEnabled( 1 );
};

#ifdef KDE2
void KrabWidget::dropEvent(QDropEvent *event)
{
	QString temp;

	if ( play_prog_run )
		emit ( play_emited() ); // turn off !!!

	if( QTextDrag::decode ( event, temp ) )
	{
		select_dir( temp, 0 );
	};
	todolist_update();
};
#else
void KrabWidget::DropEvent(KDNDDropZone *zone)
{
	QString temp;
	unsigned int i, count;
	char *url_p;

	if ( play_prog_run )
		emit ( play_emited() ); // turn off !!!

	count = zone->getURLList().count();

	for ( i=0; i < count; i++ )
	{
		if ( i == 0)
			url_p = zone->getURLList().first();
		else
			url_p = zone->getURLList().next();

		if ( *url_p !=  'f' || *(url_p+1) != 'i' )
		{
			sorry(); return ;
		};
		
		url_p = url_p + 5;
		temp = url_p;
		select_dir( temp, i );
	};
	todolist_update();
};
#endif

void KrabWidget::select_dir( QString dir, unsigned int tracknr=1 ){

#ifdef KDE2
	KURL::decode( dir );
#else
	KURL::decodeURL( dir );
#endif
	QFileInfo FileInfo( dir );
	
	if ( FileInfo.isFile() && FileInfo.isReadable() )
		select_file( dir, tracknr );

	if ( FileInfo.isDir() && FileInfo.isReadable() ){
		QString temp;
		QDir Dir( dir );

#ifdef KDE2
		QStrList *Entrys = new QStrList;
		*Entrys = Dir.encodedEntryList();
#else
		QStrList *Entrys = (QStrList*) Dir.entryList();
#endif
		tracknr=1;
		temp = Entrys->first();

		while( 1 ){
			while( temp == ".." || temp == "." ){
				temp = Entrys->next();
				if ( !Entrys->current() )
					break;
			};
			if ( !Entrys->current() )
				break;

			temp = dir + "/" + temp;
			select_dir( temp, tracknr++ );
			temp = Entrys->next();
		};
	};
};
void KrabWidget::CddaListDestroyed()
{
	krabwidget_setEnabled( 1 );
       	disconnect( CddaList, SIGNAL(destroy_cddalist()) );
 	delete CddaList;

	(void) get_cddb();

	todolist_update();
};


void KrabWidget::cddalister()
{
	if ( play_prog_run )
		emit ( play_emited() ); // turn off !!!

	krabwidget_setEnabled( 0 );
	todolist->device_choiced = QComboBox_device->text(QComboBox_device->currentItem()); 	
	CddaList = new cddalist( 0, "", todolist, 1);
       	connect( CddaList, SIGNAL(destroy_cddalist()), SLOT(CddaListDestroyed()) );
	CddaList->show();
	if ( todolist->tracks_cdda == 0 )
	{
		delete CddaList;
		krabwidget_setEnabled( 1 );
		todolist_update();
	};
};

void KrabWidget::sorry()
{
#ifdef KDE2
	QMessageBox::information( this, i18n ( "Sorry" ), i18n ( "Sorry not yet implemented \n :-(" ) );
#else
	KMsgBox::message( this, i18n ( "Sorry" ), i18n ( "Sorry not yet implemented \n :-(" ) );
#endif
};


void KrabWidget::test_env_stdout(KProcess *, char *buffer, int buffer_size)
{
	QString row;
        QString temp;
        temp = buffer;
        if (buffer_size > 1023)
        {
                help_prog_stdout_temp = help_prog_stdout_temp + temp.mid(0, 1024);
        }
        else
        {
                help_prog_stdout_temp = help_prog_stdout_temp + temp.mid(0, (buffer_size - 1));
	};
};
void KrabWidget::QComboBox_bitrate_clicked(int z){
	QLineEdit_bitrate_other->blockSignals( 1 );
	QLineEdit_bitrate_other->setText(QComboBox_bitrate->text(z));
	QLineEdit_bitrate_other->blockSignals( 0 );
};
void KrabWidget::QLineEdit_bitrate_other_changed(const char *ch){
	QComboBox_bitrate->setCurrentItem(12);
};
void KrabWidget::load_config(){
	switch( todolist->grab_mode){
	case 0:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "wav_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "wav_enc_bitrate_other", "44100" ) );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "wav_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "wav_enc_16bit", 1 ) );
		break;
	case 1:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "lame_enc_bitrate", 1) );
		QComboBox_lame_br->setCurrentItem( kconfig->readNumEntry( "lame_enc_br", 8) );
		QComboBox_lame_ql->setCurrentItem( kconfig->readNumEntry( "lame_enc_ql", 10) );
		QCheckBox_lame_copyright->setChecked( kconfig->readBoolEntry( "lame_enc_copyright", 0 ) );
		QCheckBox_lame_original->setChecked( kconfig->readBoolEntry( "lame_enc_original", 0 ) );
		QCheckBox_lame_fast->setChecked( kconfig->readBoolEntry( "lame_enc_fast", 0 ) );
		QCheckBox_lame_gui->setChecked( kconfig->readBoolEntry( "lame_enc_gui", 0 ) );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "lame_enc_stereo", 1 ) );
		break;
	case 2:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "8hz_enc_bitrate", 1) );
		QComboBox_8hz_br->setCurrentItem( kconfig->readNumEntry( "8hz_enc_br", 8) );
		QCheckBox_8hz_copyright->setChecked( kconfig->readBoolEntry( "8hz_enc_copyright", 0 ) );
		QCheckBox_8hz_original->setChecked( kconfig->readBoolEntry( "8hz_enc_original", 0 ) );
		break;
	case 3:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "l3_enc_bitrate", 6) );
		QComboBox_l3_br->setCurrentItem( kconfig->readNumEntry( "l3_enc_br", 1) );
		QCheckBox_l3_hq->setChecked( kconfig->readBoolEntry( "l3_enc_hq", 0 ) );
		QCheckBox_l3_speech->setChecked( kconfig->readBoolEntry( "l3_enc_speech", 0 ) );
		QCheckBox_l3_crc->setChecked( kconfig->readBoolEntry( "l3_enc_crc", 0 ) );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "l3_enc_stereo", 1 ) );
		break;
	case 4:
		QComboBox_mp3_br->setCurrentItem( kconfig->readNumEntry( "mp3_enc_br", 9) );
		QComboBox_mp3_ql->setCurrentItem( kconfig->readNumEntry( "mp3_enc_ql", 3) );
		QCheckBox_mp3_crc->setChecked( kconfig->readBoolEntry( "mp3_enc_crc", 0 ) );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "mp3_enc_stereo", 1 ) );
		break;
	case 5:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "blade_enc_bitrate", 1) );
		QComboBox_blade_br->setCurrentItem( kconfig->readNumEntry( "blade_enc_br", 8) );
		QCheckBox_blade_copyright->setChecked( kconfig->readBoolEntry( "blade_enc_copyright", 0 ) );
		QCheckBox_blade_private->setChecked( kconfig->readBoolEntry( "blade_enc_private", 0 ) );
		QCheckBox_blade_crc->setChecked( kconfig->readBoolEntry( "blade_enc_crc", 0 ) );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "blade_enc_stereo", 1 ) );
		break;
	case 6:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "encode_enc_bitrate", 4) );
		QComboBox_encode_br->setCurrentItem( kconfig->readNumEntry( "encode_enc_br", 8) );
		QComboBox_encode_ql->setCurrentItem( kconfig->readNumEntry( "encode_enc_ql", 8) );
		QCheckBox_encode_copyright->setChecked( kconfig->readBoolEntry( "encode_enc_copyright", 0 ) );
		QCheckBox_encode_original->setChecked( kconfig->readBoolEntry( "encode_enc_original", 0 ) );
		QCheckBox_encode_crc->setChecked( kconfig->readBoolEntry( "encode_enc_crc", 0 ) );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "encode_enc_stereo", 1 ) );
		break;
	case 7:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "xing_enc_bitrate", 4) );
		QComboBox_xing_br->setCurrentItem( kconfig->readNumEntry( "xing_enc_br", 8) );
		QComboBox_xing_ql->setCurrentItem( kconfig->readNumEntry( "xing_enc_ql", 2) );
		QCheckBox_xing_copyright->setChecked( kconfig->readBoolEntry( "xing_enc_copyright", 0 ) );
		QCheckBox_xing_original->setChecked( kconfig->readBoolEntry( "xing_enc_original", 0 ) );
		QCheckBox_xing_vbr->setChecked( kconfig->readBoolEntry( "xing_enc_vbr", 0 ) );
		QCheckBox_xing_nohigh->setChecked( kconfig->readBoolEntry( "xing_enc_nohigh", 0 ) );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "xing_enc_stereo", 1 ) );
		xing_vbr_toggled( QCheckBox_xing_vbr->isChecked() );
		break;
/***********************************************************************************************/
	case 15:
		QComboBox_cdr_device->setCurrentItem( kconfig->readNumEntry( "CDR_device", 0) );
		QComboBox_cdr_speed->setCurrentItem( kconfig->readNumEntry( "CDR_speed", 0) );
		QCheckBox_cdr_dummy->setChecked( kconfig->readBoolEntry( "CDR_dummy", 1 ) );
		QCheckBox_cdr_fix->setChecked( kconfig->readBoolEntry( "CDR_fix", 1 ) );
		QCheckBox_cdr_eject->setChecked( kconfig->readBoolEntry( "CDR_eject", 1 ) );
		break;
/***********************************************************************************************/
	case 16:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "dat_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "dat_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		break;
	case 19:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "svx_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "svx_enc_bitrate_other", "44100" ) );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "svx_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "svx_enc_16bit", 1 ) );
		break;
	case 20:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "aiff_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "aiff_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "aiff_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "aiff_enc_16bit", 1 ) );
		break;
	case 21:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "au_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "au_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "au_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "au_enc_16bit", 1 ) );
		break;
	case 22:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "maud_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "maud_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "maud_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "maud_enc_16bit", 1 ) );
		break;
	case 23:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "sf_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "sf_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "sf_enc_stereo", 1 ) );
		break;
	case 24:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "smp_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "smp_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		break;
	case 25:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "voc_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "voc_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "voc_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "voc_enc_16bit", 1 ) );
		break;
	case 26:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "cvs_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "cvs_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "cvs_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "cvs_enc_16bit", 1 ) );
		break;
	case 27:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "vms_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "vms_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "vms_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "vms_enc_16bit", 1 ) );
		break;
	case 28:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "sndr_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "sndr_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "sndr_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "sndr_enc_16bit", 1 ) );
		break;
	case 29:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "sndt_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "sndt_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "sndt_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "sndt_enc_16bit", 1 ) );
		break;
	case 30:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "txw_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "txw_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "txw_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "txw_enc_16bit", 1 ) );
		break;
	case 31:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "wve_enc_bitrate", 9) );
		QLineEdit_bitrate_other->setText( kconfig->readEntry( "wve_enc_bitrate_other", "44100" ) );
		QLineEdit_bitrate_other->setMaxLength( 5 );
		QCheckBox_stereo->setChecked( kconfig->readBoolEntry( "wve_enc_stereo", 1 ) );
		QCheckBox_16bit->setChecked( kconfig->readBoolEntry( "wve_enc_16bit", 1 ) );
		break;
	case 32:
		QComboBox_bitrate->setCurrentItem( kconfig->readNumEntry( "hcom_enc_bitrate", 3) );
		break;
	};
};
void KrabWidget::save_config(){
	switch (todolist->grab_mode){
	case 0:
		kconfig->writeEntry( "wav_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "wav_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "wav_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "wav_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 1:
		kconfig->writeEntry( "lame_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "lame_enc_br", QComboBox_lame_br->currentItem() );
		kconfig->writeEntry( "lame_enc_ql", QComboBox_lame_ql->currentItem() );
		kconfig->writeEntry( "lame_enc_copyright", QCheckBox_lame_copyright->isChecked() );
		kconfig->writeEntry( "lame_enc_original", QCheckBox_lame_original->isChecked() );
		kconfig->writeEntry( "lame_enc_fast", QCheckBox_lame_fast->isChecked() );
		kconfig->writeEntry( "lame_enc_gui", QCheckBox_lame_gui->isChecked() );
		kconfig->writeEntry( "lame_enc_stereo", QCheckBox_stereo->isChecked() );
		break;
	case 2:
		kconfig->writeEntry( "8hz_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "8hz_enc_br", QComboBox_8hz_br->currentItem() );
		kconfig->writeEntry( "8hz_enc_copyright", QCheckBox_8hz_copyright->isChecked() );
		kconfig->writeEntry( "8hz_enc_original", QCheckBox_8hz_original->isChecked() );
		break;
	case 3:
		kconfig->writeEntry( "l3_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "l3_enc_br", QComboBox_l3_br->currentItem() );
		kconfig->writeEntry( "l3_enc_hq", QCheckBox_l3_hq->isChecked() );
		kconfig->writeEntry( "l3_enc_speech", QCheckBox_l3_speech->isChecked() );
		kconfig->writeEntry( "l3_enc_crc", QCheckBox_l3_crc->isChecked() );
		kconfig->writeEntry( "l3_enc_stereo", QCheckBox_stereo->isChecked() );
		break;
	case 4:
		kconfig->writeEntry( "mp3_enc_br", QComboBox_mp3_br->currentItem() );
		kconfig->writeEntry( "mp3_enc_ql", QComboBox_mp3_ql->currentItem() );
		kconfig->writeEntry( "mp3_enc_crc", QCheckBox_mp3_crc->isChecked() );
		kconfig->writeEntry( "mp3_enc_stereo", QCheckBox_stereo->isChecked() );
		break;
	case 5:
		kconfig->writeEntry( "blade_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "blade_enc_br", QComboBox_blade_br->currentItem() );
		kconfig->writeEntry( "blade_enc_copyright", QCheckBox_blade_copyright->isChecked() );
		kconfig->writeEntry( "blade_enc_private", QCheckBox_blade_private->isChecked() );
		kconfig->writeEntry( "blade_enc_crc", QCheckBox_blade_crc->isChecked() );
		kconfig->writeEntry( "blade_enc_stereo", QCheckBox_stereo->isChecked() );
		break;
	case 6:
		kconfig->writeEntry( "encode_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "encode_enc_br", QComboBox_encode_br->currentItem() );
		kconfig->writeEntry( "encode_enc_ql", QComboBox_encode_ql->currentItem() );
		kconfig->writeEntry( "encode_enc_copyright", QCheckBox_encode_copyright->isChecked() );
		kconfig->writeEntry( "encode_enc_original", QCheckBox_encode_original->isChecked() );
		kconfig->writeEntry( "encode_enc_crc", QCheckBox_encode_crc->isChecked() );
		kconfig->writeEntry( "encode_enc_stereo", QCheckBox_stereo->isChecked() );
		break;
	case 7:
		kconfig->writeEntry( "xing_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "xing_enc_br", QComboBox_xing_br->currentItem() );
		kconfig->writeEntry( "xing_enc_ql", QComboBox_xing_ql->currentItem() );
		kconfig->writeEntry( "xing_enc_copyright", QCheckBox_xing_copyright->isChecked() );
		kconfig->writeEntry( "xing_enc_original", QCheckBox_xing_original->isChecked() );
		kconfig->writeEntry( "xing_enc_vbr", QCheckBox_xing_vbr->isChecked() );
		kconfig->writeEntry( "xing_enc_nohigh", QCheckBox_xing_nohigh->isChecked() );
		kconfig->writeEntry( "xing_enc_stereo", QCheckBox_stereo->isChecked() );
		break;
/***********************************************************************************************/
	case 15:
		kconfig->writeEntry( "CDR_device", QComboBox_cdr_device->currentItem() );
		kconfig->writeEntry( "CDR_speed", QComboBox_cdr_speed->currentItem() );
		kconfig->writeEntry( "CDR_dummy", QCheckBox_cdr_dummy->isChecked() );
		kconfig->writeEntry( "CDR_fix", QCheckBox_cdr_fix->isChecked() );
		kconfig->writeEntry( "CDR_eject", QCheckBox_cdr_eject->isChecked() );
		break;
/***********************************************************************************************/
	case 16:
		kconfig->writeEntry( "dat_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "dat_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "dat_enc_stereo", QCheckBox_stereo->isChecked() );
		break;
	case 19:
		kconfig->writeEntry( "svx_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "svx_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "svx_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "svx_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 20:
		kconfig->writeEntry( "aiff_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "aiff_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "aiff_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "aiff_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 21:
		kconfig->writeEntry( "au_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "au_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "au_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "au_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 22:
		kconfig->writeEntry( "maud_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "maud_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "maud_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "maud_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 23:
		kconfig->writeEntry( "sf_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "sf_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "sf_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "sf_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 24:
		kconfig->writeEntry( "smp_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "smp_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "smp_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "smp_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 25:
		kconfig->writeEntry( "voc_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "voc_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "voc_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "voc_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 26:
		kconfig->writeEntry( "cvs_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "cvs_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "cvs_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "cvs_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 27:
		kconfig->writeEntry( "vms_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "vms_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "vms_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "vms_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 28:
		kconfig->writeEntry( "sndr_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "sndr_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "sndr_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "sndr_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 29:
		kconfig->writeEntry( "sndt_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "sndt_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "sndt_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "sndt_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 30:
		kconfig->writeEntry( "txw_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "txw_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "txw_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "txw_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 31:
		kconfig->writeEntry( "wve_enc_bitrate", QComboBox_bitrate->currentItem() );
		kconfig->writeEntry( "wve_enc_bitrate_other", QLineEdit_bitrate_other->text() );
		kconfig->writeEntry( "wve_enc_stereo", QCheckBox_stereo->isChecked() );
		kconfig->writeEntry( "wve_enc_16bit", QCheckBox_16bit->isChecked() );
		break;
	case 32:
		kconfig->writeEntry( "hcom_enc_bitrate", QComboBox_bitrate->currentItem() );
		break;
	
	};
	kconfig->sync();
};
#ifdef KDE2
const char* kde2_translate( const char *p ){
	QString temp = i18n( p );
	char *t = (char*) malloc(1+temp.length()) ;
	strcpy ( t, temp.latin1());
	return (const char*) t;
};
#endif

