#include <qdir.h>
#include <krabwidget.h>
#include <PrefGeneric.h>
#include <PrefStartup.h>
#include <kapp.h>
#include <kurl.h>

#define SEP		KTabListBox_todo->separator()

void KrabWidget::select_file(QString file_name, unsigned int tracknr=0 )
{
	unsigned int size;
	char *ident;
	unsigned long frame_size;
	bool accepted = 0;
	QString temp;
	QFile file;
	Data *data = new Data;
	ident = (char*) malloc( 256*sizeof(char) );
	unsigned char *uident = (unsigned char*) ident;

#ifdef KDE2
	KURL::decode( file_name );
#else
	KURL::decodeURL( file_name );
#endif
	if ( !strncmp( file_name, "file:/", 6 ) )
		file_name = file_name.mid( 5, file_name.length() - 5 );

	file.setName(file_name);
	if ( !file.open( IO_ReadOnly ) )
		return;
	size = file.size();
	if ( size < 255 )
		return;

	file.readBlock( ident, 255 );

	todolist->tracks++;
	todolist->data.resize(todolist->tracks+2);
	todolist->data.insert( todolist->tracks, data );

/* the kde file identify function did not work always fine for me, so i need an own routine */
	if ( uident[0] == 255 && (uident[1]==253||uident[1]==252) ) //mp2
	{		
		if ( mpg123 )
		{
			accepted = 1;
			data->type			= 2;
			data->input_bit_per_rate 	= 16; //everytime 16bit
			data->input_compr_bitrate 	= bitrate_mpeg_layer2[(uident[2] >> 4) & 0x0F];
			if ( ((uident[3]>>6)&0x3) == 3 )				//mono
				data->input_channels = 1;
			else
				data->input_channels = 2;
		
			if (((uident[2] >> 2)&0x3) == 0||((uident[2] >> 2)&0x3) == 3 ) // 3 should never happen
				data->input_rate  = 44100;
			if (((uident[2] >> 2)&0x3) == 1 )
				data->input_rate  = 48000;
			if (((uident[2] >> 2)&0x3) == 2 )
				data->input_rate  = 32000;
			frame_size = 144*((1000*data->input_compr_bitrate)/data->input_rate);//144*(bitrate/samplerate)
			frame_size += ((uident[2] >> 1)&0x01);// + padding byte
			data->input_frames  = size / frame_size;
			data->input_size	= (8*size)/(data->input_compr_bitrate*1000);//seconds
			data->input_size   *= ((unsigned long)data->input_rate)*((unsigned long)data->input_bit_per_rate)*((unsigned long)data->input_channels);
			data->input_size   /= 8;
		}else
#ifdef KDE2
			QMessageBox::information( this, i18n( "Error" ), i18n( "You need the mpg123 ...\n") );
#else
			KMsgBox::message( this, i18n( "Error" ), i18n( "You need the mpg123 ...\n") );
#endif
	}
	else if ( (uident[0] == 255 && (uident[1]==251||uident[1]==250))   //mp3
		  || (strncmp(ident, "RIFF", 4)==0 && strncmp(ident + 8, "WAVEfmt", 7)==0&&strncmp(ident + 62, "data", 4)==0
			&& (uident[70] == 255 && (uident[71]==251||uident[71]==250)) )) // mp3 in WAVE
	{
		if ( mpg123 )
		{
			accepted = 1;
			data->type=3;
			data->input_bit_per_rate = 16; //everytime 16bit
			if ( strncmp(ident, "RIFF", 4)==0 ){
				data->input_compr_bitrate = bitrate_mpeg_layer3[(uident[72] >> 4) & 0x0F];
				if ( ((uident[73]>>6)&0x3) == 3 )				//mono
					data->input_channels = 1;
				else
					data->input_channels = 2;

				if (((uident[72] >> 2)&0x3) == 0||((uident[72] >> 2)&0x3) == 3 ) // 3 should never happen
					data->input_rate = 44100;
				if (((uident[72] >> 2)&0x3) == 1 )
					data->input_rate = 48000;
				if (((uident[72] >> 2)&0x3) == 2 )
					data->input_rate = 32000;
				frame_size = 144*((1000*data->input_compr_bitrate)/data->input_rate);//144*(bitrate/samplerate)
				frame_size += ((uident[72] >> 1)&0x01);// + padding byte
			}else{
				data->input_compr_bitrate = bitrate_mpeg_layer3[(uident[2] >> 4) & 0x0F];
				if ( ((uident[3]>>6)&0x3) == 3 )				//mono
					data->input_channels = 1;
				else
					data->input_channels = 2;

				if (((uident[2] >> 2)&0x3) == 0||((uident[2] >> 2)&0x3) == 3 ) // 3 should never happen
					data->input_rate = 44100;
				if (((uident[2] >> 2)&0x3) == 1 )
					data->input_rate = 48000;
				if (((uident[2] >> 2)&0x3) == 2 )
					data->input_rate = 32000;
				frame_size = 144*((1000*data->input_compr_bitrate)/data->input_rate);//144*(bitrate/samplerate)
				frame_size += ((uident[2] >> 1)&0x01);// + padding byte
			};
			data->input_frames = size / frame_size;
			data->input_size = (8*size)/(data->input_compr_bitrate*1000);//seconds
			data->input_size *= ((unsigned long)data->input_rate)*((unsigned long)data->input_bit_per_rate)*((unsigned long)data->input_channels);
			data->input_size /= 8;
		}
		else
#ifdef KDE2
			QMessageBox::information( this, i18n( "Error" ), i18n( "You need the mpg123 ...\n") );
#else
			KMsgBox::message( this, i18n( "Error" ), i18n( "You need the mpg123 ...\n") );
#endif
	}
	else if ( strncmp(ident, "RIFF", 4)==0 && strncmp(ident + 8, "WAVEfmt", 7)==0 )
	{

		accepted = 1;
		data->type=4;
		data->input_size = size;

		data->input_rate
				= ((unsigned int) uident[25])*256 + (unsigned int) uident[24];
		data->input_channels
				= (unsigned int) uident[22];
		data->input_bit_per_rate
				= (unsigned int) uident[34];
	}
	else 
	{
// TO FIX: size lines
		bool need_sox = 0;
		if ( strncmp(ident, "; Sample Rate", 13) == 0)
                {
			need_sox = 1;
			accepted = 1;
			data->type=5;
			data->input_size = size;
			identify( file_name, "dat", todolist->tracks );
                }
		else if ( strncmp(ident + 8, "8SVX", 4) == 0)
		{
			need_sox = 1;
			accepted = 1;
			data->type=8;
			data->input_size = size;
			identify( file_name, "8svx", todolist->tracks );
		}
   		else if ( strncmp(ident + 8, "AIFF", 4) == 0)
		{
			need_sox = 1;
			accepted = 1;
			data->type=9;
			data->input_size = size;
			identify( file_name, "aiff", todolist->tracks );
		}
		else if ( (strncmp(ident, ".snd", 4) == 0) ||(strncmp(ident, "dns.", 4) == 0) ||
			  ((ident[0] == '\0') && (strncmp(ident+1, "ds.", 3) == 0)) )
		{//.au
			need_sox = 1;
			accepted = 1;
			data->type=10;
			data->input_size = size;
			identify( file_name, "au", todolist->tracks );
		}
		else if ( strncmp(ident + 8, "MAUD", 4) == 0)
		{
			need_sox = 1;
			accepted = 1;
			data->type=11;
			data->input_size = size;
			identify( file_name, "maud", todolist->tracks );
		}
		else if ( strncmp(ident, "SOUND SAMPLE DATA ", 18) == 0)
		{
			need_sox = 1;
			accepted = 1;
			data->type=13;
			data->input_size = size;
			identify( file_name, "smp", todolist->tracks );
		}
		else if ( strncmp(ident, "Creative Voice File", 19) == 0 )
		{
			need_sox = 1;
			accepted = 1;
			data->type=14;
			data->input_size = size;
			identify( file_name, "voc", todolist->tracks );
// TO FIX: CVS und VMS
		}
		else if ( strncmp(ident, "SOUND", 5) == 0 ) //sndt
		{
			need_sox = 1;
			accepted = 1;
			data->type=18;
			data->input_size = size;
			identify( file_name, "sndt", todolist->tracks );
		}
		else if ( strncmp(ident, "LM8953", 6) == 0 ) // .txw maybe false !!
		{
			need_sox = 1;
			accepted = 1;
			data->type=19;
			data->input_size = size;
			identify( file_name, "txw", todolist->tracks );
		}
		else if ( strncmp(ident, "ALawSoundFile", 13) == 0 ) // .wve
		{
			need_sox = 1;
			accepted = 1;
			data->type=20;
			data->input_size = size;
			identify( file_name, "wve", todolist->tracks );
		}else if ( strncmp(ident+65, "FSSD", 4) == 0 && strncmp(ident+128, "HCOM", 4) == 0)
		{
			need_sox = 1;
			accepted = 1;
			data->type=21;
			data->input_size = size;
			identify( file_name, "hcom", todolist->tracks );
		}
		else if ( file_name.right( 3 ) == ".sf" || file_name.right( 3 ) == ".SF" )
		{
			need_sox = 1;
			accepted = 1;
			data->type=12;
			data->input_size = size;
			identify( file_name, "sf", todolist->tracks );
		}
		else if ( file_name.right( 4 ) == ".cdr" || file_name.right( 4 ) == ".CDR" )
		{
			need_sox = 1;
			accepted = 1;
			data->type=6;
			data->input_size = size;
			data->input_rate = 44100;
			data->input_channels = 2;
			data->input_bit_per_rate = 16;
		}
		else if ( file_name.right( 4 ) == ".raw" || file_name.right( 4 ) == ".RAW" )
		{
			need_sox = 1;
			accepted = 1;
			data->type=7;
			data->input_size     = size;
			data->input_rate     = 44100;
			data->input_channels = 2;
			data->input_bit_per_rate = 16;
		}else if ( ident[0] == 0 && ident[1] == 0 ) // maybe sndr ???
		{
			int rate = ( uident[2] & 0xff) + ((uident[3] & 0xff) << 8);
			if ( rate >= 4000 && rate <=25000 ){ // it is sndr
				need_sox = 1;
				accepted = 1;
				data->type=17;
				data->input_size = size;
				data->input_rate = (unsigned int) rate;
				identify( file_name, "sndr", todolist->tracks );
			};
		}

		if ( !sox && need_sox )
		{
			accepted = 0;
#ifdef KDE2
			QMessageBox::information( this, i18n( "Error" ), i18n( "You need the sox ...\n") );
#else
			KMsgBox::message( this, i18n( "Error" ), i18n( "You need the sox ...\n") );
#endif
		};
	};

	if (accepted){
		data->tracknumber	= tracknr;
		data->device	= file_name;
		data->year		= "";
		data->group		= "";
		data->album		= "";
		data->title		= "";
		data->comment 	= "";
		data->music_type 	= 256;
		data->cddb_disable 	= 1;
		temp.setNum( todolist->tracks );
		if ( todolist->tracks< 10 )
			temp = "0" + temp;
		data->output_filename = "KrabberFile" + temp;
		if ( data->type==3 )
		{
			char input[31];
			input[31] = '\0';
			file.at(file.size()-128);
			file.readBlock( (char*) &input, 3 );
			if ( input[0] == 'T' && input[1] == 'A' && input[2] == 'G' )
			{
				QString weg;
				file.readBlock((char*) &input, 30);
				weg = input;
				data->title = (weg.mid(0,30)).stripWhiteSpace();
				file.readBlock((char*) &input, 30);
				weg = input;
				data->group = (weg.mid(0,30)).stripWhiteSpace();
				file.readBlock((char*) &input, 30);
				weg = input;
				data->album = (weg.mid(0,30)).stripWhiteSpace();
				file.readBlock((char*) &input, 4);
				weg = input; weg = weg.left(4);
				data->year = weg.stripWhiteSpace();
				file.readBlock((char*) &input, 28);
				int char_1 = file.getch();
				int char_2 = file.getch();
				if (char_2>0 && char_1 == 0 ){
					data->tracknumber = char_2;
					weg = input;
					data->comment = (weg.mid(0,28)).stripWhiteSpace();
				}else{
					file.at( file.at() -28 );
					file.readBlock( (char*) &input, 30);
					weg = input;
					data->comment = (weg.mid(0,30)).stripWhiteSpace();
				};
				data->music_type = file.getch();
                        };
		};
	}else{
			todolist->data.remove( todolist->tracks );
			todolist->tracks--;
			todolist->data.resize(todolist->tracks+2);
	};

	free (ident);
	file.close();
};
void KrabWidget::identify( QString file_name, char *format, unsigned int entry)
{
	if ( !sox )
		return;

        FILE *sox_stream;
	char *buffer = (char*) malloc( 44 );
	unsigned char *ubuffer = (unsigned char*) buffer;
	pid_t sox_pid;
	int pipe_[2], dummy[2];

	if (pipe(pipe_)){ cout <<"UNABLE TO CREATE PIPE"<<endl;exit(1);};
	if (pipe(dummy)){ cout <<"UNABLE TO CREATE PIPE"<<endl;exit(1);};
	sox_pid = fork();
	if ( sox_pid == 0 ){
		fdopen( pipe_[1], "w" );
		dup2( pipe_[1], STDOUT_FILENO );
		dup2( dummy[1], STDERR_FILENO );
		close( pipe_[1] );
		const char *file_name_p = file_name;
		execlp( "sox", "sox", "-t", format, file_name_p, "-t", "wav", "-", 0 );
		perror( "sox died unexpected !\n" );
		_exit(1);
	};
	sox_stream = fdopen( pipe_[0], "r" );
//TO FIX: krabber can lock up, if sox did not send any data !!!
	if ( fread( buffer, 44, 1, sox_stream ) != 44 ) cout << "Internal Krabber Error. did not receive 44 bytes from sox." <<endl;
	fclose ( sox_stream );
	kill( sox_pid, SIGTERM );
	if ( strncmp(buffer, "RIFF", 4)==0 && strncmp(buffer + 8, "WAVEfmt", 7)==0 ){
		todolist->data[entry]->input_rate
				= ((unsigned int) ubuffer[25])*256 + (unsigned int) ubuffer[24];
		todolist->data[entry]->input_channels
				= (unsigned int) ubuffer[22];
		todolist->data[entry]->input_bit_per_rate
				= (unsigned int) ubuffer[34];
	}else
		cout << "unable to identify file"<<endl;
	free (buffer);
};

void KrabWidget::update_tags()
{
	int success = 0;
	QString temp;

	for (unsigned int i = 1; i <=todolist->tracks; i++)
	    if ( todolist->data[i]->type == 3 )
		{
			write_mp3_header( todolist->data[i]->device, i );
			success++;
		};
	if (success){
		temp.setNum( success );
		temp += ". ";
		temp += i18n( "MP3 TAGs updated..." );
		emit( new_status_info( temp ) );
	};
};
void KrabWidget::update_filenames()
{
	int success = 0;
	int j;
	QString temp;

	for (unsigned int i = 1; i <=todolist->tracks; i++)
	    if ( todolist->data[i]->type != 1 )
		{
			temp = todolist->data[i]->device;
			j    = temp.length() - 1;
			while( j>=0 && temp.mid( j, 1 )!="/" ) j--;
			temp = temp.mid( 0, j ) + "/" + todolist->data[i]->output_filename;
			rename( todolist->data[i]->device, temp );
			todolist->data[i]->device = temp;
			success++;
		};
//TO FIX: really done????
	if (success){
		temp.setNum( success );
		temp += ". ";
		temp += i18n( "filenames updated..." );
		emit( new_status_info( temp ) );
	};
};
void KrabWidget::todolist_update(int i)
{todolist_update();};
void KrabWidget::todolist_update(bool b)
{todolist_update();};
void KrabWidget::todolist_update()
{
	unsigned int i;
	float l;
	QString temp,
		convert,
		cddb,
		icon,
		char_,
		length,
		line;

	NameWidget = new namewidget( 0, "", todolist, 0 );
	for ( i = 1; i <= todolist->tracks; i++ )
	{
		temp  = NameWidget->update_filename_sub( kconfig->readNumEntry( "name_combo_file_1", 2 ), i );
		temp += character_replace( kconfig->readEntry( "name_line_file_1", ".@" ), "@",  " ");
		temp += NameWidget->update_filename_sub( kconfig->readNumEntry( "name_combo_file_2", 0 ), i );
		temp += character_replace( kconfig->readEntry( "name_line_file_2", "" ), "@",  " ");
		temp += NameWidget->update_filename_sub( kconfig->readNumEntry( "name_combo_file_3", 0 ), i );
		temp += character_replace( kconfig->readEntry( "name_line_file_3", "" ), "@",  " ");
		temp += NameWidget->update_filename_sub( kconfig->readNumEntry( "name_combo_file_4", 0 ), i );
		temp += ".";
		temp += format_out[todolist->grab_mode];

		if ( krabber_config.outputfilename_capital )
			for ( unsigned j = 0; j<temp.length(); j++ ){
				if ( temp.mid( j,1 ) == " " ){
					char_ 	  = temp.mid( j+1, 1 );
					char_ 	  = char_.upper();					temp 	  = temp.replace(j+1, 1, char_);
				};
			};

		if ( krabber_config.outputfilename_replace )
			todolist->data[i]->output_filename =
				character_replace( temp, krabber_config.outputfilename_replace_from, krabber_config.outputfilename_replace_to );
		else
			todolist->data[i]->output_filename = temp;
	};
	delete NameWidget;

//	char *line = (char*) malloc(1024*sizeof(char));
	QString line_;
	KTabListBox_todo->clear();
	KTabListBox_todo->setSeparator( '@' );
	KTabListBox_todo->setAutoUpdate(FALSE);
	KTabListBox_todo->clear();

	calc_total_size();

	for (i = 1; i <= todolist->tracks; i++)
	{
		cddb = "";
		switch ( todolist->data[i]->type )
		{
		case 1:
		{
			icon = "CDDA";
	                convert.sprintf( "%08x", (int) todolist->data[i]->cddb_discid );
			cddb = "  (" + convert + ")";
			break;
		};
		case 2:
		{
			icon = "MP2";
			break;
		};
		case 3:
		{
			icon = "MP3";
			break;
		};
		case 4:
		{
			icon = "WAV";
			break;
		};
		case 5:
		{
			icon = "DAT";
			break;
		};
		case 6:
		{
			icon = "CDR";
			break;
		};
		case 7:
		{
			break;
		};
		case 8:
		{
			icon = "SVX";
			break;
		};
		case 9:
		{
			icon = "AIFF";
			break;
		};
		case 10:
		{
			icon = "_AU";
			break;
		};
		case 11:
		{
			icon = "MAUD";
			break;
		};
		case 12:
		{
			icon = "_SF";
			break;
		};
		case 13:
		{
			icon = "SMP";
			break;
		};
		case 14:
		{
			icon = "VOC";
			break;
		};
		case 15:
		{
			icon = "CVS";
			break;
		};
		case 16:
		{
			icon = "VMS";
			break;
		};
		case 17:
		{
			icon = "SNDR";
			break;
		};
		case 18:
		{
			icon = "SNDT";
			break;
		};
		case 19:
		{
			icon = "TXW";
			break;
		};
		case 20:
		{
			icon = "WVE";
			break;
		};
		case 21:
		{
			icon = "HCOM";
			break;
		};
		default:
		{
			icon = "ERROR";
		};
		};
		l = todolist->length_bytes_output(i, dest_bitrate, dest_channels, dest_bits, bitrate);
		length.sprintf( "%.3f", l/1024 );

		// QString had sometimes some problems here....
/*                ostrstream( line, 1024 ) << icon <<SEP<< i <<SEP <<todolist->data[i]->tracknumber << SEP <<" "
                         <<todolist->data[i]->device + cddb <<SEP<<SEP << length << " "
                         <<SEP<< " "<< todolist->data[i]->group <<SEP<<" "<< todolist->data[i]->album<<SEP<<" "<<todolist->data[i]->title
                         <<SEP<<" "<<todolist->data[i]->output_filename <<ends;
*/
		line_.setNum(i);
		line = icon + SEP + line_ + SEP;
		line_.setNum(todolist->data[i]->tracknumber);
		line += line_ + SEP + " " + todolist->data[i]->device + cddb  + SEP + SEP + length + " " + SEP + " ";
		line += todolist->data[i]->group + SEP + " " + todolist->data[i]->album + SEP + " " + todolist->data[i]->title;
		line += SEP + todolist->data[i]->output_filename;

		KTabListBox_todo->insertItem(line);
		KTabListBox_todo->dict().replace( "CDDA", pix_cdda );
		KTabListBox_todo->dict().replace( "WAV",  pix_wav );
		KTabListBox_todo->dict().replace( "MP2",  pix_mp2 );
		KTabListBox_todo->dict().replace( "MP3",  pix_mp3 );
		KTabListBox_todo->dict().replace( "DAT",  pix_dat );
		KTabListBox_todo->dict().replace( "CDR",  pix_cdr );
		KTabListBox_todo->dict().replace( "RAW",  pix_raw );
		KTabListBox_todo->dict().replace( "SVX",  pix_svx );
		KTabListBox_todo->dict().replace( "AIFF", pix_aiff );
		KTabListBox_todo->dict().replace( "_AU",  pix_au );
		KTabListBox_todo->dict().replace( "MAUD", pix_maud );
		KTabListBox_todo->dict().replace( "_SF",  pix_sf );
		KTabListBox_todo->dict().replace( "SMP",  pix_smp );
		KTabListBox_todo->dict().replace( "VOC",  pix_voc );
		KTabListBox_todo->dict().replace( "CVS",  pix_cvs );
		KTabListBox_todo->dict().replace( "VMS",  pix_vms );
		KTabListBox_todo->dict().replace( "SNDR", pix_sndr );
		KTabListBox_todo->dict().replace( "SNDT", pix_sndt );
		KTabListBox_todo->dict().replace( "TXW",  pix_txw );
		KTabListBox_todo->dict().replace( "WVE",  pix_wve );
		KTabListBox_todo->dict().replace( "HCOM", pix_hcom );
	};

	KTabListBox_todo->setAutoUpdate(TRUE);
	KTabListBox_todo->update();
	KTabListBox_todo->repaint();
	KTabListBox_todo->setCurrentItem(0);

	if ( todolist->grab_mode == 15 )
		todolist_update_cdr();

//	free ( line );
};
void KrabWidget::todolist_update_cdr(){
	QColor color;
	QString line;

	if ( cdr_pre_loaded >= 0 ){
		line.setNum( ((total_final_size/1024)*100)/(1024*MAX_MB_ON_CD) );
		line += "%";
		QPushButton_cdr_size->setText( line );
		if ( ((total_final_size+cdr_pre_loaded)/1024) > ( MAX_MB_ON_CD *1024) ){
			color.setRgb( 200, 0, 0); // red
		}else{
			color.setRgb( 40, 190, 40 ); // green
		};
	} else if ( cdr_pre_loaded == -1 ){
		color.setRgb( 200, 0, 0); // red
		QPushButton_cdr_size->setText( i18n("No disk") );
	} else {
		color.setRgb( 200, 0, 0); // red
		QPushButton_cdr_size->setText( i18n("disk fixed") );
	};
//	QPushButton_cdr_size->setBackgroundColor( color ); // makes no sense yet...

};
unsigned long KrabWidget::calc_total_size(){

     QString string_;
     unsigned int i;

     bitrate		    = 1;

     switch ( todolist->grab_mode ){
	case 15:				// cdrecord
	case 18:				//raw or cdr output
	case 17:
	// Bob reported that mp3enc does not work fine if the defaults were changed
	case 4:				//mp3enc
		dest_bitrate = 44100;
		dest_channels = 2;
		dest_bits = 16;
		break;
	case 1:				//lame
	case 2:				//8hz
	case 3:				//l3enc
	case 5:				//bladeenc
	case 6:				//encode
		switch( QComboBox_bitrate->currentItem() ){
			case 0:{dest_bitrate = 32000;break;};
			case 1:{dest_bitrate = 44100;break;};
			case 2:{dest_bitrate = 48000;break;};
		};
		dest_channels = 2;
		dest_bits = 16;
		break;
	case 7:				//xing
		switch( QComboBox_bitrate->currentItem() ){
			case 0:{dest_bitrate = 16000;break;};
			case 1:{dest_bitrate = 22050;break;};
			case 2:{dest_bitrate = 24000;break;};
			case 3:{dest_bitrate = 32000;break;};
			case 4:{dest_bitrate = 44100;break;};
			case 5:{dest_bitrate = 48000;break;};
		};
		dest_channels = 2;
		dest_bits = 16;
		break;
	default:			//other output
		if ( QCheckBox_stereo->isChecked() )
			dest_channels = 2;
		else
			dest_channels = 1;
		if ( todolist->grab_mode==16 )
			dest_bits = 32;
		else if ( QCheckBox_16bit->isChecked() )
			dest_bits = 16;
		else
			dest_bits = 8;
		if ( strcmp(i18n("Other"), QComboBox_bitrate->currentText()) == 0 )
			string_ = QLineEdit_bitrate_other->text();
		else
			string_ = QComboBox_bitrate->text(QComboBox_bitrate->currentItem());
		const char *pointer = string_;
		dest_bitrate = 0;
		for ( unsigned int h=0; h<=string_.length() ; h++){
			if ( *pointer >= 48 &&  *pointer <=57 ){
				dest_bitrate += *pointer++ + dest_bitrate + (dest_bitrate<<3) - 48;
			}else
			pointer++;
		};
		if ( dest_bitrate > 50000 ) {
			dest_bitrate = 50000;
#ifdef KDE2
			QMessageBox::information( this, i18n( "Error" ), i18n( "Unable to work with bitrate higher than 50kHz..\nSet to 50kHz !\n") );
#else
			KMsgBox::message( this, i18n( "Error" ), i18n( "Unable to work with bitrate higher than 50kHz..\nSet to 50kHz !\n") );
#endif
		};
		break;
	};
	switch ( todolist->grab_mode )
	{
		case 1: bitrate = bitrate_lame[QComboBox_lame_br->currentItem()];
			break;
		case 2: bitrate = bitrate_8hz[QComboBox_8hz_br->currentItem()];
			break;
		case 3: bitrate = bitrate_l3[QComboBox_l3_br->currentItem()];
			break;
		case 4: bitrate = bitrate_mp3[QComboBox_mp3_br->currentItem()];
			break;
		case 5: bitrate = bitrate_blade[QComboBox_blade_br->currentItem()];
			break;
		case 6: bitrate = bitrate_encode[QComboBox_encode_br->currentItem()];
			break;
		case 7:
		     if ( QCheckBox_xing_vbr->isChecked() ){
			switch( QComboBox_xing_ql->currentItem() ){
			   case 0:
				bitrate = 96;
                               	break;
			   case 1:
				bitrate = 112;
               	                break;
			   case 2:
				bitrate = 128;
       	                        break;
			   case 3:
				bitrate = 160;
                               	break;
			   case 4:
				bitrate = 192;
               	                break;
			   case 5:
				bitrate = 320;
                                break;
			   default:
				cout << "Internal Krabber Error: false xing_vbr"<<QComboBox_xing_ql->currentItem() <<endl;
				exit( -1 );
			};
	  	    }else{
			 bitrate = bitrate_xing[QComboBox_xing_br->currentItem()];
		    };
		    break;
	};

	total_final_size = 0;
	for ( i = 1; i <= todolist->tracks; i++ ){
		total_final_size += (unsigned long) todolist->length_bytes_output(i, dest_bitrate, dest_channels, dest_bits, bitrate) ;
	};

	emit( new_size_info(total_final_size/1024/1024));
	return total_final_size;
}
void KrabWidget::krabwidget_setEnabled( bool flag )
{
	emit enable_widgets( flag );

	if ( !QCheckBox_tempfiles->isChecked() )
		KSlider_smp->setEnabled( flag );

	KSlider_nice->setEnabled( flag );
	QComboBox_encoder->setEnabled( flag );
	QComboBox_bitrate->setEnabled( flag );
	QLineEdit_bitrate_other->setEnabled( flag );
	QComboBox_device->setEnabled( flag );
	QCheckBox_mp3_header->setEnabled( flag );
	QCheckBox_16bit->setEnabled( flag );
	QCheckBox_stereo->setEnabled( flag );
	QCheckBox_jitter->setEnabled( flag );
	QCheckBox_q_resample->setEnabled( flag );
	QCheckBox_clear_list->setEnabled( flag );
	QLabel_smp->setEnabled( flag );
	QLabel_nice->setEnabled( flag );

	QPushButton_cddb_get->blockSignals( 1 );	
	QPushButton_cddb_send->blockSignals( 1 );	
	if ( flag )
	{
		QPushButton_cd->setPixmap( *pix_push_1 );
		QPushButton_outputpath->setPixmap( *pix_push_2 );
		QPushButton_names->setPixmap( *pix_push_3 );
		QPushButton_doit->setPixmap( *pix_push_4 );
		QPushButton_cddb_get->setPixmap( *pix_push_5 );
		QPushButton_cddb_send->setPixmap( *pix_push_6 );
		QPushButton_cddb_get->setOn( 0 );
		QPushButton_cddb_send->setOn( 0 );
	}
	else
	{
		QPushButton_cd->setPixmap( *pix_push_1_off );
		QPushButton_outputpath->setPixmap( *pix_push_2_off );
		QPushButton_names->setPixmap( *pix_push_3_off );
		QPushButton_doit->setPixmap( *pix_push_4_off );
		QPushButton_cddb_get->setPixmap( *pix_push_5_off );
		QPushButton_cddb_send->setPixmap( *pix_push_6_off );
	};
	QPushButton_cddb_send->blockSignals( !flag );
	QPushButton_cddb_get->blockSignals( !flag );
	QPushButton_cd->blockSignals( !flag );
	QPushButton_outputpath->blockSignals( !flag );
	QPushButton_names->blockSignals( !flag );
	QPushButton_doit->blockSignals( !flag );
	KTabListBox_todo->blockSignals( !flag );

	QComboBox_encoder_clicked( -1 ); // if some widgets were shown, but not enabled

	if ( todolist->grab_mode == 0 )
	{
		;
	};
	if ( todolist->grab_mode == 1 )
	{
		QComboBox_lame_br->setEnabled( flag );
		QCheckBox_lame_copyright->setEnabled( flag );
		QCheckBox_lame_original->setEnabled( flag );
		QCheckBox_lame_gui->setEnabled( flag );
		QCheckBox_lame_fast->setEnabled( flag );
	};
	if ( todolist->grab_mode == 2 )
	{
		QComboBox_8hz_br->setEnabled( flag );
		QCheckBox_8hz_copyright->setEnabled( flag );
		QCheckBox_8hz_original->setEnabled( flag );
	};
	if ( todolist->grab_mode == 3 )
	{
		QComboBox_l3_br->setEnabled( flag );
		QCheckBox_l3_hq->setEnabled( flag );
		QCheckBox_l3_crc->setEnabled( flag );
		QCheckBox_l3_speech->setEnabled( flag );
	};
	if ( todolist->grab_mode == 4 )
	{
		QComboBox_mp3_br->setEnabled( flag );
		QComboBox_mp3_ql->setEnabled( flag );
		QCheckBox_mp3_crc->setEnabled( flag );
	};
	if ( todolist->grab_mode == 5 )
	{
		QComboBox_blade_br->setEnabled( flag );
		QCheckBox_blade_copyright->setEnabled( flag );
		QCheckBox_blade_private->setEnabled( flag );
		QCheckBox_blade_crc->setEnabled( flag );
	};
	if ( todolist->grab_mode == 6 )
	{
		QComboBox_encode_ql->setEnabled( flag );
		QComboBox_encode_br->setEnabled( flag );
		QCheckBox_encode_copyright->setEnabled( flag );
		QCheckBox_encode_original->setEnabled( flag );
		QCheckBox_encode_crc->setEnabled( flag );
	};
	if ( todolist->grab_mode == 7 )
	{
		QCheckBox_xing_copyright->setEnabled( flag );
		QCheckBox_xing_original->setEnabled( flag );
		QCheckBox_xing_vbr->setEnabled( flag );
		QCheckBox_xing_nohigh->setEnabled( flag );
		xing_vbr_toggled( flag );
		if ( !flag ){
			QComboBox_xing_ql->setEnabled( 0 );
			QComboBox_xing_br->setEnabled( 0 );
		};
	};

	QCheckBox_tempfiles->setEnabled( flag );

	if ( todolist->grab_mode == 15 )
	{
		KSlider_smp->setEnabled( 0 );
		QCheckBox_tempfiles->setEnabled( 0 );
		QCheckBox_cdr_fix->setEnabled( flag );
		QCheckBox_cdr_dummy->setEnabled( flag );
		QCheckBox_cdr_eject->setEnabled( flag );
		QComboBox_cdr_speed->setEnabled( flag );
		QComboBox_cdr_device->setEnabled( flag );
		QPushButton_cdr_blank->blockSignals( !flag );
		QPushButton_cdr_fix->blockSignals( !flag );
	};
};

void KrabWidget::show_info(){
	unsigned int entry = KTabListBox_todo->currentItem();
	QString string_, convert;

	if ( todolist->tracks>entry ){
		entry++;
		string_ = i18n("Input file/device:") + todolist->data[entry]->device + "\n";
		string_ += i18n("Output Filename:") + todolist->data[entry]->output_filename + "\n\n";
		convert.sprintf( "%i", todolist->data[entry]->input_rate );
		string_ += i18n("Bandwith:") + convert + "\n";
		convert.sprintf( "%i", todolist->data[entry]->input_channels );
		string_ += i18n("Channels:") + convert + "\n";
		convert.sprintf( "%i", todolist->data[entry]->input_bit_per_rate );
		string_ += i18n("Bitdepth:")+ convert+ "\n\n";
		switch ( todolist->data[entry]->type ){
		case 1:	string_ += i18n( "CD-A track\n" );
			convert.sprintf( "%08x", (int) todolist->data[entry]->cddb_discid );
			string_ += i18n("CDDB ID:") + convert + "\n";
//			string_ += i18n("CD INDEX ID:") + todolist->data[entry]->cd_index + "\n";
			break;
		case 2:	string_ += i18n( "MPEG 1 Layer 2\n" );
			convert.sprintf( "%i", todolist->data[entry]->input_compr_bitrate*1000 );
			string_ += i18n( "Compressed Bitrate:" ) + convert+ "\n";
			break;
		case 3:	string_ += i18n("MPEG 1 Layer 3\n" );
			convert.sprintf( "%i", todolist->data[entry]->input_compr_bitrate*1000 );
			string_ += i18n( "Compressed Bitrate:" ) + convert+ "\n";
			break;
		case 4:	string_ += i18n("Wave/RIFF file\n" );
			break;
		case 5:	string_ += i18n("DAT text file\n" );
			break;
		case 6:	string_ += i18n("CDR file\nBandwidth, channels and bitdepths are NOT verified !!!\n" );
			break;
		case 7:	string_ += i18n("RAW file\nBandwidth, channels and bitdepths are NOT verified !!!\n" );
			break;
		case 8:	string_ += i18n("Amiga 8SVX file\n" );
			break;
		case 9:	string_ += i18n("SGI/Apple AIFF file\n" );
			break;
		case 10:string_ += i18n("Sun au file\n" );
			break;
		case 11:string_ += i18n("Amiga maud file\n" );
			break;
		case 12:string_ += i18n("Ircam sf file\n" );
			break;
		case 13:string_ += i18n("smp file (with light compression)\n" );
			break;
		case 14:string_ += i18n("Creative Labs Soundblaster file\n" );
			break;
		case 15:string_ += i18n("cvs file\n" );
			break;
		case 16:string_ += i18n("vms file\n" );
			break;
		case 17:string_ += i18n("DOS sndr file\n" );
			break;
		case 18:string_ += i18n("DOS sndt file\n" );
			break;
		case 19:string_ += i18n("txw file\n" );
			break;
		case 20:string_ += i18n("wve file\n" );
			break;
		case 21:string_ += i18n("Apple hcom file\n" );
			break;
		};
	}else
		string_ = i18n( "Choose an entry first.\n" );
	

#ifdef KDE2
	QMessageBox::information( this, i18n( "Information" ), string_ );
#else
	KMsgBox::message( this, i18n( "Information" ), string_ );
#endif
};

void KrabWidget::QComboBox_encoder_clicked(int n)
{
	if ( !Init ){
		save_config();
		switch ( todolist->grab_mode )	{
		case 0:
			initLayout_wav_del();
			break;
		case 1:
			initLayout_lame_del();
			break;
		case 2:
			initLayout_8hz_del();
			break;
		case 3:
			initLayout_l3_del();
			break;
		case 4:
			initLayout_mp3_del();
			break;
		case 5:
			initLayout_blade_del();
			break;
		case 6:
			initLayout_encode_del();
			break;
		case 7:
			initLayout_xing_del();
			break;
		case 15:
			initLayout_cdrecord_del();
			break;
		case 16:
			initLayout_dat_del();
			break;
		case 17:
			initLayout_cdr_del();
			break;
		case 18:
			initLayout_raw_del();
			break;
		case 19:
			initLayout_svx_del();
			break;
		case 20:
			initLayout_aiff_del();
			break;
		case 21:
			initLayout_au_del();
			break;
		case 22:
			initLayout_maud_del();
			break;
		case 23:
			initLayout_sf_del();
			break;
		case 24:
			initLayout_smp_del();
			break;
		case 25:
			initLayout_voc_del();
			break;
		case 26:
			initLayout_cvs_del();
			break;
		case 27:
			initLayout_vms_del();
			break;
		case 28:
			initLayout_sndr_del();
			break;
		case 29:
			initLayout_sndt_del();
			break;
		case 30:
			initLayout_txw_del();
			break;
		case 31:
			initLayout_wve_del();
			break;
		case 32:
			initLayout_hcom_del();
			break;
		};
	};
	kconfig->sync();
	if (!( n<0 ))				// simple update, after enable the widgets
		todolist->grab_mode = modes[ n ];
	switch ( todolist->grab_mode ){
	case 0 :
		initLayout_wav();
		break;
	case 1 :
		initLayout_lame();
		break;
	case 2 :
		initLayout_8hz();
		break;
	case 3 :
		initLayout_l3();
		break;
	case 4 :
		initLayout_mp3();
		break;
	case 5 :
		initLayout_blade();
		break;
	case 6 :
		initLayout_encode();
		break;
	case 7 :
		initLayout_xing();
		break;
	case 15 :
		initLayout_cdrecord();
		break;
	case 16:
		initLayout_dat();
		break;
	case 17:
		initLayout_cdr();
		break;
	case 18:
		initLayout_raw();
		break;
	case 19:
		initLayout_svx();
		break;
	case 20:
		initLayout_aiff();
		break;
	case 21:
		initLayout_au();
		break;
	case 22:
		initLayout_maud();
		break;
	case 23:
		initLayout_sf();
		break;
	case 24:
		initLayout_smp();
		break;
	case 25:
		initLayout_voc();
		break;
	case 26:
		initLayout_cvs();
		break;
	case 27:
		initLayout_vms();
		break;
	case 28:
		initLayout_sndr();
		break;
	case 29:
		initLayout_sndt();
		break;
	case 30:
		initLayout_txw();
		break;
	case 31:
		initLayout_wve();
		break;
	case 32:
		initLayout_hcom();
		break;
	};
	load_config();
	todolist_update();

	if ( todolist->grab_mode == 15 )
		cdr_check(); // really a good place for this ???
};
void KrabWidget::delete_job( unsigned int nr )
{
	unsigned int i;

	for ( i = nr; i < todolist->tracks; i++){
		todolist->data.insert( i, todolist->data[i+1] );
		todolist->data.remove( i+1 );
	};

	todolist->tracks--;
};

//****************** Arrrg, maybe this is a BIG BUG. the data is stored as pointer.... :-(
const unsigned int KrabWidget::bitrate_8hz[]   = { 32,40,48,56,64,80,96,112,128,160,192,224,256,320 };
const unsigned int KrabWidget::bitrate_blade[] = { 32,40,48,56,64,80,96,112,128,160,192,224,256,320 };
const unsigned int KrabWidget::bitrate_lame[] = { 32,40,48,56,64,80,96,112,128,160,192,224,256,320 };
const unsigned int KrabWidget::bitrate_encode[] = { 32,40,48,56,64,80,96,112,128,160,192,224,256,320 };
const unsigned int KrabWidget::bitrate_l3[]    = { 32,56,64,96,112,128,192,256 };
const unsigned int KrabWidget::bitrate_mp3[]   = { 20,24,32,40,48,56,64,96,112,128,160,192,224,256,320 };
const unsigned int KrabWidget::bitrate_xing[]   = { 32,48,64,96,112,128,160,192,224,256,320 };
const unsigned int KrabWidget::bitrate_mpeg_layer2[]   = { 0,32,48,56,64,80,96,112,128,160,192,224,256,320,384 };
const unsigned int KrabWidget::bitrate_mpeg_layer3[]   = { 0,32,40,48,56,64,80,96,112,128,160,192,224,256,320 };
const unsigned int KrabWidget::bitrate_8hz_max   = 14;
const unsigned int KrabWidget::bitrate_lame_max = 14;
const unsigned int KrabWidget::bitrate_blade_max = 14;
const unsigned int KrabWidget::bitrate_encode_max = 14;
const unsigned int KrabWidget::bitrate_l3_max    = 8;
const unsigned int KrabWidget::bitrate_mp3_max   = 15;
const unsigned int KrabWidget::bitrate_xing_max   = 11;
const char* KrabWidget::format_out[] = { "wav", "mp3", "mp3", "mp3", "mp3", "mp3", "mp3", "mp3", "EMPTY", "EMPTY",
					  "EMPTY", "EMPTY", "EMPTY", "EMPTY", "EMPTY", "cdr", "dat", "cdr", "raw",
					  "8svx", "aiff", "au", "maud", "sf", "smp", "voc", "cvs", "vms", "sndr",
					  "sndt", "txw", "wve", "hcom" };
const char* KrabWidget::format_in[] = { "EMPTY", "CD-A", "mp2", "mp3", "wav", "dat", "cdr", "raw", "8svx",
					  "aiff", "au", "maud", "sf", "smp", "voc", "cvs", "vms", "sndr", "sndt",
					  "txw", "wve", "hcom" };
