/*
	Extension for kcombo(box). if a key is pressed, the widget search the next item
        starts with this character.

	Initialy written for krabber. maybe usefull for other apps.

	http://krabber.automatix.de

	sure, this is under GPL. copyright 1999 by Adrian Schroeter

*/
#include "detect_kde_version.h"

#ifdef KDE2
	#include <kcombo.h>
#endif

#include <config.h>
#include <kcomboext.h>
#include <qlistbox.h>
#include <qkeycode.h>

KComboExt::KComboExt( QWidget* parent, const char* name, WFlags f )
		: KCombo( parent, name, f )
{
	enableSearch = 0;
	searchForw = 1;
};
KComboExt::KComboExt( bool readWrite, QWidget* parent, const char* name, WFlags f ) :
        KCombo( readWrite, parent, name, f)
{
	enableSearch = 0;
	searchForw = 1;
};
void KComboExt::setKeys( bool enable )
{
	enableSearch = enable;
};
void KComboExt::searchForward( bool enable )
{
	searchForw = enable;
};

// reemplentation from the QComboBox class...:
void KComboExt::keyPressEvent( QKeyEvent *event )
{
	int key,
	    max,
	    i = 0,
	    current;
	bool success = 0;
	char *keyS;

	key = event->key();

	QListBox *list = listBox();

	max = list->count();
	current = currentItem();
	
	// the usual cursor key implementation like motif, KCombo or QComboBox
	if ( key == Key_Down ){
		if ( max - 1> current )
			setCurrentItem( ++current );
        	event->accept();
		return;
	};
	if ( key == Key_Up ){
		if (  current > 0)
			setCurrentItem( --current );
	        event->accept();
		return;
	};
	if ( key == Key_Home || key == Key_PageUp ){
		setCurrentItem( 0 );
	        event->accept();
		return;
	};
	if ( key == Key_End || key == Key_PageDown ){
		setCurrentItem( max - 1 );
	        event->accept();
		return;
	};
	if ( key == Key_Space ){ // the one and only which work
		popup();
	        event->accept();
		return;
	};

	if ( autoCompletion() || !enableSearch || key < 1 )
	{
		event->ignore();
		return;
        };
		
	// the search function(the real new function in KComboExt)
	if ( searchForw ) {
		if ( currentItem() < max ) {
			for ( i=currentItem() + 1; i<max ; i++ ) { // from current item to the end of list
#ifdef KDE2
				keyS = (char*) new QString( list->text( i ) );
#else
				keyS = (char*) list->text( i ) ;
#endif
				if ( keyS[0]  == (char) key ) {
					success = 1;
					break;
				};
			};
		};
		if ( !success ) {
			max = currentItem();
			for ( i=0; i<max ; i++ ) {  // if no item was found it start from begin to current item
#ifdef KDE2
				keyS = (char*) new QString( list->text( i ) );
#else
				keyS = (char*) list->text( i );
#endif
				if ( keyS[0] == key ) {
					success = 1;
					break;
				};
			};
		};
	}else{
		if ( currentItem() > 0 ) {
			for ( i=currentItem() - 1; i>-1 ; i-- ) { // from current item to the start of list
#ifdef KDE2
				keyS = (char*) new QString( list->text( i ) );
#else
				keyS = (char*) list->text( i );
#endif
				if ( keyS[0]  == (char) key ) {
					success = 1;
					break;
				};
			};
		};
		if ( !success ) {
			max = currentItem();
			for ( i=list->count()-1; i>max ; i-- ) {  // if no item was found it start from end to current item
#ifdef KDE2
				keyS = (char*) new QString( list->text( i ) );
#else
				keyS = (char*) list->text( i );
#endif
				if ( keyS[0] == key ) {
					success = 1;
					break;
				};
			};
		};
	};

	// TO FIX: (or to wait for qt-2.0) the y-position of the list should be updated...
	if ( success )
		setCurrentItem( i );
	
        event->accept();
};
