#include <krab.h>
#include <kbutton.h>
#include <unistd.h>
#include <sys/types.h>
#include <config.h>
#include <klocale.h>

#ifdef KDE2
	#include <kmenubar.h>
	#include <kstddirs.h>
#endif

Krab::Krab(QWidget *parent, const char *name) :KTopLevelWidget(name)
{
	unsigned int pid;
	QString *temp = new QString( "testing......" ) ;
	playing = 0;

	QPopupMenu *file_menu = new QPopupMenu();
	file_menu->insertItem(i18n("&Select input files"), this, SLOT(select_files()));
	file_menu->insertSeparator();
	file_menu->insertItem(i18n("E&xit"), this, SLOT(quit_krabber()));

	QPopupMenu *help_menu = new QPopupMenu();
	help_menu->insertItem(i18n("&Help"), this, SLOT(invokeHelp()));
	help_menu->insertItem(i18n(i18n ( "&About..." ) ), this, SLOT(aboutme()));

	QPopupMenu *action_menu = new QPopupMenu();
	action_menu->insertItem(i18n(i18n("&Play")), this, SLOT(play_file()));
	action_menu->insertSeparator();
	action_menu->insertItem(i18n(i18n("&Store MP3 TAGs")), this, SLOT(write_tags()));
	action_menu->insertItem(i18n(i18n("&Update filenames")), this, SLOT(update_filenames()));
	action_menu->insertSeparator();
	action_menu->insertItem(i18n(i18n("&Delete All Jobs")), this, SLOT(delete_all()));
	action_menu->insertItem(i18n(i18n("Delete &Job")), this, SLOT(delete_some()));
	action_menu->insertSeparator();
	action_menu->insertItem(i18n(i18n("&Get info about selection")), this, SLOT(info_file()));
	action_menu->insertSeparator();
	action_menu->insertItem(i18n(i18n("&Scan System")), this, SLOT(system_check()));

	QPopupMenu *settings_menu = new QPopupMenu();
	settings_menu->insertItem(i18n(i18n("&Startup Settings")), this, SLOT(settings_start()));
	settings_menu->insertItem(i18n(i18n("&Generic Settings")), this, SLOT(settings_gen()));
	settings_menu->insertItem(i18n(i18n("&CDDB Settings")), this, SLOT(settings_cddb()));

	menuBar = new KMenuBar(this, "menubar");
	menuBar->insertItem(i18n("&File"), file_menu);
	menuBar->insertItem(i18n(i18n("&Action")), action_menu);
	menuBar->insertItem(i18n(i18n("&Settings")), settings_menu);
	menuBar->insertSeparator();
	menuBar->insertItem(i18n("&Help"), help_menu);
	setMenu(menuBar);

	toolBar = new KToolBar(this);
#ifdef KDE2
	toolBar->insertButton( ICON("mini-ofolder.xpm") , 0, SIGNAL( clicked() ), this, SLOT( select_files() ), TRUE, i18n( "Select Files" ) );
	toolBar->insertSeparator();
	toolBar->insertButton( ICON("UP.xpm"), 7, SIGNAL( clicked() ), this, SLOT( highest() ), TRUE, i18n( "highest" ) );
	toolBar->insertButton( ICON("up.xpm"), 8, SIGNAL( clicked() ), this, SLOT( higher() ), TRUE, i18n( "higher" ) );
	toolBar->insertButton( ICON("down.xpm"), 9, SIGNAL( clicked() ), this, SLOT( lower() ), TRUE, i18n( "lower" ) );
	toolBar->insertButton( ICON("DOWN.xpm"), 10, SIGNAL( clicked() ), this, SLOT( lowest() ), TRUE, i18n( "lowest" ) );
	toolBar->insertSeparator();
	toolBar->insertButton( ICON("play.xpm"), 1, SIGNAL( clicked() ), this, SLOT( play_file() ), TRUE, i18n( "Play" ) );
	toolBar->insertSeparator();
	toolBar->insertButton( ICON("mini-cross.xpm"), 2, SIGNAL( clicked() ), this, SLOT( delete_some() ), TRUE, i18n( "Delete Jobs" ) );
	toolBar->insertButton( ICON("cross.xpm"), 3, SIGNAL( clicked() ), this, SLOT( delete_all() ), TRUE, i18n( "Delete All Jobs" ) );
	toolBar->insertSeparator();
	toolBar->insertButton( ICON("tag.xpm"), 4, SIGNAL( clicked() ), this, SLOT( write_tags() ), TRUE, i18n( "Store MP3 TAGs" ) );
	toolBar->insertButton( ICON("rename.xpm"), 5, SIGNAL( clicked() ), this, SLOT( update_filenames() ), TRUE, i18n( "Update filenames" ) );
	toolBar->insertSeparator();
	toolBar->insertButton( ICON("info.xpm"), 6, SIGNAL( clicked() ), this, SLOT( info_file() ), TRUE, i18n( "Get info about selection" ) );
#else
	QString kde_icon_dir = KApplication::kde_icondir();
	QString kde_data_dir = KApplication::kde_datadir();

	QPix_tool_1 = new QPixmap( kde_icon_dir + "/mini/mini-cross.xpm" );
	QPix_tool_2 = new QPixmap( kde_data_dir + "/krabber/pics/cross.xpm" );
	QPix_tool_3 = new QPixmap( kde_icon_dir + "/mini/mini-ofolder.xpm" );
	QPix_tool_4 = new QPixmap( kde_data_dir + "/krabber/pics/tag.xpm" );
	QPix_tool_5 = new QPixmap( kde_data_dir + "/krabber/pics/info.xpm" );
	QPix_tool_6 = new QPixmap( kde_data_dir + "/krabber/pics/play.xpm" );
	QPix_tool_6_act = new QPixmap( kde_data_dir + "/krabber/pics/play_active.xpm" );
	QPix_tool_7 = new QPixmap( kde_data_dir + "/krabber/pics/rename.xpm" );
	QPix_tool_UP = new QPixmap( kde_data_dir + "/krabber/pics/UP.xpm" );
	QPix_tool_up = new QPixmap( kde_data_dir + "/krabber/pics/up.xpm" );
	QPix_tool_down = new QPixmap( kde_data_dir + "/krabber/pics/down.xpm" );
	QPix_tool_DOWN = new QPixmap( kde_data_dir + "/krabber/pics/DOWN.xpm" );

	toolBar->insertButton( *QPix_tool_3 , 0, SIGNAL( clicked() ), this, SLOT( select_files() ), TRUE, i18n( "Select Files" ) );
	toolBar->insertSeparator();
	toolBar->insertButton( *QPix_tool_UP, 7, SIGNAL( clicked() ), this, SLOT( highest() ), TRUE, i18n( "highest" ) );
	toolBar->insertButton( *QPix_tool_up, 8, SIGNAL( clicked() ), this, SLOT( higher() ), TRUE, i18n( "higher" ) );
	toolBar->insertButton( *QPix_tool_down, 9, SIGNAL( clicked() ), this, SLOT( lower() ), TRUE, i18n( "lower" ) );
	toolBar->insertButton( *QPix_tool_DOWN, 10, SIGNAL( clicked() ), this, SLOT( lowest() ), TRUE, i18n( "lowest" ) );
	toolBar->insertSeparator();
	toolBar->insertButton( *QPix_tool_6, 1, SIGNAL( clicked() ), this, SLOT( play_file() ), TRUE, i18n( "Play" ) );
	toolBar->insertSeparator();
	toolBar->insertButton( *QPix_tool_1, 2, SIGNAL( clicked() ), this, SLOT( delete_some() ), TRUE, i18n( "Delete Jobs" ) );
	toolBar->insertButton( *QPix_tool_2, 3, SIGNAL( clicked() ), this, SLOT( delete_all() ), TRUE, i18n( "Delete All Jobs" ) );
	toolBar->insertSeparator();
	toolBar->insertButton( *QPix_tool_4, 4, SIGNAL( clicked() ), this, SLOT( write_tags() ), TRUE, i18n( "Store MP3 TAGs" ) );
	toolBar->insertButton( *QPix_tool_7, 5, SIGNAL( clicked() ), this, SLOT( update_filenames() ), TRUE, i18n( "Update filenames" ) );
	toolBar->insertSeparator();
	toolBar->insertButton( *QPix_tool_5, 6, SIGNAL( clicked() ), this, SLOT( info_file() ), TRUE, i18n( "Get info about selection" ) );
#endif
	addToolBar(toolBar);

	statusBar = new KStatusBar(this);
	setStatusBar(statusBar);
	statusBar->insertItem( "    0MB", 2);
	statusBar->insertItem( i18n ( "Krabber is up !" ), 1);

	pid = getpid();
	temp->setNum( pid );

	tdlist = new TodoList();
	tdlist->tracks     = 0;
	tdlist->grab_mode  = 0;
	tdlist->nr_offset  = 0;
	tdlist->krabber_process_id= *temp;

	view = new KrabWidget(this, "", tdlist);
	setView(view);
	connect( view, SIGNAL(new_status_info(QString)), SLOT(new_status_info_emited(QString)) );
	connect( view, SIGNAL(new_size_info(unsigned int)), SLOT(new_size_info_emited(unsigned int)) );
	connect( view, SIGNAL(enable_widgets(bool)), SLOT(enable_widgets(bool)) );	
  	connect( view, SIGNAL(play_emited()), SLOT(play_file()) );	
  	connect( view, SIGNAL(play_finished_emited()), SLOT(play_finished()) );	

	resize( 675, 502 );
	setMinimumSize( 675, 502 );
	setCaption( "Krabber "VERSION );
	enable_widgets( TRUE );
	enabled = TRUE;

	// checking for the audio device, defined in config.h(.bot)
	FILE *file;
	file = fopen( AUDIO_DEVICE, "w" );
	if ( !file ){
		audio_device = 0;
		toolBar->setItemEnabled( 1, 0 );
		*temp  = AUDIO_DEVICE;
		*temp += i18n ( " not found/not writeable! no play function..." );
		cout << *temp <<endl;
		new_status_info_emited( *temp );
	}else{
		audio_device = 1;
		fclose( file );
	};
};

Krab::~Krab()
{
	delete toolBar;
	delete statusBar;
	delete menuBar;
	delete view;
}

void Krab::new_status_info_emited( QString temp )
{
	statusBar->changeItem( temp, 1);
};
void Krab::new_size_info_emited( unsigned int temp )
{
	QString str2;

	str2.setNum( temp );
	statusBar->changeItem( str2 + "MB", 2);
};
void Krab::play_file()
{
	unsigned int item;
	
	if ( !audio_device )
		return;

	if ( tdlist->tracks > 0 )
	{
		KButton *but = (KButton*) toolBar->getWidget( 1 );
		if ( playing ) {
			playing = 0;
			view->play_finished();
			but->setPixmap( *QPix_tool_6 );
		}else{
			playing = 1;
			item = view->KTabListBox_todo->currentItem();
			view->play_job( item + 1 );
			but->setPixmap( *QPix_tool_6_act );
		};
	};
};
void Krab::play_finished(){
	KButton *but = (KButton*) toolBar->getWidget( 1 );
	if ( playing && view->KTabListBox_todo->currentItem() < (int) (tdlist->tracks-1) ){
		playing = 0;
		view->KTabListBox_todo->setCurrentItem(view->KTabListBox_todo->currentItem()+1);
		play_file();
	}else{
		playing = 0;
		but->setPixmap( *QPix_tool_6 );
	};
};
void Krab::aboutme()
{
	QString tmp;
	tmp  = i18n("Krabber\n\nThis is a frontend for\n  cdparanoia\n  cdrecord\n  sox\n  mpg123\n  and several mp3 encoders\n\nHomepage: http://krabber.automatix.de\n Written by: Adrian Schroeter <krabber@gmx.de>\n");
	tmp += i18n("Translation by\nno mail\n");

	QString tmp2 =  i18n( "About Krabber" );
	        tmp2 += " "VERSION;

#ifdef KDE2
	QMessageBox::information( this, tmp2, tmp );
#else
	KMsgBox::message( this, tmp2, tmp );
#endif
};
void Krab::write_tags()
{
	view->update_tags();
};
void Krab::update_filenames()
{
	view->update_filenames();
};
void Krab::info_file()
{
	view->show_info();
};
void Krab::invokeHelp()
{
	kapp->invokeHTMLHelp("krabber/krabber.html", "");
}

void Krab::delete_all()
{
	if (!enabled)
		return;
	tdlist->tracks = 0;
	tdlist->data.clear();
	view->todolist_update();
};
void Krab::lowest()
{
	unsigned int item;
	
	if (!enabled)
		return;


	if ( tdlist->tracks > 0 )
	{
		item = view->KTabListBox_todo->currentItem();
		if ( item < tdlist->tracks-1 ){
			for( unsigned int i=item+1; i<tdlist->tracks; i++){
				swab_entrys( i, i+1 );
			};

			view->todolist_update();
			view->KTabListBox_todo->blockSignals(1);
			view->KTabListBox_todo->setCurrentItem( tdlist->tracks-1 );
			view->KTabListBox_todo->blockSignals(0);
		};
	};
};
void Krab::lower()
{
	unsigned int item;

	if (!enabled)
		return;

	if ( tdlist->tracks > 0 )
	{
		item = view->KTabListBox_todo->currentItem();
		if ( item < tdlist->tracks-1 ){
			swab_entrys( item+1, item+2 );

			view->todolist_update();
			view->KTabListBox_todo->setCurrentItem( item + 1 );
		};
	};
};
void Krab::highest()
{
	unsigned int item;

	if (!enabled)
		return;

	if ( tdlist->tracks > 0 )
	{
		item = view->KTabListBox_todo->currentItem();
		if ( item >0 ){
			for( unsigned int i=item+1; i>1; i--){
				swab_entrys( i, i-1 );
			};

			view->todolist_update();
			view->KTabListBox_todo->setCurrentItem( 0 );
		};
	};
};
void Krab::higher()
{
	unsigned int item;

	if (!enabled)
		return;

	if ( tdlist->tracks > 0 )
	{
		item = view->KTabListBox_todo->currentItem();
		if ( item >0 ){
			swab_entrys( item, item+1 );

			view->todolist_update();
			view->KTabListBox_todo->setCurrentItem( item - 1 );
		};
	};
};
void Krab::delete_some()
{
	if (!enabled)
		return;
	unsigned int item;
	if ( tdlist->tracks > 0 )
	{
		item = view->KTabListBox_todo->currentItem();
		view->delete_job( item + 1 );
		view->todolist_update();
		if ( tdlist->tracks > item )
			view->KTabListBox_todo->setCurrentItem( item );
		else if ( tdlist->tracks > 0 )
			view->KTabListBox_todo->setCurrentItem( item - 1 );
	};
};
void Krab::enable_widgets( bool on )
{
	enabled = on;
	toolBar->setItemEnabled( 0, on );
	toolBar->setItemEnabled( 1, on );
	toolBar->setItemEnabled( 2, on );
	toolBar->setItemEnabled( 3, on );
	toolBar->setItemEnabled( 4, on );
	toolBar->setItemEnabled( 5, on );
	toolBar->setItemEnabled( 7, on );
	toolBar->setItemEnabled( 8, on );
	toolBar->setItemEnabled( 9, on );
	toolBar->setItemEnabled(10, on );
};
void Krab::system_check()
{
	if (!enabled)
		return;

	view->test_enviroment( TRUE, TRUE );
};
void Krab::select_files()
{
	if (!enabled)
		return;
	view->select_files();
};
void Krab::settings_gen()
{
	if (!enabled)
		return;

	view->configure(1);
};
void Krab::settings_start()
{
	if (!enabled)
		return;

	view->configure(2);
};
void Krab::settings_cddb()
{
	if (!enabled)
		return;

	view->configure(3);
};

void Krab::quit_krabber()
{
	if (!enabled)
		return;
	KApplication::exit();
};
void Krab::swab_entrys(unsigned int i1, unsigned int i2)
{
	Data *d_p_1,
	     *d_p_2;

	d_p_1 = new Data;
	d_p_2 = new Data;

	*d_p_1 = *tdlist->data[i1];
	*d_p_2 = *tdlist->data[i2];
	tdlist->data.remove( i1 );
	tdlist->data.remove( i2 );
	tdlist->data.insert( i1, d_p_2 );
	tdlist->data.insert( i2, d_p_1 );
};
