#ifndef KRAB_H 
#define KRAB_H 

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

#include <kapp.h>
#include <ktopwidget.h>
#include "krabwidget.h"

#ifdef KDE2
#include <qmessagebox.h>
#else
#include <kmsgbox.h>
#endif

class Krab : public KTopLevelWidget
{
	Q_OBJECT
public:
	Krab(QWidget *parent = 0, const char *name = 0);
	virtual ~Krab();
	KrabWidget *view;

protected slots:
	void quit_krabber();
	void enable_widgets( bool );
	void invokeHelp();
	void aboutme();
	void new_status_info_emited(QString);
	void new_size_info_emited(unsigned int);
	void delete_all();
	void delete_some();
	void settings_gen();
	void settings_start();
	void settings_cddb();
	void select_files();
	void write_tags();
	void update_filenames();
	void info_file();
	void system_check();
	void play_file();
	void play_finished();
	void highest();
	void higher();
	void lower();
	void lowest();
	void swab_entrys( unsigned int, unsigned int );

private:
	TodoList   *tdlist;
	KMenuBar   *menuBar;
	QPopupMenu *file_menu;
	KStatusBar *statusBar;
	KToolBar   *toolBar;
	QPixmap    *QPix_tool_1;
	QPixmap    *QPix_tool_2;
	QPixmap    *QPix_tool_3;
	QPixmap    *QPix_tool_4;
	QPixmap    *QPix_tool_5;
	QPixmap    *QPix_tool_6;
	QPixmap    *QPix_tool_6_act;
	QPixmap    *QPix_tool_7;
	QPixmap    *QPix_tool_up;
	QPixmap    *QPix_tool_UP;
	QPixmap    *QPix_tool_DOWN;
	QPixmap    *QPix_tool_down;
	bool enabled,
             playing,
	     audio_device;
};

#endif // KRAB_H 
