// Some lines of this code had been taken from kscd: (thanks to bernd wuebben)

// this file makes sometimes (and only sometimes) trouble with egcs 1.1.1 (with my machine)
// gcc 2.8.1 has less problems... no idea why yet

#include <qdir.h>              // must be the first #include line (or gcc 2.7.x has problems)
#include <qtabdialog.h>

#include <krabwidget.h>
#include <PrefGeneric.h>
#include <PrefStartup.h>

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <math.h>
#include <qtextstream.h>

void KrabWidget::put_cddb_local()
{
	unsigned  int i, j;
	bool      flag[todolist->tracks+1];
	QString   temp,
		  interpret,
		  album;

	for ( i=1; i<=todolist->tracks; i++ )
		flag[i] = FALSE;

	for ( i=1; i<=todolist->tracks; i++ )
	{
		if ( flag[i] == FALSE && todolist->data[i]->type == 1 )
		{
			unsigned int fields = todolist->data[i]->tracks_on_cd+1;
			bool data_present = 0;
		  	QString  titles_[fields+1],
		  		 extl_[fields+1];
		  	const char  *titles[fields+1],
		  		    *extl[fields+1];
			_cddb_data.magicID   = todolist->data[i]->cddb_discid;
                        _cddb_data.tracks    = todolist->data[i]->tracks_on_cd;
                        _cddb_data.absframe  = todolist->data[i]->frames_on_cd;
			_cddb_data.o_frame   = todolist->data[i]->o_frame;
			_cddb_data.revision  = 0;

			for ( j=0; j<=(fields+1); j++)
			{
				titles[j] = empty;
				extl[j] = empty;
			};

			// Get present data
			cddb_remote_jobnr = 0;
			if ( get_cddb_info_local() )
			{
			  data_present = 1;
			  for ( j = 0; j<fields; j++ )
			  {
				const char *t1 = _cddb_data.titlelist.at(j);
				titles_[j]     = t1;
				const char *t2 = _cddb_data.extlist.at(j);
				extl_[j]       = t2;
				titles[j]      = titles_[j];
				extl[j]        = extl_[j];
			  };
			};
			// add or change to new data
			_cddb_data.category  = todolist->CDDBcateg[todolist->MP3_2_CDDBcateg[todolist->data[i]->music_type]];
			QString temp_;
			if ( todolist->data[i]->group.isEmpty() )
				temp_ = "";
			else
				temp_  = todolist->data[i]->group;
			if ( todolist->data[i]->album.isEmpty() )
				temp_ += "/ ";
			else
				temp_ += "/" + todolist->data[i]->album;
			titles[0]            = temp_;
			extl[0]              = empty;

			for ( j=i; j<=todolist->tracks; j++ )
			  if ( todolist->data[i]->cddb_discid == todolist->data[j]->cddb_discid )
			  {
				flag[j] = TRUE;
				if (todolist->data[j]->title.isEmpty())
				{
					if ( !data_present )
						titles[todolist->data[j]->tracknumber] = empty;
				}
				else
					titles[todolist->data[j]->tracknumber] = todolist->data[j]->title;

				if (todolist->data[j]->comment.isEmpty())
				{
					if ( !data_present )
						extl[todolist->data[j]->tracknumber] = "";
				}
				else
					extl[todolist->data[j]->tracknumber] = todolist->data[j]->comment;
                          };
		        _cddb_data.titlelist.clear();
		        _cddb_data.extlist.clear();
			for ( j=0; j<=todolist->data[i]->tracks_on_cd; j++)
			{
				_cddb_data.titlelist.append( titles[j] );
				_cddb_data.extlist.append( extl[j] );
			};
			QString temp2 = "XX";
                        temp2.setNum( todolist->data[i]->music_type );
			_cddb_data.mp3_year  = todolist->data[i]->year;
			_cddb_data.mp3_categ = temp2;
			// write data
			QString magic;
			magic.sprintf("%08x", (int)_cddb_data.magicID );
			QString file_name = cddb_config.cddbbasedir + "/" + _cddb_data.category;
			QFile *qdir;
			qdir = new QFile(file_name);
			if ( !qdir->exists() )
			{
				new_status_info( i18n( "Not able to read the CDDB directory..." ) );
				return;
			};
			delete qdir;
			file_name +=   "/" + magic;
			if (put_cddb_info( file_name, 0 ))
				new_status_info( i18n( "local CDDB entry written..." ) );
		};
	};

};
bool KrabWidget::put_cddb_info( QString file_name, bool remote)
{
	QString magic;
	magic.sprintf("%08x", (int)_cddb_data.magicID );

	_cddb_data.discidlist.clear();
	_cddb_data.discidlist.insert(0,magic.data());

	QFile file(file_name);
	if( !file.open( IO_WriteOnly  ))
	{
		QString str;
		str.sprintf(
			i18n("Unable to write to file:\n%s\nPlease check "\
			"your permissions and make your category directories exist."),
			((const char*)(file_name)));
#ifdef KDE2
		QMessageBox::warning(this,
			 i18n("Krabber Error"),
			 str.data()
			 );
#else
		KMsgBox::message(this,
			 i18n("Krabber Error"),
			 str.data()
			 );
#endif
		return 0;
	};

	QStrList returnlist;
	QString tmp, tmp2, datestr;
	QTextStream t(&file);

	t << "# xmcd CD database file\n";
	t << "#\n";
	t << "# Extensions for Krabber\n";
	t << "# MP3 Category Nr:"<< _cddb_data.mp3_categ<<"\n";
	t << "# Year:"<<_cddb_data.mp3_year<<"\n";
	t << "#\n";
	datestr = QDateTime::currentDateTime().toString();
	tmp = tmp.sprintf("# Generated: %s by Krabber\n",datestr.data());
	t << tmp.data();
	t << "# \n";
	t << "# Track frame offsets:\n";

	for(unsigned int i = 0 ; i < _cddb_data.tracks;i ++)
	{
		tmp = tmp.sprintf("#       %d\n", _cddb_data.o_frame.frame[i] );
		t << tmp.data();
	};

	t << "#\n";
	tmp = tmp.sprintf("# Disc length: %d seconds\n", (int) (_cddb_data.absframe/75) );
	t << tmp.data();
	t << "#\n";
	if (remote)
		tmp = tmp.sprintf("# Revision: %d\n",++_cddb_data.revision);
	else
		tmp = tmp.sprintf("# Revision: %d\n",_cddb_data.revision);
	t << tmp.data();
	t << "# Submitted via: Krabber "VERSION"\n";
	t << "#\n";

	tmp = "DISCID=";
	int counter = 0;

	for(int i = 0 ; i < (int)_cddb_data.discidlist.count();i ++)
	{
		tmp += _cddb_data.discidlist.at(i);
		if( i < (int) _cddb_data.discidlist.count() - 1)
		{
			if( counter++ == 3 )
			{
				tmp += "\nDISCID=";
				counter = 0;
			}
			else
				tmp += ",";
		};
	};
	tmp += "\n";
	t << tmp.data();

	tmp2 = (_cddb_data.titlelist.at(0));
	cddb_encode( tmp2, returnlist );
	if(returnlist.count() == 0)
	{
		// sanity provision
		tmp = tmp.sprintf("DTITLE=%s\n","");
		t << tmp.data();
	}
	else
	{
		for(int i = 0; i < (int) returnlist.count();i++)
		{
			tmp = tmp.sprintf("DTITLE=%s\n",returnlist.at(i));
			t << tmp.data();
		}
	};

	for(int i = 1 ; i <= (int)_cddb_data.tracks;i ++)
	{
		tmp2 = (_cddb_data.titlelist.at(i));
		cddb_encode(tmp2,returnlist);
		if(returnlist.count() == 0)
		{
			// sanity provision
			tmp = tmp.sprintf("TTITLE%d=%s\n",i-1,"");
			t << tmp.data();
		}
		else
		{
			for(int j = 0; j < (int) returnlist.count();j++)
			{
				tmp = tmp.sprintf("TTITLE%d=%s\n",i-1,returnlist.at(j));
				t << tmp.data();
			}
		}
	};
	file.flush();
	tmp2 = (_cddb_data.extlist.at(0));
	cddb_encode(tmp2,returnlist);

	if(returnlist.count() == 0)
	{
		// sanity provision
		tmp = tmp.sprintf("EXTD=%s\n","");
		t << tmp.data();
	}
	else
	{
		for(int i = 0; i < (int) returnlist.count();i++)
		{
			tmp = tmp.sprintf("EXTD=%s\n",(returnlist.at(i)) );
			t << tmp.data();
		};
	};

	for(int i = 1 ; i <= (int) _cddb_data.tracks;i ++)
	{
		tmp2 = (_cddb_data.extlist.at(i));
		cddb_encode(tmp2,returnlist);
		if(returnlist.count() == 0)
		{
			// sanity provision
			tmp = tmp.sprintf("EXTT%d=%s\n",i-1,"");
			t << tmp.data();
		}
		else
		{
			for(int j = 0; j < (int) returnlist.count();j++)
			{
				tmp = tmp.sprintf("EXTT%d=%s\n",i-1,(returnlist.at(j)));
				t << tmp.data();
			}
		}
	};

	cddb_playlist_encode( _cddb_data.playlist, tmp2);
	cddb_encode( tmp2, returnlist);
	for(int i = 0; i < (int) returnlist.count();i++)
	{
		tmp = tmp.sprintf("PLAYORDER=%s\n",returnlist.at(i));
		t << tmp.data();
	}

	t << "\n";

	file.close();
	chmod(file.name(), S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH );

	return 1; // success
};

void KrabWidget::get_cddb( bool force_remote = 0 )
{
	bool      flag[todolist->tracks + 1];
	QString   temp,
		  interpret,
		  album;

	unsigned int i;
	i=0;

	for ( i=1; i<=todolist->tracks; i++ )
		flag[i] = FALSE;

	for ( i=1; i<=todolist->tracks; i++ )
	{
		if ( flag[i] == FALSE && todolist->data[i]->type == 1 )
		{
			_cddb_data.magicID   = todolist->data[i]->cddb_discid;
                        _cddb_data.tracks    = todolist->data[i]->tracks_on_cd;
                        _cddb_data.absframe  = todolist->data[i]->frames_on_cd;
			_cddb_data.o_frame   = todolist->data[i]->o_frame;

			cddb_remote_jobnr    = 0;
			if ( get_cddb_info_local() )
			{
			  new_status_info( i18n( "local CDDB entry found..." ) );
			  temp = _cddb_data.titlelist.at(0);
			  interpret = temp.left( temp.find("/") );
			  album = temp.mid( temp.find("/") + 1, 256  );  //.right did not work...
                          interpret = interpret.stripWhiteSpace();
                          album = album.stripWhiteSpace();

			  for ( unsigned int j = i; j<=(todolist->tracks); j++ )
			  {
			    if (  todolist->data[i]->cddb_discid == todolist->data[j]->cddb_discid
				&& !todolist->data[j]->cddb_disable )
			    {
				flag[j] = TRUE;
				todolist->data[j]->cddb_disable = 1;
				todolist->data[j]->title   = _cddb_data.titlelist.at(todolist->data[j]->tracknumber);
				todolist->data[j]->comment = _cddb_data.extlist.at(todolist->data[j]->tracknumber);
				todolist->data[j]->group   = interpret;
				todolist->data[j]->album   = album;
				if ( _cddb_data.mp3_year.isEmpty() )
					todolist->data[j]->year = "";
				else
					todolist->data[j]->year = _cddb_data.mp3_year;
				unsigned int number = 256;
                                if ( !_cddb_data.mp3_categ.isEmpty() )
				{
					number = 0;
					const char *temp_p = _cddb_data.mp3_categ;
					for ( unsigned int h=0; h<=6 ; h++)
					{
						if ( *temp_p >= 48 &&  *temp_p <=57 )
							number += *temp_p++ + number + (number<<3) - 48;
						else
							temp_p++;
					};
				};
	                        todolist->data[j]->music_type = number;
			    };
			  };
			}
			else
			{
				if ( cddb_config.cddb_remote_enabled )
					force_remote = 1;
				for ( unsigned int j = i; j<=todolist->tracks; j++ )
					if (  todolist->data[i]->cddb_discid == todolist->data[j]->cddb_discid )
						flag[j] = TRUE;
			};
			if ( force_remote == 1 )
			{
				get_cddb_info_remote( i );
				return;
			};
		};
	};
};
void KrabWidget::get_cddb_info_remote( unsigned int begin_job )
{
	static int connected = 0;
	cddb_remote_jobnr = begin_job;
	QStrList pathlist;

	get_pathlist(pathlist);
	cddb.setBaseDir(cddb_config.cddbbasedir);
	cddb.setPathList(pathlist);

	for ( unsigned int i=begin_job; i<=todolist->tracks; i++ )
	{
		if ( todolist->data[i]->type == 1 )
		{
			_cddb_data.magicID   = todolist->data[i]->cddb_discid;
                        _cddb_data.tracks    = todolist->data[i]->tracks_on_cd;
                        _cddb_data.absframe  = todolist->data[i]->frames_on_cd;
			_cddb_data.o_frame   = todolist->data[i]->o_frame;

			if(!connected){
				connect(&cddb,SIGNAL(cddb_ready()),this,SLOT(cddb_ready()));
				connect(&cddb,SIGNAL(cddb_failed()),this,SLOT(cddb_failed()));
				connect(&cddb,SIGNAL(cddb_done()),this,SLOT(cddb_done()));
				connect(&cddb,SIGNAL(cddb_timed_out()),this,SLOT(cddb_timed_out()));
				connect(&cddb,SIGNAL(cddb_inexact_read()),this,SLOT(mycddb_inexact_read()));
				connect(&cddb,SIGNAL(cddb_no_info()),this,SLOT(cddb_no_info()));
				connected = 1;
			};

			krabwidget_setEnabled( 0 );
			QPushButton_cddb_get->blockSignals( 1 );
			QPushButton_cddb_get->setOn( 1 );
			QPushButton_cddb_get->blockSignals( 0 );
			new_status_info( i18n( "Try to connect with CDDB server..." ) );
			cddb.cddb_connect(cddb_config.current_server);
			return;
		};
	};
};

bool KrabWidget::get_cddb_info_local() // from kscd with MAJOR changes:
{
	QFile *qdir;
	qdir = new QFile(cddb_config.cddbbasedir);
	if ( !qdir->exists() )
	{
		new_status_info( i18n( "Not able to read the CDDB directory..." ) );
		return 0;
	};
	delete qdir;

	QStrList pathlist;

	get_pathlist(pathlist);
	cddb.setBaseDir(cddb_config.cddbbasedir);
	cddb.setPathList(pathlist);

	bool res = cddb.local_query(
		_cddb_data.magicID,
		_cddb_data.data,
		_cddb_data.titlelist,
		_cddb_data.extlist,
		_cddb_data.category,
		_cddb_data.discidlist,
		_cddb_data.revision,
		_cddb_data.playlist,
		_cddb_data.mp3_categ,
		_cddb_data.mp3_year
	);

	if( !res )
	{
		cddb_no_info();
		return (res) ;
	};

       	if(_cddb_data.titlelist.count() != (_cddb_data.tracks + 1))
		printf("WARNING LOCAL QUERY tracktitleslist.count = %d != cd->ntracks +1 = %d\n",
               		_cddb_data.titlelist.count(),_cddb_data.tracks + 1);
        if(_cddb_data.extlist.count() != (_cddb_data.tracks + 1))
		printf("WARNING LOCAL QUERYextlist.count = %d != cd->ntracks +1 = %d\n",
                          _cddb_data.extlist.count(),_cddb_data.tracks + 1);

	return 1;
};

void KrabWidget::cddb_ready()
{
	QString num;

	_cddb_data.querylist.clear();
	_cddb_data.titlelist.clear();
	_cddb_data.extlist.clear();
	_cddb_data.discidlist.clear();

	for(unsigned int i = 0 ; i < _cddb_data.tracks; i++)
		_cddb_data.querylist.append(num.sprintf("%d", _cddb_data.o_frame.frame[i]));

	_cddb_data.querylist.append(num.sprintf("%d", (int) _cddb_data.absframe/75));
	cddb_inexact_sentinel = false;
	cddb.queryCD(_cddb_data.magicID, _cddb_data.querylist);
};

void KrabWidget::cddb_no_info()// from kscd with minor changes:
{
	_cddb_data.titlelist.clear();
	_cddb_data.titlelist.append("");
	for(unsigned int i = 0 ; i < _cddb_data.tracks; i++)
		_cddb_data.titlelist.append("");

	_cddb_data.extlist.clear();
	for(unsigned int i = 0 ; i <= _cddb_data.tracks; i++)
		_cddb_data.extlist.append("");

	_cddb_data.discidlist.clear();

	cddb_inexact_sentinel =false;
	if ( cddb_remote_jobnr != 0 )
		for ( unsigned j = cddb_remote_jobnr; j<(todolist->tracks); j++ )
			if (  todolist->data[cddb_remote_jobnr]->cddb_discid != todolist->data[j]->cddb_discid && todolist->data[j]->type == 1 )
			{
				new_status_info( i18n( "CDDB query NOT successful, starting next query..." ) );
				get_cddb_info_remote( j );
				return;
			};
	new_status_info( i18n( "CDDB query NOT successful..." ) );
	krabwidget_setEnabled( 1 );
}

void KrabWidget::cddb_failed()// from kscd with minor changes:
{
	// TODO differentiate between those casees where the communcition really
	// failed and those where we just couldn't find anything
	new_status_info( i18n( "Error while getting CDDB entry." ) );

	_cddb_data.titlelist.clear();
	_cddb_data.titlelist.append(i18n("Error while getting CDDB entry."));
	for(unsigned int i = 0 ; i < _cddb_data.tracks; i++)
		_cddb_data.titlelist.append("");

	_cddb_data.extlist.clear();
	for(unsigned int i = 0 ; i <= _cddb_data.tracks; i++)
		_cddb_data.extlist.append("");

	_cddb_data.discidlist.clear();

	cddb_inexact_sentinel =false;

	if ( cddb_remote_jobnr != 0 )
		for ( unsigned j = cddb_remote_jobnr; j<(todolist->tracks); j++ )
			if (  todolist->data[cddb_remote_jobnr]->cddb_discid != todolist->data[j]->cddb_discid && todolist->data[j]->type == 1 )
			{
				new_status_info( i18n( "CDDB query NOT successful, starting next query..." ) );
				get_cddb_info_remote( j );
				return;
			};
	new_status_info( i18n( "CDDB query NOT successful..." ) );
	krabwidget_setEnabled( 1 );
}

void KrabWidget::cddb_timed_out()// from kscd with minor changes:
{
	new_status_info( i18n( "CDDB query timed out." ) );

	_cddb_data.titlelist.clear();
	_cddb_data.titlelist.append(i18n("CDDB query timed out."));
	for(unsigned int i = 0 ; i <= _cddb_data.tracks; i++)
		_cddb_data.titlelist.append("");

	_cddb_data.extlist.clear();
	for(unsigned int i = 0 ; i <= _cddb_data.tracks; i++)
		_cddb_data.extlist.append("");

	_cddb_data.discidlist.clear();

	cddb_inexact_sentinel =false;

	new_status_info( i18n( "CDDB server did not response..." ) );
	krabwidget_setEnabled( 1 );
}

void KrabWidget::mycddb_inexact_read()// from kscd with minor changes:
{
/*	if(cddb_inexact_sentinel == true)
		return;

	cddb_inexact_sentinel = true;
	QStrList inexact_list;
	cddb.get_inexact_list(inexact_list);

	InexactDialog *dialog;
	dialog = new InexactDialog(0,"inexactDialog",true);
	dialog->insertList(inexact_list);

	if(dialog->exec() != QDialog::Accepted){
		cddb.close_connection();
	        return;
	};

	QString pick;
	dialog->getSelection(pick);
	delete dialog;


	if(pick.isEmpty())
		return;

	pick = "200 " + pick;
	cddb.query_exact(pick);
*/
};

void KrabWidget::cddb_done()// from kscd with lots of changes:
{
	QString   temp,
		  interpret,
		  album;

	cddb_inexact_sentinel =false;

	cddb.getData(_cddb_data.data,_cddb_data.titlelist,_cddb_data.extlist,
		_cddb_data.category,_cddb_data.discidlist,
		_cddb_data.revision,_cddb_data.playlist,
		_cddb_data.mp3_categ,_cddb_data.mp3_year);

	if(_cddb_data.titlelist.count() != (_cddb_data.tracks + 1))
	{
		printf("WARNING tracktitleslist.count = %d != cd->ntracks +1 = %d\n",
        	_cddb_data.titlelist.count(),_cddb_data.tracks + 1);
	};

	if(_cddb_data.extlist.count() != (_cddb_data.tracks + 1))
	{
		printf("WARNING extlist.count = %d != cd->ntracks +1 = %d\n",
		_cddb_data.extlist.count(),_cddb_data.tracks + 1);
	};

	temp = _cddb_data.titlelist.at(0);
	interpret = temp.left( temp.find("/") );
	album = temp.mid( temp.find("/") + 1, 256  );  //.right did not work...
        interpret = interpret.stripWhiteSpace();
        album = album.stripWhiteSpace();

	for ( unsigned j = cddb_remote_jobnr; j<=(todolist->tracks); j++ )
		if (  todolist->data[cddb_remote_jobnr]->cddb_discid == todolist->data[j]->cddb_discid && todolist->data[j]->type == 1)
		{
			todolist->data[j]->cddb_disable = 1;
			todolist->data[j]->title      = _cddb_data.titlelist.at(todolist->data[j]->tracknumber);
			todolist->data[j]->comment    = _cddb_data.extlist.at(todolist->data[j]->tracknumber);
			todolist->data[j]->title      = todolist->data[j]->title.stripWhiteSpace();
			todolist->data[j]->comment    = todolist->data[j]->comment.stripWhiteSpace();
			todolist->data[j]->group      = interpret;
			todolist->data[j]->album      = album;
			if ( _cddb_data.mp3_year.isEmpty() )
				todolist->data[j]->year = "";
			else
				todolist->data[j]->year = _cddb_data.mp3_year;
			unsigned int number = 256;
                               if ( !_cddb_data.mp3_categ.isEmpty() )
			{
				number = 0;
				const char *temp_p = _cddb_data.mp3_categ;
				for ( unsigned int h=0; h<=6 ; h++)
				{
					if ( *temp_p >= 48 &&  *temp_p <=57 )
						number += *temp_p++ + number + (number<<3) - 48;
					else
						temp_p++;
				};
			};
                        todolist->data[j]->music_type = number;
		};

	bool known_categ = 0;
	for ( unsigned int j = 0; j<NR_CDDB_CATEG; j++ )
		if ( _cddb_data.category == todolist->CDDBcateg[j] )
		{
			known_categ = 1;
			break;
		};

	QString magic, file_name;
	magic.sprintf("%08x", (int)_cddb_data.magicID );
	if ( known_categ )
		file_name = cddb_config.cddbbasedir + "/" + _cddb_data.category + "/" + magic;
	else
		file_name = cddb_config.cddbbasedir + "/misc/" + magic;

	(void) put_cddb_info( file_name, 0 );
	todolist_update();

	if ( cddb_remote_jobnr != 0 ){
		unsigned j = 0;
		for ( j = cddb_remote_jobnr; j<(todolist->tracks); j++ )
			if (  todolist->data[cddb_remote_jobnr]->cddb_discid != todolist->data[j]->cddb_discid && todolist->data[j]->type == 1 )
			{
				new_status_info( i18n( "CDDB query successful, starting next query..." ) );
				get_cddb_info_remote( j );
				return;
			};
	};
	new_status_info( i18n( "CDDB query successful..." ) );
	krabwidget_setEnabled( 1 );
}

void KrabWidget::get_pathlist(QStrList& _pathlist)// from kscd with minor changes:
{
	QDir d;
	QStrList list;

	d.setFilter( QDir::Dirs);
	d.setSorting( QDir::Size);
	d.setPath(cddb_config.cddbbasedir);
	if ( !d.exists() )
		return;

	_pathlist.clear();
#ifdef KDE2
	list = d.encodedEntryList();
#else
	list = *d.entryList();
#endif

	for(uint i = 0; i < list.count(); i++)
		if(QString(list.at(i)) != QString (".") && QString(list.at(i)) != QString (".."))
			_pathlist.append( QString (cddb_config.cddbbasedir + "/" +  list.at(i)));
};

void KrabWidget::configure(unsigned int page)
{
	QString server_copy, tmp, temp2;
//	QTabDialog *tabdialog;

	if ( tabdialog )
		{ cout <<"tabdialog BUG workaround"<<endl;return; }

	tabdialog = new QTabDialog(0,"tabdialog",TRUE);
	tabdialog->setCaption( i18n("Krabber Configuration") );
	tabdialog->resize(559, 512);
	tabdialog->setCancelButton( i18n("Cancel") );

	QWidget *about = new QWidget(tabdialog,"about");
	QGroupBox *box = new QGroupBox(about,"box");
	QLabel  *label = new QLabel(box,"label");

	box->setGeometry(10,10,520,420);

	tmp  = i18n( "This Application is under the GPL\n"\
                    "copyright 1998-1999 Adrian Schroeter\n" );
	tmp += "\n";
	tmp += i18n( "Translation by\nno mail\n" );
	tmp += "\n";
	tmp += i18n( "Special thanks to:\n Bernd Wuebben and\n"\
		    " Sam Malony (They have written main parts of the CDDB code)\n");
 	tmp += "\n";
	tmp += i18n( "Chris Rigby and his friend (for the icons)\n" );
 	tmp += "\n";
	tmp += i18n( "and everybody else, who wanted to help me !\n" );
 	tmp += "\n";
	temp2.setNum( kconfig->readUnsignedLongNumEntry( "total_counter", 0 ) );
	tmp += temp2;
	tmp += i18n( " megabytes of raw music data had been converted !\n" );

	label->setGeometry(20,20,390,390);
	label->setAlignment( AlignCenter);
	label->setAlignment(AlignLeft|WordBreak|ExpandTabs);
	label->setText( tmp );

	smtpconfig = new SMTPConfig(tabdialog, "smtpconfig", &cddb_config.smtpConfigData);
	cddb_setup = new CDDBSetup();
	PrefGeneric *generic    = new PrefGeneric();
	PrefStartup *startup    = new PrefStartup();

	connect(cddb_setup,SIGNAL(updateCDDBServers()),this,SLOT(getCDDBservers()));
	connect(cddb_setup,SIGNAL(updateCurrentServer()),this,SLOT(updateCurrentCDDBServer()));

	tabdialog->addTab(startup, i18n("Startup Options"));
	tabdialog->addTab(generic, i18n("Generic Options"));
	tabdialog->addTab(cddb_setup,"CDDB");
	tabdialog->addTab(smtpconfig, i18n("SMTP Setup"));
	tabdialog->addTab(about, i18n("About") );

	cddb_setup->insertData(cddb_config.cddbserverlist,
               	       	       cddb_config.cddbsubmitlist,
                               cddb_config.cddbbasedir,
       	                       cddb_config.submitaddress,
               	               cddb_config.current_server,
                               cddb_config.cddb_remote_enabled,
       	                       cddb.useHTTPProxy(),
       	                       cddb.getHTTPProxyHost(),
       	                       cddb.getHTTPProxyPort()
       	);

	startup->CheckBox_startUp_syscheck->setChecked( krabber_config.testOnStartup );
	startup->QLineEdit_scan_device->setText( krabber_config.scan_device );
	generic->CheckBox_readAll->setChecked( krabber_config.readall );
	generic->CheckBox_Capital_filename->setChecked( krabber_config.outputfilename_capital );
	generic->CheckBox_replace->setChecked( krabber_config.outputfilename_replace );
	const char *from_p = krabber_config.outputfilename_replace_from;
	const char *to_p   = krabber_config.outputfilename_replace_to;
	generic->LineEdit_replace1->setText( from_p );
	generic->LineEdit_replace2->setText( to_p );

	if ( krabber_config.mp3tag_version == 0 )
		generic->RadioButton_tag_v1->setChecked( TRUE );
	if ( krabber_config.mp3tag_version == 1 )
		generic->RadioButton_tag_v11->setChecked( TRUE );
	if ( krabber_config.mp3tag_version == 2 )
		generic->RadioButton_tag_v2->setChecked( TRUE );
        if ( page == 1 )
		tabdialog->showPage( startup );
        if ( page == 2 )
		tabdialog->showPage( generic );
        if ( page == 3 )
		tabdialog->showPage( cddb_setup );
        if ( page == 4 )
		tabdialog->showPage( smtpconfig );
        if ( page == 5 )
		tabdialog->showPage( about );

	if( tabdialog->exec() == QDialog::Accepted )
	{
// ******************************* Generic Prefs:
		krabber_config.testOnStartup 			= startup->CheckBox_startUp_syscheck->isChecked();
		krabber_config.readall 				= generic->CheckBox_readAll->isChecked();
		krabber_config.outputfilename_capital 		= generic->CheckBox_Capital_filename->isChecked();
		krabber_config.outputfilename_replace		= generic->CheckBox_replace->isChecked();
		krabber_config.outputfilename_replace_from 	= generic->LineEdit_replace1->text( );
		krabber_config.outputfilename_replace_to	= generic->LineEdit_replace2->text( );
		krabber_config.scan_device			= startup->QLineEdit_scan_device->text();
		if ( generic->RadioButton_tag_v1->isChecked() )
			krabber_config.mp3tag_version = 0;
		if ( generic->RadioButton_tag_v11->isChecked() )
			krabber_config.mp3tag_version = 1;
		if ( generic->RadioButton_tag_v2->isChecked() )
			krabber_config.mp3tag_version = 2;

// *******************************           CDDB Pref.
	        smtpconfig->commitData();

		bool    cddb_proxy_enabled;
		QString cddb_proxy_host;
		int     cddb_proxy_port;

		cddb_setup->getData(cddb_config.cddbserverlist,
                	       	    cddb_config.cddbsubmitlist,
	                            cddb_config.cddbbasedir,
        	                    cddb_config.submitaddress,
                	            cddb_config.current_server,
	                            cddb_config.cddb_remote_enabled,
        	                    cddb_proxy_enabled,
                	            cddb_proxy_host,
	                            cddb_proxy_port
        	);

	        cddb.setHTTPProxy(cddb_proxy_host, cddb_proxy_port);
        	cddb.useHTTPProxy(cddb_proxy_enabled);
	}
	else
        	cddb_config.current_server = server_copy.copy();

	disconnect(cddb_setup,SIGNAL(updateCDDBServers()),this,SLOT(getCDDBservers()));
	disconnect(cddb_setup,SIGNAL(updateCurrentServer()),this,SLOT(updateCurrentCDDBServer()));

	delete startup;
	startup = NULL;
	delete generic;
	generic = NULL;
	delete cddb_setup;
	cddb_setup = NULL;
	delete smtpconfig;
	smtpconfig = NULL;
	delete about;
	delete tabdialog;
	tabdialog = 0;

	todolist_update();
};


void KrabWidget::smtpMessageSent(void)
{
	for ( unsigned j = cddb_remote_jobnr; j<(todolist->tracks); j++ )
		if (  todolist->data[cddb_remote_jobnr]->cddb_discid != todolist->data[j]->cddb_discid && todolist->data[j]->type == 1 )
		{
			new_status_info( i18n( "CDDB data is posted successful, post next..." ) );
			put_cddb_remote( j );
			return;
		};
	new_status_info( i18n( "All CDDB data is posted successful ..." ) );
	krabwidget_setEnabled( 1 );
}

void KrabWidget::smtpError(int errornum)
{
	switch(errornum)
	{
	case 10:
		emit( new_status_info(i18n("Error connecting to server.")));
	        break;
	case 11:
		emit( new_status_info(i18n("Not connected.")));
		break;
	case 15:
		emit( new_status_info(i18n("Connection timed out.")));
		break;
	case 16:
		emit( new_status_info(i18n("Time out waiting for server interaction.")));
	        break;
	default:
		emit( new_status_info(i18n("Server failure...")));
	};
}

void KrabWidget::updateCurrentCDDBServer()
{
	if(cddb_setup)
		cddb_setup->getCurrentServer(cddb_config.current_server);
}

void KrabWidget::getCDDBservers()
{
	emit( new_status_info(i18n("Reading server list...")));
    // Get current server and proxy settings from CDDB setup dialog befoe proceed
	bool    cddb_proxy_enabled;
	QString cddb_proxy_host;
	int     cddb_proxy_port;
	cddb_setup->getData( cddb_config.cddbserverlist,
			cddb_config.cddbsubmitlist,
			cddb_config.cddbbasedir,
			cddb_config.submitaddress,
			cddb_config.current_server,
			cddb_config.cddb_remote_enabled,
			cddb_proxy_enabled,
			cddb_proxy_host,
			cddb_proxy_port
	);
	cddb.setHTTPProxy(cddb_proxy_host, cddb_proxy_port);
	cddb.useHTTPProxy(cddb_proxy_enabled);

	connect(&cddb,SIGNAL(get_server_list_done()),this,SLOT(getCDDBserversDone()));
	connect(&cddb,SIGNAL(get_server_list_failed()),this,SLOT(getCDDBserversFailed()));

	cddb.cddbgetServerList(cddb_config.current_server);
}

void KrabWidget::getCDDBserversFailed()
{
	disconnect(&cddb,SIGNAL(get_server_list_done()),this,SLOT(getCDDBserversDone()));
	disconnect(&cddb,SIGNAL(get_server_list_failed()),this,SLOT(getCDDBserversFailed()));
	emit( new_status_info( i18n("Unable to get CDDB server list.")));
}

void KrabWidget::getCDDBserversDone()
{
    disconnect(&cddb,SIGNAL(get_server_list_done()),this,SLOT(getCDDBserversDone()));
    disconnect(&cddb,SIGNAL(get_server_list_failed()),this,SLOT(getCDDBserversFailed()));
    cddb.serverList(cddb_config.cddbserverlist);
    if(cddb_setup)
        cddb_setup->insertServerList(cddb_config.cddbserverlist);
}

void KrabWidget::put_cddb_remote( unsigned int begin_job )
{
//	if(!checkit())
//		return;
if( begin_job == 1 )
{
QString temp = "since Krabber has some extensions for the database, we need again\n";
temp += "a test and register procedure...\n";
temp += "Same procedure as the register procedure of kscd...., this means:\n";
temp += "The submission you are about to make will go to the test server\n";
temp += "cddb-test@cddb.com. This is because this is the first release of\n";
temp += "the cddb addition to Krabber and I need to avoid corruption\n";
temp += "of the remote cddb data bases due to possible bugs in Krabber.\n";
temp += "Since we need about 100 error free test submissions\n";
temp += "before we will be granted write access to the 'true' cddb databases,\n";
temp += "I would like you ask you to upload as many test submissions as possible.\n";
temp += "You don't need to try to find a CD that is not in the database \n";
temp += "(thought that would be helpful),it suffices to submit existing\n";
temp += "entries with Krabber.\n";
temp += "After submission you should receive a mail notifying you of success or\n";
temp += "or failure of your submission. Should you receive a failure notice\n";
temp += "please forward the failure report to me: <krabber@gmx.de>\n";
temp += "Check back often for the availablity of a fully enabled version of krabber.\n";
temp += "Thank you for your support.\n";

#ifdef KDE2
QMessageBox::information( this, "Message", temp, i18n("OK"), 0 );
#else
KMsgBox::message( this, "Message", temp, 0, i18n("OK") );
#endif
};
	unsigned  int i, j;
	QString   temp,
		  interpret,
		  album;
	bool      flag[todolist->tracks + 2];

	cddb_remote_jobnr = begin_job;

	for ( i=1; i<=todolist->tracks; i++ )
		flag[i] = FALSE;

	for ( i=begin_job; i<=todolist->tracks; i++ )
	{
		if ( todolist->data[i]->type == 1 && !flag[i] )
		{
			unsigned int fields = todolist->data[i]->tracks_on_cd + 1;
			bool db_ok = 0;
			bool data_present = 0;
		  	QString  titles_[fields+1],
		  		 extl_[fields+1];
		  	const char  *titles[fields+1],
		  		    *extl[fields+1];
			_cddb_data.magicID   = todolist->data[i]->cddb_discid;
                        _cddb_data.tracks    = todolist->data[i]->tracks_on_cd;
                        _cddb_data.absframe  = todolist->data[i]->frames_on_cd;
			_cddb_data.o_frame   = todolist->data[i]->o_frame;
			_cddb_data.revision  = 0;

			QString temp_        = todolist->data[i]->group + "/" + todolist->data[i]->album ;
			titles[0]            = temp_;
			extl[0]              = empty;

			for ( j=i; j<=todolist->tracks; j++ )
			  if ( todolist->data[i]->cddb_discid == todolist->data[j]->cddb_discid )
			  {
				flag[j] = TRUE;
				if (todolist->data[j]->title.isEmpty())
				{
					if ( !data_present )
						titles[todolist->data[j]->tracknumber] = empty;
				}
				else
				{
					db_ok = 1;
					titles[todolist->data[j]->tracknumber] = todolist->data[j]->title;
				};

				if (todolist->data[j]->comment.isEmpty())
				{
					if ( !data_present )
						extl[todolist->data[j]->tracknumber] = empty;
				}
				else
					extl[todolist->data[j]->tracknumber] = todolist->data[j]->comment;
                          };
		        _cddb_data.titlelist.clear();
		        _cddb_data.extlist.clear();
			for ( j=0; j<=todolist->data[i]->tracks_on_cd; j++)
			{
				_cddb_data.titlelist.append( titles[j] );
				_cddb_data.extlist.append( extl[j] );
			};
			QString temp2 = "XX";
                        temp2.setNum( todolist->data[i]->music_type );
			_cddb_data.mp3_year = todolist->data[i]->year;
			_cddb_data.mp3_categ = temp2;

// write data
			if ( db_ok && !todolist->data[i]->group.isEmpty() && !todolist->data[i]->album.isEmpty() )
			{
				QString submit_category;
				
				if ( todolist->data[i]->music_type >= NR_CATEGORIES )
					submit_category = "misc";
				else
					submit_category = todolist->CDDBcateg[todolist->MP3_2_CDDBcateg[todolist->data[i]->music_type]];

			        _cddb_data.category = submit_category;
				QString tempfile;
				tempfile = tempfile.sprintf("%s",tmpnam(0L));

				put_cddb_info(tempfile, true);

				QString subject;
				subject.sprintf("cddb %s %08x", submit_category.data(), (int) todolist->data[i]->cddb_discid);

				if(cddb_config.smtpConfigData.enabled)
				{
					QFile file(tempfile);
        	
					file.open(IO_ReadOnly);
					QTextStream ti(&file);

					QString s;

					while (!ti.eof())
						s += ti.readLine() + "\n";
#ifndef KDE2
					smtpMailer->setServerHost(cddb_config.smtpConfigData.serverHost.data());
					smtpMailer->setPort(cddb_config.smtpConfigData.serverPort.toInt());

					smtpMailer->setSenderAddress(cddb_config.smtpConfigData.senderAddress.data());
					smtpMailer->setRecipientAddress(cddb_config.submitaddress.data());
					smtpMailer->setMessageSubject(subject.data());
					smtpMailer->setMessageBody(s.data());

					smtpMailer->sendMessage();
#endif
					return;
				};


				QString cmd;
				cmd = cmd.sprintf( cddb_config.mailcmd + " " + cddb_config.submitaddress, subject.data() );;
cout << cddb_config.submitaddress<<endl;
//				cmd = cmd.sprintf( cddb_config.mailcmd + " " + "adrian@localhost", subject.data() );;

				FILE* mailpipe;
				mailpipe = popen(cmd.data(),"w");

				if(mailpipe == NULL)
				{
					QString str;
					str.sprintf(i18n("Could not pipe contents into:\n %s"),cmd.data());

#ifdef KDE2
					QMessageBox::critical(this, "Krabber", str.data());
#else
					KMsgBox::message(this, "Krabber", str.data());
#endif
					pclose(mailpipe);
					return;
				};

				QFile file(tempfile);

				file.open(IO_ReadOnly);
				QTextStream ti(&file);

				QTextStream to(mailpipe,IO_WriteOnly );

				QString s;

				while ( !ti.eof() )
				{
					s = ti.readLine();
					if(!ti.eof())
						to << s.data() << '\n';
				};

				pclose(mailpipe);
				file.close();
				unlink(tempfile.data());
			};
		};
	};
	
	krabwidget_setEnabled( 1 );

};

