#include <namewidget.h>
#include <qvalidator.h>
#include <kapp.h>
#include <klocale.h>

void namewidget::initLayout(void)
{
	QLineEdit_group = new QLineEdit( this, "QLineEdit_group" );
	QLineEdit_album = new QLineEdit( this, "QLineEdit_album" );
	QLineEdit_year = new QLineEdit( this, "QLineEdit_year" );
	QComboBoxType = new KComboExt( FALSE, this, "QComboBoxType" );
	QLineEdit_comment = new QLineEdit( this, "QLineEdit_comment" );
	QLineEdit_title = new QLineEdit( this, "QLineEdit_title" );

	QCheckButton_create_groupdir = new QCheckBox( this, "CheckButton_create_groupdir" );
	QCheckButton_create_albumdir = new QCheckBox( this, "CheckButton_create_albumdir" );
	QLineEdit_nr_offset = new QLineEdit( this, "QLineEdit_nr_offset" );

	QComboBox_file_1 = new QComboBox( FALSE, this, "QComboBox_file_1" );
	QLineEdit_file_1 = new QLineEdit( this, "QLineEdit_file_1" );
	QComboBox_file_2 = new QComboBox( FALSE, this, "QComboBox_file_2" );
	QLineEdit_file_2 = new QLineEdit( this, "QLineEdit_file_2" );
	QComboBox_file_3 = new QComboBox( FALSE, this, "QComboBox_file_3" );
	QLineEdit_file_3 = new QLineEdit( this, "QLineEdit_file_3" );
	QComboBox_file_4 = new QComboBox( FALSE, this, "QComboBox_file_4" );
	QLineEdit_file_4 = new QLineEdit( this, "QLineEdit_file_4" );

	QGroupInfo = new QLabel( this, "GroupInfo" );
	QYearInfo = new QLabel( this, "YearInfo" );
	QTypeInfo = new QLabel( this, "TypeInfo" );
	QCommentInfo = new QLabel( this, "CommentInfo" );
	QLabel_AlbumInfo = new QLabel( this, "QLabel_AlbumInfo" );
	QLabel_FileInfo = new QLabel( this, "QLabel_FileInfo" );
	QLabel_filename = new QLabel( this, "QLabel_filename" );
	QLabel_Offset = new QLabel( this, "QLabel_offset" );

	QPushButton_Help         = new QPushButton( this, "PushButton_Help" );
	QPushButton_p_file       = new QPushButton( this, "PushButton_p_file" );		
	QPushButton_n_file       = new QPushButton( this, "PushButton_n_file" );
	QPushButton_Finish       = new QPushButton( this, "PushButton_Finish" );
        QPushButton_lock_group   = new QPushButton( this, "PushButton_lock_group" );
        QPushButton_lock_album   = new QPushButton( this, "PushButton_lock_album" );
        QPushButton_lock_year    = new QPushButton( this, "PushButton_lock_year" );
        QPushButton_lock_type    = new QPushButton( this, "PushButton_lock_type" );
        QPushButton_lock_comment = new QPushButton( this, "PushButton_lock_comment" );
				
	QLineEdit_nr_offset->setGeometry( 62, 155, 30, 20 );
	QLineEdit_nr_offset->setMaxLength( 3 );
	QLineEdit_nr_offset->setText( "0" );
	QIntValidator *v = new QIntValidator( 0, 999, this );
	QLineEdit_nr_offset->setValidator( (QValidator*) v );
	QLineEdit_nr_offset->show();

	QLineEdit_group->setGeometry( 10, 40, 220, 30 );
	QLineEdit_group->setText( "" );
	QLineEdit_group->setMaxLength( 32767 );
	QLineEdit_group->setEchoMode( QLineEdit::Normal );
	QLineEdit_group->setFrame( TRUE );

	QLineEdit_album->setGeometry( 240, 40, 170, 30 );
	QLineEdit_album->setText( "" );
	QLineEdit_album->setMaxLength( 32767 );
	QLineEdit_album->setEchoMode( QLineEdit::Normal );
	QLineEdit_album->setFrame( TRUE );

	QLineEdit_year->setGeometry( 420, 40, 50, 30 );
	QLineEdit_year->setText( "" );
	QLineEdit_year->setMaxLength( 32767 );
	QLineEdit_year->setEchoMode( QLineEdit::Normal );
	QLineEdit_year->setFrame( TRUE );

	QLineEdit_comment->setGeometry( 590, 40, 100, 30 );
	QLineEdit_comment->setText( "" );
	QLineEdit_comment->setMaxLength( 32767 );
	QLineEdit_comment->setEchoMode( QLineEdit::Normal );
	QLineEdit_comment->setFrame( TRUE );

	QLineEdit_title->setGeometry( 10, 80, 680, 30 );
	QLineEdit_title->setText( "" );
	QLineEdit_title->setMaxLength( 32767 );
	QLineEdit_title->setEchoMode( QLineEdit::Normal );
	QLineEdit_title->setFrame( TRUE );
	
	QPushButton_lock_group->setGeometry( 210, 17, 18, 18 );
	QPushButton_lock_group->setPixmap( *QPixmap_unlocked );

	QPushButton_lock_album->setGeometry( 390, 17, 18, 18 );
	QPushButton_lock_album->setPixmap( *QPixmap_unlocked );

	QPushButton_lock_year->setGeometry( 450, 17, 18, 18 );
	QPushButton_lock_year->setPixmap( *QPixmap_unlocked );

	QPushButton_lock_type->setGeometry( 560, 17, 18, 18 );
	QPushButton_lock_type->setPixmap( *QPixmap_unlocked );

	QPushButton_lock_comment->setGeometry( 670, 17, 18, 18 );
	QPushButton_lock_comment->setPixmap( *QPixmap_unlocked );

	QLabel_Offset->setGeometry( 10, 155, 50, 20 );
	QLabel_Offset->setText( i18n ( "Offset:" ) );
	QLabel_Offset->setAlignment( 292 );
	QLabel_Offset->setMargin( -1 );

	QLabel_AlbumInfo->setGeometry( 240, 10, 150, 30 );
	QLabel_AlbumInfo->setText( i18n ( "Album:" ) );
	QLabel_AlbumInfo->setAlignment( 292 );
	QLabel_AlbumInfo->setMargin( -1 );

	QGroupInfo->setGeometry( 10, 10, 200, 30 );
	QGroupInfo->setText( i18n ( "Group:" ) );
	QGroupInfo->setAlignment( 292 );
	QGroupInfo->setMargin( -1 );

	QYearInfo->setGeometry( 420, 10, 30, 30 );
	QYearInfo->setText( i18n ( "Year:" ) );
	QYearInfo->setAlignment( 292 );
	QYearInfo->setMargin( -1 );

	QTypeInfo->setGeometry( 480, 10, 80, 30 );
	QTypeInfo->setText( i18n ( "Type:" ) );
	QTypeInfo->setAlignment( 292 );
	QTypeInfo->setMargin( -1 );

	QCommentInfo->setGeometry( 590, 10, 80, 30 );
	QCommentInfo->setText( i18n ( "Comment:" ) );
	QCommentInfo->setAlignment( 292 );
	QCommentInfo->setMargin( -1 );

	QLabel_filename->setGeometry( 100, 150, 330, 30 );
	QLabel_filename->setText( i18n( "build your filename:" ) );
	QLabel_filename->setAlignment( 289 );
	QLabel_filename->setMargin( -1 );

	QCheckButton_create_groupdir->setGeometry( 450, 120, 240, 30 );
	QCheckButton_create_groupdir->setText( i18n ( "Write in a Directory named as the group" ) );
	QCheckButton_create_groupdir->setAutoRepeat( FALSE );
	QCheckButton_create_groupdir->setAutoResize( FALSE );

	QCheckButton_create_albumdir->setGeometry( 450, 150, 240, 30 );
	QCheckButton_create_albumdir->setText( i18n( "Write in a Directory named as the album") );
	QCheckButton_create_albumdir->setAutoRepeat( FALSE );
	QCheckButton_create_albumdir->setAutoResize( FALSE );

	QLabel_FileInfo->setGeometry( 10, 120, 430, 30 );
	QLabel_FileInfo->setText( i18n( "FileInfo:")  );
	QLabel_FileInfo->setAlignment( 289 );
	QLabel_FileInfo->setMargin( -1 );

	QPushButton_p_file->setGeometry( 160, 240, 170, 30 );
	QPushButton_p_file->setText( i18n ( "Previous File" ) );
	QPushButton_p_file->setAutoRepeat( FALSE );
	QPushButton_p_file->setAutoResize( FALSE );

	QPushButton_n_file->setGeometry( 340, 240, 170, 30 );
	QPushButton_n_file->setText( i18n ("Next File" ) );
	QPushButton_n_file->setAutoRepeat( FALSE );
	QPushButton_n_file->setAutoResize( FALSE );
	QPushButton_n_file->setDefault( TRUE );

	QPushButton_Finish->setGeometry( 560, 240, 130, 30 );
	QPushButton_Finish->setText( i18n ( "Finish" ) );
	QPushButton_Finish->setAutoRepeat( FALSE );
	QPushButton_Finish->setAutoResize( FALSE );

	QPushButton_Help->setGeometry( 10, 240, 90, 30 );
	QPushButton_Help->setText( i18n ( "Help" ) );
	QPushButton_Help->setAutoRepeat( FALSE );
	QPushButton_Help->setAutoResize( FALSE );

	QComboBoxType->setGeometry( 480, 40, 100, 30 );
	QComboBoxType->setSizeLimit( 10 );
	QComboBoxType->setAutoResize( FALSE );
	QComboBoxType->setKeys( 1 );

	QComboBox_file_1->setGeometry( 10, 190, 90, 30 );
	QComboBox_file_1->setSizeLimit( 10 );
	QComboBox_file_1->setAutoResize( FALSE );
	QComboBox_file_1->insertItem( "" );
	QComboBox_file_1->insertItem( i18n ( "Jobnumber" ) );
	QComboBox_file_1->insertItem( i18n ( "Tracknumber" ) );
	QComboBox_file_1->insertItem( i18n ( "Group" ));
	QComboBox_file_1->insertItem( i18n ( "Album" ));
	QComboBox_file_1->insertItem( i18n ( "Year" ));
	QComboBox_file_1->insertItem( i18n ( "Title" ));
	
	QComboBox_file_2->setGeometry( 190, 190, 90, 30 );
	QComboBox_file_2->setSizeLimit( 10 );
	QComboBox_file_2->setAutoResize( FALSE );
	QComboBox_file_2->insertItem( "" );
	QComboBox_file_2->insertItem( i18n ( "Jobnumber" ) );
	QComboBox_file_2->insertItem( i18n ( "Tracknumber" ) );
	QComboBox_file_2->insertItem( i18n ( "Group" ));
	QComboBox_file_2->insertItem( i18n ( "Album" ));
	QComboBox_file_2->insertItem( i18n ( "Year" ));
	QComboBox_file_2->insertItem( i18n ( "Title" ));

	QComboBox_file_3->setGeometry( 370, 190, 90, 30 );
	QComboBox_file_3->setSizeLimit( 10 );
	QComboBox_file_3->setAutoResize( FALSE );
	QComboBox_file_3->insertItem( "" );
	QComboBox_file_3->insertItem( i18n ( "Jobnumber" ) );
	QComboBox_file_3->insertItem( i18n ( "Tracknumber" ) );
	QComboBox_file_3->insertItem( i18n ( "Group" ));
	QComboBox_file_3->insertItem( i18n ( "Album" ));
	QComboBox_file_3->insertItem( i18n ( "Year" ));
	QComboBox_file_3->insertItem( i18n ( "Title" ));

	QComboBox_file_4->setGeometry( 550, 190, 90, 30 );
	QComboBox_file_4->setSizeLimit( 10 );
	QComboBox_file_4->setAutoResize( FALSE );
	QComboBox_file_4->insertItem( "" );
	QComboBox_file_4->insertItem( i18n ( "Jobnumber" ) );
	QComboBox_file_4->insertItem( i18n ( "Tracknumber" ) );
	QComboBox_file_4->insertItem( i18n ( "Group" ));
	QComboBox_file_4->insertItem( i18n ( "Album" ));
	QComboBox_file_4->insertItem( i18n ( "Year" ));
	QComboBox_file_4->insertItem( i18n ( "Title" ));

	QLineEdit_file_1->setGeometry( 100, 190, 90, 30 );
	QLineEdit_file_1->setMaxLength( 32767 );
	QLineEdit_file_1->setEchoMode( QLineEdit::Normal );
	QLineEdit_file_1->setFrame( TRUE );

	QLineEdit_file_3->setGeometry( 460, 190, 90, 30 );
	QLineEdit_file_3->setMaxLength( 32767 );
	QLineEdit_file_3->setEchoMode( QLineEdit::Normal );
	QLineEdit_file_3->setFrame( TRUE );

	QLineEdit_file_2->setGeometry( 280, 190, 90, 30 );
	QLineEdit_file_2->setMaxLength( 32767 );
	QLineEdit_file_2->setEchoMode( QLineEdit::Normal );
	QLineEdit_file_2->setFrame( TRUE );
	
	QLineEdit_file_4->setGeometry( 640, 190, 50, 30 );
	QLineEdit_file_4->setMaxLength( 32767 );
	QLineEdit_file_4->setEchoMode( QLineEdit::Normal );
	QLineEdit_file_4->setFrame( TRUE );
};
