#ifndef __NAMEWIDGET__
#define __NAMEWIDGET__

#include <kapp.h>
#include <kcomboext.h>

#include "detect_kde_version.h"

#include <qpushbutton.h>
#include <qlabel.h>
#include <qframe.h>
#include <qlineedit.h>
#include <qradiobutton.h>
#include <qcombobox.h>
#include <qdialog.h>
#include <qcheckbox.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qlist.h>
#include <cddalist.h>

#include <config.h>

#ifdef KDE2
	#include <klocale.h>
#endif

struct TypeIndex
{
	QString      TypeName;
	unsigned int typeNr;
};

class TList : public QList<TypeIndex>
{
public:
	TList( bool temp=TRUE );
	~TList();
private:
#ifdef KDE2
	QCollection::Item newItem( QCollection::Item d );
	void  deleteItem( QCollection::Item d );
	int compareItems( QCollection::Item t1, QCollection::Item t2);
#else
        GCI   newItem( GCI d );
	void  deleteItem( GCI d );
	int compareItems( GCI t1, GCI t2);
#endif
	bool dc;
};

class namewidget : public QWidget
{
	Q_OBJECT
public:
	namewidget(QWidget *parent=NULL, const char *name=NULL, TodoList *todolist=NULL , bool gui_ = 1 );
	~namewidget();
	QString update_filename_sub( unsigned int id, unsigned int nr);

	QComboBox *QComboBox_file_1,
		  *QComboBox_file_2,
		  *QComboBox_file_3,
		  *QComboBox_file_4;
	KComboExt *QComboBoxType;
	QLineEdit *QLineEdit_file_1,
		  *QLineEdit_file_2,
		  *QLineEdit_file_3,
		  *QLineEdit_file_4;
	QCheckBox *QCheckButton_create_groupdir,
		  *QCheckButton_create_albumdir;

public slots:
signals:
	void destroy_namewidget();
protected slots:
	void lock_group();
	void lock_album();
	void lock_year();
	void lock_type();
	void lock_comment();
	void invokeHelp();
	void finish();
	void save_input();
	void update_view();
	void update_nr_offset( const char * );
	void update_view_filename(const char *);
	void update_view_filename(int);
	QString update_filename( unsigned int nr);
	void previous_file();	
	void next_file();
	void closeEvent( QCloseEvent * );
	void init_db();
	void init_db_sub( const char *, unsigned int);
	unsigned int find( unsigned int typeNr);

protected:
	TodoList               *todolist_n;
	unsigned int           todolist_nr;
	bool                   init,
			       gui,
			       group_locked,
			       album_locked,
			       year_locked,
			       type_locked,
			       comment_locked;
        TList		       tlist;
	TypeIndex	       TypeList[NR_CATEGORIES];
//	static const TypeIndex TypeList[]; //klocale->translate did not work during init.

	QLabel *QYearInfo,
	       *QTypeInfo,
	       *QCommentInfo,
	       *QLabel_filename,
               *QGroupInfo,
	       *QLabel_AlbumInfo,
	       *QLabel_FileInfo,
	       *QLabel_Offset;
	QPixmap *QPixmap_locked,
                *QPixmap_unlocked;
	QPushButton *QPushButton_p_file,
 		    *QPushButton_n_file,
		    *QPushButton_Finish,
		    *QPushButton_Help,
		    *QPushButton_lock_group,
		    *QPushButton_lock_album,
	            *QPushButton_lock_year,
	            *QPushButton_lock_type,
	            *QPushButton_lock_comment;
	QLineEdit *QLineEdit_group,
		  *QLineEdit_year,
		  *QLineEdit_comment,
		  *QLineEdit_album,
		  *QLineEdit_title,
		  *QLineEdit_nr_offset;

	void initLayout(void);
};
#endif 
