#include "status_window.h"
#include <krabwidget.h>
#include <kapp.h>
#include <klocale.h>


void status_window::initLayout(void) {
	unsigned int i;

	QFrame_Status = new QFrame ( this, "QFrame_progress");
	QLabel_Status_read = new QLabel ( QFrame_Status, "");
	QLabel_Status_total = new QLabel ( QFrame_Status, "");
	KProgress_read = new KProgress ( 0, 100, 0, KProgress::Horizontal, QFrame_Status, "");
	KProgress_total = new KProgress ( 0, 100, 0, KProgress::Horizontal, QFrame_Status, "");
	QLabel_led_read = new QLabel ( QFrame_Status );
	QLabel_led_total = new QLabel ( QFrame_Status );
	QPushButton_Status_Cancel = new QPushButton ( this , "");
	QPushButton_Status_Stop = new QPushButton ( this , "");
	KSlider_nice = new KSlider ( 0 , 19, 1, 19, KSlider::Horizontal,  this, "");
	QLabel_nice = new QLabel( i18n( "Priority:"), this, "QLabel_nice" );

	this->setCaption( i18n ("Krabber Status") );
	this->setGeometry( 219, 285, 217, 117 );
	this->setMinimumSize( 0, 0 );
	this->setMaximumSize( 32767, 32767 );
	this->setMouseTracking( FALSE);
	this->setSizeIncrement( 0, 0 );

	QFrame_Status->setCaption( "" );
	QFrame_Status->setGeometry( 0, 0, 240, 160 + write_nr*30 );
	QFrame_Status->setMinimumSize( 0, 0 );
	QFrame_Status->setMaximumSize( 32767, 32767 );
	QFrame_Status->setMouseTracking( FALSE);
	QFrame_Status->setSizeIncrement( 0, 0 );
	QFrame_Status->setLineWidth( 1 );
	QFrame_Status->setMidLineWidth( 0 );
	QFrame_Status->setFrameStyle( QFrame::Panel | QFrame::Raised );

	QLabel_Status_read->setCaption( "" );
	QLabel_Status_read->setGeometry( 8, 8, 201, 20 );
	QLabel_Status_read->setMinimumSize( 0, 0 );
	QLabel_Status_read->setMaximumSize( 32767, 32767 );
	QLabel_Status_read->setMouseTracking( FALSE);
	QLabel_Status_read->setSizeIncrement( 0, 0 );
	QLabel_Status_read->setLineWidth( 1 );
	QLabel_Status_read->setMidLineWidth( 0 );
	QLabel_Status_read->setText( i18n ( "read job" ) );
	QLabel_Status_read->setMargin( -1 );
	QLabel_Status_read->setAlignment( AlignLeft | AlignVCenter | ExpandTabs );
	QLabel_Status_read->setAutoResize( FALSE );

	KProgress_read->setCaption( "" );
	KProgress_read->setGeometry( 8, 30, 201, 29 );
	KProgress_read->setMinimumSize( 0, 0 );
	KProgress_read->setMaximumSize( 32767, 32767 );
	KProgress_read->setMouseTracking( FALSE);
	KProgress_read->setTextEnabled( TRUE );

	QLabel_led_read->setGeometry( 211, 33, 24, 24 );
#ifdef KDE2
	QPixmap pix( led_out_p );
	QLabel_led_read->setPixmap( pix );
#else
	QLabel_led_read->setPixmap( led_out_p );
#endif
	if ( write_nr != 0 )
	{
		QLabel_Status_write = new QLabel ( QFrame_Status, "");

		QLabel_Status_write->setCaption( "" );
		QLabel_Status_write->setGeometry( 8, 67, 201, 29 );
		QLabel_Status_write->setMinimumSize( 0, 0 );
		QLabel_Status_write->setMaximumSize( 32767, 32767 );
		QLabel_Status_write->setMouseTracking( FALSE);
		QLabel_Status_write->setSizeIncrement( 0, 0 );
		QLabel_Status_write->setLineWidth( 1 );
		QLabel_Status_write->setMidLineWidth( 0 );
		QLabel_Status_write->setText( i18n( "write job" ) );
 		QLabel_Status_write->setMargin( -1 );
		QLabel_Status_write->setAlignment( AlignLeft | AlignVCenter | ExpandTabs );
		QLabel_Status_write->setAutoResize( FALSE );
	}

	for ( i = 0; i < write_nr; i++ )
	{
		KProgress_write[i] = new KProgress ( 0, 100, 0, KProgress::Horizontal, QFrame_Status, "");
		KProgress_write[i]->setCaption( "" );
		KProgress_write[i]->setGeometry( 8, 89 + (i * 30) , 201, 29 );
		KProgress_write[i]->setMinimumSize( 0, 0 );
		KProgress_write[i]->setMaximumSize( 32767, 32767 );
		KProgress_write[i]->setMouseTracking( FALSE);
		KProgress_write[i]->setTextEnabled( TRUE );

		QLabel_led_write[i] = new QLabel ( QFrame_Status );
		QLabel_led_write[i]->setGeometry( 211, 92 + (i * 30), 24, 24 );
#ifdef KDE2
		QLabel_led_write[i]->setPixmap( pix );
#else
		QLabel_led_write[i]->setPixmap( led_out_p );
#endif
	}

	QLabel_Status_total->setCaption( "" );
	QLabel_Status_total->setGeometry( 8, 100 + (write_nr * 30 ), 201, 20 );
	QLabel_Status_total->setMinimumSize( 0, 0 );
	QLabel_Status_total->setMaximumSize( 32767, 32767 );
	QLabel_Status_total->setMouseTracking( FALSE);
	QLabel_Status_total->setSizeIncrement( 0, 0 );
	QLabel_Status_total->setLineWidth( 1 );
	QLabel_Status_total->setMidLineWidth( 0 );
	QLabel_Status_total->setText( i18n ( "total job" ) );
	QLabel_Status_total->setMargin( -1 );
	QLabel_Status_total->setAlignment( AlignLeft | AlignVCenter | ExpandTabs );
	QLabel_Status_total->setAutoResize( FALSE );

	KProgress_total->setCaption( "" );
	KProgress_total->setGeometry( 8, 120 + (write_nr * 30), 201, 29 );
	KProgress_total->setMinimumSize( 0, 0 );
	KProgress_total->setMaximumSize( 32767, 32767 );
	KProgress_total->setMouseTracking( FALSE);
	KProgress_total->setTextEnabled( TRUE );

	QLabel_led_total->setGeometry( 211, 123 + (write_nr * 30), 24, 24 );
#ifdef KDE2
	QLabel_led_total->setPixmap( pix );
#else
	QLabel_led_total->setPixmap( led_out_p );
#endif

	KSlider_nice->setCaption( "" );
	KSlider_nice->setGeometry( 75, (165 + (write_nr * 30)), 165, 29 );

	QLabel_nice->setGeometry( 0, 165 + (write_nr * 30), 70, 24 );

	QPushButton_Status_Cancel->setCaption( "" );
	QPushButton_Status_Cancel->setGeometry( 0, (240 + (write_nr * 30)), 240, 29 );
	QPushButton_Status_Cancel->setMinimumSize( 0, 0 );
	QPushButton_Status_Cancel->setMaximumSize( 32767, 32767 );
	QPushButton_Status_Cancel->setMouseTracking( FALSE);
	QPushButton_Status_Cancel->setSizeIncrement( 0, 0 );
	QPushButton_Status_Cancel->setText( i18n ( "Cancel" ) );
	QPushButton_Status_Cancel->setAutoResize( FALSE );
	QPushButton_Status_Cancel->setAutoRepeat( FALSE );
	QPushButton_Status_Cancel->setToggleButton( FALSE );
	QPushButton_Status_Cancel->setAutoDefault( FALSE );

	QPushButton_Status_Stop->setCaption( "" );
	QPushButton_Status_Stop->setGeometry( 0, (195 + (write_nr * 30)), 240, 29 );
	QPushButton_Status_Stop->setMinimumSize( 0, 0 );
	QPushButton_Status_Stop->setMaximumSize( 32767, 32767 );
	QPushButton_Status_Stop->setMouseTracking( FALSE);
	QPushButton_Status_Stop->setSizeIncrement( 0, 0 );
	QPushButton_Status_Stop->setText( i18n ( "Stop" ) );
	QPushButton_Status_Stop->setAutoResize( FALSE );
	QPushButton_Status_Stop->setAutoRepeat( FALSE );
	QPushButton_Status_Stop->setToggleButton( FALSE );
	QPushButton_Status_Stop->setAutoDefault( FALSE );

}
