#include <todolist.h>

TodoList::TodoList()
{
	nr_offset = 0;
	grab_mode = 999;
};
TodoList::~TodoList()
{};

unsigned long TodoList::length_bytes(unsigned int i, unsigned int bitrate, unsigned int channels, unsigned int bits )
{
	double factor, size;
	unsigned long size_;

	if ( data[i]->type == 5 )
		bitrate = 32;

	factor = (unsigned long) bitrate*channels*bits;
	factor = factor/((unsigned long)(data[i]->input_rate*data[i]->input_channels*data[i]->input_bit_per_rate));

	if (data[i]->type == 1)
		size = factor*((unsigned long)(2352*(data[i]->o_frame.frame[data[i]->tracknumber] - data[i]->o_frame.frame[data[i]->tracknumber - 1])));
	else
		size = factor*((unsigned long)data[i]->input_size);

	switch (data[i]->type){
		case  5: size /= 72;break;
		case 15: size *= 5.5;break;
		case 21: size *= 1.54875;break;
	};

	size_ = (unsigned long) size;
	return ( size_ );
};
unsigned long TodoList::length_bytes_output(unsigned int i, unsigned int bitrate, unsigned int channels, unsigned int bits, unsigned int mp3_br=1 )
{
	unsigned long size;
	unsigned long multiplicator;

	size = length_bytes( i, bitrate, channels, bits );

	switch ( grab_mode ){
		case 16: multiplicator = 72000;	 break; //               VMS
		case 26: multiplicator = 182;	 break; // 1/5.5         CVS
		case 32: multiplicator = 646;    break; // 1/1.54875     HCOM
		default: multiplicator = 1000;
	};
	size = ( size / multiplicator) *1000;

	if ( mp3_br > 1 ){
		size /= (bitrate*channels*bits);
		size *= mp3_br*1000;
	};

	return size;
};

const char* TodoList::CDDBcateg[] = {"rock", "classical", "jazz", "soundtrack",
				     "newage", "blues", "folk", "country", 
				     "reggae", "misc", "data" };

const char*  TodoList::categories[] = { "Blues", "Classic Rock", "Country", "Dance", "Disco", "Funk"
		, "Grunge", "Hip-Hop", "Jazz", "Metal", "New Age", "Oldies", "Other", "Pop", "R&B", "Rap"
		, "Reggae", "Rock", "Techno", "Industrial", "Alternative", "Ska", "Death Metal", "Pranks"
		, "Soundtrack", "Euro-Techno", "Ambient", "Trip-Hop", "Vocal", "Jazz+Funk", "Fusion", "Trance"
		, "Classical", "Instrumental", "Acid", "House", "Game", "Sound Clip", "Gospel", "Noise"
		, "AlternRock", "Bass", "Soul", "Punk", "Space", "Meditative", "Instrumental Pop"
		, "Instrumental Rock", "Ethnic", "Gothic", "Darkwave", "Techno-Industrial", "Electronic"
		, "Pop-Folk", "Eurodance", "Dream", "Southern Rock", "Comedy", "Cult", "Gangsta", "Top 40"
		, "Christian Rap", "Pop/Funk", "Jungle", "Native American", "Cabaret", "New Wave", "Psychadelic"
		, "Rave", "Showtunes", "Trailer", "Lo-Fi", "Tribal", "Acid Punk", "Acid Jazz", "Polka"
		, "Retro", "Musical", "Rock & Roll", "Hard Rock", "Unknown"
// WINAMP extensions:
		, "Folk", "Folk-Rock", "National Folk", "Swing", "Fast Fusion", "Bebob", "Latin"
		, "Revival", "Celtic", "Bluegrass", "Avantgarde", "Gothic Rock", "Progressive Rock"
		, "Psychedelic Rock", "Symphonic Rock", "Slow Rock", "Big Band", "Chorus", "Easy Listening"
		, "Acoustic", "Humour", "Speech", "Chanson", "Opera", "Chamber Music", "Sonata"
		, "Symphony", "Booty Bass", "Primus", "Porn Groove", "Satire", "Slow Jam", "Club", "Tango"
		, "Samba", "Folklore", "Ballad", "Power Ballad", "Rhythmic Soul", "Freestyle", "Duet"
		, "Punk Rock", "Drum Solo", "Acapella", "Euro-House", "Dance Hall"
	 };

const unsigned int TodoList::MP3_2_CDDBcateg[] = 
	       { 5, 0, 7, 9, 9, 9,
		 9, 9, 2, 9, 4, 9, 9, 9, 9, 9,
		 8, 0, 9, 9, 9, 9, 9, 9,
		 3, 9, 9, 9, 9, 9, 9, 9, 
		 1, 9, 9, 9, 9, 1, 9, 9,
		 0, 9, 9, 9, 9, 9, 9,
		 0, 9, 9, 9, 9, 9,
		 6, 9, 9, 0, 9, 9, 9, 9,
		 9, 9, 9, 9, 9, 9, 9,
		 9, 9, 9, 9, 9, 9, 9, 6,
		 9, 9 ,0, 0, 9,
// WINAMP extensions:
		 6, 6, 6, 9, 9, 2, 9,
		 9, 9, 9, 9, 0, 0,
		 0, 0, 0, 9, 9, 9,
		 9, 9, 9, 9, 9, 1, 1,
		 1, 9, 9, 9, 9, 9, 9, 9,
		 9, 6, 9, 9, 9, 9, 9,
		 0, 9, 9, 9, 9
	       };
