
#ifndef __TODOLIST_H
#define __TODOLIST_H

#include "iostream.h"
#include <qstring.h>
#include <qvector.h>

#define NR_CATEGORIES 126   // 127???
#define NR_CDDB_CATEG 11

struct offset_frame
{
	int frame[99];
};

struct Data{
	QString       device,
		      group,
		      album,
	              title,
		      year,
		      comment,
		      output_filename,
		      cd_index;
	unsigned int  music_type,
		      type,
		      tracknumber,
		      tracks_on_cd,
		      frames_on_cd;
	offset_frame  o_frame;
	unsigned long est_temp_size,
		      cddb_discid,
		      input_frames, //only mp?
		      input_size;
	unsigned int  input_rate,
		      input_channels,
		      input_bit_per_rate,
		      input_compr_bitrate;
	bool          cddb_disable;
};

class TodoList
{
public:
	TodoList();
	virtual ~TodoList();

	bool          create_dir_group,
		      create_dir_album;
	unsigned int  grab_mode,
		      tracks,
		      tracks_cdda,
		      nr_offset;
	QString       device_choiced,
	 	      krabber_process_id,
		      outputPath,
		      tempPath;
	static const char* categories[];
	static const char* CDDBcateg[];
	static const unsigned int MP3_2_CDDBcateg[];

	bool BUG_FLAG;

	QVector<Data> data;

	unsigned long length_bytes( unsigned int entry, unsigned int dest_bitrate,
					unsigned int dest_channels, unsigned int dest_bits );
	unsigned long length_bytes_output( unsigned int entry, unsigned int dest_bitrate, 
					unsigned int dest_channels, unsigned int dest_bits,
					unsigned int mp3_br=1 ); 

};


#endif

